<?php

/*
configuration
$Author: dougqh $
$Revision: 1.9 $
$Date: 2004/04/27 20:35:39 $
$Log: configuration.php,v $
Revision 1.9  2004/04/27 20:35:39  dougqh
- Fix for email issue under windows

Revision 1.8  2004/04/26 18:02:02  dougqh
- Adding some checks to make sure PHP is configured correctly.

Revision 1.6  2004/01/07 14:39:19  dougqh
- Better error reporting

Revision 1.5  2003/11/03 19:15:36  dougqh
- Feature 3744

Revision 1.4  2003/09/29 16:46:05  dougqh
Using DIRECTORY_SEPARATOR to be compatible with Windows.

Revision 1.3  2003/08/29 21:12:46  dougqh
- More warning message changes

Revision 1.2  2003/08/29 21:12:12  dougqh
- Changed some warning messages.

Revision 1.1  2003/08/29 21:10:51  dougqh
Initial revision

Revision 1.3  2003/03/28 16:59:36  dougqh
Revised to allow IS_DEMO to be true while IS_DEVELOPMENT or IS_QA are true.

Revision 1.2  2003/03/03 15:46:57  millz
updated for demo user

Revision 1.1  2002/11/14 16:22:59  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//load shared settings with Perl from BugPort.conf into constants
//========================================================================

$configDir = preg_replace(
   '/\\' . DIRECTORY_SEPARATOR . 'configuration.php\Z/', '',
   realpath( __FILE__ ) );

define( 'CONFIG_PHP', $configDir . DIRECTORY_SEPARATOR . 'config.php' );
define( 'CONFIG_CONF', $configDir . DIRECTORY_SEPARATOR . 'config.conf' );

if ( file_exists( CONFIG_PHP ) )
{
   require_once( CONFIG_PHP );
}
else
{
   $oldFileHandle = @fopen( CONFIG_CONF, 'r' );
   if ( $oldFileHandle !== false )
   {
      $oldContents = fread( $oldFileHandle, filesize( CONFIG_CONF ) );
      fclose( $oldFileHandle );
      eval( $oldContents );

      $newFileHandle = @fopen( CONFIG_PHP, 'w' );
      if ( $newFileHandle !== false )
      {
         fwrite( $newFileHandle, '<?php' . "\n" . $oldContents . "\n" . '?>' );
         fclose( $newFileHandle );
         unlink( CONFIG_CONF );
      }
      else
      {
         ob_start();
         print '<font color="red" size="+1">' . "\n";
         print 'SECURITY ERROR <br />' . "\n";
         print 'conf/config.conf should be changed to conf/config.php to prevent' . "\n";
         print 'unauthorizing viewing of the configuration information by web server users. <br />' . "\n";
         print '&lt;?php will need to be added at the start' . "\n";
         print 'and ?&gt; will need to be added at the end of the new config.php file.' . "\n";
         print '<br />' . "\n";
         print '<br />' . "\n";
         print 'BugPort will do this conversion automatically if the web server has ' . "\n";
         print 'has write access to the conf directory.' . "\n";
         print '</font>' . "\n";
      }
   }
   else
   {
      print 'Configuration Error - Failed to read configuration file <br/>' . "\n";
      print 'Config Reader: ' . __FILE__ . '<br />' . "\n";
      print 'Realpath( Config Reader ): ' . realpath( __FILE__ ) . '<br />' . "\n";
      print 'Config Dir: ' . $configDir . '<br />' . "\n";
      print 'Attempted Config File: ' . CONFIG_PHP . '<br />' . "\n";
      exit;
   }
}

//========================================================================

if ( ! isset( $home ) )
{
    //Set the current working directory to the directory of this script
    $myDir = substr( __FILE__, 0, strrpos( __FILE__, DIRECTORY_SEPARATOR ) );
    $directories = explode( DIRECTORY_SEPARATOR, $myDir );
    array_pop( $directories ); // pop off conf
    $rootDir = implode( DIRECTORY_SEPARATOR, $directories );
    define( 'BASE_DIRECTORY', realpath( $rootDir ) . DIRECTORY_SEPARATOR );
}
else
{
	 //This constant is NOT the actual apache htdocs directory.
	 //This MUST have a trailing slash.
	 define( 'BASE_DIRECTORY', realpath( $home ) . DIRECTORY_SEPARATOR );
}

define(
   'PHP_INI_MODIFICATION_INFO',
   'See <a href="http://us3.php.net/manual/en/function.ini-set.php">http://us3.php.net/manual/en/function.ini-set.php</a> ' .
      'for more information on modifying php.ini settings.<br />' );

if ( ! file_exists( BASE_DIRECTORY ) )
{
   print 'Specified BugPort Home directory does not exist. <br />';
   print 'BugPort Home: ' . BASE_DIRECTORY . '<br />';
   print 'configuration.php Path: ' . __FILE__ . '<br />';
   exit;
}
elseif ( strpos( realpath( __FILE__ ), BASE_DIRECTORY ) === false )
{
   print 'BugPort Home exists, but is probably incorrect <br />';
   print 'This configuration file is not contained in a sub-directory of the specified BugPort Home <br />';
   print 'BugPort Home: ' . BASE_DIRECTORY . '<br />';
   print 'configuration.php Path: ' . __FILE__ . '<br />';
   exit;
}

if ( get_magic_quotes_gpc() && ! $allowMagicQuotes )
{
   print 'magic_quotes_gpc is enabled. <br />';
   print 'It is HIGHLY recommended that magic_quotes_gpc be disabled in your php.ini. <br />';
   print PHP_INI_MODIFICATION_INFO;
   print '<br />';
   print 'If you wish to run BugPort with magic_quotes_gpc enabled, <br />';
   print 'you may disable this check by setting "$allowMagicQuotes=1" in <br />';
   print 'BugPort\'s conf/config.php.  This is NOT recommended.';
   exit;
}

if ( isset( $emailUseAngleBrackets ) )
{
   define( 'EMAIL_USE_ANGLE_BRACKETS', $emailUseAngleBrackets );
}
else
{
   if ( ini_get( 'sendmail_path' ) == '' )
   {
      define( 'EMAIL_USE_ANGLE_BRACKETS', false );
   }
   else
   {
//Need to strip any arguments off sendmail_path for this check to work
//      if ( file_exists( ini_get( 'sendmail_path' ) ) )
//      {
         define( 'EMAIL_USE_ANGLE_BRACKETS', true );
//      }
//      else
//      {
//         print 'php.ini setting sendmail_path is invalid. <br />';
//         print PHP_INI_MODIFICATION_INFO;
//         exit;
//      }
   }
}

if ( isset( $enableDebugging ) )
{
   define( 'ALLOW_CUSTOM_DEBUGGING', $enableDebugging );
}

if ( empty( $adoDir ) )
{
   define( 'ADO_DIR', BASE_DIRECTORY . 'adodb' . DIRECTORY_SEPARATOR );
}
else
{
   define( 'ADO_DIR', $adoDir );
}

define( 'FILES_BASE_DIR_NAME', realpath( $attachmentDirectory ) . DIRECTORY_SEPARATOR );

define( 'DATABASE_USER', $db_user );
define( 'DATABASE_PASSWORD', $db_pass );
define( 'DATABASE_HOST', $db_host );
define( 'DATABASE_PORT', $db_port );
define( 'DATABASE_TYPE', $db_type );

define( 'SEQUENCE_SCHEMA', $sequenceSchema );
define( 'SHARED_SCHEMA', $sharedSchema );
define( 'DEFAULT_SCHEMA', $bugSchema );

//set to DEVELOPMENT, QA, or RELEASE as appropriate
if ( ! isset( $versionType ) )
{
    define( 'VERSION_TYPE', 'RELEASE' );
}
else
{
    define( 'VERSION_TYPE', $versionType );
}

define( 'DEV_ITEM_SEND_EMAIL', $systemEmail );

if ( isset( $enableStrictVerification ) )
{
   define( 'ENABLE_STRICT_VERIFICATION', $enableStrictVerification );
}
else
{
   define( 'ENABLE_STRICT_VERIFICATION', false );
}

//timeout and memory usage settings
//========================================================================

define( 'GENEPORT4_TIMEOUT', 90 );

//controls the maximum amount of memory an Apache chilld can use before
//it is killed in kilobytes
if ( isset( $maxApacheChildMemory ) && is_numeric( trim( $maxApacheChildMemory ) ) )
{
   define( 'MAX_APACHE_CHILD_MEMORY', floatval( trim( $maxApacheChildMemory ) ) );
}

//auto-set variables - do not change
//========================================================================

//NOTE: do not touch these lines
//sets other defines based on the values above
define( 'IS_DEVELOPMENT', ( VERSION_TYPE == 'DEVELOPMENT' ) );
define( 'IS_QA', ( VERSION_TYPE == 'QA' ) );
define( 'IS_RELEASE', ( VERSION_TYPE == 'RELEASE' ) );
define( 'IS_DEMO', ( isset( $isDemo ) && ( intval( $isDemo ) != 0 ) ) );

//read version from version.txt translate appropriately for the VERSION_TYPE
$versionFile = $configDir . DIRECTORY_SEPARATOR . 'version.txt';

//standard fread and filesize combination did NOT work
//so using readfile with output buffering
ob_start();
readfile( $versionFile );
$version = ob_get_contents();
ob_end_clean();

//print 'File Version: ' . $version . '<br />';

if ( IS_DEVELOPMENT )
{
   //use exact version in file
   define( 'VERSION', $version );
}
elseif ( IS_RELEASE )
{
   //decrement last portion
   list( $major, $minor ) = explode( '.', $version );
   define( 'VERSION', sprintf( '%d.%03d', $major, ( $minor - 1 ) ) );
}
else
{
   print 'Invalid $versionType in ' . CONFIG_PHP . ' <br />';
   exit;
}


//========================================================================

$pos = strpos( strtolower( trim( PHP_OS ) ), 'win' );
//found at beginning of string
define( 'IS_WINDOWS', ( $pos !== false && $pos == 0 ) );

//========================================================================

define( 'IS_PHP5', floatval( PHP_VERSION ) >= 5 );
	
//========================================================================

if ( isset( $showDiagnostics ) && $showDiagnostics )
{
   $constants = get_defined_constants();
   $keys = array(
   	'CONFIG_PHP', 'CONFIG_CONF', 'BASE_DIRECTORY', 'FILES_BASE_DIR_NAME', 'EMAIL_USE_ANGLE_BRACKETS',
   	'ALLOW_CUSTOM_DEBUGGING', 'ADO_DIR', 'DATABASE_TYPE', 'SEQUENCE_SCHEMA', 'SHARED_SCHEMA', 'DEFAULT_SCHEMA',
   	'VERSION_TYPE', 'DEV_ITEM_SEND_EMAIL', 'EMAIL_STRICT_VERIFICATION', 'GENEPORT4_TIMEOUT',
   	'MAX_APACHE_CHILD_MEMORY', 'IS_DEVELOPMENT', 'IS_QA', 'IS_RELEASE', 'IS_DEMO',
   	'VERSION' );
   	
   	foreach ( $keys as $curKey )
   	{
   		  print '[' . $curKey . '] = "' . $constants{ $curKey } . '"' . "<br />\n";
   	}
   	exit;
}

//========================================================================

?>