USE bugport;

CREATE TABLE tablecaching (
   tableName VARCHAR(100) NOT NULL ,
   date_modified DATETIME NOT NULL ,
   UNIQUE ( tableName ),
PRIMARY KEY ( tableName ) );

CREATE TABLE state (
	state_id INT NOT NULL AUTO_INCREMENT,
	name VARCHAR(255) ,
	color VARCHAR(20) ,
 PRIMARY KEY (state_id));
INSERT INTO state ( state_id, name, color ) VALUES ( 200, 'Submitted - New', 'green' );
INSERT INTO state ( state_id, name, color ) VALUES ( 201, 'Submitted - More Info. Given', 'green' );
INSERT INTO state ( state_id, name, color ) VALUES ( 202, 'Submitted - ReOpened', 'green' );
INSERT INTO state ( state_id, name, color ) VALUES ( 210, 'Under Development - Assigned', 'blue' );
INSERT INTO state ( state_id, name, color ) VALUES ( 211, 'Under Development - More Info. Given', 'blue' );
INSERT INTO state ( state_id, name, color ) VALUES ( 212, 'Under Development - Fix Failed', 'blue' );
INSERT INTO state ( state_id, name, color ) VALUES ( 220, 'Verification Requested', 'red' );
INSERT INTO state ( state_id, name, color ) VALUES ( 230, 'Bug Incomplete - Designer Needs More Info', 'red' );
INSERT INTO state ( state_id, name, color ) VALUES ( 231, 'Bug Incomplete - Not Reproducible', 'red' );
INSERT INTO state ( state_id, name, color ) VALUES ( 232, 'Bug Incomplete - Developer Needs More Info', 'red' );
INSERT INTO state ( state_id, name, color ) VALUES ( 240, 'Closed - Fixed', 'black' );
INSERT INTO state ( state_id, name, color ) VALUES ( 241, 'Closed - Duplicate', 'black' );
INSERT INTO state ( state_id, name, color ) VALUES ( 242, 'Closed - Will Not Implement', 'black' );
INSERT INTO state ( state_id, name, color ) VALUES ( 243, 'Closed - Errata', 'black' );
INSERT INTO state ( state_id, name, color ) VALUES ( 244, 'Closed - Task Completed', 'black' );
INSERT INTO state ( state_id, name, color ) VALUES ( 245, 'Closed - Not a Bug', 'black' );
INSERT INTO state ( state_id, name, color ) VALUES ( 203, 'Submitted - Reviewed', 'green' );
INSERT INTO state ( state_id, name, color ) VALUES ( 204, 'Submitted - Assigned', 'blue' );
INSERT INTO state ( state_id, name, color ) VALUES ( 246, 'Closed - Not Reproducible', 'black' );

CREATE TABLE usertype (
	usertype_id INT NOT NULL AUTO_INCREMENT,
	name VARCHAR(100) ,
 PRIMARY KEY (usertype_id));
INSERT INTO usertype ( usertype_id, name ) VALUES ( 2, 'Developer' );
INSERT INTO usertype ( usertype_id, name ) VALUES ( 4, 'Designer' );
INSERT INTO usertype ( usertype_id, name ) VALUES ( 7, 'Quality Assurance' );
INSERT INTO usertype ( usertype_id, name ) VALUES ( 112, 'QA Lead' );

CREATE TABLE iuser (
	user_id INT NOT NULL AUTO_INCREMENT,
	user_name VARCHAR(30) ,
	email VARCHAR(50) ,
	title BLOB ,
	first_name VARCHAR(50) ,
	last_name VARCHAR(50) ,
	address VARCHAR(100) ,
	address2 BLOB ,
	city VARCHAR(50) ,
	state VARCHAR(100) ,
	zipcode VARCHAR(16) ,
	phone VARCHAR(16) ,
	fax VARCHAR(16) ,
	password VARCHAR(20) ,
	company BLOB ,
	car VARCHAR(16) ,
	country VARCHAR(100) ,
	phone2 VARCHAR(50) ,
	phone3 VARCHAR(20) ,
	currentProject_id INT NOT NULL default '1',
	isAdmin tinyint(4) NOT NULL default '0',
	notes BLOB ,
 PRIMARY KEY (user_id));
INSERT INTO iuser (
   user_id,
   user_name,
   email,
   title,
   first_name,
   last_name,
   address,
   address2,
   city,
   state,
   zipcode,
   phone,
   fax,
   password,
   company,
   car,
   country,
   phone2,
   phone3,
   currentProject_id,
   notes,
   isAdmin )
VALUES (
   1,
   'designer',
   'designer@null.org',
   '',
   'Designer',
   'User',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   'not used by SSL auth',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   1,
   'unused',
   1 );
INSERT INTO iuser (
   user_id,
   user_name,
   email,
   title,
   first_name,
   last_name,
   address,
   address2,
   city,
   state,
   zipcode,
   phone,
   fax,
   password,
   company,
   car,
   country,
   phone2,
   phone3,
   currentProject_id,
   notes,
   isAdmin )
VALUES (
   2,
   'tester',
   'tester@null.org',
   '',
   'Tester',
   'User',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   'not used by SSL auth',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   1,
   'unused',
   0 );
INSERT INTO iuser (
   user_id,
   user_name,
   email,
   title,
   first_name,
   last_name,
   address,
   address2,
   city,
   state,
   zipcode,
   phone,
   fax,
   password,
   company,
   car,
   country,
   phone2,
   phone3,
   currentProject_id,
   notes,
   isAdmin )
VALUES (
   3,
   'developer',
   'developer@null.org',
   '',
   'Developer',
   'User',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   'not used by SSL auth',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   1,
   'unused',
   0 );
INSERT INTO iuser (
   user_id,
   user_name,
   email,
   title,
   first_name,
   last_name,
   address,
   address2,
   city,
   state,
   zipcode,
   phone,
   fax,
   password,
   company,
   car,
   country,
   phone2,
   phone3,
   currentProject_id,
   notes,
   isAdmin )
VALUES (
   4,
   'qalead',
   'qalead@null.org',
   '',
   'QA Lead',
   'User',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   'not used by SSL auth',
   'unused',
   'unused',
   'unused',
   'unused',
   'unused',
   1,
   'unused',
   0 );

CREATE TABLE project (
	project_id INT NOT NULL  AUTO_INCREMENT,
	name VARCHAR(100) ,
	description LONGBLOB ,
	doc_link BLOB ,
	features Bit ,
	version VARCHAR(100) ,
	full_name VARCHAR(200) ,
	image_html BLOB ,
	hasdemo INT ,
	ispublic INT ,
	requirements BLOB ,
	main_features BLOB ,
	defaultTester_id INT NOT NULL ,
 PRIMARY KEY (project_id));
INSERT INTO project (
   project_id,
   name,
   description,
   doc_link,
   features,
   version,
   full_name,
   image_html,
   hasdemo,
   ispublic,
   requirements,
   defaultTester_id,
   main_features )
VALUES (
   1,
   'Example Project',
   'unused',
   '',
   0,
   'unused',
   'unused',
   'unused',
   0,
   0,
   'unused',
   1,
   'unused' );

CREATE TABLE severity (
	severity_id INT NOT NULL AUTO_INCREMENT,
	name VARCHAR(50) ,
	INDEX AI_severity_id (severity_id),
 PRIMARY KEY (severity_id));
INSERT INTO severity ( severity_id, name ) VALUES ( 5, '5 - Critical' );
INSERT INTO severity ( severity_id, name ) VALUES ( 4, '4 - Important' );
INSERT INTO severity ( severity_id, name ) VALUES ( 3, '3 - Medium' );
INSERT INTO severity ( severity_id, name ) VALUES ( 2, '2 - Low' );
INSERT INTO severity ( severity_id, name ) VALUES ( 1, '1 - Cosmetic' );

CREATE TABLE platform (
	platform_id INT NOT NULL AUTO_INCREMENT,
	architecture VARCHAR(100) ,
	architecture_desc BLOB ,
	os VARCHAR(100) ,
	isClient Tinyint NOT NULL ,
	os_desc BLOB ,
	INDEX AI_platform_id (platform_id),
 PRIMARY KEY (platform_id));
INSERT INTO platform ( platform_id, architecture, architecture_desc, os, isClient, os_desc ) VALUES ( 1, 'Sparc', 'Sun\'s Proprietary hardware', 'Solaris 9', 0, 'Sun OS 5.9' );
INSERT INTO platform ( platform_id, architecture, architecture_desc, os, isClient, os_desc ) VALUES ( 2, 'x86', '', 'Win2000 Professional', 1, '' );

CREATE TABLE report (
	report_id INT NOT NULL AUTO_INCREMENT,
	reporttype_id INT NOT NULL ,
	project_id INT NOT NULL ,
	state_id INT NOT NULL ,
	severity_id INT,
	date_in DATETIME ,
	report TEXT ,
	submitter_id INT NOT NULL ,
	designer_id INT ,
	developer_id INT ,
	tester_id INT ,
	assigneddate DATETIME ,
	develplan TEXT ,
	testhours DECIMAL(5,3) ,
	esttesthours DECIMAL(5,3) ,
	codehours DECIMAL(5,3) ,
	estcodehours DECIMAL(5,3) ,
	mischours DECIMAL(5,3) ,
	estmischours DECIMAL(5,3) ,
	designhours DECIMAL(5,3) ,
	fixeddate DATETIME ,
	fixednotes TEXT ,
	priority_id INT NOT NULL ,
	frequency_id INT,
	duedate DATETIME ,
	subject TEXT ,
	repsteps TEXT ,
	date_state DATETIME ,
	subproject_id INT NOT NULL ,
	category_id INT NOT NULL ,
	initClientVersion_id INT NOT NULL ,
	clientPlatform_id INT NOT NULL ,
	clientType_id INT NOT NULL ,
	initServerVersion_id INT NOT NULL ,
	serverInstance_id INT NOT NULL ,
	serverPlatform_id INT NOT NULL ,
	clientFixedVersion_id INT,
	serverFixedVersion_id INT,
	instance_id INT NOT NULL ,
	UNIQUE (report_id),
	INDEX AI_report_id (report_id),
 PRIMARY KEY (report_id));

CREATE TABLE attachment (
   attachment_id INT NOT NULL AUTO_INCREMENT,
   filename VARCHAR( 255 ) NOT NULL,
   date_in DATETIME NOT NULL,
   user_id INT( 11 ) NOT NULL,
   description MEDIUMBLOB,
   report_id INT ( 11 ) NOT NULL,
   INDEX AI_attachment_id ( attachment_id ),
   PRIMARY KEY (attachment_id));

CREATE TABLE comment (
	comment_id INT NOT NULL AUTO_INCREMENT,
	comments TEXT ,
	date_in DATETIME ,
	report_id INT NOT NULL ,
	user_id INT NOT NULL ,
	commenttype_id INT NOT NULL ,
	INDEX AI_comment_id (comment_id),
 PRIMARY KEY (comment_id));

CREATE TABLE commenttype (
	commenttype_id INT NOT NULL AUTO_INCREMENT,
	name VARCHAR(200) ,
	color VARCHAR(20) ,
	INDEX AI_commenttype_id (commenttype_id),
 PRIMARY KEY (commenttype_id));
INSERT INTO commenttype ( commenttype_id, name, color ) VALUES ( 1, 'QA Comment', 'dd0000' );
INSERT INTO commenttype ( commenttype_id, name, color ) VALUES ( 2, 'Design Alert', 'dd0000' );
INSERT INTO commenttype ( commenttype_id, name, color ) VALUES ( 3, 'Files Modified', '6C9D40' );
INSERT INTO commenttype ( commenttype_id, name, color ) VALUES ( 4, 'More Information', '73C488' );
INSERT INTO commenttype ( commenttype_id, name, color ) VALUES ( 5, 'Development Comment', '00B098' );
INSERT INTO commenttype ( commenttype_id, name, color ) VALUES ( 6, 'Design Comment', '00A9EB' );
INSERT INTO commenttype ( commenttype_id, name, color ) VALUES ( 7, 'Other', 'aaaaaa' );
INSERT INTO commenttype ( commenttype_id, name, color ) VALUES ( 8, 'Steps to Reproduce', '0071BC' );
INSERT INTO commenttype ( commenttype_id, name, color ) VALUES ( 9, 'More Information Needed', 'F26935' );
INSERT INTO commenttype ( commenttype_id, name, color ) VALUES ( 10, 'Bug Fixed Failed', 'FCB13A' );
INSERT INTO commenttype ( commenttype_id, name, color ) VALUES ( 11, 'Reason Closed', 'E3AB02' );
INSERT INTO commenttype ( commenttype_id, name, color ) VALUES ( 12, 'Reason Reopened', 'E3AB02' );

CREATE TABLE priority (
	priority_id INT NOT NULL AUTO_INCREMENT,
	name VARCHAR(50) ,
	INDEX AI_priority_id (priority_id),
 PRIMARY KEY (priority_id));
INSERT INTO priority ( priority_id, name ) VALUES ( 6, '6 - Very Urgent' );
INSERT INTO priority ( priority_id, name ) VALUES ( 5, '5 - Urgent' );
INSERT INTO priority ( priority_id, name ) VALUES ( 4, '4 - High' );
INSERT INTO priority ( priority_id, name ) VALUES ( 3, '3 - Medium' );
INSERT INTO priority ( priority_id, name ) VALUES ( 2, '2 - Low' );
INSERT INTO priority ( priority_id, name ) VALUES ( 1, '1 - Very Low' );

CREATE TABLE instance (
	instance_id INT NOT NULL AUTO_INCREMENT,
	name VARCHAR(100) NOT NULL ,
	project_id INT NOT NULL ,
	UNIQUE (instance_id),
	Index AI_instance_id (instance_id),
 PRIMARY KEY (instance_id));
INSERT INTO instance ( instance_id, name, project_id ) VALUES ( 1, 'Example Project Instance 1', 1 );

CREATE TABLE frequency (
	frequency_id INT NOT NULL AUTO_INCREMENT,
	name VARCHAR(50) ,
	INDEX AI_frequency_id (frequency_id),
 PRIMARY KEY (frequency_id));
INSERT INTO frequency ( frequency_id, name ) VALUES ( 1, '1 - Almost Never Visible' );
INSERT INTO frequency ( frequency_id, name ) VALUES ( 2, '2 - Rarely Visible' );
INSERT INTO frequency ( frequency_id, name ) VALUES ( 3, '3 - Occasionally Visible' );
INSERT INTO frequency ( frequency_id, name ) VALUES ( 4, '4 - Frequently Visible' );
INSERT INTO frequency ( frequency_id, name ) VALUES ( 5, '5 - Always Visible' );

CREATE TABLE relatedbugs (
	report_id INT NOT NULL ,
	related_id INT NOT NULL );

CREATE TABLE reporttype (
	reporttype_id INT NOT NULL AUTO_INCREMENT,
	name VARCHAR(200) ,
	UNIQUE (reporttype_id),
	INDEX AI_reporttype_id (reporttype_id),
 PRIMARY KEY ( reporttype_id ) );
INSERT INTO reporttype ( reporttype_id, name ) VALUES ( 1, 'Bug' );
INSERT INTO reporttype ( reporttype_id, name ) VALUES ( 2, 'Feature' );
INSERT INTO reporttype ( reporttype_id, name ) VALUES ( 3, 'Task' );

CREATE TABLE version (
	version_id INT NOT NULL AUTO_INCREMENT,
	name VARCHAR(200) NOT NULL ,
	project_id INT NOT NULL ,
	isClient Tinyint NOT NULL  DEFAULT 1 ,
	date_in DATETIME ,
	UNIQUE (version_id),
	INDEX AI_version_id (version_id),
 PRIMARY KEY (version_id));

CREATE TABLE category (
	category_id INT NOT NULL AUTO_INCREMENT,
	project_id INT NOT NULL ,
	name VARCHAR(100) NOT NULL ,
	UNIQUE (category_id),
	INDEX AI_category_id (category_id),
 PRIMARY KEY (category_id));
INSERT INTO category ( category_id, project_id, name ) VALUES ( 1, 1, 'Example Category' );

CREATE TABLE subproject (
	subproject_id INT NOT NULL AUTO_INCREMENT,
	name VARCHAR(100) NOT NULL ,
	project_id INT NOT NULL ,
	UNIQUE (subproject_id),
	INDEX AI_subproject_id (subproject_id),
 PRIMARY KEY (subproject_id));
INSERT INTO subproject ( subproject_id, project_id, name ) VALUES ( 1, 1, 'Example Subproject' );

CREATE TABLE type (
	type_id INT NOT NULL AUTO_INCREMENT,
	name VARCHAR(100) ,
	project_id INT NOT NULL ,
	UNIQUE (type_id),
	INDEX AI_type_id (type_id),
 PRIMARY KEY (type_id));
INSERT INTO type ( type_id, name, project_id ) VALUES ( 1, 'Example Client Type', 1 );

CREATE TABLE user_project_usertype (
	project_id INT NOT NULL ,
	user_id INT NOT NULL ,
	usertype_id INT NOT NULL );
INSERT INTO user_project_usertype ( project_id, user_id, usertype_id ) VALUES ( 1, 1, 2 );
INSERT INTO user_project_usertype ( project_id, user_id, usertype_id ) VALUES ( 1, 1, 4 );
INSERT INTO user_project_usertype ( project_id, user_id, usertype_id ) VALUES ( 1, 2, 7 );
INSERT INTO user_project_usertype ( project_id, user_id, usertype_id ) VALUES ( 1, 3, 2 );
INSERT INTO user_project_usertype ( project_id, user_id, usertype_id ) VALUES ( 1, 4, 7 );
INSERT INTO user_project_usertype ( project_id, user_id, usertype_id ) VALUES ( 1, 4, 112 );

CREATE TABLE `stathistory` (
  `stathistory_id` int(11) NOT NULL auto_increment,
  `date_in` datetime NOT NULL default '0000-00-00 00:00:00',
  `value` varchar(100) NOT NULL default '',
  `count` varchar(100) NOT NULL default '',
  `project_id` int(11) NOT NULL default '0',
  `statcolumn_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`stathistory_id`),
  UNIQUE KEY `stathistory_id` (`stathistory_id`),
  KEY `AI_stathistory_id` (`stathistory_id`)
);


CREATE TABLE `statcolumn` (
  `statcolumn_id` int(11) NOT NULL default '0',
  `viewClass` char(255) default '',
  `name` char(255) NOT NULL default ''
) ;

insert into statcolumn values ( 1, 'Bugs.State', 'state_id');
insert into statcolumn values (  4 , 'Bugs.ReportType' , 'reporttype_id');
insert into statcolumn values (  5 , 'Bugs.Version'    , 'initClientVersion_id');
insert into statcolumn values (    6 , 'Bugs.Platform'   , 'clientPlatform_id');
insert into statcolumn values (    7 , 'Bugs.Severity'   , 'severity_id');
insert into statcolumn values (  24 , 'Bugs.Category'   , 'category_id');
insert into statcolumn values (   9 , 'Shared.User'     , 'submitter_id');
insert into statcolumn values (  10 , 'Shared.User'     , 'designer_id');
insert into statcolumn values (  11 , 'Shared.User'     , 'developer_id');
insert into statcolumn values (  12 , 'Shared.User'     , 'tester_id');
insert into statcolumn values (  13 , 'Bugs.Priority'   , 'priority_id');
insert into statcolumn values (  14 , 'Bugs.Frequency'  , 'frequency_id');
insert into statcolumn values (  15 , 'Bugs.Version'    , 'serverFixedVersion_id');
insert into statcolumn values (  16 , 'Bugs.Version'    , 'clientFixedVersion_id');
insert into statcolumn values (  19 , 'Bugs.ClientType' , 'clientType_id');
insert into statcolumn values (  20 , 'Bugs.Platform'   , 'serverPlatform_id');
insert into statcolumn values (  23 , 'Bugs.Subproject' , 'subproject_id');

Create table config (
	config_id Int NOT NULL AUTO_INCREMENT,
	typeName Varchar(100) NOT NULL,
	varName Varchar(100) ,
	description Text ,
	value Text,
	user_id Int NOT NULL,
	UNIQUE (config_id),
	Index AI_config_id (config_id),
 Primary Key (config_id));

CREATE FULLTEXT INDEX report_fulltext
ON report (report,develplan,fixednotes,repsteps,subject);
CREATE FULLTEXT INDEX comment_fulltext
ON comment (comments);
CREATE INDEX comment_report_id
ON comment (report_id);
CREATE INDEX relatedbugs_report_id
       ON relatedbugs (report_id);
CREATE INDEX report_project_id
       ON report (project_id);
CREATE INDEX report_submitter_id
       ON report (submitter_id);
CREATE INDEX report_tester_id
       ON report (tester_id);
CREATE INDEX report_designer_id
       ON report (designer_id);
CREATE INDEX report_developer_id
       ON report (developer_id);
CREATE INDEX report_state_id
       ON report (state_id);
CREATE INDEX report_priority_id
       ON report (priority_id);