#!/bin/sh
#
# =========================================================================
# Copyright (c) 2003, Josh Glover <jmglov@jmglov.net>
#
# LICENCE:
#
#   This file is distributed under the terms of the BSD License, version
#   2. See the COPYING file, which should have been distributed with this
#   file, for details. If you did not receive the COPYING file, see:
#
#   http://www.jmglov.net/opensource/licences/bsd.txt
#
# disable-userpriv.sh
#
# DESCRIPTION:
#
#   Disables the Portage 'userpriv' feature, which is necessary from time
#   to time due to a bug in the webapp-apache eclass.
#
# USAGE:
#
#   disable-userpriv.sh
#
#   Make sure to run as root! (e.g. 'sudo ./disable-userpriv.sh')
#
# EXAMPLES:
#
#   disable-userpriv.sh
#
# DEPENDENCIES:
#
#   None
#
# TODO:
#
#   - Nothing, this code is perfect
#
# MODIFICATIONS:
#
#   Josh Glover <jmglov@jmglov.net> (2003/12/04): Initial revision
# =========================================================================

if grep '^FEATURES=.\+userpriv' /etc/make.conf >/dev/null 2>&1; then
  sudo sed -i.ORIG -e 's/^FEATURES=\(.\+\)userpriv\(.\+\)$/FEATURES=\1\2/'\
           /etc/make.conf
fi
