<?php

define( 'CLASS_DIR', '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'php_classes' );
define( 'IS_GENEPORT4_SCRIPT', true );
require_once( CLASS_DIR . DIRECTORY_SEPARATOR . 'Libraries' . DIRECTORY_SEPARATOR . 'importLibrary.php' );

primeImport();

runLightStartUpProcesses();

//========================================================================

define( 'REVIEW', true );
define( 'MAIN_SCHEMA2', DEFAULT_SCHEMA );
define( 'SHARED_SCHEMA2', SHARED_SCHEMA );

//========================================================================

function getDefaultSubprojectID( $dbcon, $projectID )
{
   static $stmt;
   if ( is_null( $stmt ) )
   {
      $stmt = $dbcon->Prepare(
         'SELECT subproject_id FROM ' . MAIN_SCHEMA2 . 'subproject WHERE project_id = ?' );
   }

   $subprojectIDs = $dbcon->GetCol( $stmt, array( $projectID ) );
   if ( empty( $subprojectIDs ) ) $subprojectIDs = array();

   switch ( count( $subprojectIDs ) )
   {
      case 0:
      unreachablePoint( 'Project: ' . $projectID );

      case 1:
      return $subprojectIDs[ 0 ];

      default:
      unreachablePoint( 'Project: ' . $projectID );
   };
}

//========================================================================

function fixSubprojects( $dbcon, $projectID )
{
   $subprojectID = getDefaultSubprojectID( $dbcon, $projectID );

   static $stmt;
   if ( is_null( $stmt ) )
   {
      $stmt = $dbcon->Prepare(
         'SELECT report_id ' .
         'FROM ' . MAIN_SCHEMA2 . 'report LEFT JOIN ' . MAIN_SCHEMA2 . 'subproject ON report.subproject_id = subproject.subproject_id ' .
         'WHERE subproject.name IS NULL ' .
         'AND report.project_id = ?' );
   }

   $reportIDs = $dbcon->GetCol( $stmt, array( $projectID ) );
   if ( empty( $reportIDs ) ) $reportIDs = array();

   print $dbcon->ErrorMsg() . BR_NL;

   print 'Project: ' . $project_id . BR_NL;

   if ( REVIEW )
   {
      static $stmt3;
      if ( is_null( $stmt3 ) )
      {
         $stmt3 = $dbcon->Prepare(
            'SELECT subproject_id FROM ' . MAIN_SCHEMA2 . 'report WHERE report_id = ?' );
      }
   }
   else
   {
      static $stmt2;
      if ( is_null( $stmt2 ) )
      {
         $stmt2 = $dbcon->Prepare(
            'UPDATE ' . MAIN_SCHEMA2 . 'report SET subproject_id = ? WHERE report_id = ?' );
      }
   }

   foreach ( $reportIDs as $curReportID )
   {
      if ( REVIEW )
      {
         $oldSubprojectID = $dbcon->GetOne( $stmt3, array( $curReportID ) );

         print 'Project: ' . $projectID . ' | Report: ' . $curReportID .
            ' | New Subproject: ' . $subprojectID .
            ' | Old Subproject : ' . $oldSubprojectID . BR_NL;
      }
      else
      {
         $dbcon->Execute( $stmt2, array( $subprojectID, $curReportID ) );
      }
   }
}

//========================================================================

importClass( 'Database.DBConnectionProvider' );
$dbcon =& DBConnectionProvider::getConnection();

$projectIDs = $dbcon->GetCol( 'SELECT project_id FROM ' . SHARED_SCHEMA2 . 'project' );

print $dbcon->ErrorMsg() . BR_NL;

print_r( $projectIDs );

foreach ( $projectIDs as $curProjectID )
{
   fixSubprojects( $dbcon, $curProjectID );
}

//========================================================================

runLightEndProcesses();

//========================================================================

?>