<?php

/*
AForm
$Author: dougqh $
$Revision: 1.16 $
$Date: 2004/02/09 15:04:29 $
$Log: AForm.php,v $
Revision 1.16  2004/02/09 15:04:29  dougqh
- 4041

Revision 1.15  2004/01/13 15:14:48  dougqh
- Added method _showCancel and used it in getHTML.

Revision 1.14  2004/01/08 15:27:31  dougqh
- Fixed a bug with GET handling

Revision 1.13  2004/01/08 14:00:03  dougqh
- Removed some debugging

Revision 1.12  2004/01/07 22:19:12  millz
- refactor

Revision 1.11  2004/01/07 21:46:38  dougqh
- Better message in unreachablePoint call

Revision 1.10  2004/01/06 21:57:20  millz
- added isFormEnabled

Revision 1.9  2004/01/06 17:43:05  millz
- added getTarget

Revision 1.8  2003/12/30 15:42:24  dougqh
- Investigating 3925

Revision 1.7  2003/12/18 20:44:00  dougqh
- Updated to work under PHP 4.2

Revision 1.6  2003/12/10 22:01:24  millz
- made submit button disabling optional with disableSubmit

Revision 1.5  2003/12/05 20:19:16  millz
- adding disable

Revision 1.4  2003/12/03 21:11:37  millz
- added getSubmitText

Revision 1.3  2003/08/13 21:45:29  dougqh
- Using the new KeyManager class - part of 3297

Revision 1.2  2003/07/23 21:57:42  dougqh
- Removed final specification from _getActionURL

Revision 1.1  2003/07/09 19:55:42  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.AView' );

//========================================================================

/*!
@class AForm
@abstract -
*/

importClass( 'Common.Utilities.FormSubmitMethod' );

define( 'FORM_AUTH_KEY_PREFIX', 'form_auth_key' );
define( 'FORM_AUTH_KEY_VARIABLE', '9jfd45' );
define( 'SUBMIT_BUTTON_ID', 'submitButton' );

define( 'DISABLE_FORM_FUNC_NAME', 'disableForm' );

class AForm extends AView
{

//========================================================================

   /*!
   @function AForm()
   @discussion - constructs a new AForm object
   @result - constructs a new AForm object
   */

   function AForm()
   {
      $this->AView();

      $this->showErrors = false;
   }

//========================================================================

    /*!
    @funciton _getTarget()
    */
    function _getTarget()
    {
        return '';
    }

//========================================================================


   /*!
   @funciton _isFormEnabled()
   @discussion - whether this form is enabled
   @result - returns a boolean
   */
    function _isFormEnabled()
    {
        return true;
    }

//========================================================================

   /*!
   @funciton isUploader()
   @discussion - indicates if this Form has file upload fields
      - default implementation always returns false
   @result - returns a boolean
   */

   function isUploader()
   {
      return false;
   }

//========================================================================

   /*!
   @function allowDuplicateSubmissions()
   @discussion - indicates if this AForm allows duplicate submissions

      Default implementation always returns false.  A child class can
      override this behavior if it is not desired.
   @result - returns a boolean
   */

   function allowDuplicateSubmissions()
   {
      return false;
   }

//========================================================================

   /*!
   @function getMethod()
   @discussion - provides the method used to submit this form
      - default implementation returns GET

      Note, if isUploader returns true this method will return POST
      regardless of the value returned _getValue
   @result - returns GET or POST
   */

   /* final */
   function getMethod()
   {
      if ( $this->isUploader() )
      {
         return POST;
      }
      else
      {
         return $this->_getMethod();
      }
   }

//========================================================================

   /*!
   @function useRedirect()
   @discussion - indicates if the Controller should redirect to the
      new View after processing this Form

      Default implementation always returns true.
   */
   function useRedirect()
   {
      return true;
   }

//========================================================================

   /*!
   @function _getMethod()
   @discussion - provides the method used to submit this form
      - default implementation returns GET
   @result - returns GET or POST
   */

   function _getMethod()
   {
      return GET;
   }

//========================================================================

   /*!
   @function getHTML()
   @discussion - produces the HTML for this AForm
   @result - returns a String of HTML
   */

   function getHTML()
   {
      $hidden = '';

// this does not work, trying to disable all form elements on this jsfunc call
//      static $disableMethodAdded;
//      if( !isset( $disableMethodAdded ) )
//      {
//         importClass( 'HTMLComponents.Scripting.ScriptFunction' );
//
//         $jsFunc =& ScriptFunction::getJavaScriptFunction( DISABLE_FORM_FUNC_NAME, new_array('form') );
//         $jsFunc->addCode( '  for( i = form.elements.length; i >= 0; i-- ) { form.elements[i].disabled = true; window.alert(form.elements[i]); } ' );
//
//         importClass( 'HTMLComponents.Scripting.ScriptBlock' );
//         $jsBlock =& ScriptBlock::createJavaScriptBlock();
//         $jsBlock->addFunction( $jsFunc );
//         $jsBlock->addToPageHead();
//      }

      if ( $this->getMethod() == GET )
      {
         $methodString = 'GET';
      }
      else // if ( $this->getMethod() == POST )
      {
         $methodString = 'POST';
      }

      $actionURL = getBaseURLFromURL( $this->_getActionURL() );

      foreach ( getParametersFromURL( $this->_getActionURL() ) as $name => $value )
      {
         $hidden .= '<input type="hidden" name="' . $name . '" value="' . $value . '" />' . NL;
      }

      if ( ! $this->allowDuplicateSubmissions() )
      {
         $hidden .= '<input type="hidden" name="' .
            FORM_AUTH_KEY_VARIABLE . '" value="' . $this->_createAuthenticationKey() . '" />';
      }

      if( $this->isUploader() )
      {
         $multiPart = ' enctype="multipart/form-data" ';
      }
      else
      {
         $multiPart = '';
      }

      $html = '<form ';

      if ( $this->disableSubmit() && $this->_isFormEnabled() )
      {
         $html .= 'onSubmit="window.document.forms.'.$this->getName().
         '.'.SUBMIT_BUTTON_ID.'.disabled=true; window.document.forms.'.$this->getName().
         '.'.SUBMIT_BUTTON_ID.'.value=\''.$this->getSubmittingText().'...'.
         '\'; return true;" ';
      }

      $target = $this->_getTarget();

      if( $target != '' )
      {
        $html .=  'target="' . $target . '" ';
      }

      $html .=  'name="' . $this->getName() . '" ';
      $html .= $multiPart;

      if ( $this->_isFormEnabled() )
      {
         $html .= 'action="' . $actionURL . '" ';
      }

      $html .= 'method="' . $methodString . '">' . NL;
      $html .= $hidden;

      if ( $this->showErrors )
      {
         importClass( 'HTMLComponents.Text' );
         $text =& new Text( $this->_getErrors() );
         $html .= '<font color=#ff0000>';
         $html .= $text->getHTML() . BR;
         $html .= '</font>';
      }

      $html .= $this->_getBodyHTML();
      $html .= '<br />';

      if( $this->_isFormEnabled() )
      {
         $html .= '<input type="submit" id="'.SUBMIT_BUTTON_ID.'"  value="'.$this->getSubmitText().'" />';
         if ( $this->_showCancel() )
         {
            $html .= '<input type="button" value="Cancel" onclick="window.history.go(-1);" />';
         }
      }

      $html .= '</form>';

      return $html;
   }

//========================================================================

   /*!
   @function disableSubmit()
   @discussion -
   */
    function disableSubmit()
    {
        return false;
    }

//========================================================================

   /*!
   @function getSubmitText()
   @discussion - returns text to use for submit button
   @result - returns a String
   */
   function getSubmitText()
   {
      return 'Submit';
   }

//========================================================================

   /*!
   @function getSubmittingText()
   @discussion - returns text to use for submit button during the submission itself (after the user submits)
   @result - returns a String
   */
   function getSubmittingText()
   {
      return 'Submitting';
   }

//========================================================================

   /*!
   @function getName()
   @discussion - provides a name for this form
      - default implementation just numbers each form as
         form0, form1, form2, etc ...
   @result - returns a String
   */

   function getName()
   {
      if ( ! isset( $this->formName ) )
      {
         static $formCount;

         if ( ! isset( $formCount ) )
         {
            $formCount = 0;
         }
         else
         {
            ++$formCount;
         }

         $this->formName = 'form' . $formCount;
      }

      return $this->formName;
   }

//========================================================================

   /*!
   @function _getActionURL()
   @discussion - provides the URL for the action of this Form
   */

   function _getActionURL()
   {
      importClass( 'BugUI.Controller' );
      return Controller::_getDisplayURL( $this, true );
   }

//========================================================================

   /*!
   @function _getBodyHTML()
   @discussion - provides the HTML for the body of the form - which does
      NOT include the form tags
   @result - returns a String of HTML
   */

   /* abstract function _getBodyHTML(); */

//========================================================================

   /*!
   @function execute()
   @discussion - called to execute this Form
   @result - returns an AView to display
   */

   function execute()
   {
      $this->_clearAuthenticationKey();

      $this->_execute();
   }

//========================================================================

   /*!
   @function _loadData()
   @discussion - called before _isValid to any loading of data that
      may be necessary
   */

   /* abstract function _loadData(); */

//========================================================================

   /*!
   @function isValid()
   @discussion - indicates if the Form data was valid
   @result - returns a boolean
   */

   /* final */
   function isValid()
   {
      if ( ! isset( $this->loadedData ) )
      {
         $this->_loadData();
      }

      $valid = $this->_isValid();

      if ( ! $valid ) $this->showErrors = true;

      return $valid;
   }

//========================================================================

   /*!
   @function _isValid()
   @discussion - indicates if the Form data was valid
      - default implementation always returns true
   @result - returns a boolean
   */

   function _isValid()
   {
      return true;
   }

//========================================================================

   /*!
   @function _getErrors()
   @discussion - if isValid returns false then this is called to get
      the appropriate error message

      Default _isValid is always true, so default implementation is
      unreachable.
   @result - returns a String
   */

   function _getErrors()
   {
      unreachablePoint( 'AForm->_getErrors is abstract' );
   }

//========================================================================

   /*!
   @function _execute()
   @discussion - called by execute if _isValid returns true
   */

   /* abstract function &_execute(); */

//========================================================================

   /*!
   @function getNextView()
   @discussion - provides the View to show after the AForm execution
      has been completed
   */

   /* abstract function getNextView(); */

//========================================================================

   /*!
   @function _showCancel()
   @discussion - indicates if this AForm should display the "Cancel"
      button
   @result - returns a boolean
   */
   function _showCancel()
   {
      return true;
   }

//========================================================================

   /*!
   @function useNextViewAfterDuplicateSubmission()
   @discussion - indicates if the View returned by getNextView
      should be displayed in the event of a duplicate submission

      Default implementation returns true.
   @result - returns a boolean
   */

   function useNextViewAfterDuplicateSubmission()
   {
      return true;
   }

//========================================================================

   /*!
   @function _getFormID()
   @discussion - provides an ID for this form derived via the class
      name and getParameters
   @result - returns a String
   */

   function _getFormID()
   {
      //the URL should be sufficient, since it should contain the
      //class name and all the parameters
      return $this->_getActionURL();
   }

//========================================================================

   /*!
   @function _createAuthenticationKey()
   @discussion - creates an authentication key for this form
   @result - returns a Stirng
   */

   function _createAuthenticationKey()
   {
      importClass( 'BugUI.KeyManager' );
      return KeyManager::registerKey( FORM_AUTH_KEY_PREFIX . $this->_getFormID() );
   }

//========================================================================

   /*!
   @function _clearAuthenticationKey()
   @discussion - clears the stored authentication key from the session
   */

   function _clearAuthenticationKey()
   {
      if ( isset( $_REQUEST{ FORM_AUTH_KEY_VARIABLE } ) )
      {
         importClass( 'BugUI.KeyManager' );
         KeyManager::clearKeyValue(
            FORM_AUTH_KEY_PREFIX . $this->_getFormID(),
            $_REQUEST{ FORM_AUTH_KEY_VARIABLE } );
      }
   }

//========================================================================

   /*!
   @function isAuthorizedSubmission()
   @discussion - indicates if the current form submission is allowable
   @result - returns a boolean
   */

   function isAuthorizedSubmission()
   {
      if ( $this->allowDuplicateSubmissions() )
      {
         return true;
      }
      else
      {
         importClass( 'BugUI.KeyManager' );
         return
            isset( $_REQUEST{ FORM_AUTH_KEY_VARIABLE } ) &&
            KeyManager::checkKeyValue(
               FORM_AUTH_KEY_PREFIX . $this->_getFormID(),
               $_REQUEST{ FORM_AUTH_KEY_VARIABLE } );
      }
   }

//========================================================================

};

?>