<?php

/*
ALightFormFieldForm
$Author: dougqh $
$Revision: 1.4 $
$Date: 2004/01/13 18:02:48 $
$Log: ALightFormFieldForm.php,v $
Revision 1.4  2004/01/13 18:02:48  dougqh
- ?

Revision 1.3  2004/01/07 22:19:03  millz
- refactor

Revision 1.2  2004/01/07 21:09:50  dougqh
- Correcting some oversights in my design

Revision 1.1  2004/01/07 19:55:09  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.AForm' );

//========================================================================

/*!
@class ALightFormFieldForm
@abstract -
*/

class ALightFormFieldForm extends AForm
{

//========================================================================

   /*!
   @function ALightFormFieldForm()
   @discussion - constructs a new ALightFormFieldForm object
   @result - constructs a new ALightFormFieldForm object
   */

   function ALightFormFieldForm()
   {
      $this->AForm();
   }

//========================================================================

   /*!
   @function _addError( $error )
   @param $error - a String
   @discussion - adds an error to the running list of problems
      with this ADevelopmentItem
   */

   function _addError( $error )
   {
      $this->errors .= $error . NL;
   }

//========================================================================

   /*!
   @function _getErrors()
   */

   function _getErrors()
   {
      //replace any double NLs with a single NL, just in case
      return str_replace( NL . NL, NL, $this->errors );
   }

//========================================================================

   /*!
   @function _loadData()
   @discussion - loads the form data for the specified fields

      This method will NOT throw an error if one of the fields
      does not exist.
   */

   function _loadData()
   {
      $this->loadedFieldsAreValid = true;
      $this->errors = '';

      $names = $this->getInputFieldNames();
      foreach( $names as $curName )
      {
         $field =& $this->getField( $curName );
         if ( $field !== NULL )
         {
            $field->loadFormData();
            if ( ! $field->isValid() )
            {
               $this->loadedFieldsAreValid = false;
               $this->_addError( $field->getErrors() );
            }
         }
      }
   }


//========================================================================

   /*!
   @function _isValid()
   @discussion - runs checks to ensure that all fields/columns are valid for this item
   @result - bool
   */

   function _isValid()
   {
      return
         $this->loadedFieldsAreValid &&
         $this->_areAdditionalChecksValid();
   }

//========================================================================

   /*!
   @function &getField( $name )
   @discussion - any field not listed in getInputFieldNames() will be disabled
      before it is returned by getField, since it canNOT be used for input
   */

   function &getField( $name )
   {
      if ( ! isset( $this->fieldsHash{ $name } ) )
      {
         if ( in_array( $name, $this->getInputFieldNames() ) )
         {
            $this->fieldsHash{ $name } =& $this->_createField( $name );
         }
         else
         {
            $tryAsPresentationOnly =
               ! method_exists( $this, 'getPresentationOnlyFieldNames' ) ||
               in_array( $name, $this->getPresentationOnlyFieldNames() );

            if ( $tryAsPresentationOnly )
            {
               $this->fieldsHash{ $name } =& $this->_createField( $name );
               if ( ! is_null( $this->fieldsHash{ $name } ) )
               {
                  $this->fieldsHash{ $name }->setEnabled( false );
               }
            }
            else
            {
               $this->fieldsHash{ $name } = NULL;
            }
         }
      }

      return $this->fieldsHash{ $name };
   }

//========================================================================

   /*!
   @function hasField( $name )
   */

   function hasField( $name )
   {
       return ! is_null( $this->getField( $name ) );
   }

//========================================================================

   /*!
   ABSTRACT
   @function getInputFieldNames()
   @discussion - list of Field whose values need to be loaded
   */

//========================================================================

   /*!
   @function getPresentationOnlyFieldNames()
   @discussion - used to check the correctness of other fields that
     may or may not exist - if not defined then _createField WILL
     be called when an unrecognized name is used
   */

   /* optional abstract getPresentationOnlyFieldNames() */

//========================================================================

   /*!
   @function &_createField( $name )
   @discussion - Constructs the corresponding ALightFormField with the
      appropriate isEnabled and isRequired status already set
   */

   /* abstract &_createField( $name ) */

//========================================================================

   /*!
   @function _areAdditionalChecksValid()
   */

   function _areAdditionalChecksValid()
   {
       return true;
   }

//========================================================================

};

?>