<?php

/*
AOperation
$Author: dougqh $
$Revision: 1.2 $
$Date: 2003/10/21 14:12:21 $
$Log: AOperation.php,v $
Revision 1.2  2003/10/21 14:12:21  dougqh
*** empty log message ***

Revision 1.1  2003/07/09 19:55:42  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.AHTMLComponent' );

//========================================================================

/*!
@class AOperation
@abstract - a class used to generate links to other actions
   Putting state in subclasses of AOperation is generally NOT a good idea.
*/

class AOperation extends AHTMLComponent
{

//========================================================================

   /*!
   @function AOperation()
   @discussion - constructs a new AOperation object
   @result - constructs a new AOperation object
   */

   function AOperation()
   {
      $this->AHTMLComponent();
   }

//========================================================================

   /*!
   @function getName()
   @discussion - provides a name for this Operation
   @result - returns a user presentable String
   */

   /* abstract function getName(); */

//========================================================================

   /*!
   @function &_getDefaultComponent()
   @discussion - provides the AHTMLComponent to use one is not
      explicitly provided to getLink

      Default implementation uses a Text object produced using
      getName.
   @result - returns an AHTMLComponent
   */

   function &_getDefaultComponent()
   {
      importClass( 'HTMLComponents.Text' );
      return new Text( $this->getName() );
   }

//========================================================================

   /*!
   @function getLink( [ $htmlComponent ] )
   @param $htmlComponent - an optional parameter specifying an HTMLComponent
      to use as the body for the returned Link
   @discussion - responds with a Link object that when triggered
      will execute this Operation

      If this Operation is not visible a NullLink object is returned.  If
      this Operation is visible, but not enabled then a disabled link
      is returned.
   @result - returns a Link object that when clicked triggers
      the execution of this operation
   */

   function &getLink( $htmlComponent = UNSPECIFIED )
   {
      $link =& $this->_getLink();

      if ( $this->isVisible() )
      {
         if ( $htmlComponent === UNSPECIFIED )
         {
            $link->setLinkBody(
               $this->_getDefaultComponent() );
         }
         else
         {
            $link->setLinkBody( $htmlComponent );
         }

         $link->setEnabled( $this->isEnabled() );
      }
      else
      {
         $link->setVisible( false );
      }

      return $link;
   }

//========================================================================

   /*!
   @function _getLink()
   @discussion - provides a Link with no body that triggers
      this Operation
   @result - returns a Link
   */

   /* abstract function &_getLink(); */

//========================================================================

   /*!
   @function getHTML()
   @discussion - uses the HTML from Link provided by getLink
   @result - returns a String of HTML
   */

   function getHTML()
   {
      $link =& $this->getLink();
      return $link->getHTML();
   }

//========================================================================

   /*!
   @function isEnabled()
   @discussion - indicates if this Operation should be enabled
   @result - returns a boolean
   */

   function isEnabled()
   {
      return true;
   }

//========================================================================

   /*!
   @function isVisible()
   @discussion - indicates if this Operation is visible
   @result - returns a boolean
   */

   function isVisible()
   {
      return true;
   }

//========================================================================

   /*!
   @function doRedirect()
   @discussion - triggers a redirect to the URL of this AOperation
   */

   function doRedirect()
   {
      //Only need the Link's URL not the HTMLComponent,
      //so calling _getLink instead of getLink is okay.

      if ( $this->isEnabled() && $this->isVisible() )
      {
         $link =& $this->_getLink();
         $url =& $link->getURL();

         $urlStr = $url->getAbsoluteURLString();

         if ( PAUSE_ON_REDIRECT )
         {
            print 'This page is for debugging purposes only.' . BR_NL;
            print BR_NL;
            print 'WAS going to redirect to... <a href="' . $urlStr . '">' . $urlStr . '</a>';
            exit;
         }
         else
         {
            header( 'Location: ' . $url->getAbsoluteURLString() );
         }
      }
   }

//========================================================================

};

?>