<?php

/*
AStatelessOperation
$Author: dougqh $
$Revision: 1.3 $
$Date: 2003/12/17 14:43:22 $
$Log: AStatelessOperation.php,v $
Revision 1.3  2003/12/17 14:43:22  dougqh
- Fixed bug _clearAuthKey

Revision 1.2  2003/08/13 21:46:02  dougqh
- Using the new KeyManager class - part of 3297

Revision 1.1  2003/07/09 19:55:42  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.AOperation' );

//========================================================================

define( 'OPERATION_AUTH_KEY_PREFIX', 'op_auth_key' );
define( 'OPERATION_AUTH_KEY_VARIABLE', 'fad4324' );

//========================================================================

/*!
@class AStatelessOperation
@abstract - acts by reading $_REQUEST{ CHANGE_PROJECT_FIELD_NAME }
*/

class AStatelessOperation extends AOperation
{

//========================================================================

   /*!
   @function AStatelessOperation()
   */

   function AStatelessOperation()
   {
      $this->AOperation();
   }

//========================================================================

   /*!
   @function &_getLink()
   */

   function &_getLink()
   {
      importClass( 'HTMLComponents.Links.ExternalLink' );
      importClass( 'BugUI.Controller' );
      $link =& new ExternalLink( $this->_getActionURL() );

      if ( ! $this->allowDuplicateSubmissions() )
      {
         $link->addParameter(
            OPERATION_AUTH_KEY_VARIABLE,
            $this->_createAuthenticationKey() );
      }

      return $link;
   }

//========================================================================

   /*!
   @function _getActionURL()
   */

   function _getActionURL()
   {
      return addParametersToURL(
         Controller::_getStatelssOperationURL( $this ),
         $this->getParameters() );
   }

//========================================================================

   /*!
   @function _getID()
   */

   function _getID()
   {
      //Can't use _getActionURL because it might change - just
      //use the class name and parameters
      //I'll abuse the addParametersToURL function; its ugly, but effective.

      return trim( addParametersToURL(
         get_class( $this ),
         $this->getParameters() ) );
   }

//========================================================================

   /*!
   @function createFromRequest()
   @discussion - called by Controller when this Operation is instantiated
      for execution
   @result - returns an AStatelessOperation
   */

   /* abstract static function &createFromRequest(); */

//========================================================================

   /*!
   @function execute()
   @discussion - executes the current operation
      Does checks to make sure isVisible and isEnabled are true
      then defers to _execute.
   */

   function execute()
   {
//      print getLocation() . BR_NL;
//
//      print getStringDepiction( $this->isAuthorizedSubmission() ) . BR_NL;
//      print getStringDepiction( $this->isVisible() ) . BR_NL;
//      print getStringDepiction( $this->isEnabled() ) . BR_NL;

      if (
         $this->isAuthorizedSubmission() &&
         $this->isVisible() &&
         $this->isEnabled() )
      {
         $this->_clearAuthenticationKey();

         $this->_execute();
      }
   }

//========================================================================

   /*!
   @function allowDuplicateSubmissions()
   @discussion - indicates if duplicate submissions are allowed
      Default implementation returns false.
   @result - returns a boolean
   */

   function allowDuplicateSubmissions()
   {
      return false;
   }

//========================================================================

   /*!
   @function _execute()
   @discussion - performs the actual activity of this Operation
   */

   /* abstract function _execute(); */

//========================================================================

   /*!
   @function getParameters()
   @discussion - provides any additional parameters needed by
      this AStatelessOperation
   */

   /* abstract function getParameters(); */

//========================================================================

   /*!
   @function _createAuthenticationKey()
   @discussion - creates an authentication key for this form
   @result - returns a Stirng
   */

   function _createAuthenticationKey()
   {
      importClass( 'BugUI.KeyManager' );
      return KeyManager::registerKey( OPERATION_AUTH_KEY_PREFIX . $this->_getID() );
   }

//========================================================================

   /*!
   @function _clearAuthenticationKey()
   @discussion - clears the stored authentication key from the session
   */

   function _clearAuthenticationKey()
   {
      if ( isset( $_REQUEST{ OPERATION_AUTH_KEY_VARIABLE } ) )
      {
         importClass( 'BugUI.KeyManager' );
         KeyManager::clearKeyValue(
             OPERATION_AUTH_KEY_PREFIX . $this->_getID(),
            $_REQUEST{ OPERATION_AUTH_KEY_VARIABLE } );
      }
   }

//========================================================================

   /*!
   @function isAuthorizedSubmission()
   @discussion - indicates if the current form submission is allowable
   @result - returns a boolean
   */

   function isAuthorizedSubmission()
   {
      if ( $this->allowDuplicateSubmissions() )
      {
         return true;
      }
      else
      {
         importClass( 'BugUI.KeyManager' );
         return
            isset( $_REQUEST{ OPERATION_AUTH_KEY_VARIABLE } ) &&
            KeyManager::checkKeyValue(
               OPERATION_AUTH_KEY_PREFIX . $this->_getID(),
               $_REQUEST{ OPERATION_AUTH_KEY_VARIABLE } );
      }
   }
//========================================================================

};

?>