<?php

/*
AView
$Author: dougqh $
$Revision: 1.2 $
$Date: 2004/01/13 18:57:59 $
$Log: AView.php,v $
Revision 1.2  2004/01/13 18:57:59  dougqh
- Added ability to change target window of getDisplayOperation.

Revision 1.1  2003/07/09 19:55:42  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.AHTMLComponent' );

//========================================================================

/*!
@class AView
@abstract -
*/

class AView extends AHTMLComponent
{

//========================================================================

   /*!
   @function AView()
   @discussion - constructs a new AView object
   @result - constructs a new AView object
   */

   function AView()
   {
      $this->AHTMLComponent();
   }

//========================================================================

   /*!
   @function getTitle()
   @discussion - provides a String containing the title of this View
   @result - returns a String
   */

   /* abstract function getTitle(); */

//========================================================================

   /*!
   @function getShortTitle()
   @discussion - provides an abbreviated title for this View
       - default implementation returns getTitle
   @result - returns a String
   */

   function getShortTitle()
   {
      return $this->getTitle();
   }

//========================================================================

   /*!
   @function getTitleImage()
   @discussion - provides a title image for this AView

      Default implementation tries to use a StaticInternalImage
      with the name <class>_title.jpg.
   @result - returns an Image
   */

   function &getTitleImage()
   {
      importClass( 'HTMLComponents.Images.StaticInternalImage' );
      return new StaticInternalImage(
         get_class( $this ) . '_title.jpg',
         $this->getTitle() );
   }

//========================================================================

   /*!
   @function getHTML()
   @discussion - provides a String of HTML that display the contents
      of this View
   @result - returns a String of HTML
   */

   /* abstract function getHTML(); */

//========================================================================

   /*!
   @function getContentType()
   @discussion - indicates the http content-type, such as text/html.
   @result - returns a string
   */

   function getContentType()
   {
      return 'text/html';
   }

//========================================================================

   /*!
   @function isEnabled()
   @discussion - indicates if this isEnabled at the current time
      Default implementation always returns true.
   @result - returns a boolean
   */

   function isEnabled()
   {
      return true;
   }

//========================================================================

   /*!
   @function getDisplayOperation( [ $target ] )
   @param $target - the window to target - if empty targets the current
      window
   @discussion - provides an AOperation that will display this
      View its executed
   @result - returns an AOperation
   */

   function &getDisplayOperation( $target = UNSPECIFIED )
   {
      importClass( 'BugUI.Operations.ViewOperation' );
      return new ViewOperation( $this, $target );
   }

//========================================================================

   /*!
   @function getParameters()
   @discussion - called by ViewOperation to determine if any additional
      parameters need to be added to the generated Link

      Default implementation returns an empty array.
   */

   function getParameters()
   {
      return array();
   }

//========================================================================

};

?>