<?php

/*
Controller
$Author: dougqh $
$Revision: 1.8 $
$Date: 2004/11/17 19:51:37 $
$Log: Controller.php,v $
Revision 1.8  2004/11/17 19:51:37  dougqh
- Using the new reflection library

Revision 1.7  2004/11/17 19:26:12  millz
new timer print

Revision 1.6  2004/04/01 22:06:48  millz
just some debug

Revision 1.5  2004/02/09 15:04:19  dougqh
- 4041

Revision 1.4  2003/12/30 15:37:22  dougqh
- Investigating 3925

Revision 1.3  2003/12/17 15:13:17  dougqh
- 3913

Revision 1.2  2003/12/17 14:41:25  dougqh
- nothing

Revision 1.1  2003/07/09 19:55:42  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

define( 'VIEW_PACKAGE', 'BugUI.Views.' );
define( 'VIEW_CLASS', 'view' );
define( 'IS_SUBMIT', 'submit' );

define( 'OPERATION_PACKAGE', 'BugUI.Operations.' );
define( 'OPERATION_CLASS', 'op' );

class Controller extends Object
{

//========================================================================

   /*!
   @function Controller()
   @discussion - constructs a controller object
   */

   function Controller()
   {
      $this->doRedirect = false;
      $this->start = getmicrotime();
      $this->Object();
   }

//========================================================================

   /*!
   @function getInstance()
   @discussion - provides the instance of Controller
   @result - returns a Controller
   */

   function &getInstance()
   {
      //standard static array idiom to avoid garbage collection
      static $instanceArray;

      if ( ! isset( $instanceArray ) )
      {
         $instanceArray = array();
         $instanceArray[ 0 ] =& new Controller();
      }
      
      return $instanceArray[ 0 ];
   }

//========================================================================

   /*!
   @function _executeOperation()
   @discussion - executes any other Operations
   */

   function _executeOperation()
   {
      if (
         isset( $_REQUEST{ OPERATION_CLASS } ) &&
         tryImportClass( OPERATION_PACKAGE . $_REQUEST{ OPERATION_CLASS } ) )
      {
         $this->doRedirect = true;

         $operation =& callStaticMethod(
            $_REQUEST{ OPERATION_CLASS },
            'createFromRequest',
            new_array() );

         //print_r( $operation );
         //print BR_NL;

         if ( ! is_null( $operation ) )
         {
            //AStatelessOperation::execute will NOT do anything if
            //isEnabled or isVisible are false, its rather inconsistent
            //with the way the AForms are handled, so one or the other
            //should be changed
            $operation->execute();
         }
      }
   }

//========================================================================

   /*!
   @function printHTML()
   @discussion - prints the html for the current view
      CanNOT name this print because print is a reserved word.
   */

   function printHTML()
   {
      $this->_executeOperation();

      $view =& $this->_getCurrentView();

        // print_r( $view );

      if ( $this->doRedirect )
      {
         //This is a little ugly, but it fixes a problem with
         //handling duplicate submissions of add forms
         $operation =& $view->getDisplayOperation();

//         $link =& $operation->getLink();
//         $url =& $link->getURL();
//         print 'Redirecting to ...' . $url->getURLString() . BR_NL;
//         exit;

         $operation->doRedirect();
      }

      importClass( 'BugUI.OtherComponents.Window' );
      
      if( $view->getContentType() == 'text/html' )
      {
         $window =& new Window( $view );
         print $window->getHTML();
         print '<font size=-1>Time Elapsed: ' . number_format( getmicrotime() - $this->start, 3 ) . ' secs - <a href="http://www.incogen.com/index.php?type=General&param=bugport">BugPort</a> is developed by <a href="http://www.incogen.com">INCOGEN</a></font>'. BR_NL;

      }
      else
      {
         header( 'Content-Type: '.$view->getContentType() );
         print $view->getHTML();
      }
   }

//========================================================================

   /*!
   @function _getCurrentView()
   @discussion - gets the current view.
   @return - returns a view object
   */

   function &_getCurrentView()
   {
      //print "[".tryImportClass( VIEW_PACKAGE . $_REQUEST{ VIEW_CLASS } )."]";
      // print 'in _getCurrentView';
      if ( ! isset( $this->curView ) )
      {
         
         if (
            isset( $_REQUEST{ VIEW_CLASS } ) &&
            tryImportClass( VIEW_PACKAGE . $_REQUEST{ VIEW_CLASS } ) )
         {
            $class = $_REQUEST{ VIEW_CLASS };
            //print_r( $class ) . BR_NL;
            //print VIEW_PACKAGE . $_REQUEST{ VIEW_CLASS };
            //TODO: It probably would have been better to require each top-level
            //View to have createFromRequest static method, since the current
            //scheme leads to some rather unsafe variable usage in the
            //constructors of Views.  Alas, it will not be corrected at the
            //current time.

            if ( isset( $_REQUEST{ IS_SUBMIT } ) )
            {
               $form =& Controller::_createView( $class );

               if ( $form->isAuthorizedSubmission() )
               {
                  if ( $form->isValid() )
                  {
                     $form->execute();

                     $this->curView =& $form->getNextView();
                     $this->doRedirect = $form->useRedirect();
                  }
                  else
                  {
                     $this->curView =& $form;
                  }
               }
               elseif ( $form->useNextViewAfterDuplicateSubmission() )
               {
                  $this->curView =& $form->getNextView();
               }
            }
            else
            {
               $this->curView =& Controller::_createView( $class );
            }
         }

         if (
            ! isset( $this->curView ) ||
            ( ! $this->curView->isEnabled() ) )
         {
            // print 'Using default view';
            $this->curView =& $this->getDefaultView();
         }
      }

      return $this->curView;
   }

//========================================================================

   /*!
   @function _createView( $viewClass )
   */

   /* static */
   function &_createView( $viewClass )
   {
      if ( reflect::methodExists( $viewClass, 'createFromRequest' ) )
      {
         return callStaticMethod(
            $viewClass, 'createFromRequest', new_array( $viewClass ) );
      }
      else
      {
         return new $viewClass();
      }
   }

//========================================================================

   /*!
   @function getDefaultView()
   @discussion - provides the View displayed by default by the Controller
   @result - returns an AView
   */

   function &getDefaultView()
   {
      importClass( 'BugUI.Views.ProjectView' );
      $view =& new ProjectView();

      importClass( 'Shared.User' );
      $curUser =& User::getCurrentUser();
      $view->setProject( $curUser->getCurrentProject() );
      return $view;
   }

//========================================================================

   /*!
   @function _getDisplayURL( $view, [ $isSubmit ] )
   @param $view - the AView to be displayed
   @param $isSubmit - a boolean indicating if this is AForm submit
      action - defaults to false
   @discussion - helper method used AForm::_getAction and
      ViewOperation::_getLink
   @result - returns a String
   */

   /* static */
   function _getDisplayURL( &$view, $isSubmit = false )
   {
      //getAbsoluteClass preserves the case which is important
      //then use absoluteClassToClass to strip off the package info

      $url =
         addParameterToURL(
            $_SERVER{ 'PHP_SELF' },
            VIEW_CLASS, absoluteClassToClass( $view->getAbsoluteClass() ) );

      $url = addParametersToURL( $url, $view->getParameters() );

      if ( $isSubmit )
      {
         return addParameterToURL( $url, IS_SUBMIT, 1 );
      }
      else
      {
         return $url;
      }
   }

//========================================================================

   /*!
   @function _getStatelessOperationURL( $operation )
   @param $operation - an AStatelessOperation
   @discussion - provides URL that invoke the specified Operation
   @result - returns a String containing an URL
   */

   /* static */
   function _getStatelssOperationURL( &$operation )
   {
      $controller =& Controller::getInstance();

      return
         addParameterToURL(
            Controller::_getDisplayURL( $controller->_getCurrentView() ),
            OPERATION_CLASS, absoluteClassToClass( $operation->getAbsoluteClass() ) );
   }

//========================================================================

};

?>