<?php

/*
ADevelopmentItemController
$Author: dougqh $
$Revision: 1.14 $
$Date: 2003/12/18 20:43:47 $
$Log: ADevelopmentItemController.php,v $
Revision 1.14  2003/12/18 20:43:47  dougqh
- Updated to work under PHP 4.2

Revision 1.13  2003/11/05 14:15:46  dougqh
- Feature 3754

Revision 1.12  2003/11/03 18:13:24  dougqh
- Feature 3743

Revision 1.11  2003/10/21 14:11:18  dougqh
Refactoring email handling

Revision 1.10  2003/09/04 19:21:59  dawn
- removed line inserted previously

Revision 1.9  2003/09/04 19:18:31  dawn
- playing with default field entries

Revision 1.8  2003/08/05 18:10:34  dougqh
- Added a guard to catch bad ADevelopmentItems in createFromExisting

Revision 1.7  2003/07/23 22:10:21  dougqh
- Added project field support, added method shouldAddHiddenProjectField, added handled for that hidden field in _setBasics.

Revision 1.6  2003/07/22 13:45:00  millz
- updated to allow for any sep character for related items

Revision 1.5  2003/07/14 18:01:18  dawn
- add tester

Revision 1.4  2003/07/14 17:17:23  dawn
- capitalization

Revision 1.3  2003/07/14 16:35:59  dawn
- change tester form

Revision 1.2  2003/07/09 22:21:36  dougqh
Accounting for moving IDListField from CollectionUI to DatabaseUI.

Revision 1.1  2003/07/09 20:09:49  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

//import for its constants
importClass( 'Bugs.ADevelopmentItem' );

//========================================================================

/*!
@class ADevelopmentItemController
@abstract - a helper class used by concrete AFormViews that wish to enter /
   manipulate an ADevelopmentItem
@discussion - This class bears no resemblance to the GoF builder pattern.
*/

class ADevelopmentItemController extends Object
{

//========================================================================

   /*!
   @function ADevelopmentItemController()
   @discussion - constructs a new ADevelopmentItemController object
   @result - constructs a new ADevelopmentItemController object
   */

   function ADevelopmentItemController()
   {
      $this->Object();

      $this->loadedFieldsAreValid = true;
      $this->errors = '';
   }

//========================================================================

   /*!
   @function _createController( $devItemType )
   @param $devItemType - one of FEATURE_REQUEST, TASK, DEFECT
   @discussion - provides a new concrete ADevelopmentItemController
      chosen based on $devItemType

      Helper static method of createFromExisting and createForNew.
   @result - returns an ADevelopmentItemController
   */

   function &_createController( $devItemType )
   {
      //ADevelopmentItem was imported at the top of the file, so
      //the constants are definitely loaded.
      switch ( $devItemType )
      {
         case TASK:
         importClass( 'BugUI.DevelopmentItemControllers.TaskController' );
         return new TaskController();

         case FEATURE_REQUEST:
         importClass( 'BugUI.DevelopmentItemControllers.FeatureRequestController' );
         return new FeatureRequestController();

         case DEFECT:
         importClass( 'BugUI.DevelopmentItemControllers.DefectController' );
         return new DefectController();

         default:
         unreachablePoint(
            getLocation() . NL .
            'Invalid DevItemType: ' . $devItemType );
         break;
      };
   }

//========================================================================

   /*!
   @function createForNew( $devItemType )
   @param $devItemType - one of TASK, FEATURE_REQUEST, or DEFECT
   @discussion - constructs an ADevelopmentItemBuilder that will add
      the specified type of defect to the specified Project
   @result - returns a ADevelopmentItemBuilder
   */

   function &createForNew( $devItemType )
   {
      $controller =& ADevelopmentItemController::_createController( $devItemType );

      $controller->_setBasics( $devItemType );
      importClass( 'BugUI.DevelopmentItemControllers.AddDevelopmentItemAction' );
      $controller->_setAction( new AddDevelopmentItemAction( $controller ) );

      return $controller;
   }

//========================================================================

   /*!
   @function _setBasics( $project, $devItemType )
   @param $project - a Project
   @param $devItemType - one of FEATURE_REQUEST, TASK, or DEFECT
   @discussion - called by ADevelopmentItem::createForNew on the newly
      constructed ADevelopmentItemController to finish its
      initialization
   */

   function _setBasics( $devItemType )
   {
      //imported for the HIDDEN_PROJECT_ID_FIELD constant
      importClass( 'BugUI.Views.ADevelopmentItemFormView' );
      if (
         isset( $_REQUEST{ HIDDEN_PROJECT_ID_FIELD } ) &&
         is_numeric( $_REQUEST{ HIDDEN_PROJECT_ID_FIELD } ) )
      {
         importClass( 'Shared.Project' );
         $this->project =& Project::getFromPrimaryID( $_REQUEST{ HIDDEN_PROJECT_ID_FIELD } );

         $this->isProjectExplicit = true;
      }
      else
      {
         $user =& $this->getUser();
         $this->project =& $user->getCurrentProject();

         $this->isProjectExplicit = false;
      }

      $this->devItemType = $devItemType;
      $this->creatingNew = true;
   }

//========================================================================

   /*!
   @function getUser()
   @discussion - provides the user performing interacting with this
      Controller
   */

   function getUser()
   {
      importClass( 'Shared.User' );
      return User::getCurrentUser();
   }

//========================================================================

   /*!
   @function createFromExisting( $devItem, $actionSpecifier )
   @param $devItem - an ADevelopmentItem
   @param $actionSpecifier - an ActionType - see constants at top of file
   @discussion - provides an appropriate ADevelopmentItemController
      for the specified ADevelopmentItem
   @result - returns a new ADevelopmentItemController
   */

   function &createFromExisting( &$devItem, $actionSpecifier )
   {
      if ( $devItem->isNull() )
      {
         unreachablePoint( 'Invalid DevItem' );
      }

      $controller =& ADevelopmentItemController::_createController(
         $devItem->_getReportTypeID() );

      $controller->_setDevelopmentItem( $devItem );

      $controller->_setAction2( $actionSpecifier );

      return $controller;
   }

//========================================================================

   /*!
   @function _setAction2( $actionSpecifier )
   @param $devItemController - an ADevelopmentItemController with which
      the created ADevelopmentItemAction will be associated
   @param $actionSpecifier - an ActionType - see constants at top of file
   @discussion - creates an Action corresponding to the provided specifier
   @result - returns an ADevelopmentItemAction
   */

   function &_setAction2( $actionSpecifier )
   {
      switch ( $actionSpecifier )
      {
         case REVIEW_DEV_ITEM:
         importClass( 'BugUI.DevelopmentItemControllers.ReviewDevelopmentItemAction' );
         $this->devItemAction =& new ReviewDevelopmentItemAction( $this );
         break;

         case VERIFY_DEV_ITEM:
         importClass( 'BugUI.DevelopmentItemControllers.VerifyDevelopmentItemAction' );
         $this->devItemAction =& new VerifyDevelopmentItemAction( $this );
         break;

         case FAIL_DEV_ITEM:
         importClass( 'BugUI.DevelopmentItemControllers.FailDevelopmentItemAction' );
         $this->devItemAction =& new FailDevelopmentItemAction( $this );
         break;

         case FIX_DEV_ITEM:
         importClass( 'BugUI.DevelopmentItemControllers.FixDevelopmentItemAction' );
         $this->devItemAction =& new FixDevelopmentItemAction( $this );
         break;

         case ADD_COMMENT_DEV_ITEM:
         importClass( 'BugUI.DevelopmentItemControllers.AddCommentDevelopmentItemAction' );
         $this->devItemAction =& new AddCommentDevelopmentItemAction( $this );
         break;

         case MORE_INFO_NEEDED_DEV_ITEM:
         importClass( 'BugUI.DevelopmentItemControllers.MoreInfoNeededDevelopmentItemAction' );
         $this->devItemAction =& new MoreInfoNeededDevelopmentItemAction( $this );
         break;

         case MORE_INFO_GIVEN_DEV_ITEM:
         importClass( 'BugUI.DevelopmentItemControllers.MoreInfoGivenDevelopmentItemAction' );
         $this->devItemAction =& new MoreInfoGivenDevelopmentItemAction( $this );
         break;

         case REOPEN_DEV_ITEM:
         importClass( 'BugUI.DevelopmentItemControllers.ReOpenDevelopmentItemAction' );
         $this->devItemAction =& new ReOpenDevelopmentItemAction( $this );
         break;

         case DESIGNER_CLOSE_DEV_ITEM:
         importClass( 'BugUI.DevelopmentItemControllers.DesignerCloseDevelopmentItemAction' );
         $this->devItemAction =& new DesignerCloseDevelopmentItemAction( $this );
         break;

         case ADD_ATTACHMENT_DEV_ITEM:
         importClass( 'BugUI.DevelopmentItemControllers.AddAttachmentDevelopmentItemAction' );
         $this->devItemAction =& new AddAttachmentDevelopmentItemAction( $this );
         break;

         case ADD_RELATED_DEV_ITEM:
         importClass( 'BugUI.DevelopmentItemControllers.AddRelatedDevelopmentItemAction' );
         $this->devItemAction =& new AddRelatedDevelopmentItemAction( $this );
         break;

         case CHANGE_TESTER_DEV_ITEM:
         importClass( 'BugUI.DevelopmentItemControllers.ChangeTesterDevelopmentItemAction' );
         $this->devItemAction =& new ChangeTesterDevelopmentItemAction( $this );
         break;

         default:
         unreachablePoint( 'Unknown actionSpecifier: ' . $actionSpecifier );
         break;
      };
   }

//========================================================================

   /*!
   @function _setDevelopmemtItem( $devItem )
   @param $devItem - an ADevelopmentItem
   @discussion - called by ADevelopmentItem::createFromExisting on the
      newly constructed ADevelopmentItemController to finish its
      initialization
   */

   function _setDevelopmentItem( &$devItem )
   {
      $this->project =& $devItem->getProject();
      $this->devItem =& $devItem;
      $this->creatingNew = false;
   }

//========================================================================

   /*!
   @function _setAction( $devItemAction )
   @param $devItemAction - an ADevelopmentItemAction
   @discussion - sets the ADevelopmentItemAction that controller will
      be using
   */

   function _setAction( &$devItemAction )
   {
      $this->devItemAction =& $devItemAction;
   }

//========================================================================

   /*!
   @function createFromRequest( $actionSpecifier )
   @param $actionSpecifier - an ActionType - see constants at top of file
   @discussion - attempts to create an ADevelopmentItemController based
      on the $_REQUEST variables
   @result - returns an ADevelopmentItemController
   */

   function &createFromRequest( $actionSpecifier )
   {
      //try to use a devItemID first
      //failing that use devItemType
      //if its not present then throw an error

      if ( isset( $_REQUEST{ 'devItemID' } ) && isInteger( $_REQUEST{ 'devItemID' } ) )
      {
         //TODO: For security, verify that devItemID is an integer

         importClass( 'Bugs.ADevelopmentItem' );
         return ADevelopmentItemController::createFromExisting(
            ADevelopmentItem::getFromPrimaryID(
               $_REQUEST{ 'devItemID' } ),
            $actionSpecifier );
      }
      elseif (
         isset( $_REQUEST{ 'devItemType' } ) && isInteger( $_REQUEST{ 'devItemType' } ) )
      {
         //TODO: For security, verify that devItemType is actually one of
         // FEATURE_REQUEST, TASK, or DEFECT
         //Ideally, there should be a function that does this check.

         return ADevelopmentItemController::createForNew(
            $_REQUEST{ 'devItemType' } );
      }
      else
      {
         unreachablePoint(
            'Insufficient REQUEST data to construct an ADevelopmentItemController' . NL );
      }
   }

//========================================================================

   /*!
   @function _getDevelopmentItem()
   @discussion - provides the ADevelopmentItem being manipulated by
      this ADevelopmentItemController

      This method should only be called if _creatingNew returns false.
   @result - returns an ADevelopmentItem
   */

   function &_getDevelopmentItem()
   {
      if ( ! isset( $this->devItem ) && $this->_creatingNew() )
      {
         $this->devItem =& $this->_createDevelopmentItem();
      }

      return $this->devItem;
   }

//========================================================================

   /*!
   @function _getProject()
   @discussion - provides the Project in which the pre-existing
      ADevelopmentItem exists or to which the new ADevelopmentItem
      should be added
   @result - returns a Project
   */

   function &_getProject()
   {
      return $this->project;
   }

//========================================================================

   /*!
   @function getField( $name )
   @param $name - a String
   @discussion - provides a LightFormField
   @result - returns a LightFormField or NULL
   */

   /* final */
   function &getField( $name )
   {
      if ( ! isset( $this->fieldsHash{ $name } ) )
      {
         $this->fieldsHash{ $name } =& $this->_createField( $name );

         if ( $this->fieldsHash{ $name } !== NULL )
         {
            $this->fieldsHash{ $name }->setRequired(
               $this->devItemAction->isRequired( $name ) );

            //If the ADevItemController::_createField made an enabled
            //field and the Action actually wants the Field enabled
            //then set the Field isEnabled.
            $this->fieldsHash{ $name }->setEnabled(
               $this->fieldsHash{ $name }->isEnabled() &&
               $this->devItemAction->isFieldEnabled( $name ) );
         }
      }

      return $this->fieldsHash{ $name };
   }

//========================================================================

   /*!
   @function hasField( $name )
   @param $name - a String - the name of a field
   @discussion - indicates if this builder has a given field
   @result - returns a boolean
   */

   /* final */
   function hasField( $name )
   {
      $field =& $this->getField( $name );
      return ( $field !== NULL );
   }

//========================================================================

   /*!
   @function _createField( $name )
   @param $name - a String - the name of a field
   @discussion - creates the ALightFormField that corresponds to the given
      name

      Child classes may override this method to support additional fields,
      but they should always call parent::_createField.
   @result - returns an ALightFormField
   */

   function &_createField( $name )
   {
      $isDesigner = $this->_isDesigner();
      $isDeveloper = $this->_isDeveloper();
      $isNew = $this->_creatingNew();

      if ( ! $isNew )
      {
         $devItem =& $this->_getDevelopmentItem();
      }

      $isTester = $this->_isTester();

      switch ( $name )
      {
         //---------------------------------------------------------------

         case 'ID':
         if ( $isNew )
         {
            $field = NULL;
         }
         else
         {
            $field =& $this->_createText( $name, 'TR-ID' );
            $field->setEnabled( false );
            $field->setValue( toRef( $devItem->getID() ) );
         }
         return $field;

         //---------------------------------------------------------------

         case 'project':
         $field =& $this->_createSelect1( 'Shared.Project', 'project' );
         $field->setValue( $this->_getProject() );
         $field->setEnabled( false );
         return $field;

         //---------------------------------------------------------------

         case 'subject':
         $field =& $this->_createText( $name );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getSubject() );
         return $field;

         //---------------------------------------------------------------

         case 'comment':
         $field =& $this->_createTextArea( $name );
         // $field->setEnabled( $isNew );
         // if ( ! $isNew ) $field->setValue( $devItem->getReport() );
         return $field;

         //---------------------------------------------------------------

         case 'report':
         $field =& $this->_createTextArea( $name );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getReport() );
         return $field;

         //---------------------------------------------------------------

         case 'priority':
         $field =& $this->_createSelect1(
            'Bugs.Priority',
            $name );
         if ( ! $isNew ) $field->setValue( $devItem->getPriority() );
         return $field;

         //---------------------------------------------------------------

         case 'developer':
         $field =& $this->_createSelect2(
            $this->project->getDevelopers(),
            $name );
         $field->setAllowNull( '--Unassigned--' );
         $field->setEnabled( $isDesigner );
         if ( ! $isNew ) $field->setValue( $devItem->getDeveloper() );
         return $field;

         //---------------------------------------------------------------

         case 'developmentPlan':
         $field =& $this->_createTextArea( $name, 'Development Plan' );
         if ( ! $isNew && $devItem->isDesigned() )
         {
            //once its been set - it cannot be changed
            $field->setEnabled( false );
            $field->setValue( $devItem->getDevelopmentPlan() );
         }
         else
         {
            $field->setEnabled( $isDesigner );
         }
         return $field;

         //---------------------------------------------------------------

         case 'newDesignDuration':
         $field =& $this->_createTimeDuration( $name, 'New Design Time' );
         if ( $devItem->isDesigned() )
         {
            importClass( 'Bugs.ADevelopmentItem' );
            $field->setValue( ADevelopmentItem::_createDuration( 0 ) );
         }
         $field->setEnabled( $isNew || ( ! $devItem->isDesigned() ) );
         return $field;

         //---------------------------------------------------------------

         case 'estCodeDuration':
         $field =& $this->_createTimeDuration( $name, 'Estimated Code Time' );
         if ( ! $isNew && $devItem->isDesigned() )
         {
            //once its been set - it cannot be changed
            $field->setEnabled( false );
            $field->setValue( $devItem->getEstimatedCodeDuration() );
         }
         else
         {
            $field->setEnabled( $isDesigner );
         }
         return $field;

         //---------------------------------------------------------------

         case 'estMiscDuration':
         $field =& $this->_createTimeDuration( $name, 'Estimated Misc. Time' );
         if ( ! $isNew && $devItem->isDesigned() )
         {
            //once its been set - it cannot be changed
            $field->setEnabled( false );
            $field->setValue( $devItem->getEstimatedMiscDuration() );
         }
         else
         {
            $field->setEnabled( $isDesigner );
         }
         return $field;

         //---------------------------------------------------------------

         case 'totalCodeDuration':
         $field =& $this->_createTimeDuration( $name, 'Total Code Time' );
         $field->setEnabled( false );
         if ( ! $isNew ) $field->setValue( $devItem->getTotalDuration() );
         return $field;

         //---------------------------------------------------------------

         case 'newCodeDuration':
         $field =& $this->_createTimeDuration( $name, 'New Code Time' );
         $field->setEnabled( $isDeveloper );
         return $field;

         //---------------------------------------------------------------

         case 'totalMiscDuration':
         $field =& $this->_createTimeDuration( $name, 'Total Misc. Time' );
         $field->setEnabled( false );
         if ( ! $isNew ) $field->setValue( $devItem->getTotalMiscDuration() );
         return $field;

         //---------------------------------------------------------------

         case 'newMiscDuration':
         $field =& $this->_createTimeDuration( $name, 'New Misc. Time' );
         $field->setEnabled( $isDeveloper );
         return $field;

         //---------------------------------------------------------------

         case 'newTestDuration':
         $field =& $this->_createTimeDuration( $name, 'New Test Time' );
         return $field;

         //---------------------------------------------------------------

         case 'detectedServerVersion':
         $field =& $this->_createVersion(
            $this->project->getServerVersions(),
            $name,
            'Server Detected Version' );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getDetectedServerVersion() );
         return $field;

         //---------------------------------------------------------------

         case 'state':
         $field =& $this->_createSelect2(
            $this->devItemAction->getAvailableStates(),
            $name );
         if ( ! $isNew ) $field->setValue( $devItem->getState() );
         return $field;

         //---------------------------------------------------------------

         case 'fixedServerVersion':
         $field =& $this->_createVersion(
            $this->project->getServerVersions(),
            $name,
            'Server Fixed Version' );
         if ( ! $isNew ) $field->setValue( $devItem->getFixedServerVersion() );
         return $field;

         //---------------------------------------------------------------

         case 'serverPlatform':
         $field =& $this->_createSelect2(
            $this->project->getServerPlatforms(),
            $name,
            'Server Platform' );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getServerPlatform() );
         return $field;

         //---------------------------------------------------------------

         case 'serverInstance':
         $field =& $this->_createSelect2(
            $this->project->getServerInstances(),
            $name,
            'Server Instance' );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getServerInstance() );
         return $field;

         //---------------------------------------------------------------

         case 'detectedClientVersion':
         $field =& $this->_createVersion(
            $this->project->getClientVersions(),
            'detectedClientVersion',
            'Client Detected Version' );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getDetectedClientVersion() );
         return $field;

         //---------------------------------------------------------------

         case 'fixedClientVersion':
         $field =& $this->_createVersion(
            $this->project->getClientVersions(),
            $name,
            'Client Fixed Version' );
         $field->setRequired( false );
         if ( ! $isNew ) $field->setValue( $devItem->getFixedClientVersion() );
         return $field;

         //---------------------------------------------------------------

         case 'clientPlatform':
         $field =& $this->_createSelect2(
            $this->project->getClientPlatforms(),
            $name,
            'Client Platform' );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getClientPlatform() );
         return $field;

         //---------------------------------------------------------------

         case 'clientType':
         $field =& $this->_createSelect2(
            $this->project->getClientTypes(),
            'clientType',
            'Client Type' );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getClientType() );
         return $field;

         //---------------------------------------------------------------

         case 'category':
         $field =& $this->_createSelect2(
            $this->project->getCategories(),
            $name );
         $field->setEnabled( $isNew || $isDeveloper || $isDesigner );
         if ( ! $isNew ) $field->setValue( $devItem->getCategory() );
         return $field;

         //---------------------------------------------------------------

         case 'subproject':
         $field =& $this->_createSelect2(
            $this->project->getSubprojects(),
            $name );
         $field->setEnabled( $isNew || $isDeveloper || $isDesigner );
         if ( ! $isNew ) $field->setValue( $devItem->getSubproject() );
         return $field;

         //---------------------------------------------------------------

         case 'tester':
         $field =& $this->_createSelect2(
            $this->project->getAvailableTesters(),
            $name );
         // $field->setEnabled( $isDesigner );
         if ( ! $isNew ) $field->setValue( $devItem->getTester() );
         return $field;

         //---------------------------------------------------------------

         case 'commentType':
         $field =& $this->_createSelect2(
            $this->devItemAction->getAvailableCommentTypes(),
            $name,
            'Type' );
         return $field;

         //---------------------------------------------------------------

         case 'attachmentFile':
         importClass( 'HTMLComponents.LightForms.LightFileField' );
         return new LightFileField( $name, 'Attachment' );

         //---------------------------------------------------------------

         case 'attachmentDescription':
         return $this->_createTextArea( $name, 'Description' );

         //---------------------------------------------------------------

         case 'newRelated':
         importClass( 'DatabaseUI.IDListField' );
         importClass( 'Bugs.ADevelopmentItem' );
         return new IDListField(
            $name,
            'Related IDs (separated by anything)',
            ADevelopmentItem::getPrototype() );

         //---------------------------------------------------------------

         default:
         return toRef( NULL );

         //---------------------------------------------------------------

      } //case
   }

//========================================================================

   /*!
   @function _createText( $name, [ $displayName ] )
   @param $name - an identifying String
   @param $displayName - a user-presentable String - optional
      - defaults to ucfirst( $name )
   @discussion - constructs a LightTextField using the standard size
      for this builder
   @result - returns a new LightTextField
   */

   function &_createText( $name, $displayName = UNSPECIFIED )
   {
      $displayName = $this->_getDisplayName( $name, $displayName );

      importClass( 'HTMLComponents.LightForms.LightTextField' );
      return new LightTextField( $name, $displayName, 200, 106 );
   }

//========================================================================

   /*!
   @function _createTextArea( $name, [ $displayName ] )
   @param $name - an identifying String
   @param $displayName - a user-presentable String - optional
      - defaults to ucfirst( $name )
   @discussion - constructs a LightTextAreaField using the standard size
      for this builder
   @result - returns a new LightTextAreaField
   */

   function &_createTextArea( $name, $displayName = UNSPECIFIED )
   {
      $displayName = $this->_getDisplayName( $name, $displayName );

      importClass( 'HTMLComponents.LightForms.LightTextAreaField' );
      return new LightTextAreaField( $name, $displayName, 80, 7 );
   }

//========================================================================

   /*!
   @function _createNumber( $name, [ $displayName ] )
   @param $name - an identifying String
   @param $displayName - a user-presentable String - optional
      - defaults to ucfirst( $name )
   @discussion - constructs a LightNumberField using the standard
      size for this builder
   @result - returns a new LightNumberField
   */

   function &_createNumber( $name, $displayName = UNSPECIFIED )
   {
      $displayName = $this->_getDisplayName( $name, $displayName );

      importClass( 'HTMLComponents.LightForms.LightTextField' );
      return new LightTextField( $name, $displayName, 20, 20 );
   }

//========================================================================

   /*!
   @function _createTimeDuration( $name, [ $displayName ] )
   @param $name - an identifying String
   @param $displayName - a user-presentable String - optional
      - defaults to ucfirst( $name )
   @discussion - constructs a TimeDurationField
   @result - returns a new TimeDurationField
   */

   function &_createTimeDuration( $name, $displayName = UNSPECIFIED )
   {
      $displayName = $this->_getDisplayName( $name, $displayName );

      //need a constant
      importClass( 'Bugs.ADevelopmentItem' );
      importClass( 'TimeUI.TimeDurationField' );
      return new TimeDurationField( $name, $displayName, DEFAULT_DEV_ITEM_TIME_UNIT );
   }

//========================================================================

   /*!
   @function _createSelect1( $absClassName, $name, [ $displayName ] )
   @param $absClassName - absolute class specifier for an ADatabaseItem
      class
   @param $name - an identifying String
   @param $displayName - a user-presentable String - optional
      - defaults to ucfirst( $name )
   @discussion - creates a LightIteratorSelectField provided by
      a default search on a $absClassName prototype
   @result - returns a new LightIteratorSelectField
   */

   function &_createSelect1( $absClassName, $name, $displayName = UNSPECIFIED )
   {
      $displayName = $this->_getDisplayName( $name, $displayName );

      importClass( $absClassName );
      $prototype =&
         callStaticMethod(
            absoluteClassToClass( $absClassName ),
            'getPrototype',
            new_array() );

      //print_r( $prototype );

      importClass( 'DatabaseUI.LightIteratorSelectField' );
      return new LightIteratorSelectField(
         $prototype->doSearch(),
         $name,
         $displayName,
         SINGLE_SELECT );
   }

//========================================================================

   /*!
   @function _createSelect2( $iterator, $name, [ $displayName ] )
   @param $iterator - an IIterator< ADatabaseItem >
   @param $name - an identifying String
   @param $displayName - a user-presentable String - optional
      - defaults to ucfirst( $name )
   @discussion - creates a LightIteratorSelectField
   @result - returns a new LightIteratorSelectField
   */

   function &_createSelect2( &$iterator, $name, $displayName = UNSPECIFIED )
   {
      $displayName = $this->_getDisplayName( $name, $displayName );

      importClass( 'DatabaseUI.LightIteratorSelectField' );
      return new LightIteratorSelectField(
         $iterator,
         $name,
         $displayName,
         SINGLE_SELECT );
   }

//========================================================================

   /*!
   @function _createVersion( $iterator, $name, [ $displayName ] )
   @param $iterator - an IIterator< Version >
   @param $name - an identifying String
   @param $displayName - a user-presentable String - optional
      - defaults to ucfirst( $name )
   @discussion - constructs a new VersionField
   @result - returns a new VersionField
   */

   function &_createVersion( &$iterator, $name, $displayName )
   {
      $displayName = $this->_getDisplayName( $name, $displayName );

      importClass( 'BugUI.OtherComponents.VersionField' );
      return new VersionField( &$iterator, $name, $displayName );
   }

//========================================================================

   /*!
   @function _getDisplayName( $name, $displayName )
   @param $name - a String
   @param $displayName - a user-presentable String or UNSPECIFIED
   @discussion - if $displayName is UNSPECIFIED returns
      ucfirst( $name ); otherwise just returns $displayName
   @result - returns a user-presentable String
   */

   function _getDisplayName( $name, $displayName )
   {
      return ( $displayName === UNSPECIFIED ) ?
         ucfirst( $name ) :
         $displayName;
   }

//========================================================================

   /*!
   @function _isTester()
   @discussion - indicates if the current user is the tester
      for the target ADevelopmentItem
   @result - returns a boolean
   */

   function _isTester()
   {
      //TODO: Finish implementing this
      return ( ! $this->_creatingNew() );
   }

//========================================================================

   /*!
   @function _isDeveloper()
   @discussion - indicates if the current user is the developer
      for the target ADevelopmentItem
   @result - returns a boolean
   */

   function _isDeveloper()
   {
      //TODO: Finish implementing this
      return ( ! $this->_creatingNew() );
   }

//========================================================================

   /*!
   @function _isDesigner()
   @discussion - indicates if the current user is a designer for
      the Project of the target ADevelopmentItem
   @result - returns a boolean
   */

   function _isDesigner()
   {
      //unreachablePoint(); - surely this line SHOULD not be here

      importClass( 'Shared.User' );
      return $this->project->isDesigner( User::getCurrentUser() );
   }

//========================================================================

   /*!
   @function _creatingNew()
   @discussion - indicates if this ADevelopmentItemController is creating
      a new item
   @result - returns a boolean
   */

   function _creatingNew()
   {
      return $this->creatingNew;
   }

//========================================================================

   /*!
   @function _loadFields( $names )
   @param $names - a String[] of field names
   @discussion - loads the form data for the specified fields

      This method will NOT throw an error if one of the fields
      does not exist.
   */

   function _loadFields( $names )
   {
      foreach( $names as $curName )
      {
         $field =& $this->getField( $curName );
         if ( $field !== NULL )
         {
            $field->loadFormData();
            if ( ! $field->isValid() )
            {
               $this->loadedFieldsAreValid = false;
               $this->_addError( $field->getErrors() );
            }
         }
      }
   }

//========================================================================

   /*!
   @function load()
   @discussion - loads the necessary for this ADevelopmentItemController
   @result - returns a String
   */

   function load()
   {
//      print getLocation() . BR_NL;

      $this->_loadFields(
         $this->devItemAction->getAvailableFieldNames() );
   }

//========================================================================

   /*!
   @function execute()
   @discussion - actually performs the action of this ADevelopmentItemController
   */

   function execute()
   {
      $this->devItemAction->execute();

      importClass( 'BugUI.DevelopmentItemEmail' );
      $email =& new DevelopmentItemEmail(
         $this->getDisplayName(),
         $this->_getDevelopmentItem() );

      $email->addUserRecipients(
         $this->devItemAction->getEmailRecipients() );

      if ( $this->devItemAction->excludeTriggeringUserFromEmail() )
      {
         $email->addUserExclusion( $this->getUser() );
      }

      $email->send();
   }

//========================================================================

   /*!
   @function isValid()
   @discussion - runs checks to ensure that all fields/columns are valid for this item
   @result - bool
   */

   function isValid()
   {
      return
         $this->loadedFieldsAreValid &&
         $this->devItemAction->areAdditionalChecksValid();
   }

//========================================================================

   /*!
   @function _addError( $error )
   @param $error - a String
   @discussion - adds an error to the running list of problems
      with this ADevelopmentItem
   */

   function _addError( $error )
   {
      $this->errors .= $error . NL;
   }

//========================================================================

   /*!
   @funciton getErrors()
   @discussion - provides a String of error messages in the event
      that isValid returns false

      isValid should be called before getErrors is called.
   @result - returns a String
   */

   function getErrors()
   {
      //replace any double NLs with a single NL, just in case
      return str_replace( NL . NL, NL, $this->errors );
   }

//========================================================================

   /*!
   @function getFieldValue( $name )
   @param $name - a String - contains a field name
   @discussion - provides the loaded value of the field
   @result - returns Any
   */

   function &getFieldValue( $name )
   {
      $field =& $this->getField( $name );
      return $field->getValue();
   }

//========================================================================

   /*!
   @function _createDevelopmentItem()
   @discussion - provides a new ADevelopmentItem of the appropriate type
      - used when this builder is _creatingNew
   @result - returns an ADevelopmentItem
   */

   /* abstract function &_createDevelopmentItem(); */

//========================================================================

   /*!
   @function _setAdditionalNewFields( $devItem )
   @discussion - sets any additional fields that are required for
      a new ADevelopmentItem
   */

   /* abstract function _setAdditionalNewFields( $devItem ); */

//========================================================================

   /*!
   @function isEnabled()
   @discussion - indicates whether or not this ADevItemController
      isEnabled

      Just dispatches to its wrapped ADevItemAction.
   @result - returns a boolean
   */

   /* final */
   function isEnabled()
   {
      return $this->devItemAction->isEnabled();
   }

//========================================================================

   /*!
   @function getDisplayName()
   @discussion - provides a user presentable name for the action
      being performed by this controller

      Just dispatches to its wrapped ADevItemAction
   @result - returns a user-presentable String
   */

   /* final */
   function getDisplayName()
   {
      //print_r( $this->devItemAction );
      return $this->devItemAction->getDisplayName();
   }

//========================================================================

   /*!
   @function getParameters()
   */

   function getParameters()
   {
      if ( $this->_creatingNew() )
      {
         return array( 'devItemType' => $this->devItemType );
      }
      else
      {
         return array( 'devItemID' => $this->devItem->getPrimaryID() );
      }
   }

//========================================================================

   /*!
   @function shouldAddHiddenProject()
   @discussion - indicates to ADevelopmentItemFormView the need to add
      a hidden project field
   @result - returns a boolean
   */

   function shouldAddHiddenProject()
   {
      return $this->_creatingNew();
   }

//========================================================================

   /*!
   @function getDevelopmentItemType()
   @discussion - provides a constant representing the type of
      ADevelopmentItem being created
   @result - returns a DevelopmentItemType constant
   */

   function getDevelopmentItemType()
   {
      if ( $this->_creatingNew() )
      {
         return $this->devItemType;
      }
      else
      {
         return $this->devItem->_getReportTypeID();
      }
   }

//========================================================================

   /*!
   @function getTypeDisplayName()
   @discussion - provides a user-presentable name for the type
      of ADevelopmentItem
   @result - returns a String
   */

   function getTypeDisplayName()
   {
      return ADevelopmentItem::getTypeDisplayName(
         $this->getDevelopmentItemType() );
   }

//========================================================================

   /*!
   @function getMethod()
   @discussion - indicates how the form should be submitted
   @result - returns GET or POST
   */

   /* final */
   function getMethod()
   {
      return $this->devItemAction->getMethod();
   }

//========================================================================

   /*!
   @function isUploader()
   @discussion - indicates if this form uses uploaded files
   @result - returns a boolean
   */

   /* final */
   function isUploader()
   {
      return $this->devItemAction->isUploader();
   }

//========================================================================

};

?>