<?php

/*
DevelopmentItemEmail
$Author: dougqh $
$Revision: 1.7 $
$Date: 2003/11/03 20:08:18 $
$Log: DevelopmentItemEmail.php,v $
Revision 1.7  2003/11/03 20:08:18  dougqh
- Added ability to enable debug flag PRINT_EMAIL_RECIPIENTS_AND_EXIT to show recipients list and exit when in development mode.

Revision 1.6  2003/10/21 14:15:14  dougqh
- Fixed syntax error in send

Revision 1.5  2003/10/21 14:12:21  dougqh
Added support for excluding users
Moved recipient selection into ADevelopmentItemAction

Revision 1.4  2003/09/29 18:13:26  dougqh
- No longer using short hand PHP tags

Revision 1.3  2003/09/09 15:30:02  dougqh
- Using a constant that can be set in config.conf in getSenderEmail.

Revision 1.2  2003/09/09 15:25:04  dougqh
- Blocking email sending when in demo mode.

Revision 1.1  2003/07/09 19:55:42  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'Email.AEmail' );

//========================================================================

class DevelopmentItemEmail extends AEmail
{

//========================================================================

   var $baseTitle;
   var $devItem;

//========================================================================

   /*!
   @function DevelopmentItemEmail( $baseTitle, $devItem )
   @param $baseTitle - a String
   @param $devItem - an ADevelopmentItem
   @discussion DevelopmentItemEmail constructor
   */

   function DevelopmentItemEmail( $baseTitle, &$devItem )
   {
      $this->AEmail();

      $this->baseTitle = $baseTitle;
      $this->devItem =& $devItem;
   }

//========================================================================

   /*!
   @function addUserRecipients( $userIter )
   @param $userIter - an IIterator< User >
   @discussion - adds any necessary recipients
   */

   function addUserRecipients( &$userIter )
   {
      $this->_addUserRecipients( $userIter );
   }

//========================================================================

   /*!
   @function addUserExclusion( $user )
   @param $user - a User to exclude from receiving this Email
   @discussion - adds any necessary recipients
   */

   function addUserExclusion( &$user )
   {
      $this->_addUserExclusion( $user );
   }

//========================================================================

   /*!
   @function getBody()
   @discussion - provides the body of the email
   @result - returns a String
   */

   function getBody()
   {
      $out = 'TR-ID: ' . $this->devItem->getPrimaryID() . NL;
      $out .= 'Subject: ' . $this->devItem->getSubject() . NL;

      importClass( 'BugUI.Views.DevelopmentItemDetailsView' );
      $detailsView =& DevelopmentItemDetailsView::create( $this->devItem );

      //jump through hoops to get the actual URL
      $op =& $detailsView->getDisplayOperation();
      $link =& $op->getLink();
      $url =& $link->getURL();

      $out .= 'Link: ' . $url->getAbsoluteURLString() . NL;
      $out .= '------------------------------------------------------' . NL;
      $out .= 'Report: ' . NL;
      $out .= $this->devItem->getReport() . NL;
      $out .= '------------------------------------------------------' . NL;
      $out .= 'Steps to Reproduce: ' . NL;
      $out .= $this->devItem->getRepSteps() . NL;

      return $out;
   }

//========================================================================

   /*!
   @function getTitle()
   */

   function getTitle()
   {
      $project =& $this->devItem->getProject();
      $state =& $this->devItem->getState();

      return
         $project->getName() . ' - ' .
         $this->devItem->getPrimaryID() . ' (' .
         $state->getName(). ')  ' .
         $this->baseTitle  . ': ' .
         $this->devItem->getSubject();
   }

//========================================================================

   /*!
   @function getSenderEmail()
   */

   function getSenderEmail()
   {
      return DEV_ITEM_SEND_EMAIL;
   }

//========================================================================

   /*!
   @function getSenderDisplayName()
   */

   function getSenderDisplayName()
   {
      return 'BugPort';
   }

//========================================================================

   /*!
   @function send()
   */

   function send()
   {
      if ( ! IS_DEVELOPMENT && ! IS_DEMO )
      {
         parent::send();
      }
      elseif ( PRINT_EMAIL_RECIPIENTS_AND_EXIT )
      {
         print 'Recipients: ' . htmlentities( $this->getRecipientsList() ) . BR_NL;
         exit;
      }
      // log who would have received the email in some fashion
   }

//========================================================================

};

?>