<?php

/*
InvisibleOperation
$Author: dougqh $
$Revision: 1.1 $
$Date: 2004/04/01 18:10:35 $
$Log: InvisibleOperation.php,v $
Revision 1.1  2004/04/01 18:10:35  dougqh
- Operation that is always invisible

Revision 1.2  2003/10/21 14:12:21  dougqh
*** empty log message ***

Revision 1.1  2003/07/09 19:55:42  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.AOperation' );

//========================================================================

/*!
@class InvisibleOperation
@abstract - a class used to generate links to other actions
   Putting state in subclasses of InvisibleOperation is generally NOT a good idea.
*/

class InvisibleOperation extends AOperation
{

//========================================================================

   /*!
   @function InvisibleOperation()
   @discussion - constructs a new InvisibleOperation object
   @result - constructs a new InvisibleOperation object
   */

   function InvisibleOperation()
   {
      $this->AOperation();
   }

//========================================================================

   /*!
   @function getInstance()
   */
   function &getInstance()
   {
      return new InvisibleOperation();
   }

//========================================================================

   /*!
   @function getName()
   @discussion - provides a name for this Operation
   @result - returns a user presentable String
   */

   function getName()
   {
      return 'IRRELEVANT';
   }

//========================================================================

   /*!
   @function _getLink()
   @discussion - provides a Link with no body that triggers
      this Operation
   @result - returns a Link
   */

   function &_getLink()
   {
      importClass( 'HTMLComponents.Links.ExternalLink' );
      return new ExternalLink( '#' );
   }

//========================================================================

   /*!
   @function isEnabled()
   @discussion - indicates if this Operation should be enabled
   @result - returns a boolean
   */

   function isEnabled()
   {
      return false;
   }

//========================================================================

   /*!
   @function isVisible()
   @discussion - indicates if this Operation is visible
   @result - returns a boolean
   */

   function isVisible()
   {
      return false;
   }

//========================================================================

};

?>