<?php

/*
KeyManager
$Author: dougqh $
$Revision: 1.2 $
$Date: 2003/09/09 17:26:53 $
$Log: KeyManager.php,v $
Revision 1.2  2003/09/09 17:26:53  dougqh
- Fixed problem with using unused variable entry in KeyManager::clearKeyValue

Revision 1.1  2003/08/13 21:45:06  dougqh
- A new class to manage duplicate submission check keys.


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

define( 'KEY_PREFIX', 'key_' );

//========================================================================

/*!
@class KeyManager
@abstract -
*/

class KeyManager extends Object
{


//========================================================================

   /*!
   @function KeyManager()
   */

   function KeyManager()
   {
      $this->Object();
   }

//========================================================================

   /*!
   @function getInstance()
   @discussion - provides the sole instance of the KeyManager
   @result - returns a KeyManager
   */

   function &getInstance()
   {
      static $instanceArray;
      if ( is_null( $instanceArray ) )
      {
         $instanceArray[ 0 ] =& new KeyManager();
      }

      return $instanceArray[ 0 ];
   }

//========================================================================

   /*!
   @function registerKey( $key )
   @param $key - a String
   @discussion - registers the provided key in this KeyManager
   @result - returns a timestamp
   */

   /* static */
   function registerKey( $key )
   {
      //Need to store multiple keys in a hash to handle multiple registrations
      //under the same key
      $value = time();
      $_SESSION{ KEY_PREFIX . $key }{ $value } = true;
      return $value;
   }

//========================================================================

   /*!
   @function checkKeyValue( $key, $value )
   @param $key - a String
   @param $value - a String
   @discussion - indicates if the provided value is known value for this
      key
   @result - returns a boolean
   */

   /* static */
   function checkKeyValue( $key, $value )
   {
      return isset( $_SESSION{ KEY_PREFIX . $key }{ $value } );
   }

//========================================================================

   /*!
   @function clearKeyValue( $key, $value )
   @param $key - a String
   @param $value - a String
   @discussion - clears the provided value from the list of acceptable
      values for the specified key
   */

   /* static */
   function clearKeyValue( $key, $value )
   {
      unset( $_SESSION{ KEY_PREFIX . $key }{ $value } );
   }

//========================================================================

};

?>