<?php

/*
ChangeDevelopmentItemUnderDevelopmentStatusOperation
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/07/09 20:28:56 $
$Log: ChangeDevelopmentItemUnderDevelopmentStatusOperation.php,v $
Revision 1.1  2003/07/09 20:28:56  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.AStatelessOperation' );

//========================================================================

/*!
@class ChangeDevelopmentItemUnderDevelopmentStatusOperation
@abstract - acts by reading $_REQUEST{ CHANGE_PROJECT_FIELD_NAME }
*/

class ChangeDevelopmentItemUnderDevelopmentStatusOperation extends AStatelessOperation
{

//========================================================================

   /*!
   @function ChangeDevelopmentItemUnderDevelopmentStatusOperation(
      &$devItem, [ $isActive ] )
   @param $devItem - a ADevelopmentItem - on which to change the active state
   @param $isActive - an optional boolean specifying if the ADevelopmentItem
      should be set to active or inactive - defaults to opposite the current
      state of the ADevelopmentItem
   */

   function ChangeDevelopmentItemUnderDevelopmentStatusOperation( &$devItem, $isActive = UNSPECIFIED )
   {
      $this->AStatelessOperation();

      $this->devItem =& $devItem;

      if ( $isActive == UNSPECIFIED )
      {
         $this->isActive = ( ! $this->devItem->isUnderDevelopment() );
      }
      else
      {
         $this->isActive = $isActive;
      }
   }

//========================================================================

   /*!
   @function createFromRequest()
   @discussion - instantiates a ChangeDevelopmentItemUnderDevelopmentStatusOperation from
      the Request variables
   */

   function &createFromRequest()
   {
      if (
         isset( $_REQUEST{ 'casDevItemID' } ) &&
         isInteger( $_REQUEST{ 'casDevItemID' } ) &&
         isset( $_REQUEST{ 'casActive' } ) &&
         ( $_REQUEST{ 'casActive' } == 0 || $_REQUEST{ 'casActive' } == 1 ) )
      {
         importClass( 'Bugs.ADevelopmentItem' );
         return new ChangeDevelopmentItemUnderDevelopmentStatusOperation(
            ADevelopmentItem::getFromPrimaryID( $_REQUEST{ 'casDevItemID' } ),
            boolval( $_REQUEST{ 'casActive' } ) );
      }
      else
      {
         return NULL;
      }
   }

//========================================================================

   /*!
   @function getName()
   */

   function getName()
   {
      if ( $this->isActive )
      {
         return 'Change to Under Development';
      }
      else
      {
         return 'Change to Inactive';
      }
   }

//========================================================================

   /*!
   @function getParameters()
   */

   function getParameters()
   {
      return array(
         'casDevItemID' => $this->devItem->getPrimaryID(),
         'casActive' => intval( $this->isActive ) );
   }

//========================================================================

   /*!
   @function isMarkingAsUnderDevelopment()
   @discussion - indicates what this Operation will do
   @result - returns a boolean
   */

   function isMarkingAsUnderDevelopment()
   {
      return $this->isActive;
   }

//========================================================================

   /*!
   @function isEnabled()
   */

   function isEnabled()
   {
      importClass( 'Shared.User' );
      if ( ! $this->devItem->isDeveloper( User::getCurrentUser() ) )
      {
         return false;
      }

      //Check the opposite of what we aim to achieve to determine
      //enabled status
      if ( $this->isActive )
      {
         return $this->devItem->isNotUnderDevelopment();
      }
      else
      {
         return $this->devItem->isUnderDevelopment();
      }
   }

//========================================================================

   /*!
   @function _execute()
   */

   function _execute()
   {
      $this->devItem->setDevelopmentStatus( $this->isActive );

      importClass( 'BugUI.DevelopmentItemEmail' );
      $email =& new DevelopmentItemEmail(
         $this->getName(),
         $this->devItem );
      $email->send();
   }

//========================================================================

};

?>