<?php

/*
ViewOperation
$Author: dougqh $
$Revision: 1.2 $
$Date: 2004/01/13 18:57:44 $
$Log: ViewOperation.php,v $
Revision 1.2  2004/01/13 18:57:44  dougqh
- Added ability to change target window.

Revision 1.1  2003/07/09 20:28:56  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.AOperation' );

//========================================================================

/*!
@class ViewOperation
@abstract -
*/

class ViewOperation extends AOperation
{

//========================================================================

   /*!
   @function ViewOperation( $view, [ $target ] )
   @param $view - the AView to display
   @param $target - the window to target - if empty the current window
      is targeted
   @discussion - constructs a new ViewOperation object
   @result - constructs a new ViewOperation object
   */

   function ViewOperation( &$view, $target = UNSPECIFIED )
   {
      $this->AOperation();
      $this->view =& $view;
      if ( $target !== UNSPECIFIED ) $this->target = $target;
   }

//========================================================================

   /*!
   @function getName()
   @discussion - uses the short title of the View
   */

   function getName()
   {
      return $this->view->getShortTitle();
   }

//========================================================================

   /*!
   @function _getLink()
   @discussion - provides a Link which cause the Controller to
      reconstruct the View provided at the time of construction
   @result - returns
   */

   function &_getLink()
   {
      importClass( 'BugUI.Controller' );
      importClass( 'HTMLComponents.Links.ExternalLink' );
      $link =& new ExternalLink(
         Controller::_getDisplayURL( $this->view ) );
      if ( isset( $this->target ) ) $link->setTarget( $this->target );

      return $link;
   }

//========================================================================

   /*!
   @function isEnabled()
   @discussion - a ViewOperation isEnabled if its View isEnabled
   */

   function isEnabled()
   {
      return $this->view->isEnabled();
   }

//========================================================================

};

?>