<?php

/*
DevelopmentItemLinks
$Author: dougqh $
$Revision: 1.6 $
$Date: 2004/01/13 18:55:49 $
$Log: DevelopmentItemLinks.php,v $
Revision 1.6  2004/01/13 18:55:49  dougqh
- Added Add to Favorites link

Revision 1.5  2004/01/13 18:14:15  dawn
- unlocking file

Revision 1.4  2003/07/15 17:17:33  millz
- updated for verif reqd button display logic change

Revision 1.2  2003/07/14 16:35:12  dawn
- change tester page

Revision 1.1  2003/07/09 20:26:12  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.AHTMLComponent' );

//========================================================================

/*!
@class DevelopmentItemLinks
@abstract -
*/

class DevelopmentItemLinks extends AHTMLComponent
{

//========================================================================

   var $devItem;
   var $isDetailsView;

//========================================================================

   /*!
   @function DevelopmentItemLinks( $devItem, [ $isDetailsView ], [ $showAddFavorites ] )
   @param $devItem - the devItem in question
   @param $isDetailsView - a boolean - that indicates if these
      links are being shown in DevelopmentItemDetailsView -
      defaults to false
   @param $showAddFavorites - a boolean - indicates if the "Add to Favorites Group"
      link should be included - defaults to value of $isDetailsView
   @discussion - constructs a new DevelopmentItemLinks object
   @result - constructs a new DevelopmentItemLinks object
   */

   function DevelopmentItemLinks( &$devItem, $isDetailsView = UNSPECIFIED, $showAddToFavorites = UNSPECIFIED )
   {
      $this->AHTMLComponent();

      $this->devItem =& $devItem;

      if ( $isDetailsView === UNSPECIFIED )
         $this->isDetailsView = false;
      else
         $this->isDetailsView = $isDetailsView;

      if ( $showAddToFavorites === UNSPECIFIED )
         $this->showAddToFavorites = $this->isDetailsView;
      else
         $this->showAddToFavorites = $showAddToFavorites;

      $this->showAll = false;
   }

//========================================================================

   /*
   @function setShowAll( $bool = true )
   @discussion - if showAll mode is turned on, then all buttons will be displayed, regardless of isDetails mode
   @result - nothing
   */

   function setShowAll( $bool = true )
   {
      $this->showAll = $bool;
   }

//========================================================================

   /*
   @function getHTML()
   @discussion - builds and returns the html to show links for the various operations for this devItem
      takes current state and currently logged in user in account
   @result - html string
   */

   function getHTML()
   {
      importClass( 'HTMLComponents.CompositeHTMLComponent' );
      $this->composite =& new CompositeHTMLComponent( '' );

      //------------------------------------------------------------------

      if ( ! $this->isDetailsView || $this->showAll )
      {
         importClass( 'BugUI.Views.DevelopmentItemDetailsView' );
         $this->_addView(
            DevelopmentItemDetailsView::create( $this->devItem ),
            'viewdetails' );
      }

      //------------------------------------------------------------------

      $show = ( $this->isDetailsView || $this->showAll );
      //The repetition of the ifs is intentional in case other
      //conditions are added for specific action at a later date

      //------------------------------------------------------------------

      if ( $show && !$this->devItem->isVerificationRequested() )
      {
         importClass( 'BugUI.Views.ADevelopmentItemFormView' );
         $this->_addView(
            ADevelopmentItemFormView::createModifyForm(
               $this->devItem,
               FIX_DEV_ITEM ),
            'verifreq' );
      }

      //------------------------------------------------------------------

      if ( $show )
      {
         $this->_addUnderDevelopmentStatusChangeOperation();
      }

      //------------------------------------------------------------------

      if ( $show )
      {
         importClass( 'BugUI.Views.ADevelopmentItemFormView' );
         $this->_addView(
            ADevelopmentItemFormView::createModifyForm(
               $this->devItem,
               REVIEW_DEV_ITEM ),
            'assign' );
      }

      //------------------------------------------------------------------

      if ( $show )
      {
         importClass( 'BugUI.Views.ADevelopmentItemFormView' );
         $this->_addView(
            ADevelopmentItemFormView::createModifyForm(
               $this->devItem,
               DESIGNER_CLOSE_DEV_ITEM ),
            'close' );
      }

      //------------------------------------------------------------------

      if ( $show )
      {
         importClass( 'BugUI.Views.ADevelopmentItemFormView' );
         $this->_addView(
            ADevelopmentItemFormView::createModifyForm(
               $this->devItem,
               MORE_INFO_NEEDED_DEV_ITEM ),
            'incomplete' );
      }


      //------------------------------------------------------------------

      if ( $show )
      {
         importClass( 'BugUI.Views.ADevelopmentItemFormView' );
         $this->_addView(
            ADevelopmentItemFormView::createModifyForm(
               $this->devItem,
               VERIFY_DEV_ITEM ),
            'close' );
      }

      //------------------------------------------------------------------

      if ( $show )
      {
         importClass( 'BugUI.Views.ADevelopmentItemFormView' );
         $this->_addView(
            ADevelopmentItemFormView::createModifyForm(
               $this->devItem,
               FAIL_DEV_ITEM ),
            'fixfailed' );
      }

      //------------------------------------------------------------------

      if ( $show )
      {
         importClass( 'BugUI.Views.ADevelopmentItemFormView' );
         $this->_addView(
            ADevelopmentItemFormView::createModifyForm(
               $this->devItem,
               MORE_INFO_GIVEN_DEV_ITEM ),
            'giveMoreInfo' );
      }

      //------------------------------------------------------------------

      if ( $show )
      {
         importClass( 'BugUI.Views.ADevelopmentItemFormView' );
         $this->_addView(
            ADevelopmentItemFormView::createModifyForm(
               $this->devItem,
               REOPEN_DEV_ITEM ),
            'reopen' );
      }

      //------------------------------------------------------------------

      if ( $show )
      {
         importClass( 'BugUI.Views.ADevelopmentItemFormView' );
         $this->_addView(
            ADevelopmentItemFormView::createModifyForm(
               $this->devItem,
               ADD_COMMENT_DEV_ITEM ),
            'addcomment' );
      }

      //------------------------------------------------------------------

      if ( $show )
      {
         importClass( 'BugUI.Views.ADevelopmentItemFormView' );
         $this->_addView(
            ADevelopmentItemFormView::createModifyForm(
               $this->devItem,
               ADD_ATTACHMENT_DEV_ITEM ),
            'addattachment' );
      }

      //------------------------------------------------------------------

      if ( $show )
      {
         importClass( 'BugUI.Views.ADevelopmentItemFormView' );
         $this->_addView(
            ADevelopmentItemFormView::createModifyForm(
               $this->devItem,
               ADD_RELATED_DEV_ITEM ),
            'addrelated' );
      }

      //------------------------------------------------------------------

      if ( $show )
      {
         importClass( 'BugUI.Views.ADevelopmentItemFormView' );
         $this->_addView(
            ADevelopmentItemFormView::createModifyForm(
               $this->devItem,
               CHANGE_TESTER_DEV_ITEM ),
            'changetester' );
      }
      //------------------------------------------------------------------

      if ( $this->showAddToFavorites )
      {
         importClass( 'BugUI.Views.AddToFavoriteItemSetView' );
         $view =& AddToFavoriteItemSetView::create2( $this->devItem );
         //print_r( get_class_methods( get_class( $view ) ) );
         $this->_addOperation(
            $view->getDisplayOperation( '_blank' ),
            'addtofavorite' );
      }

      //------------------------------------------------------------------

      $html = $this->composite->getHTML();
      //done with the CompositeHTMLComponent, so get rid of it
      unset( $this->composite );
      return $html;
   }

//========================================================================

   /*!
   @function _addView( &$view, $imageBaseName )
   @param $view - a AView
   @param $imageBaseName - a String - containing an image name (without extension)
   @discussion - a helper method used by getHTML
   */

   function _addView( &$view, $imageBaseName )
   {
      $this->_addOperation(
         $view->getDisplayOperation(),
         $imageBaseName );
   }

//========================================================================

   /*!
   @function _addOperation( $operation, $imageBaseName )
   @param $operation - an AOperation
   @param $imageBaseName - a String - containing an image name (without extension)
   @discussion - a helper method used by getHTML
   */

   function _addOperation( &$operation, $imageBaseName )
   {
      if ( $operation->isEnabled() && $operation->isVisible() )
      {
         importClass( 'HTMLComponents.Images.RollOverImage' );
         $image =& new RollOverImage(
            $imageBaseName . '.gif',
            $imageBaseName . '_over.gif',
            $operation->getName() );

         $this->composite->add(
            $operation->getLink( $image ) );
      }
   }

//========================================================================

   /*!
   @function _addUnderDevelopmentStatusChangeOperation()
   @discussion - adds an Operation that changes the "Under Development"
      status of the target ADevelopmentItem
   */

   function _addUnderDevelopmentStatusChangeOperation()
   {
      importClass( 'BugUI.Operations.ChangeDevelopmentItemUnderDevelopmentStatusOperation' );
      $operation =&
          new ChangeDevelopmentItemUnderDevelopmentStatusOperation( $this->devItem );

      if ( $operation->isMarkingAsUnderDevelopment() )
      {
         $this->_addOperation( $operation, 'underDevelopment' );
      }
      else
      {
         $this->_addOperation( $operation, 'submittedAssigned' );
      }

   }

//========================================================================

};

?>