<?php

/*
NavigationBar
$Author: dougqh $
$Revision: 1.4 $
$Date: 2004/11/15 16:23:56 $
$Log: NavigationBar.php,v $
Revision 1.4  2004/11/15 16:23:56  dougqh
- Added All Favorites to the navigation bar

Revision 1.3  2004/04/01 22:08:22  millz
added admin link

Revision 1.2  2003/09/04 17:38:56  millz
- added links to stats page

Revision 1.1  2003/07/09 20:26:12  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.AHTMLComponent' );

//========================================================================

/*!
@class NavigationBar
@abstract - used for the navigation bar that appears at the top
   and bottom of all pages
*/

class NavigationBar extends AHTMLComponent
{

//========================================================================

   /*!
   @function NavigationBar()
   @discussion - constructs a new NavigationBar object
   @result - constructs a new NavigationBar object
   */

   function NavigationBar()
   {
      $this->AHTMLComponent();
   }

//========================================================================

   /*!
   @function getInstance()
   @discussion - provides the sole instance of NavigationBar
   @result - returns a NavigationBar
   */

   function &getInstance()
   {
      //standard static array hack
      static $instanceArray;

      if ( ! isset( $instanceArray ) )
      {
         $instanceArray = array();
         $instanceArray[ 0 ] =& new NavigationBar();
      }

      return $instanceArray[ 0 ];
   }

//========================================================================

	/*!
	@function _getLinksComponent
	*/
	function &_getLinksComponent()
	{
     if ( ! isset( $this->completeHTML ) )
     {
			   $primaryLinks =& $this->_getPrimaryLinksComponent();
			   $secondaryLinks =& $this->_getSecondaryLinksComponent();
			   
			   $this->completeHTML = $primaryLinks->getHTML() . BR_NL . $secondaryLinks->getHTML();
		 }
	   
	   importClass( 'HTMLComponents.RawHTML' );
	   return new RawHTML( $this->completeHTML );
	}
	
//========================================================================

   /*!
   @function _getPrimaryLinksComponent()
   @discussion - provides an AHTMLComponent containing the Links
      that the NavigationBar should display
   @result - returns an AHTMLComponent
   */

   function &_getPrimaryLinksComponent()
   {
       importClass( 'Shared.User' );
       $curUser =& User::getCurrentUser();

       importClass( 'HTMLComponents.CompositeHTMLComponent' );
       $composite =& new CompositeHTMLComponent( '][' );

       importClass( 'BugUI.Controller' );
       $controller =& Controller::getInstance();
       $view =& $controller->getDefaultView();

       $operation =& $view->getDisplayOperation();
       importClass( 'HTMLComponents.Text' );
       $composite->add( $operation->getLink( new Text( 'Project Home' ) ) );

       importClass( 'BugUI.Views.SearchForm' );
       $searchForm =& new SearchForm();
       $composite->add( $searchForm->getDisplayOperation() );

       //used throughout the block delimited by the horizontal dashed lines
       importClass( 'BugUI.Views.ADevelopmentItemFormView' );

       $taskForm =& ADevelopmentItemFormView::createAddForm( TASK );
       $composite->add( $taskForm->getDisplayOperation() );

       $featureForm =& ADevelopmentItemFormView::createAddForm( FEATURE_REQUEST );
       $composite->add( $featureForm->getDisplayOperation() );

       $defectForm =& ADevelopmentItemFormView::createAddForm( DEFECT );
       $composite->add( $defectForm->getDisplayOperation() );
       
       return new RawHTML( '[' . $composite->getHTML() . ']' );
   }
   
//========================================================================

	 /*!
	 @function _getSecondaryLinksComponent()
	 */
	 function &_getSecondaryLinksComponent()
	 {
         importClass( 'HTMLComponents.CompositeHTMLComponent' );
         $composite =& new CompositeHTMLComponent( '][' );
         
         importClass( 'BugUI.Views.StatsView' );
         $statsView =& new StatsView();
         $composite->add( $statsView->getDisplayOperation() );
         
         importClass( 'BugUI.Views.AdminToolsLinksView' );
         $toolsView =& new AdminToolsLinksView();
         // we want to hide this one when it is not useable
         if ( $toolsView->isEnabled() ) $composite->add( $toolsView->getDisplayOperation() );
         
         importClass( 'BugUI.Views.AllFavoritesView' );
         $favoritesView =& new AllFavoritesView();
         $composite->add( $favoritesView->getDisplayOperation() );
         
         importClass( 'HTMLComponents.RawHTML' );
         return new RawHTML( '[' . $composite->getHTML() . ']' );
	 }   

//========================================================================

   /*!
   @function _getSearchFieldComponent()
   @discussion - provides an AHTMLComponent that
   @result - returns an AHTMLComponent
   */

   function &_getSearchFieldComponent()
   {
      if ( ! isset( $this->searchComponent ) )
      {
         importClass( 'HTMLComponents.LightForms.TextComponent' );
         $textComp =& new TextComponent( 'quickSearch', '', 10 );

         //TODO: Clean-up this ugliness
         $html = '<table><form>' . NL;
         $html .= '<tr>' . NL;
         $html .= '<td>' . $textComp->getHTML() . '</td>' . NL;
         $html .= '<td><input type="hidden" value="1" name="submit" />' . NL;
         $html .= '<input type="hidden" value="SearchForm" name="view" />' . NL;
         $html .= '<input type="submit" value="Go"></td>' . NL;
         $html .= '</tr>' . NL;
         $html .= '</form>' . NL;
         $html .= '</table>' . NL;

         importClass( 'HTMLComponents.RawHTML' );
         $this->searchComponent =& new RawHTML( $html );
      }

      return $this->searchComponent;
   }

//========================================================================

   /*!
   @function _getChangeProjectComponent()
   @discussion - provides an AHTMLCompoent that allows the user
      to change the current project
   @result - returns an AHTMLComponent
   */

   function &_getChangeProjectComponent()
   {
      //No caching here - need to make sure the forms have different
      //names

      static $numCalls;
      if ( ! isset( $numCalls ) )
      {
         $numCalls = 0;
      }
      else
      {
         ++$numCalls;
      }

      importClass( 'CollectionUI.IteratorSelectComponent' );
      importClass( 'Shared.Project' );

      //imported here for CHANGE_PROJECT_FIELD_NAME constant
      importClass( 'BugUI.Operations.ChangeUserProjectOperation' );
      $projProto =& Project::getPrototype();
      $projectSelect =& new IteratorSelectComponent(
         $projProto->doSearch(),
         CHANGE_PROJECT_FIELD_NAME,
         SINGLE_SELECT );

      importClass( 'Shared.User' );
      $curUser =& User::getCurrentUser();
      $projectSelect->setSelected( $curUser->getCurrentProject() );

      $formName = 'changeProjectForm' . $numCalls;
      $projectSelect->setOnChange( 'window.document.forms.' . $formName . '.submit();' );

      importClass( 'HTMLComponents.LightForms.LightForm' );
      $changeProjectForm =& new LightForm( $formName );

      //imported above
      $changeProjectForm->setOperation( new ChangeUserProjectOperation() );
      $changeProjectForm->setBodyHTML( $projectSelect->getHTML() );

      return $changeProjectForm;
   }

//========================================================================

   /*!
   @function getHTML()
   */

   function getHTML()
   {
      importClass( 'BugUI.Controller' );
      $controller =& Controller::getInstance();

      importClass( 'Shared.User' );
      $thisUser =& User::getCurrentUser();
      $curProject =& $thisUser->getCurrentProject();

      //--------------------------------------------------------------

      importClass( 'HTMLComponents.Table.Table' );
      $table =& new Table( 'NavBar Table' );
      $table->setWidth( '100%' );
      // $table->setBorder( '2' );
      $table->setCellPadding( '1' );

      importClass( 'Display.Color' );
      $table->startRow( Color::getColor( 220, 220, 195) );

      importClass( 'Display.Font' );
      $font =& Font::getFont( 'verdana', '-2' );
      importClass( 'HTMLComponents.Text' );
      $text =& new Text( 'Current Project:' );
      $text->setFont( $font );

      importClass( 'HTMLComponents.Table.TableCell' );
      $cell =& new TableCell( $text );
      $cell->setWidth('1%');
      $cell->disableWrapping();

      $table->addCell( $cell );

      //---------------------------------------------------------------

      $table->addCell( $this->_getChangeProjectComponent() );

      //------------------------------------------------------------------

      $text =& new Text( 'Search:' );
      $text->setFont( $font );
      $cell =& new TableCell( $text );
      $cell->setWidth('1%');
      $cell->setHorizontalAlignment( RIGHT );
      $cell->disableWrapping();
      $table->addCell( $cell );

      $cell =& new TableCell( $this->_getSearchFieldComponent() );
      $cell->setWidth('1%');
      $cell->setHorizontalAlignment( RIGHT );
      $cell->disableWrapping();
      $table->addCell( $cell );

      $text =& new Text( '[?]' );
      $text->setFont( $font );
      importClass( 'HTMLComponents.Links.ExternalLink' );
      $link =& new ExternalLink( 'searchHelp.html', $text );
      $link->setOnClick( 'window.open("searchHelp.html",null,"height=300,resizable=yes,scrollbars=yes,width=550,status=yes,toolbar=no,menubar=no,location=no"); return false;' );

      $table->addCell( $link );

      //------------------------------------------------------------------

      $table->addCell( $this->_getLinksComponent(), RIGHT );

      //---------------------------------------------------------------

      importClass( 'HTMLComponents.SimpleBorderDecorator' );
      $borderedTable =& new SimpleBorderDecorator( $table );
      $html = $borderedTable->getHTML();

      return $html;
   }

//========================================================================

};

?>