<?php

/*
AgeStatsPortlet
$Author: millz $
$Revision: 1.3 $
$Date: 2004/01/07 19:23:38 $
$Log: AgeStatsPortlet.php,v $
Revision 1.3  2004/01/07 19:23:38  millz
- changed to use static creator for DevelopmentItemResultsView

Revision 1.2  2003/09/08 14:06:54  millz
- changed date string to shorter version

Revision 1.1  2003/09/04 17:38:11  millz
-

Revision 1.3  2003/09/04 15:05:57  dougqh
- Got rid of hardcoding of schema name - now using the global constant

Revision 1.2  2003/07/17 20:37:05  millz
- updated to show links

Revision 1.1  2003/07/09 20:17:26  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.Portlets.APortlet' );

//========================================================================

/*!
@class AgeStatsPortlet
@abstract -
*/

class AgeStatsPortlet extends APortlet
{


//========================================================================

   /*!
   @function AgeStatsPortlet(  $name )
   @param $name - the title of the AgeStatsPortlet
   @discussion - constructs a new AgeStatsPortlet object
   @result - constructs a new AgeStatsPortlet object
   */

   function AgeStatsPortlet( )
   {
      $this->APortlet( 'Issue Age Statistics' );
   }

//========================================================================

   /*!
   @function _getBodyHTML()
   */

   function _getBodyHTML()
   {
      importClass( 'Database.DBConnectionProvider' );
      $dbcon =& DBConnectionProvider::getReadOnlyConnection();

      importClass( 'HTMLComponents.Table.Table' );
      importClass( 'HTMLComponents.Text' );
      importClass( 'HTMLComponents.RawHTML' );

      $table =& new Table( 'Age Stats' );
      $table->setWidth( '100%' );

      
      $sql = 'SELECT report_id,date_in FROM report order by date_in limit 1';

      importClass( 'Database.StandardCacheHandler' );
      $cacheHandler =& StandardCacheHandler::create( 'report' );

      $recordSet = $dbcon->cacheExecute($cacheHandler->getMultipleCacheTime(), $sql);
      $fields = $recordSet->fields;

      importClass( 'Bugs.ADevelopmentItem' );
      $devItem =& ADevelopmentItem::getFromPrimaryID( $fields['report_id'] );
      
      importClass( 'BugUI.Views.DevelopmentItemDetailsView' );
      $detailsView =& DevelopmentItemDetailsView::create( $devItem );
      $displayOp =& $detailsView->getDisplayOperation();
      $link = $displayOp->getLink( new Text( $fields['report_id'] ) );

      $table->startRow();
      $table->addCell( new Text('Oldest Issue') );
      $table->addCell( new RawHTML('ID: '. $link->getHTML().' - Created: '.getShortFormattedDBTimeStamp($fields['date_in']) ),RIGHT );

      //-----------------------------------------------------

      importClass( 'Bugs.State' );
      $sql = 'SELECT report_id,date_in FROM report where state_id < '.CLOSED_FIXED_STATE_ID.' order by date_in limit 1';

      importClass( 'Database.StandardCacheHandler' );
      $cacheHandler =& StandardCacheHandler::create( 'report' );

      $recordSet = $dbcon->cacheExecute($cacheHandler->getMultipleCacheTime(), $sql);
      $fields = $recordSet->fields;

      importClass( 'Bugs.ADevelopmentItem' );
      $devItem =& ADevelopmentItem::getFromPrimaryID( $fields['report_id'] );
      
      importClass( 'BugUI.Views.DevelopmentItemDetailsView' );
      $detailsView =& DevelopmentItemDetailsView::create( $devItem );
      $displayOp =& $detailsView->getDisplayOperation();
      $link = $displayOp->getLink( new Text( $fields['report_id'] ) );

      $table->startRow();
      $table->addCell( new Text('Oldest Active Issue') );
      $table->addCell( new RawHTML('ID: '. $link->getHTML().' - Created: '.getShortFormattedDBTimeStamp($fields['date_in']) ),RIGHT );


      //-----------------------------------------------------

      importClass( 'Bugs.State' );
      $sql = 'SELECT report_id,date_in FROM report order by date_in desc limit 1';

      importClass( 'Database.StandardCacheHandler' );
      $cacheHandler =& StandardCacheHandler::create( 'report' );

      $recordSet = $dbcon->cacheExecute($cacheHandler->getMultipleCacheTime(), $sql);
      $fields = $recordSet->fields;

      importClass( 'Bugs.ADevelopmentItem' );
      $devItem =& ADevelopmentItem::getFromPrimaryID( $fields['report_id'] );
      
      importClass( 'BugUI.Views.DevelopmentItemDetailsView' );
      $detailsView =& DevelopmentItemDetailsView::create( $devItem );
      $displayOp =& $detailsView->getDisplayOperation();
      $link = $displayOp->getLink( new Text( $fields['report_id'] ) );

      $table->startRow();
      $table->addCell( new Text('Newest Issue') );
      $table->addCell( new RawHTML('ID: '. $link->getHTML().' - Created: '.getShortFormattedDBTimeStamp($fields['date_in']) ),RIGHT );

      
      return $table->getHTML();
   }

//========================================================================

   /*
   @function _addCellToTable( $whereClause, &$binds, &$table )
   @discussion - helper to make and use iterators
   @result - nothing, mods the table
   */

   function _addCellToTable( $whereClause, &$binds, &$table)
   {
      importClass( 'Bugs.ADevelopmentItem' );

      $proto =& ADevelopmentItem::getPrototype();
      $iterator =& $proto->doSearch(
         $whereClause,
         $binds );


      importClass( 'BugUI.Views.DevelopmentItemResultsView' );
      $view =& DevelopmentItemResultsView::create2(  $iterator );

      $operation =& $view->getDisplayOperation();

      $text = '[View]';

      $link = $operation->getLink( new Text( $text ) );

      importClass( 'HTMLComponents.Table.TableCell' );
      $viewCell =& new TableCell( $link );
      $viewCell->disableWrapping();
      $viewCell->setWidth( 40 );
      $viewCell->setHorizontalAlignment( RIGHT );

      $table->addCell( $viewCell );
   }

//========================================================================

};

?>