<?php

/*
PersonalStatsPortlet
$Author: dougqh $
$Revision: 1.6 $
$Date: 2004/06/16 16:15:18 $
$Log: PersonalStatsPortlet.php,v $
Revision 1.6  2004/06/16 16:15:18  dougqh
- Fixed 4558

Revision 1.5  2004/01/07 19:23:16  millz
- changed to use static creator for DevelopmentItemResultsView

Revision 1.4  2003/11/07 22:23:14  millz
- fixing bug with where clause of closed-in-last-7-days entry

Revision 1.3  2003/11/05 14:18:26  millz
- added 7 days items

Revision 1.2  2003/07/17 14:59:51  millz
- updated to provide links for items counted

Revision 1.1  2003/07/09 20:17:26  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.Portlets.APortlet' );

//========================================================================

/*!
@class PersonalStatsPortlet
@abstract -
*/

class PersonalStatsPortlet extends APortlet
{


//========================================================================

   /*!
   @function PersonalStatsPortlet(  $name )
   @param $name - the title of the PersonalStatsPortlet
   @discussion - constructs a new PersonalStatsPortlet object
   @result - constructs a new PersonalStatsPortlet object
   */

   function PersonalStatsPortlet()
   {
      $this->APortlet( 'My Statistics' );
   }



//========================================================================

   /*!
   @function _getBodyHTML()
   */

   function _getBodyHTML()
   {
      //TODO: move the SELECT COUNT statements into methods of Project or User
      // as appropriate
      importClass( 'Database.DBConnectionProvider' );
      $dbcon =& DBConnectionProvider::getReadOnlyConnection();

      importClass( 'HTMLComponents.Table.Table' );
      importClass( 'HTMLComponents.Text' );

      importClass( 'Bugs.State' ); // for the constants

      $table =& new Table( 'Personal Stats' );
      // $table->setBorder(1);
      $table->setWidth( '100%' );

      importClass( 'Shared.User' );
      $user_id = User::getCurrentUserID();

      importClass( 'Database.StandardCacheHandler' );
      $cacheHandler =& StandardCacheHandler::create( 'report' );

      //---------------------------------------------------------
      $this->_addRowToTable( 'Number of issues I have submitted', 'submitter_id = ?', new_array($user_id), $table);

      $this->_addRowToTable( 'Number of my submitted issues that are now closed', 'submitter_id = ? AND state_id >= ?', new_array($user_id, CLOSED_FIXED_STATE_ID), $table);

      $this->_addRowToTable( 'Number of my development issues that are now closed', 'developer_id = ? AND state_id >= ?', new_array($user_id, CLOSED_FIXED_STATE_ID), $table);

      $this->_addRowToTable( 'Number of issues I have designed', 'designer_id = ?', new_array($user_id), $table);

      importClass( 'Database.QueryUtils' );
      importClass( 'Database.DBConnectionProvider' );
      importClass( 'Time.TimeDuration' );
      importClass( 'BugUI.Views.SearchForm' ); // for constants
      importConstants( 'Database' );

      $submitDateAgeWherePair =& QueryUtils::getDateOlderWherePair( DBConnectionProvider::getReadOnlyConnection(),
                                                                        SUBMITTED_DATE_COLUMN,
                                                                        LESS_THAN,
                                                                        new TimeDuration( 7, DAY_UNIT ) );

      $this->_addRowToTable(  'Number of issues I have submitted in the last 7 days',
                              'submitter_id = ? and '.$submitDateAgeWherePair[0],
                              array_merge_compat(array($user_id),$submitDateAgeWherePair[1]), $table);

      $stateDateAgeWherePair =& QueryUtils::getDateOlderWherePair( DBConnectionProvider::getReadOnlyConnection(),
                                                                        'date_state',
                                                                        LESS_THAN,
                                                                        new TimeDuration( 7, DAY_UNIT ) );

      $this->_addRowToTable(  'Number of issues I have closed in the last 7 days',
                              'tester_id = ? AND state_id >= ? and '.$stateDateAgeWherePair[0],
                              array_merge_compat(array($user_id,CLOSED_FIXED_STATE_ID),$stateDateAgeWherePair[1]), $table);

      return $table->getHTML();
   }

//========================================================================

   /*
   @function _addRowToTable( $label, $whereClause, &$binds, &$table)
   @discussion - helper to make and use iterators
   @result - nothing, mods the table
   */

   function _addRowToTable( $label, $whereClause, &$binds, &$table)
   {
      importClass( 'Bugs.ADevelopmentItem' );

      $proto =& ADevelopmentItem::getPrototype();
      $iterator =& $proto->doSearch(
         $whereClause,
         $binds );

      //TODO: Switch this to use single quotes and binds
      // $sql = "SELECT COUNT(*) num FROM report WHERE submitter_id = $user_id";
      $num = $iterator->getCount();
      //$dbcon->cacheGetOne($cacheHandler->getMultipleCacheTime(), $sql);

      importClass( 'BugUI.Views.DevelopmentItemResultsView' );
      $view =& DevelopmentItemResultsView::create2($iterator);


      $operation =& $view->getDisplayOperation();

      $text = '[View]';

      $link = $operation->getLink( new Text( $text ) );

      $table->startRow();
      $table->addCell( new Text($label) );
      $table->addCell( new Text($num),RIGHT );

      importClass( 'HTMLComponents.Table.TableCell' );
      $viewCell =& new TableCell( $link );
      $viewCell->disableWrapping();
      $viewCell->setWidth( 40 );
      $viewCell->setHorizontalAlignment( RIGHT );

      $table->addCell( $viewCell );
   }

//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */

   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>