<?php

/*
ProjectStatsPortlet
$Author: millz $
$Revision: 1.5 $
$Date: 2004/01/07 19:23:47 $
$Log: ProjectStatsPortlet.php,v $
Revision 1.5  2004/01/07 19:23:47  millz
- changed to use static creator for DevelopmentItemResultsView

Revision 1.4  2003/07/29 14:38:37  millz
- added link to history view

Revision 1.3  2003/07/29 14:28:44  dawn
-

Revision 1.2  2003/07/17 14:59:36  millz
- updated to provide links for devel items which were counted

Revision 1.1  2003/07/09 20:17:26  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.Portlets.APortlet' );

//========================================================================

/*!
@class ProjectStatsPortlet
@abstract -
*/

class ProjectStatsPortlet extends APortlet
{


//========================================================================

   /*!
   @function ProjectStatsPortlet( $project )
   @discussion - constructs a new ProjectStatsPortlet object
   @result - constructs a new ProjectStatsPortlet object
   */

   function ProjectStatsPortlet( &$project )
   {
      $this->project =& $project;
      importClass( 'Shared.*' );

      $this->APortlet( '"'. $project->getName() . '" Project Statistics' );
   }

//========================================================================

   /*!
   @function _getBodyHTML()
   */

   function _getBodyHTML()
   {
      importClass( 'Database.DBConnectionProvider' );
      $dbcon =& DBConnectionProvider::getReadOnlyConnection();

      importClass( 'HTMLComponents.Table.Table' );
      importClass( 'HTMLComponents.Text' );

      $table =& new Table( 'Personal Stats' );
      $table->setWidth( '100%' );

      //------------------------------------------------------------------------

      $this->_addRowToTable( 'Total Number of Issues', $this->project->getAllDevelopmentItems(), $table);

      //------------------------------------------------------------------------

      $this->_addRowToTable( 'Number of Active Very Urgent Issues', $this->project->getAllActiveVeryUrgentDevelopmentItems(), $table);

      //------------------------------------------------------------------------

      $this->_addRowToTable( 'Number of Active Urgent Issues', $this->project->getAllActiveUrgentDevelopmentItems(), $table);

      //------------------------------------------------------------------------

      $this->_addRowToTable( 'Number of Verif. Req\'d Issues', $this->project->getVerificationRequestedDevelopmentItems(), $table);
      
      //------------------------------------------------------------------------

      $this->_addRowToTable( 'Total Number of Active Issues', $this->project->getAllActiveDevelopmentItems(), $table);


      //------------------------------------------------------------------------

      $this->_addRowToTable( 'Total Number of Closed Issues', $this->project->getAllClosedDevelopmentItems(), $table);

      //------------------------------------------------------------------------

      $table->startRow();
      
      importClass( 'BugUI.Views.HistoryView' );
      $historyView =& new HistoryView();
      $op =& $historyView->getDisplayOperation();
      
      $table->addCell( $op->getLink( new Text('[View Historical Counts]') ) );

      return $table->getHTML();
   }

//========================================================================

   /*
   @function _addRowToTable( $label, $iterator, &$table)
   @discussion - helper to use iterators
   @result - nothing, mods the table
   */

   function _addRowToTable( $label, $iterator, &$table)
   {

      $num = $iterator->getCount(); 


      importClass( 'BugUI.Views.DevelopmentItemResultsView' );
      $view =& DevelopmentItemResultsView::create2($iterator);

      $operation =& $view->getDisplayOperation();

      $text = '[View]';

      $link = $operation->getLink( new Text( $text ) );

      $table->startRow();
      $table->addCell( new Text($label) );
      $table->addCell( new Text($num),RIGHT );
      
      importClass( 'HTMLComponents.Table.TableCell' );
      $viewCell =& new TableCell( $link );
      $viewCell->disableWrapping();
      $viewCell->setWidth( 40 );
      $viewCell->setHorizontalAlignment( RIGHT );
      
      $table->addCell( $viewCell );
   }

//========================================================================

};

?>