<?php

/*
SystemStatsPortlet
$Author: millz $
$Revision: 1.5 $
$Date: 2004/01/07 19:23:23 $
$Log: SystemStatsPortlet.php,v $
Revision 1.5  2004/01/07 19:23:23  millz
- changed to use static creator for DevelopmentItemResultsView

Revision 1.4  2003/09/08 14:06:35  millz
- added top commenter

Revision 1.3  2003/09/04 15:05:57  dougqh
- Got rid of hardcoding of schema name - now using the global constant

Revision 1.2  2003/07/17 20:37:05  millz
- updated to show links

Revision 1.1  2003/07/09 20:17:26  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.Portlets.APortlet' );

//========================================================================

/*!
@class SystemStatsPortlet
@abstract -
*/

class SystemStatsPortlet extends APortlet
{


//========================================================================

   /*!
   @function SystemStatsPortlet(  $name )
   @param $name - the title of the SystemStatsPortlet
   @discussion - constructs a new SystemStatsPortlet object
   @result - constructs a new SystemStatsPortlet object
   */

   function SystemStatsPortlet( )
   {
      $this->APortlet( 'System Statistics' );
   }

//========================================================================

   /*!
   @function _getBodyHTML()
   */

   function _getBodyHTML()
   {
      importClass( 'Database.DBConnectionProvider' );
      $dbcon =& DBConnectionProvider::getReadOnlyConnection();

      importClass( 'HTMLComponents.Table.Table' );
      importClass( 'HTMLComponents.Text' );

      $table =& new Table( 'Personal Stats' );
      $table->setWidth( '100%' );

      //TODO: Clean up this code
      $sql =
         'SELECT count(*) counter, ' .
            'MAX(first_name) first, ' .
            'MAX(last_name) last, ' .
            'MAX(user_id) user_id ' .
            'FROM report,' . SHARED_SCHEMA . '.iuser ' .
            'WHERE state_id >= ' .
            CLOSED_FIXED_STATE_ID .
            ' AND iuser.user_id = report.developer_id GROUP BY developer_id ORDER BY counter DESC';

      importClass( 'Database.StandardCacheHandler' );
      $cacheHandler =& StandardCacheHandler::create( 'report' );

      $recordSet = $dbcon->cacheExecute($cacheHandler->getMultipleCacheTime(), $sql);
      $fields = $recordSet->fields;

      $table->startRow();
      $table->addCell( new Text('Top Issue Killer') );
      $table->addCell( new Text( $fields['first'].' '.$fields['last'].' ('.$fields['counter'].' issues)' ),RIGHT );

      $this->_addCellToTable( 'state_id >= ? and developer_id = ?', new_array(CLOSED_FIXED_STATE_ID,$fields['user_id']), &$table);

      //========================================================================

      $sql =
         'SELECT COUNT(*) counter, ' .
            'MAX(first_name) first, ' .
            'MAX(last_name) last, ' .
            'MAX(user_id) user_id ' .
            'FROM report, ' . SHARED_SCHEMA . '.iuser '.
            'WHERE iuser.user_id = report.submitter_id GROUP BY submitter_id ORDER BY counter DESC';

      $recordSet = $dbcon->cacheExecute($cacheHandler->getMultipleCacheTime(), $sql);
      $fields = $recordSet->fields;

      $table->startRow();
      $table->addCell( new Text('Top Issue Submitter') );
      $table->addCell( new Text( $fields['first'].' '.$fields['last'].' ('.$fields['counter'].' issues)' ),RIGHT );

      $this->_addCellToTable( 'submitter_id = ?', new_array($fields['user_id']), &$table);


      //========================================================================

      $sql =
         'SELECT count(*) counter, ' .
            'MAX(first_name) first, ' .
            'MAX(last_name) last, ' .
            'MAX(user_id) user_id ' .
            'FROM report, ' . SHARED_SCHEMA . '.iuser ' .
            'WHERE iuser.user_id = report.designer_id GROUP BY designer_id ORDER BY counter desc';

      $recordSet = $dbcon->cacheExecute($cacheHandler->getMultipleCacheTime(), $sql);
      $fields = $recordSet->fields;

      $table->startRow();
      $table->addCell( new Text('Top Issue Designer') );
      $table->addCell( new Text( $fields['first'].' '.$fields['last'].' ('.$fields['counter'].' issues)' ),RIGHT );

      $this->_addCellToTable( 'designer_id = ?', new_array($fields['user_id']), &$table);


      //========================================================================

      $sql =
         'SELECT COUNT(*) counter, ' .
            'MAX(first_name) first, ' .
            'MAX(last_name) last, ' .
            'MAX(user_id) user_id ' .
            'FROM report, ' . SHARED_SCHEMA . '.iuser ' .
            'WHERE (state_id >= ' . UNDER_DEVELOPMENT_ASSIGNED_STATE_ID . ' AND state_id <= ' . UNDER_DEVELOPMENT_FIX_FAILED_STATE_ID . ') ' .
            ' AND iuser.user_id = report.developer_id '.
            'GROUP BY developer_id ORDER BY counter DESC';

      $recordSet = $dbcon->cacheExecute($cacheHandler->getMultipleCacheTime(), $sql);
      $fields = $recordSet->fields;

      $table->startRow();
      $table->addCell( new Text('Most Issues Under Development') );
      $table->addCell( new Text( $fields['first'].' '.$fields['last'].' ('.$fields['counter'].' issues)' ),RIGHT );

      $this->_addCellToTable( '(state_id >= ? and  state_id <= ?) and developer_id = ?', new_array(UNDER_DEVELOPMENT_ASSIGNED_STATE_ID,UNDER_DEVELOPMENT_FIX_FAILED_STATE_ID,$fields['user_id']), &$table);

      //========================================================================

      $sql =
         'SELECT count(*) counter, ' .
            'MAX(first_name) first, ' .
            'MAX(last_name) last, ' .
            'MAX(iuser.user_id) user_id ' .
            'FROM comment, ' . SHARED_SCHEMA . '.iuser ' .
            'WHERE iuser.user_id = comment.user_id GROUP BY iuser.user_id ORDER BY counter desc';

      //print $sql;

      $recordSet = $dbcon->cacheExecute($cacheHandler->getMultipleCacheTime(), $sql);
      $fields = $recordSet->fields;

      $table->startRow();
      $table->addCell( new Text('Top Commenter') );
      $table->addCell( new Text( $fields['first'].' '.$fields['last'].' ('.$fields['counter'].' comments)' ),RIGHT );
      $table->addSpacerCell();
      // $this->_addCellToTable( 'submitter_id = ?', new_array($fields['user_id']), &$table);


      return $table->getHTML();
   }

//========================================================================

   /*
   @function _addCellToTable( $whereClause, &$binds, &$table )
   @discussion - helper to make and use iterators
   @result - nothing, mods the table
   */

   function _addCellToTable( $whereClause, &$binds, &$table)
   {
      importClass( 'Bugs.ADevelopmentItem' );

      $proto =& ADevelopmentItem::getPrototype();
      $iterator =& $proto->doSearch(
         $whereClause,
         $binds );


      importClass( 'BugUI.Views.DevelopmentItemResultsView' );
      $view =& DevelopmentItemResultsView::create2($iterator);

      $operation =& $view->getDisplayOperation();

      $text = '[View]';

      $link = $operation->getLink( new Text( $text ) );

      importClass( 'HTMLComponents.Table.TableCell' );
      $viewCell =& new TableCell( $link );
      $viewCell->disableWrapping();
      $viewCell->setWidth( 40 );
      $viewCell->setHorizontalAlignment( RIGHT );

      $table->addCell( $viewCell );
   }

//========================================================================

};

?>