<?php

/*
ADevelopmentItemAction
$Author: dougqh $
$Revision: 1.5 $
$Date: 2003/12/18 20:43:53 $
$Log: ADevelopmentItemAction.php,v $
Revision 1.5  2003/12/18 20:43:53  dougqh
- Updated to work under PHP 4.2

Revision 1.4  2003/12/09 15:05:44  dougqh
Refactoring View->Action->Factory classes

Revision 1.3  2003/11/03 18:13:33  dougqh
- Feature 3743

Revision 1.2  2003/10/21 14:11:18  dougqh
Refactoring email handling

Revision 1.1  2003/07/09 20:09:49  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'DatabaseUI.ADbItemAction' );

//========================================================================

/*!
@class ADevelopmentItemAction
@abstract -
*/

class ADevelopmentItemAction extends ADbItemAction
{

//========================================================================

   /*!
   @function ADevelopmentItemAction()
   @discussion - constructs a new ADevelopmentItemAction object
   */

   function ADevelopmentItemAction()
   {
      $this->ADbItemAction();
   }

//========================================================================

   /*!
   @function createDbItem()
   */

   function &createDbItem()
   {
      $proto =& $this->dbItemFormView->getItemPrototype();
      return $proto->createNew( array( $this->getDevItemType() ) );
   }

//========================================================================

   /*!
   @function _createAdd( $project, $devItemType )
   */

   function &_createAdd( &$project, $devItemType )
   {
      importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.AddDevelopmentItemAction' );
      $action =& new AddDevelopmentItemAction();
      $action->_setBasics( $project, $devItemType );
      return $action;
   }

//========================================================================

   /*!
   @function _createModify( $actionSpecifier )
   */

   function &_createModify( $actionSpecifier )
   {
      switch ( $actionSpecifier )
      {
         case REVIEW_DEV_ITEM:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.ReviewDevelopmentItemAction' );
         return new ReviewDevelopmentItemAction();
         break;

         case VERIFY_DEV_ITEM:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.VerifyDevelopmentItemAction' );
         return new VerifyDevelopmentItemAction();
         break;

         case FAIL_DEV_ITEM:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.FailDevelopmentItemAction' );
         return new FailDevelopmentItemAction();
         break;

         case FIX_DEV_ITEM:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.FixDevelopmentItemAction' );
         return new FixDevelopmentItemAction();
         break;

         case ADD_COMMENT_DEV_ITEM:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.AddCommentDevelopmentItemAction' );
         return new AddCommentDevelopmentItemAction();
         break;

         case MORE_INFO_NEEDED_DEV_ITEM:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.MoreInfoNeededDevelopmentItemAction' );
         return new MoreInfoNeededDevelopmentItemAction();
         break;

         case MORE_INFO_GIVEN_DEV_ITEM:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.MoreInfoGivenDevelopmentItemAction' );
         return new MoreInfoGivenDevelopmentItemAction();
         break;

         case REOPEN_DEV_ITEM:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.ReOpenDevelopmentItemAction' );
         return new ReOpenDevelopmentItemAction();
         break;

         case DESIGNER_CLOSE_DEV_ITEM:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.DesignerCloseDevelopmentItemAction' );
         return new DesignerCloseDevelopmentItemAction();
         break;

         case ADD_ATTACHMENT_DEV_ITEM:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.AddAttachmentDevelopmentItemAction' );
         return new AddAttachmentDevelopmentItemAction();
         break;

         case ADD_RELATED_DEV_ITEM:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.AddRelatedDevelopmentItemAction' );
         return new AddRelatedDevelopmentItemAction();
         break;

         case CHANGE_TESTER_DEV_ITEM:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.ChangeTesterDevelopmentItemAction' );
         return new ChangeTesterDevelopmentItemAction();
         break;

         default:
         unreachablePoint( 'Unknown actionSpecifier: ' . $actionSpecifier );
         break;
      };
   }

//========================================================================

   /*!
   @function _setDbItem( $devItem )
   */

   function _setDbItem( &$devItem )
   {
      if ( is_null( $devItem ) )
      {
         unreachablePoint( 'Invalid DbItem at ADevItemAction->_setDbItem' );
      }

      $this->project =& $devItem->getProject();
      $this->devItemType = $devItem->_getReportTypeID();
      parent::_setDbItem( $devItem );
   }

//========================================================================

   /*!
   @function _setBasics( $project, $devItemType )
   */

   function _setBasics( &$project, $devItemType )
   {
      $this->project =& $project;
      $this->devItemType = $devItemType;
   }

//========================================================================

   /*!
   @function getProject()
   */

   function &getProject()
   {
      return $this->project;
   }

//========================================================================

   /*!
   @function getDevItemType()
   */

   function getDevItemType()
   {
      return $this->devItemType;
   }

//========================================================================

   /*!
   @function getAvailableStates()
   @discussion - provides a set of states the ADevelopmentItem may
      be placed in

      By default returns an IIterator across all States.
   @result - returns an IIterator< State >
   */

   function &getAvailableStates()
   {
      importClass( 'Bugs.State' );
      $stateProto =& State::getPrototype();

      return $stateProto->doSearch();
   }

//========================================================================

   /*!
   @function getAvailableCommentTypes()
   @discussion - provides a set of CommentTypes that may used when
      adding a Comment to the ADevelopmentItem

      By default returns an IIterator of all CommentTypes.
   @result - returns an IIterator< CommentType >
   */

   function &getAvailableCommentTypes()
   {
      importClass( 'Bugs.CommentType' );
      return CommentType::getCommentTypes(
         $this->getUser(),
         $this->getDbItem() );
   }

//========================================================================

   /*!
   @function execute()
   */

   function execute()
   {
      $this->_execute();

      importClass( 'BugUI.DevelopmentItemEmail' );
      $email =& new DevelopmentItemEmail(
         $this->getDisplayName(),
         $this->getDbItem() );

      $email->addUserRecipients(
         $this->getEmailRecipients() );

      if ( $this->excludeTriggeringUserFromEmail() )
      {
         $email->addUserExclusion( $this->getUser() );
      }

      $email->send();
   }

//========================================================================

   /*!
   @function _execute()
   */

   /* abstract function _execute(); */


//========================================================================

   /*!
   @function excludeTriggeringUserFromEmail()
   */

   function excludeTriggeringUserFromEmail()
   {
      return false;
   }

//========================================================================

   /*!
   @function getEmailRecipients()
   @discussion - provides an IIterator< User > of Users that
      should be email about this Action
   @result - returns an IIterator< User >
   */

   function &getEmailRecipients()
   {
      $devItem =& $this->getDbItem();
      $state =& $devItem->getState();

      $recipients = array();
      $associatedUsersIteratorArray = array();
      
      if ( $state->notifyTester() )
      {
         $recipients[] =& $devItem->getTester();
      }

      if ( $state->notifyDeveloper() )
      {
         $recipients[] =& $devItem->getDeveloper();
      }

      $associatedUsersIteratorArray[] =& IteratorFactory::getHashIterator( 
            $recipients );
      
      importClass( 'Collections.IteratorFactory' );
      if ( $state->notifyDesigners() )
      {
         $project =& $devItem->getProject();

         $associatedUsersIteratorArray[] =& $project->getDesigners();
      }
      if ( $state->notifyQALeads() )
      {
         $project =& $devItem->getProject();
         
         $associatedUsersIteratorArray[] =& $project->getQALeads();
      }

      return IteratorFactory::getMergeIterator( $associatedUsersIteratorArray );
   }

//========================================================================

   /*!
   @function getDevelopmentItemType()
   @discussion - provides a constant representing the type of
      ADevelopmentItem being created
   @result - returns a DevelopmentItemType constant
   */

   function getDevelopmentItemType()
   {
      if ( $this->isAdding() )
      {
         return $this->devItemType;
      }
      else
      {
         $devItem =& $this->getDbItem();
         return $devItem->_getReportTypeID();
      }
   }

//========================================================================

   /*!
   @function getTypeDisplayName()
   @discussion - provides a user-presentable name for the type
      of ADevelopmentItem
   @result - returns a String
   */

   function getTypeDisplayName()
   {
      return ADevelopmentItem::getTypeDisplayName(
         $this->getDevelopmentItemType() );
   }

//========================================================================

};

?>