<?php

/*
AddAttachmentDevelopmentItemAction
$Author: dougqh $
$Revision: 1.6 $
$Date: 2003/12/09 15:05:44 $
$Log: AddAttachmentDevelopmentItemAction.php,v $
Revision 1.6  2003/12/09 15:05:44  dougqh
Refactoring View->Action->Factory classes

Revision 1.5  2003/11/04 14:36:08  dougqh
- Fixed bug in 3743

Revision 1.4  2003/11/03 18:13:08  dougqh
- Feature 3743

Revision 1.3  2003/10/21 14:21:24  dougqh
Overridding getEmailRecipients to return DevItem->getAssociatedUsers.

Revision 1.2  2003/10/20 19:40:20  dougqh
- Using the new ADevItemController- method

Revision 1.1  2003/07/09 20:09:49  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.ADevelopmentItemAction' );

//========================================================================

/*!
@class AddAttachmentDevelopmentItemAction
@abstract - a concrete ADevelopmentItemAction
*/

class AddAttachmentDevelopmentItemAction extends ADevelopmentItemAction
{

//========================================================================

   /*!
   @function AddAttachmentDevelopmentItemAction()
   @discussion - constructs a new AddAttachmentDevelopmentItemAction object
   */

   function AddAttachmentDevelopmentItemAction()
   {
      $this->ADevelopmentItemAction();
   }

//========================================================================

   /*!
   @function getAvailableFieldNames()
   @discussion - provides an array of field names that are available
      for use with this Action
   @result - returns String[]
   */

   function getAvailableFieldNames()
   {
      return array(
         'attachmentFile',
         'attachmentDescription' );
   }

//========================================================================

   /*!
   @function isRequired( $fieldName )
   @param $fieldName - a String - specifying a field name
   @discussion - indicates if that field is required for this action
   @result - returns a boolean
   */

   function isRequired( $fieldName )
   {
      switch ( $fieldName )
      {
         case 'attachmentFile':
         return true;

         default:
         return false;
      };
   }

//========================================================================


   /*!
   @function _execute()
   */

   function _execute()
   {
      $devItem =& $this->getDbItem();

      $fileField =& $this->getField( 'attachmentFile' );

      //Create and add the Attachment here
      importClass( 'Bugs.Attachment' );
      $devItem->addAttachment(
         Attachment::create(
            $this->getUser(),
            $this->getFieldValue( 'attachmentFile' ),
            $this->getFieldValue( 'attachmentDescription' ) ) );
   }

//========================================================================

   /*!
   @function isEnabled()
   */

   function isEnabled()
   {
      return true;
   }

//========================================================================

   /*!
   @function getDisplayName()
   */

   function getDisplayName()
   {
      return 'Add Attachment';
   }

//========================================================================

   /*!
   @function isUploader()
   */

   function isUploader()
   {
      return true;
   }

//========================================================================

   /*!
   @function getEmailRecipients()
   */

   function &getEmailRecipients()
   {
      $devItem =& $this->getDbItem();
      return $devItem->getAssociatedUsers();
   }

//========================================================================

   /*!
   @function excludeTriggeringUserFromEmail()
   */

   function excludeTriggeringUserFromEmail()
   {
      return true;
   }

//========================================================================

};

?>