<?php

/*
AddDevelopmentItemAction
$Author: dougqh $
$Revision: 1.3 $
$Date: 2003/12/31 16:02:41 $
$Log: AddDevelopmentItemAction.php,v $
Revision 1.3  2003/12/31 16:02:41  dougqh
- 3930

Revision 1.2  2003/12/09 15:05:44  dougqh
Refactoring View->Action->Factory classes

Revision 1.1  2003/07/09 20:09:49  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.ADevelopmentItemAction' );

//========================================================================

/*!
@class AddDevelopmentItemAction
@abstract - a concrete ADevelopmentItemAction that adds a new
   ADevelopmentItem to a Project
*/

class AddDevelopmentItemAction extends ADevelopmentItemAction
{

//========================================================================

   /*!
   @function AddDevelopmentItemAction()
   @discussion - constructs a new AddDevelopmentItemAction object
   */

   function AddDevelopmentItemAction()
   {
      $this->ADevelopmentItemAction();
   }

//========================================================================

   /*!
   @function isAdding()
   */

   function isAdding()
   {
      return true;
   }

//========================================================================

   /*!
   @function getAvailableFieldNames()
   @discussion - provides an array of field names that are available
      for use with this Action
   @result - returns String[]
   */

   function getAvailableFieldNames()
   {
      $fields = array(
         'subject',
         'report',
         'frequency',
         'severity',
         'steps',
         'subproject',
         'category',
         'clientPlatform',
         'clientType',
         'detectedClientVersion',
         'serverPlatform',
         'serverInstance',
         'detectedServerVersion' );

      //if its a task, then set the priority up front
      if ( $this->getDevelopmentItemType() == TASK )
      {
         $fields[] = 'priority';
      }

      return $fields;
   }

//========================================================================

   /*!
   @function isRequired( $fieldName )
   @param $fieldName - a String - specifying a field name
   @discussion - indicates if that field is required for this action
   @result - returns a boolean
   */

   function isRequired( $fieldName )
   {
      switch ( $fieldName )
      {
         case 'subject':
         case 'report':
         case 'frequency':
         case 'severity':
         case 'priority':
         case 'steps':
         case 'subproject':
         case 'category':
         case 'clientPlatform':
         case 'clientType':
         case 'detectedClientVersion':
         case 'serverPlatform':
         case 'serverInstance':
         case 'detectedServerVersion':
         return true;

         default:
         return false;
      };
   }

//========================================================================

   /*!
   @function _execute()
   @discussion - actually performs the action

      Only called if all validation checks passed.
   */

   function _execute()
   {
      $devItem =& $this->getDbItem();

      $devItem->_setBasics(
         $this->getFieldValue( 'subject' ),
         $this->getFieldValue( 'report' ),
         $this->getFieldValue( 'subproject' ),
         $this->getFieldValue( 'category' ),
         $this->getUser() );

      $devItem->_setInitialServerInfo(
         $this->getFieldValue( 'serverPlatform' ),
         $this->getFieldValue( 'serverInstance' ),
         $this->getFieldValue( 'detectedServerVersion' ) );

      $devItem->_setInitialClientInfo(
         $this->getFieldValue( 'clientPlatform' ),
         $this->getFieldValue( 'clientType' ),
         $this->getFieldValue( 'detectedClientVersion' ) );

      $priorityField =& $this->getField( 'priority' );
      if ( $priorityField->isEnabled() )
      {
         $devItem->_setPriority( $priorityField->getValue() );
      }

      if ( $this->hasField( 'severity' ) )
      {
         $devItem->_setSeverity( $this->getFieldValue( 'severity' ) );
      }

      if ( $this->hasField( 'frequency' ) )
      {
         $devItem->_setFrequency( $this->getFieldValue( 'frequency' ) );
      }

      if ( $this->hasField( 'steps' ) )
      {
         $devItem->_setStepsToReproduce( $this->getFieldValue( 'steps' ) );
      }

      $project =& $this->getProject();
      $project->addDevelopmentItem( $devItem );
   }

//========================================================================

   /*!
   @function isEnabled()
   */

   function isEnabled()
   {
      //only designers can add Tasks
      importClass( 'Bugs.ADevelopmentItem' );
      if ( $this->getDevItemType() == TASK )
      {
         $project =& $this->getProject();
         return $project->isDesigner( $this->getUser() );
      }
      else
      {
         return true;
      }
   }

//========================================================================

   /*!
   @function getDisplayName()
   */

   function getDisplayName()
   {
      return 'Add ' . $this->getTypeDisplayName();
   }

//========================================================================

};

?>