<?php

/*
ChangeTesterDevelopmentItemAction
$Author: dougqh $
$Revision: 1.9 $
$Date: 2003/12/12 16:43:29 $
$Log: ChangeTesterDevelopmentItemAction.php,v $
Revision 1.9  2003/12/12 16:43:29  dougqh
Fixing 3901

Revision 1.8  2003/12/09 15:05:44  dougqh
Refactoring View->Action->Factory classes

Revision 1.7  2003/11/03 20:11:34  dougqh
- Fixed 3748

Revision 1.6  2003/10/21 14:11:18  dougqh
Using the new ADevelopmentItemController->getUser method.

Revision 1.5  2003/07/14 17:53:12  dawn
- tester_id -

Revision 1.4  2003/07/14 17:15:33  dawn
- capitalization

Revision 1.3  2003/07/14 17:00:22  dawn
- correct typo

Revision 1.2  2003/07/14 16:35:35  dawn
- change tester form

Revision 1.1  2003/07/14 16:13:10  dawn
- adding change tester field

Revision 1.1  2003/07/09 20:09:49  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.ADevelopmentItemAction' );

//========================================================================

/*!
@class ChangeTesterDevelopmentItemAction
@abstract - a concrete ADevelopmentItemAction
*/

class ChangeTesterDevelopmentItemAction extends ADevelopmentItemAction
{

//========================================================================

   /*!
   @function ChangeTesterDevelopmentItemAction()
   @discussion - constructs a new ChangeTesterDevelopmentItemAction object
   */

   function ChangeTesterDevelopmentItemAction()
   {
      $this->ADevelopmentItemAction();
   }

//========================================================================

   /*!
   @function getAvailableFieldNames()
   @discussion - provides an array of field names that are available
      for use with this Action
   @result - returns String[]
   */

   function getAvailableFieldNames()
   {
      return array( 'tester' );
   }

//========================================================================

   /*!
   @function isRequired( $fieldName )
   @param $fieldName - a String - specifying a field name
   @discussion - indicates if that field is required for this action
   @result - returns a boolean
   */

   function isRequired( $fieldName )
   {
      switch ( $fieldName )
      {
         case 'tester':
         return true;

         default:
         return false;
      };
   }

//========================================================================


   /*!
   @function _execute()
   @discussion - actually performs the action

      Only called if all validation checks passed.
   */

   function _execute()
   {
      $devItem =& $this->getDbItem();
      $devItem->_setTester( $this->getFieldValue( 'tester' ) );
      $devItem->_store();
   }

//========================================================================

   /*!
   @function isEnabled()
   */
   function isEnabled()
   {
      $devItem =& $this->getDbItem();
      if( $devItem->isClosed() ) return false;
      $project =& $devItem->getProject();
      return $project->isQALead( $this->getUser() );
   }

//========================================================================

   /*!
   @function getDisplayName()
   */

   function getDisplayName()
   {
      return 'Change Tester';
   }

//========================================================================

   /*!
   @function getEmailRecipients()
   */

   function &getEmailRecipients()
   {
      $devItem =& $this->getDbItem();
      importClass( 'Collections.IteratorFactory' );
      return IteratorFactory::getScalarIterator( $devItem->getTester() );
   }

//========================================================================

};

?>