<?php

/*
FixDevelopmentItemAction
$Author: dougqh $
$Revision: 1.6 $
$Date: 2003/12/12 16:43:29 $
$Log: FixDevelopmentItemAction.php,v $
Revision 1.6  2003/12/12 16:43:29  dougqh
Fixing 3901

Revision 1.5  2003/12/09 19:31:49  dougqh
- 3894

Revision 1.4  2003/12/09 15:05:44  dougqh
Refactoring View->Action->Factory classes

Revision 1.3  2003/11/05 14:17:12  dougqh
- Feature 3754

Revision 1.2  2003/10/21 14:11:18  dougqh
Using the new ADevelopmentItemController->getUser method.

Revision 1.1  2003/07/09 20:09:49  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.ADevelopmentItemAction' );

//========================================================================

/*!
@class FixDevelopmentItemAction
@abstract - a concrete ADevelopmentItemAction
*/

class FixDevelopmentItemAction extends ADevelopmentItemAction
{

//========================================================================

   /*!
   @function FixDevelopmentItemAction()
   @discussion - constructs a new FixDevelopmentItemAction object
   */

   function FixDevelopmentItemAction()
   {
      $this->ADevelopmentItemAction();
   }

//========================================================================

   /*!
   @function getAvailableFieldNames()
   @discussion - provides an array of field names that are available
      for use with this Action
   @result - returns String[]
   */

   function getAvailableFieldNames()
   {
      return array(
         'newCodeDuration',
         'newMiscDuration',
         'fixedClientVersion',
         'fixedServerVersion',
         'comment' );
   }

//========================================================================

   /*!
   @function isRequired( $fieldName )
   @param $fieldName - a String - specifying a field name
   @discussion - indicates if that field is required for this action
   @result - returns a boolean
   */

   function isRequired( $fieldName )
   {
      switch ( $fieldName )
      {
         case 'newCodeDuration':
         case 'newMiscDuration':
         case 'fixedClientVersion':
         case 'fixedServerVersion':
         return true;

         default:
         return false;
      };
   }

//========================================================================

   /*!
   @function additionalChecksAreValid()
   @discussion - overridden to do some additional checks that related
      to development plan, newDesignHours, etc.
   */

   function additionalChecksAreValid()
   {
      //TODO: verify that code hours are positive

      return true;
   }

//========================================================================


   /*!
   @function _execute()
   @discussion - actually performs the action

      Only called if all validation checks passed.
   */

   function _execute()
   {
      $devItem =& $this->getDbItem();
      $devItem->fixed(
         $this->getUser(),
         $this->getFieldValue( 'newCodeDuration' ),
         $this->getFieldValue( 'newMiscDuration' ),
         $this->getFieldValue( 'fixedServerVersion' ),
         $this->getFieldValue( 'fixedClientVersion' ),
         $this->getFieldValue( 'comment' ) );
   }

//========================================================================

   /*!
   @function isEnabled()
   */

   function isEnabled()
   {
      $devItem =& $this->getDbItem();
      $state =& $devItem->getState();

      return $devItem->canFix( $this->getUser() ) &&
         ( $state->getPrimaryID() < CLOSED_FIXED_STATE_ID );
   }

//========================================================================

   /*!
   @function getDisplayName()
   */

   function getDisplayName()
   {
      return 'Verification Requested';
   }

//========================================================================

};

?>