<?php

/*
ADevelopmentItemFieldFactory
$Author: dougqh $
$Revision: 1.5 $
$Date: 2004/05/19 14:18:19 $
$Log: ADevelopmentItemFieldFactory.php,v $
Revision 1.5  2004/05/19 14:18:19  dougqh
- Added support for duedate

Revision 1.4  2004/05/19 13:41:53  millz
- added duedate

Revision 1.3  2004/01/21 13:53:13  millz
- making constructor call parent

Revision 1.2  2003/12/09 19:31:38  dougqh
- 3894

Revision 1.1  2003/12/09 15:06:27  dougqh
Initial revision

Revision 1.13  2003/11/05 14:15:46  dougqh
- Feature 3754

Revision 1.12  2003/11/03 18:13:24  dougqh
- Feature 3743

Revision 1.11  2003/10/21 14:11:18  dougqh
Refactoring email handling

Revision 1.10  2003/09/04 19:21:59  dawn
- removed line inserted previously

Revision 1.9  2003/09/04 19:18:31  dawn
- playing with default field entries

Revision 1.8  2003/08/05 18:10:34  dougqh
- Added a guard to catch bad ADevelopmentItems in createFromExisting

Revision 1.7  2003/07/23 22:10:21  dougqh
- Added project field support, added method shouldAddHiddenProjectField, added handled for that hidden field in _setBasics.

Revision 1.6  2003/07/22 13:45:00  millz
- updated to allow for any sep character for related items

Revision 1.5  2003/07/14 18:01:18  dawn
- add tester

Revision 1.4  2003/07/14 17:17:23  dawn
- capitalization

Revision 1.3  2003/07/14 16:35:59  dawn
- change tester form

Revision 1.2  2003/07/09 22:21:36  dougqh
Accounting for moving IDListField from CollectionUI to DatabaseUI.

Revision 1.1  2003/07/09 20:09:49  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

//import for its constants
importClass( 'Bugs.ADevelopmentItem' );

//========================================================================

importClass( 'DatabaseUI.ADbItemFieldFactory' );

//========================================================================

/*!
@class ADevelopmentItemFieldFactory
@abstract - a helper class used by concrete AFormViews that wish to enter /
   manipulate an ADevelopmentItem
@discussion - This class bears no resemblance to the GoF builder pattern.
*/

class ADevelopmentItemFieldFactory extends ADbItemFieldFactory
{

//========================================================================

   /*!
   @function ADevelopmentItemFieldFactory()
   @discussion - constructs a new ADevelopmentItemFieldFactory object
   @result - constructs a new ADevelopmentItemFieldFactory object
   */

   function ADevelopmentItemFieldFactory()
   {
      $this->ADbItemFieldFactory();
   }

//========================================================================

   /*!
   @function create( $devItemType )
   @param $devItemType - one of FEATURE_REQUEST, TASK, DEFECT
   @discussion - provides a new concrete ADevelopmentItemFieldFactory
      chosen based on $devItemType

      Helper static method of createFromExisting and createForNew.
   @result - returns an ADevelopmentItemFieldFactory
   */

   function &create( $devItemType )
   {
      //ADevelopmentItem was imported at the top of the file, so
      //the constants are definitely loaded.
      switch ( $devItemType )
      {
         case TASK:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.FieldFactories.TaskFieldFactory' );
         return new TaskFieldFactory();

         case FEATURE_REQUEST:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.FieldFactories.FeatureFieldFactory' );
         return new FeatureFieldFactory();

         case DEFECT:
         importClass( 'BugUI.UIHelpers.DevelopmentItem.FieldFactories.DefectFieldFactory' );
         return new DefectFieldFactory();

         default:
         unreachablePoint(
            getLocation() . NL .
            'Invalid DevItemType: ' . $devItemType );
         break;
      };
   }

//========================================================================

   /*!
   @function _createField( $name )
   @param $name - a String - the name of a field
   @discussion - creates the ALightFormField that corresponds to the given
      name

      Child classes may override this method to support additional fields,
      but they should always call parent::_createField.
   @result - returns an ALightFormField
   */

   function &_createField( $name )
   {
      $isDesigner = $this->_isDesigner();
      $isDeveloper = $this->_isDeveloper();
      $project =& $this->action->getProject();
      $isNew = $this->_creatingNew();
      $canFix = false;

      if ( ! $isNew )
      {
         $devItem =& $this->getDbItem();
         $canFix = $devItem->canFix( $this->getUser() );
      }

      $isTester = $this->_isTester();

      switch ( $name )
      {
         //---------------------------------------------------------------

         case 'ID':
         if ( $isNew )
         {
            $field = NULL;
         }
         else
         {
            $field =& $this->_createText( $name, 'TR-ID' );
            $field->setEnabled( false );
            $field->setValue( toRef( $devItem->getID() ) );
         }
         return $field;

         //---------------------------------------------------------------

         case 'project':
         $field =& $this->_createSelect1( 'Shared.Project', 'project' );
         $field->setValue( $this->action->getProject() );
         $field->setEnabled( false );
         return $field;

         //---------------------------------------------------------------

         case 'duedate':
         $field =& $this->_createFutureDate( $name, 'Due Date' );
         if ( ! $isNew ) $field->setValue( $devItem->getDueDateEpoch() );
         return $field;

         //---------------------------------------------------------------

         case 'subject':
         $field =& $this->_createText( $name );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getSubject() );
         return $field;

         //---------------------------------------------------------------

         case 'comment':
         $field =& $this->_createTextArea( $name );
         // $field->setEnabled( $isNew );
         // if ( ! $isNew ) $field->setValue( $devItem->getReport() );
         return $field;

         //---------------------------------------------------------------

         case 'report':
         $field =& $this->_createTextArea( $name );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getReport() );
         return $field;

         //---------------------------------------------------------------

         case 'priority':
         $field =& $this->_createSelect1(
            'Bugs.Priority',
            $name );
         if ( ! $isNew ) $field->setValue( $devItem->getPriority() );
         return $field;

         //---------------------------------------------------------------

         case 'developer':
         $field =& $this->_createSelect2(
            $project->getDevelopers(),
            $name );
         $field->setAllowNull( '--Unassigned--' );
         $field->setEnabled( $isDesigner );
         if ( ! $isNew ) $field->setValue( $devItem->getDeveloper() );
         return $field;

         //---------------------------------------------------------------

         case 'developmentPlan':
         $field =& $this->_createTextArea( $name, 'Development Plan' );
         if ( ! $isNew && $devItem->isDesigned() )
         {
            //once its been set - it cannot be changed
            $field->setEnabled( false );
            $field->setValue( $devItem->getDevelopmentPlan() );
         }
         else
         {
            $field->setEnabled( $isDesigner );
         }
         return $field;

         //---------------------------------------------------------------

         case 'newDesignDuration':
         $field =& $this->_createTimeDuration( $name, 'New Design Time' );
         if ( $devItem->isDesigned() )
         {
            importClass( 'Bugs.ADevelopmentItem' );
            $field->setValue( ADevelopmentItem::_createDuration( 0 ) );
         }
         $field->setEnabled( $isNew || ( ! $devItem->isDesigned() ) );
         return $field;

         //---------------------------------------------------------------

         case 'estCodeDuration':
         $field =& $this->_createTimeDuration( $name, 'Estimated Code Time' );
         if ( ! $isNew && $devItem->isDesigned() )
         {
            //once its been set - it cannot be changed
            $field->setEnabled( false );
            $field->setValue( $devItem->getEstimatedCodeDuration() );
         }
         else
         {
            $field->setEnabled( $isDesigner );
         }
         return $field;

         //---------------------------------------------------------------

         case 'estMiscDuration':
         $field =& $this->_createTimeDuration( $name, 'Estimated Misc. Time' );
         if ( ! $isNew && $devItem->isDesigned() )
         {
            //once its been set - it cannot be changed
            $field->setEnabled( false );
            $field->setValue( $devItem->getEstimatedMiscDuration() );
         }
         else
         {
            $field->setEnabled( $isDesigner );
         }
         return $field;

         //---------------------------------------------------------------

         case 'totalCodeDuration':
         $field =& $this->_createTimeDuration( $name, 'Total Code Time' );
         $field->setEnabled( false );
         if ( ! $isNew ) $field->setValue( $devItem->getTotalDuration() );
         return $field;

         //---------------------------------------------------------------

         case 'newCodeDuration':
         $field =& $this->_createTimeDuration( $name, 'New Code Time' );
         $field->setEnabled( $canFix );
         return $field;

         //---------------------------------------------------------------

         case 'totalMiscDuration':
         $field =& $this->_createTimeDuration( $name, 'Total Misc. Time' );
         $field->setEnabled( false );
         if ( ! $isNew ) $field->setValue( $devItem->getTotalMiscDuration() );
         return $field;

         //---------------------------------------------------------------

         case 'newMiscDuration':
         $field =& $this->_createTimeDuration( $name, 'New Misc. Time' );
         $field->setEnabled( $canFix );
         return $field;

         //---------------------------------------------------------------

         case 'newTestDuration':
         $field =& $this->_createTimeDuration( $name, 'New Test Time' );
         return $field;

         //---------------------------------------------------------------

         case 'detectedServerVersion':
         $field =& $this->_createVersion(
            $project->getServerVersions(),
            $name,
            'Server Detected Version' );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getDetectedServerVersion() );
         return $field;

         //---------------------------------------------------------------

         case 'state':
         $field =& $this->_createSelect2(
            $this->action->getAvailableStates(),
            $name );
         if ( ! $isNew ) $field->setValue( $devItem->getState() );
         return $field;

         //---------------------------------------------------------------

         case 'fixedServerVersion':
         $field =& $this->_createVersion(
            $project->getServerVersions(),
            $name,
            'Server Fixed Version' );
         if ( ! $isNew ) $field->setValue( $devItem->getFixedServerVersion() );
         return $field;

         //---------------------------------------------------------------

         case 'serverPlatform':
         $field =& $this->_createSelect2(
            $project->getServerPlatforms(),
            $name,
            'Server Platform' );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getServerPlatform() );
         return $field;

         //---------------------------------------------------------------

         case 'serverInstance':
         $field =& $this->_createSelect2(
            $project->getServerInstances(),
            $name,
            'Server Instance' );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getServerInstance() );
         return $field;

         //---------------------------------------------------------------

         case 'detectedClientVersion':
         $field =& $this->_createVersion(
            $project->getClientVersions(),
            'detectedClientVersion',
            'Client Detected Version' );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getDetectedClientVersion() );
         return $field;

         //---------------------------------------------------------------

         case 'fixedClientVersion':
         $field =& $this->_createVersion(
            $project->getClientVersions(),
            $name,
            'Client Fixed Version' );
         $field->setRequired( false );
         if ( ! $isNew ) $field->setValue( $devItem->getFixedClientVersion() );
         return $field;

         //---------------------------------------------------------------

         case 'clientPlatform':
         $field =& $this->_createSelect2(
            $project->getClientPlatforms(),
            $name,
            'Client Platform' );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getClientPlatform() );
         return $field;

         //---------------------------------------------------------------

         case 'clientType':
         $field =& $this->_createSelect2(
            $project->getClientTypes(),
            'clientType',
            'Client Type' );
         $field->setEnabled( $isNew );
         if ( ! $isNew ) $field->setValue( $devItem->getClientType() );
         return $field;

         //---------------------------------------------------------------

         case 'category':
         $field =& $this->_createSelect2(
            $project->getCategories(),
            $name );
         $field->setEnabled( $isNew || $isDeveloper || $isDesigner );
         if ( ! $isNew ) $field->setValue( $devItem->getCategory() );
         return $field;

         //---------------------------------------------------------------

         case 'subproject':
         $field =& $this->_createSelect2(
            $project->getSubprojects(),
            $name );
         $field->setEnabled( $isNew || $isDeveloper || $isDesigner );
         if ( ! $isNew ) $field->setValue( $devItem->getSubproject() );
         return $field;

         //---------------------------------------------------------------

         case 'tester':
         $field =& $this->_createSelect2(
            $project->getAvailableTesters(),
            $name );
         // $field->setEnabled( $isDesigner );
         if ( ! $isNew ) $field->setValue( $devItem->getTester() );
         return $field;

         //---------------------------------------------------------------

         case 'commentType':
         $field =& $this->_createSelect2(
            $this->action->getAvailableCommentTypes(),
            $name,
            'Type' );
         return $field;

         //---------------------------------------------------------------

         case 'attachmentFile':
         importClass( 'HTMLComponents.LightForms.LightFileField' );
         return new LightFileField( $name, 'Attachment' );

         //---------------------------------------------------------------

         case 'attachmentDescription':
         return $this->_createTextArea( $name, 'Description' );

         //---------------------------------------------------------------

         case 'newRelated':
         importClass( 'DatabaseUI.IDListField' );
         importClass( 'Bugs.ADevelopmentItem' );
         return new IDListField(
            $name,
            'Related IDs (separated by anything)',
            ADevelopmentItem::getPrototype() );

         //---------------------------------------------------------------

         default:
         return toRef( NULL );

         //---------------------------------------------------------------

      } //case
   }

//========================================================================

   /*!
   @function _createVersion( $iterator, $name, [ $displayName ] )
   @param $iterator - an IIterator< Version >
   @param $name - an identifying String
   @param $displayName - a user-presentable String - optional
      - defaults to ucfirst( $name )
   @discussion - constructs a new VersionField
   @result - returns a new VersionField
   */

   function &_createVersion( &$iterator, $name, $displayName )
   {
      $displayName = $this->_getDisplayName( $name, $displayName );

      importClass( 'BugUI.OtherComponents.VersionField' );
      return new VersionField( &$iterator, $name, $displayName );
   }

//========================================================================

   /*!
   @function _isTester()
   @discussion - indicates if the current user is the tester
      for the target ADevelopmentItem
   @result - returns a boolean
   */

   function _isTester()
   {
      if ( $this->_creatingNew() )
      {
         $project =& $this->action->getProject();
         return $project->isQA( $this->getUser() );
      }
      else
      {
         $devItem =& $this->getDbItem();
         return $devItem->isTester( $this->getUser() );
      }
   }

//========================================================================

   /*!
   @function _isDeveloper()
   @discussion - indicates if the current user is the developer
      for the target ADevelopmentItem
   @result - returns a boolean
   */

   function _isDeveloper()
   {
      $project =& $this->action->getProject();
      if ( $this->_creatingNew() )
      {
         return $project->isDeveloper( $this->action->getUser() );
      }
      else
      {
         $devItem =& $this->getDbItem();
         return $devItem->isDeveloper( $this->action->getUser() );
      }
   }

//========================================================================

   /*!
   @function _isDesigner()
   @discussion - indicates if the current user is a designer for
      the Project of the target ADevelopmentItem
   @result - returns a boolean
   */

   function _isDesigner()
   {
      $project =& $this->action->getProject();
      return $project->isDesigner( $this->action->getUser() );
   }

//========================================================================

   /*!
   @function _creatingNew()
   */

   function _creatingNew()
   {
      return $this->action->isAdding();
   }

//========================================================================

};

?>