<?php

/*
AFavoriteItemSetAction
$Author: dougqh $
$Revision: 1.3 $
$Date: 2004/01/14 23:08:32 $
$Log: AFavoriteItemSetAction.php,v $
Revision 1.3  2004/01/14 23:08:32  dougqh
- Minor correction to my last change

Revision 1.2  2004/01/14 23:07:29  dougqh
- Made createFromRequest return an add action if the favSetAction is not specified in the REQUEST

Revision 1.1  2004/01/14 23:06:09  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'DatabaseUI.ADbItemSetAction' );

//========================================================================

/*!
@class AFavoriteItemSetAction
@abstract -
*/

define( 'ADD_TO_FAVORITE_ITEM_SET_ACTION', 0 );
define( 'REMOVE_FROM_FAVORITE_ITEM_SET_ACTION', 1 );
class AFavoriteItemSetAction extends ADbItemSetAction
{

//========================================================================

   /*!
   @function AFavoriteItemSetAction( &$user )
   @param $user - the User invoking this ADbItemSetAction
   */

   function AFavoriteItemSetAction( &$user )
   {
      $this->ADbItemSetAction( $user );
   }

//========================================================================

   /*!
   @function createAddToAction( $user )
   @discussion - provides an AFavoriteItemSetAction that adds to a new
      FavoriteItemSet
   @param $user - the User executing this Action
   */

   /* static */
   function &createAddToAction( &$user )
   {
      importClass( 'BugUI.UIHelpers.FavoriteItemSet.AddToFavoriteItemSetAction' );
      return new AddToFavoriteItemSetAction( $user );
   }

//========================================================================

   /*!
   @function createRemoveFromAction( &$user, &$favSet )
   @param $user - the User executing this Action
   @param $favSet - a FavoriteItemSet
   @discussion -
   /* static */
   function &createRemoveFromAction( &$user, &$favSet )
   {
      importClass( 'BugUI.UIHelpers.FavoriteItemSet.RemoveFromFavoriteItemSetAction' );
      return new RemoveFromFavoriteItemSetAction( $user, $favSet );
   }

//========================================================================

   /*!
   @function createFromRequest( $user )
   @param $user - User executing this Action
   @discussion - constructs an AFavoriteItemSetAction based on information
      in _REQUEST
   @result - returns a AFavoriteItemSetAction
   */

   /* static */
   function &createFromRequest( &$user )
   {
      if ( ! isset( $_REQUEST{ 'favSetAction' } ) )
      {
         return AFavoriteItemSetAction::createAddToAction( $user );
      }

      $params[] =& $user;
      switch ( $_REQUEST{ 'favSetAction' } )
      {
         case ADD_TO_FAVORITE_ITEM_SET_ACTION:
         importClass( 'BugUI.UIHelpers.FavoriteItemSet.AddToFavoriteItemSetAction' );
         return callStaticMethod( 'AddToFavoriteItemSetAction', '_createFromRequest', $params );

         case REMOVE_FROM_FAVORITE_ITEM_SET_ACTION:
         importClass( 'BugUI.UIHelpers.FavoriteItemSet.RemoveFromFavoriteItemSetAction' );
         return callStaticMethod( 'RemoveFromFavoriteItemSetAction', '_createFromRequest', $params );

         default:
         unreachablePoint( 'AFavoriteItemSetAction::createFromRequest (2)- Favorite Item Set Action unknown' );
      };
   }

//========================================================================

   /*!
   @function _createFromRequest( $user )
   @param $user - the User that executhing this Action
   @discussion - defined by the child class to instantiate an instance
      based on the information in _REQUEST
   @result - returns an AFavoriteItemSetAction
   */

   /* abstract static &_createFromRequest( &$user ); */

//========================================================================

   /*!
   @function getParameters()
   */

   function getParameters()
   {
      return array( 'favSetAction' => $this->_getActionID() );
   }

//========================================================================

   /*!
   @function _getActionID()
   @discussion - provides an ID to identify the type of AFavoriteItemSetAction
   */

   /* abstract _getActionID(); */

//========================================================================

};

?>