<?php

/*
RemoveFromFavoriteItemSetAction
$Author: dougqh $
$Revision: 1.1 $
$Date: 2004/01/14 23:06:09 $
$Log: RemoveFromFavoriteItemSetAction.php,v $
Revision 1.1  2004/01/14 23:06:09  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.UIHelpers.FavoriteItemSet.AFavoriteItemSetAction' );

//========================================================================

/*!
@class RemoveFromFavoriteItemSetAction
@abstract -
*/

class RemoveFromFavoriteItemSetAction extends AFavoriteItemSetAction
{


//========================================================================

   /*!
   @function RemoveFromFavoriteItemSetAction( $user, $favSet )
   @param $user - the User invoking this Action
   @param $favSet - the FavoriteItemSet attempting to be modified
   */

   function RemoveFromFavoriteItemSetAction( &$user, &$favSet )
   {
      $this->AFavoriteItemSetAction( $user );
      $this->favSet =& $favSet;
   }

//========================================================================

   /*!
   @function _createFromRequest( $user )
   */
   function &_createFromRequest( &$user )
   {
      //TODO: Make this check more stringent (only integers)
      if ( isset( $_REQUEST{ 'rmFavSetID' } ) && is_numeric( $_REQUEST{ 'rmFavSetID' } ) )
      {
         importClass( 'Bugs.FavoriteItemSet' );
         return new RemoveFromFavoriteItemSetAction(
            &$user,
            FavoriteItemSet::getFromPrimaryID( $_REQUEST{ 'rmFavSetID' } ) );
      }
      else
      {
         unreachablePoint( 'Invalid input RemoveFromFavoriteItemSetAction::createFromRequest' );
      }
   }

//========================================================================

   /*!
   @function _getActionID()
   */
   function _getActionID()
   {
      return REMOVE_FROM_FAVORITE_ITEM_SET_ACTION;
   }

//========================================================================

   /*!
   @function getDisplayName()
   */
   function getDisplayName()
   {
      return 'Remove checked items from Favorites Group';
   }

//========================================================================

   /*!
   @function getParameters()
   */
   function getParameters()
   {
      $params = parent::getParameters();
      $params{ 'rmFavSetID' } = $this->favSet->getPrimaryID();
      return $params;
   }

//========================================================================

   /*!
   @function getFieldDisplayName()
   */
   function getFieldDisplayName()
   {
      return 'Selected items';
   }

//========================================================================

   /*!
   @function isEnabled()
   */
   function isEnabled()
   {
      return $this->favSet->isUser( $this->getUser() );
   }

//========================================================================

   /*!
   @function execute()
   */
   function execute( &$checkBoxGroup )
   {
      $this->favSet->removeDevelopmentItemsByIDs( $checkBoxGroup->getChecked() );
      $user =& $this->getUser();
      $user->storeFavoriteItemSet( $this->favSet );
   }

//========================================================================

   /*!
   @function getNextView()
   */
   function &getNextView()
   {
      importClass( 'BugUI.Views.FavoriteItemSetView' );
      return FavoriteItemSetView::create( $this->favSet );
   }

//========================================================================

};

?>