<?php

/*
AddProjectAction
$Author: millz $
$Revision: 1.2 $
$Date: 2004/04/01 22:09:23 $
$Log: AddProjectAction.php,v $
Revision 1.2  2004/04/01 22:09:23  millz
more fields in place

Revision 1.1  2004/03/24 19:42:39  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/
//========================================================================

importClass( 'DatabaseUI.ADbItemAction' );
/*!
@class AddProjectAction
@abstract - 
*/

class AddProjectAction extends ADbItemAction
{

//========================================================================

   // <class vars>

//========================================================================

   /*!
   @function AddProjectAction(  )
   @discussion - constructs a new AddProjectAction object
   @result - constructs a new AddProjectAction object
   */
   
   function AddProjectAction( )
   {

         $this->ADbItemAction();

   }
   
   
//========================================================================

   /*!
   @function getAvailableFieldNames()
   @discussion - provides an array of field names that are available
      for use with this Action
   @result - returns String[]
   */

   function getAvailableFieldNames()
   {
    
       return array( 'name','defaultTester','categoryName','clientTypeName','instanceName','subprojectName' );
      
   }

//========================================================================

   /*!
   @function isAdding()
   */

   function isAdding()
   {
      return true;
   }

//========================================================================

   /*!
   @function creatingNew()
   */

   function creatingNew()
   {
      return true;
   }

//========================================================================

   /*!
   @function isRequired( $fieldName )
   @param $fieldName - a String - specifying a field name
   @discussion - indicates if that field is required for this action
   @result - returns a boolean
   */

   function isRequired( $fieldName )
   {
      return true;
   }

//========================================================================

   /*!
   @function execute()
   @discussion - actually performs the action

      Only called if all validation checks passed.
   */

   function execute()
   {
        //Have to the store early, so the project contains
        // a real project_id when we call the various add methods
        $project =& $this->getDbItem();
        $project->_setName( $this->getFieldValue( 'name' ) );
        $project->_setDefaultTester( $this->getFieldValue( 'defaultTester' ) );
        $project->_store();

        importClass( 'Bugs.Category' );
        $category =& new Category();
        $category->_setName( $this->getFieldValue( 'categoryName' ) );
        $project->addCategory( $category );
        
        importClass( 'Bugs.Subproject' );
        $subproject =& new Subproject();
        $subproject->_setName( $this->getFieldValue( 'subprojectName' ) );
        $project->addSubproject( $subproject );

        importClass( 'Bugs.ClientType' );
        $clientType =& new ClientType();
        $clientType->_setName( $this->getFieldValue( 'clientTypeName' ) );
        $project->addClientType( $clientType );
        
        importClass( 'Bugs.ServerInstance' );
        $instance =& new ServerInstance();
        $instance->_setName( $this->getFieldValue( 'instanceName' ) );
        $project->addServerinstance( $instance );

   }

//========================================================================

   /*!
   @function isEnabled()
   @discussion - determines if this ADevItemAction isEnabled used
      by ADevelopmentItemController and then ADevelopmentItemFormView
      to determine if its enabled
   @result - returns a boolean
   */

   function isEnabled()
   {
      importClass( 'Shared.User' );
      $currUser =& User::getCurrentUser();
      
      return $currUser->isAdmin();
      
   }

//========================================================================

};

?>