<?php

/*
ProjectElementAddAction
$Author: millz $
$Revision: 1.1 $
$Date: 2004/04/01 22:08:58 $
$Log: ProjectElementAddAction.php,v $
Revision 1.1  2004/04/01 22:08:58  millz
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/


importClass( 'DatabaseUI.ADbItemAction' );

/*!
@class ProjectElementAddAction
@abstract - 
*/

class ProjectElementAddAction extends ADbItemAction
{

//========================================================================

   <class vars>

//========================================================================

   /*!
   @function ProjectElementAddAction( &$project, &$prototype )
   @discussion - constructs a new ProjectElementAddAction object
   @result - constructs a new ProjectElementAddAction object
   */
   
   function ProjectElementAddAction( &$project, &$prototype )
   {

         $this->ADbItemAction();
         $this->project =& $project;
         $this->prototype =& $prototype;

   }

//========================================================================

   /*!
   @function getAvailableFieldNames()
   @discussion - provides an array of field names that are available
      for use with this Action
   @result - returns String[]
   */

   function getAvailableFieldNames()
   {
      
      return array( 'name' );
   }
   
//========================================================================

   /*!
   @function isEnabled()
   @discussion - determines if this ADevItemAction isEnabled used
      by ADevelopmentItemController and then ADevelopmentItemFormView
      to determine if its enabled
   @result - returns a boolean
   */

   function isEnabled()
   {
      importClass( 'Shared.User' );
      $currUser =& User::getCurrentUser();
      
      return $currUser->isAdmin();
      
   }

//========================================================================

   /*!
   @function isRequired( $fieldName )
   @param $fieldName - a String - specifying a field name
   @discussion - indicates if that field is required for this action
   @result - returns a boolean
   */

   function isRequired( $fieldName )
   {
      return true;
   }

//========================================================================


   /*!
   @function execute()
   @discussion - actually performs the action

      Only called if all validation checks passed.
   */

   function execute()
   {
         $projectElement =& $this->getDbItem();
         $projectElement->setName( $this->getFieldValue( 'name' ) );
         $this->project->addElement( $projectElement );
   }
   
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>