<?php

/*
UserAction
$Author: millz $
$Revision: 1.2 $
$Date: 2004/04/01 22:08:46 $
$Log: UserAction.php,v $
Revision 1.2  2004/04/01 22:08:46  millz
removed processing of currentProject

Revision 1.1  2004/03/24 19:43:26  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

importClass( 'DatabaseUI.ADbItemAction' );

//========================================================================

/*!
@class UserAction
@abstract - 
*/

class UserAction extends ADbItemAction
{

//========================================================================

   // <class vars>

//========================================================================

   /*!
   @function UserAction()
   @discussion - constructs a new UserAction object
   @result - constructs a new UserAction object
   */
   
   function UserAction( $isAdding )
   {
         $this->ADbItemAction();
         //print "setting isAdding to ". $isAdding;
         $this->isAdding = $isAdding;
         // print "in UserAction"; exit;
   }

//========================================================================

   /*static*/ 
   function &createAdd()
   {
      return new UserAction( true );
   }
   
//========================================================================            

   /*static*/ 
   function &createModify()
   {
      return new UserAction( false );
   }            

//========================================================================

   function isAdding()
   {
      return $this->isAdding;
   }
   

   
//========================================================================

   /*!
   @function getAvailableFieldNames()
   @discussion - provides an array of field names that are available
      for use with this Action
   @result - returns String[]
   */

   function getAvailableFieldNames()
   {
      
      return array( 'first_name', 'last_name', 'email', 'user_name', 'isAdmin' );
   }


//========================================================================

   /*!
   @function isRequired( $fieldName )
   @param $fieldName - a String - specifying a field name
   @discussion - indicates if that field is required for this action
   @result - returns a boolean
   */

   function isRequired( $fieldName )
   {
      return true;
   }

//========================================================================

   /*!
   @function execute()
   @discussion - actually performs the action

      Only called if all validation checks passed.
   */

   function execute()
   {
      $user =& $this->getDbItem();

      //You may need to add some setters to Shared.User
      $user->setFirstName( $this->getFieldValue( 'first_name' ) );
      $user->setLastName( $this->getFieldValue( 'last_name' ) );
      $user->setEmail( $this->getFieldValue( 'email' ) );
      

      // currently the username is static
      $user->setUserName( $this->getFieldValue( 'user_name' ) );
      
      //print "running \$user->setAdmin( \$this->getFieldValue( 'isAdmin' ) );";
      $user->setAdmin( $this->getFieldValue( 'isAdmin' ) );

      //importClass( 'Shared.Project' );
      //$fieldVal = $this->getFieldValue( 'currentProject' );
      
      // NOTE!!!!! setCurrentProject is calling _store() for us!!!!!!!!!!!!!!!!!!
      //$user->setCurrentProject(  $fieldVal );

      $user->_store();
   }

//========================================================================

   /*!
   @function isEnabled()
   @discussion - determines if this ADevItemAction isEnabled used
      by ADevelopmentItemController and then ADevelopmentItemFormView
      to determine if its enabled
   @result - returns a boolean
   */

   function isEnabled()
   {
      importClass( 'Shared.User' );
      $currUser =& User::getCurrentUser();
      
      return $currUser->isAdmin();
      
   }

//========================================================================

};

?>