<?php

/*
UserFieldFactory
$Author: millz $
$Revision: 1.2 $
$Date: 2004/04/01 22:08:33 $
$Log: UserFieldFactory.php,v $
Revision 1.2  2004/04/01 22:08:33  millz
removed currentProject field

Revision 1.1  2004/03/24 19:43:40  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

importClass( 'DatabaseUI.ADbItemFieldFactory' );

//========================================================================

/*!
@class UserFieldFactory
@abstract - 
*/

class UserFieldFactory extends ADbItemFieldFactory
{

//========================================================================

   // <class vars>

//========================================================================

   /*!
   @function UserFieldFactory()
   @discussion - constructs a new UserFieldFactory object
   @result - constructs a new UserFieldFactory object
   */
   
   function UserFieldFactory()
   {
      $this->ADbItemFieldFactory();
   }

//========================================================================

   /*!
   @function _creatingNew()
   */

   function _creatingNew()
   {
      return $this->action->isAdding();
   }

//========================================================================

   /*!
   @function _isAdmin()
   @discussion - indicates if the current user is an admin
   @result - returns a boolean
   */

   function _isAdmin()
   {
      $user =& $this->action->getUser();
      return $user->isAdmin();
   }
   
//========================================================================

   /*!
   @function _createField( $name )
   @param $name - a String - the name of a field
   @discussion - creates the ALightFormField that corresponds to the given
      name
   @result - returns an ALightFormField
   */

   function &_createField( $name )
   {
      
      $isAdmin = $this->_isAdmin();
      // $isDeveloper = $this->_isDeveloper();
      //$project =& $this->action->getProject();
      $isNew = $this->_creatingNew();
      
      
      
      $canFix = true;

      if ( ! $isNew )
      {
         $userItem =& $this->getDbItem();
      }


      switch ( $name )
      {
         //---------------------------------------------------------------

         case 'ID':
         if ( $isNew )
         {
            $field = NULL;
         }
         else
         {
            $field =& $this->_createShortText( $name, 'User Database ID' );
            $field->setEnabled( false );
            
            $field->setValue( toRef( $userItem->getID() ) );
         }
         return $field;

         //---------------------------------------------------------------

         case 'first_name':
         $field =& $this->_createShortText( $name, 'First Name' );
         if(!$isNew) $field->setValue( toRef( $userItem->getFirstName() ) );
         return $field;

         //---------------------------------------------------------------

         case 'last_name':
         $field =& $this->_createShortText( $name, 'Last Name' );
         if(!$isNew) $field->setValue( toRef( $userItem->getLastName() ) );
         return $field;
         
         //---------------------------------------------------------------

         case 'email':
         $field =& $this->_createShortText( $name, 'E-mail' );
         if(!$isNew) $field->setValue( toRef( $userItem->getEmailAddress() ) );
         return $field;

         //---------------------------------------------------------------

         case 'user_name':
         $field =& $this->_createShortText( $name, 'Login name' );
         if(!$isNew) $field->setValue( toRef( $userItem->getUsername() ) );
         if(!$isNew) $field->setEnabled( false );
         return $field;

         //---------------------------------------------------------------

        // we don't want to force this to be set by the admin b/c there may not be any projects to set to yet
         //case 'currentProject':
         //$field =& $this->_createSelect1( 'Shared.Project', 'Default Project' );
         //if(!$isNew) $field->setValue( $userItem->getCurrentProject()  );
         //if(!$isNew) $field->setEnabled( false );
         //return $field;

         //---------------------------------------------------------------

         case 'isAdmin':
         $field =& $this->_createBoolean( $name, 'Is Administrator' );
         if(!$isNew) $field->setValue( toRef( $userItem->isAdmin() ) );
         return $field;

         //---------------------------------------------------------------

         default:
         return toRef( NULL );

         //---------------------------------------------------------------

      } //case
   }   

//========================================================================

};

?>