<?php

/*
ADevelopmentItemFormView
$Author: dougqh $
$Revision: 1.10 $
$Date: 2004/04/01 18:09:15 $
$Log: ADevelopmentItemFormView.php,v $
Revision 1.10  2004/04/01 18:09:15  dougqh
- Minor restructuring

Revision 1.9  2004/01/07 21:46:59  dougqh
- debugging?

Revision 1.8  2003/12/10 22:01:15  millz
- made submit button disabling optional with disableSubmit

Revision 1.7  2003/12/09 15:08:23  dougqh
Refactoring View->Action->Factory interaction

Revision 1.6  2003/12/05 20:19:06  millz
- adding disable

Revision 1.5  2003/12/03 21:11:30  millz
- added getSubmitText

Revision 1.4  2003/10/21 14:13:23  dougqh
Refactored email handling

Revision 1.3  2003/07/23 22:09:49  dougqh
- Overriding _getActionURL, display project field if ID is not available, added constant HIDDEN_PROJECT_ID_FIELD.

Revision 1.2  2003/07/14 16:35:49  dawn
- change tester form

Revision 1.1  2003/07/09 19:57:45  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.AForm' );

//========================================================================

//imported for its constants
importClass( 'Bugs.ADevelopmentItem' );

//========================================================================

//ActionTypes
define( 'ADD_DEV_ITEM', 0 );
define( 'REVIEW_DEV_ITEM', 1 );
define( 'FIX_DEV_ITEM', 2 );
define( 'VERIFY_DEV_ITEM', 3 );
define( 'DESIGNER_CLOSE_DEV_ITEM', 4 );
define( 'REOPEN_DEV_ITEM', 5 );
define( 'ADD_COMMENT_DEV_ITEM', 6 );
define( 'MORE_INFO_NEEDED_DEV_ITEM', 7 );
define( 'MORE_INFO_GIVEN_DEV_ITEM', 8 );
define( 'ADD_ATTACHMENT_DEV_ITEM', 9 );
define( 'ADD_RELATED_DEV_ITEM', 10 );
define( 'FAIL_DEV_ITEM', 11 );
define( 'CHANGE_TESTER_DEV_ITEM', 12 );

//========================================================================

importClass( 'DatabaseUI.ADbItemFormView' );

//========================================================================

/*!
@class ADevelopmentItemFormView
@abstract - abstract class that handles most of logic for adding
   a DevelopmentItem
*/

class ADevelopmentItemFormView extends ADbItemFormView
{

//========================================================================

   /*!
   @function ADevelopmentItemFormView()
   @discussion - constructs a new ADevelopmentItemFormView object
   @result - constructs a new ADevelopmentItemFormView object
   */

   function ADevelopmentItemFormView()
   {
      $this->ADbItemFormView();
      $user =& $this->getUser();
      $this->project =& $user->getCurrentProject();
   }

//========================================================================

   /*!
   @function &_createView( $actionSpecifier )
   */

   function &_createView( $actionSpecifier )
   {
      switch ( $actionSpecifier )
      {
         case ADD_DEV_ITEM:
         importClass( 'BugUI.Views.AddDevelopmentItemFormView' );
         return new AddDevelopmentItemFormView();

         case REVIEW_DEV_ITEM:
         importClass( 'BugUI.Views.ReviewDevelopmentItemFormView' );
         return new ReviewDevelopmentItemFormView();

         case FIX_DEV_ITEM:
         importClass( 'BugUI.Views.FixDevelopmentItemFormView' );
         return new FixDevelopmentItemFormView();

         case VERIFY_DEV_ITEM:
         case FAIL_DEV_ITEM:
         importClass( 'BugUI.Views.VerifyDevelopmentItemFormView' );
         return new VerifyDevelopmentItemFormView( $actionSpecifier );

         case DESIGNER_CLOSE_DEV_ITEM:
         importClass( 'BugUI.Views.DesignerCloseDevelopmentItemFormView' );
         return new DesignerCloseDevelopmentItemFormView();

         case ADD_COMMENT_DEV_ITEM:
         importClass( 'BugUI.Views.AddRegularCommentDevelopmentItemFormView' );
         return new AddRegularCommentDevelopmentItemFormView();

         case ADD_ATTACHMENT_DEV_ITEM:
         importClass( 'BugUI.Views.AddAttachmentDevelopmentItemFormView' );
         return new AddAttachmentDevelopmentItemFormView();

         case ADD_RELATED_DEV_ITEM:
         importClass( 'BugUI.Views.AddRelatedDevelopmentItemFormView' );
         return new AddRelatedDevelopmentItemFormView();

         case MORE_INFO_NEEDED_DEV_ITEM:
         case MORE_INFO_GIVEN_DEV_ITEM:
         case REOPEN_DEV_ITEM:
         importClass( 'BugUI.Views.AddSpecialCommentDevelopmentItemFormView' );
         return new AddSpecialCommentDevelopmentItemFormView( $actionSpecifier );

         case CHANGE_TESTER_DEV_ITEM:
         importClass( 'BugUI.Views.ChangeTesterDevelopmentItemFormView' );
         return new ChangeTesterDevelopmentItemFormView();

         default:
         unreachablePoint( 'Unknown DevItemAction : ' . $actionSpecifier );
         break;
      };
   }

//========================================================================

   /*!
   @function _createAction( $actionSpecifier )
   */

   function &_createAction( $actionSpecifier )
   {
      importClass( 'BugUI.UIHelpers.DevelopmentItem.Actions.ADevelopmentItemAction' );
      switch ( $actionSpecifier )
      {
         case ADD_DEV_ITEM:
         return ADevelopmentItemAction::_createAdd(
            $this->project, $this->devItemType );

         default:
         return ADevelopmentItemAction::_createModify( $actionSpecifier );
      }
   }

//========================================================================

   /*!
   @function createAddForm( $devItemType )
   @discussion - creates a form that adds the specified type
      of ADevelopmentItem to the User's current Project
   @result - returns an ADevelopmentItemFormView
   */

   function &createAddForm( $devItemType )
   {
      importClass( 'Shared.User' );
      $user =& User::getCurrentUser();

      //initialize the prototype
      $viewProto =& new ADevelopmentItemFormView();
      $viewProto->project =& $user->getCurrentProject();
      $viewProto->devItemType = $devItemType;

      //use the prototype as a factory
      $view =& $viewProto->_createView( ADD_DEV_ITEM );
      $view->_setAction(
         $viewProto->_createAction( ADD_DEV_ITEM ),
         ADD_DEV_ITEM );
      return $view;
   }

//========================================================================

   /*!
   @function disableSubmit()
   @discussion -
   */
    function disableSubmit()
    {
        return true;
    }

//========================================================================

   /*!
   @function createModifyForm( $devItem, $actionSpecifier )
   @param $actionSpecifier - an DevelopmentItemActionType - see constants
      at top of file
   @discussion - provides a form appropriate for the specified Action
   */

   function &createModifyForm( &$devItem, $actionSpecifier )
   {
      $viewProto =& new ADevelopmentItemFormView();
      return
         ADbItemFormView::_staticCreateView(
            $viewProto,
            $devItem,
            $actionSpecifier );
   }

//========================================================================

   /*!
   @function _createFieldFactory()
   */

   function &_createFieldFactory()
   {
      importClass( 'BugUI.UIHelpers.DevelopmentItem.FieldFactories.ADevelopmentItemFieldFactory' );
      return ADevelopmentItemFieldFactory::create( $this->action->getDevelopmentItemType() );
   }

//========================================================================

   /*!
   @function _addHeaderFields()
   */
   function _addHeaderFields()
   {
      //Some quirk is causing it to render funny if its not given the
      //full row, but its not important enough to really worry about
      if ( ! $this->_addIfExists( 'ID', true ) )
      {
         //if the ID is not available, at least the project
         $this->_add( 'project', true );
      }

      $this->_add( 'subject', true );
      $this->_add( 'report', true );
   }

//========================================================================

   /*!
   @function getDbItemClass()
   */

   function getDbItemClass()
   {
      return 'Bugs.ADevelopmentItem';
   }

//========================================================================

   /*!
   @function _addFields()
   @discussion - called by _getBodyHTML, so that a concrete child
      can add any necessary fields using the various _add<X>
      methods
   */

   /* abstract function _addFields(); */

//========================================================================

   /*!
   @function _getAdditionalParameters()
   */

   function _getAdditionalParameters()
   {
      if ( $this->action->isAdding() )
      {
         return array( 'devItemType' => $this->action->getDevItemType() );
      }
      else
      {
         return array();
      }
   }

//========================================================================

   /*!
   @function _getActionURL()
   */

   function _getActionURL()
   {
      if ( $this->action->isAdding() )
      {
         return addParameterToURL(
            parent::_getActionURL(),
            'project_id',
            $this->project->getPrimaryID() );
      }
      else
      {
         return parent::_getActionURL();
      }
   }

//========================================================================

   /*!
   @function _loadAdditionalParameters()
   */

   function _loadAdditionalParameters()
   {
      if ( isset( $_REQUEST{ 'project_id' } ) )
      {
         if ( isNumeric( $_REQUEST{ 'project_id' } ) )
         {
            importClass( 'Shared.Project' );
            $this->project =& Project::getFromPrimaryID( $_REQUEST{ 'project_id' } );
         }
         else
         {
            unreachablePoint( 'Invalid ProjectID' );
         }
      }

      if ( isset( $_REQUEST{ 'devItemType' } ) )
      {
         $this->devItemType = $_REQUEST{ 'devItemType' };
      }
   }

//========================================================================

   /*!
   @function getNextView()
   */

   function &getNextView()
   {
      importClass( 'BugUI.Views.DevelopmentItemDetailsView' );
      return DevelopmentItemDetailsView::create(
         $this->action->getDbItem() );
   }

//========================================================================

   /*!
   @function getProject()
   */

   function &getProject()
   {
      return $this->action->getProject();
   }

//========================================================================

   /*!
   @function getDevItemType()
   */

   function getDevItemType()
   {
      return $this->action->getDevItemType();
   }

//========================================================================

};

?>