<?php

/*
AddDevelopmentItemFormView
$Author: dougqh $
$Revision: 1.2 $
$Date: 2003/12/09 15:08:23 $
$Log: AddDevelopmentItemFormView.php,v $
Revision 1.2  2003/12/09 15:08:23  dougqh
Refactoring View->Action->Factory interaction

Revision 1.1  2003/07/09 19:57:45  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.Views.ADevelopmentItemFormView' );

//========================================================================

/*!
@class AddDevelopmentItemFormView
@abstract - abstract class that handles most of logic for adding
   a DevelopmentItem
*/

class AddDevelopmentItemFormView extends ADevelopmentItemFormView
{

//========================================================================

   /*!
   @function AddDevelopmentItemFormView( [ $devItemType ] )
   @param $devItemType - one of DEFECT, TASK, FEATURE_REQUEST
      If ommitted it will be determined from the $_REQUEST variables.
   @discussion - constructs a new AddDevelopmentItemFormView object
   @result - constructs a new AddDevelopmentItemFormView object
   */

   function AddDevelopmentItemFormView()
   {
      $this->ADevelopmentItemFormView();
   }

//========================================================================

   /*!
   @function create( $devItemType )
   @param $devItemType - FEATURE_REQUEST, TASK, or DEFECT
   @discussion - provides an AddDevelopmentItemFormView of the appropriate
      type

      There is an assumption that only one instance of AddDevelopmentItemFormView
      will be needed for each $devItemType for a given page load.
   @result - returns an AddDevelopmentItemFormView
   */

   function &create( $devItemType )
   {
      static $instanceHash;

      if ( ! isset( $instanceHash{ $devItemType } ) )
      {
         $instanceHash{ $devItemType } =& new AddDevelopmentItemFormView();
         $instanceHash{ $devItemType }->_setDevelopmentItemType( $devItemType );
      }

      return $instanceHash{ $devItemType };
   }

//========================================================================

   /*!
   @function _addFields()
   @discussion - provides the basic outline of this Form
   */

   function _addFields()
   {
      $project =& $this->getProject();

      $fourColTable =& $this->_getFourColumnTable();

      //------------------------------------------------------------------

      $this->_add( 'subject', true );
      $this->_add( 'report', true );
      $this->_addIfExistsEnabled( 'steps', true );

      if ( $this->getDevItemType() == TASK )
      {
         //Tasks have neither, so add priority instead.
         $this->_addIfEnabled( 'priority' );
         $fourColTable->forceNewRow();
      }
      else
      {
         //Defects have frequency and severity.
         //Feature Requests just have frequency.

         //Add frequency first, so its always on left even when severity is
         //absent.
         $this->_addIfExistsEnabled( 'frequency' );
         $this->_addIfExistsEnabled( 'severity' );
      }

      $this->_add( 'subproject' );
      $this->_add( 'category' );

      //------------------------------------------------------------------

      //true forces removal of the group name in elements added to the group
      $fourColTable->startGroup( 'Client', true );
      $this->_add( 'clientPlatform' );
      $this->_add( 'clientType' );
      $this->_add( 'detectedClientVersion' );
      $fourColTable->endGroup();

      //------------------------------------------------------------------

      //true forces removal of the group name in elements added to the group
      $fourColTable->startGroup( 'Server', true );
      $this->_add( 'serverPlatform' );
      $this->_add( 'serverInstance' );
      $this->_add( 'detectedServerVersion' );
      $fourColTable->endGroup();

      //------------------------------------------------------------------
   }

//========================================================================

   /*!
   @function getTitleImage()
   */

   function &getTitleImage()
   {
      switch ( $this->getDevItemType() )
      {
         case FEATURE_REQUEST:
         $image = 'addfeaturerequestformview_title.jpg';
         break;

         case TASK:
         $image = 'addtaskformview_title.jpg';
         break;

         case DEFECT:
         $image = 'adddefectformview_title.jpg';
         break;
      };

      importClass( 'HTMLComponents.Images.StaticInternalImage' );
      return new StaticInternalImage(
         $image,
         $this->getTitle() );
   }

//========================================================================

};

?>