<?php

/*
AddToFavoriteItemSetView
$Author: dougqh $
$Revision: 1.2 $
$Date: 2004/02/09 15:04:50 $
$Log: AddToFavoriteItemSetView.php,v $
Revision 1.2  2004/02/09 15:04:50  dougqh
- 4041

Revision 1.1  2004/01/13 18:59:24  dougqh
- An AForm that adds to a new or existing FavoriteItemSet.


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.ALightFormFieldForm' );

//========================================================================

/*!
@class AddToFavoriteItemSetView
@abstract -
*/

class AddToFavoriteItemSetView extends ALightFormFieldForm
{

//========================================================================

   /*!
   @function AddToFavoriteItemSetView()
   @param $ids - an array of DevelopmentItem ids
   */
   function AddToFavoriteItemSetView( $ids )
   {
      $this->ALightFormFieldForm();
      $this->ids = $ids;
   }

//========================================================================

   /*!
   @function create( $ids )
   */

   /* static */
   function &create( $ids )
   {
      return new AddToFavoriteItemSetView( $ids );
   }

//========================================================================

   /*!
   @function create2( $devItem )
   */

   function &create2( &$devItem )
   {
      return new AddToFavoriteItemSetView( array( $devItem->getPrimaryID() ) );
   }

//========================================================================

   /*!
   @function getTitle()
   */

   function getTitle()
   {
      return 'Add To Favorite Group';
   }

//========================================================================

   /*!
   @function createFromRequest()
   */

   /* static */
   function &createFromRequest()
   {
      if ( ! isset( $_REQUEST{ 'ids' } ) || ! is_array( $_REQUEST{ 'ids' } ) )
      {
         unreachablePoint( 'Invalid ids in AddToFavoriteItemSetView::createFromRequest' );
      }
      return AddToFavoriteItemSetView::create( $_REQUEST{ 'ids' } );
   }

//========================================================================

   /*!
   @function allowDuplicateSubmissions()
   */
   function allowDuplicateSubmissions()
   {
      return true;
   }

//========================================================================

   /*!
   @function _getMethod()
   */

   function _getMethod()
   {
      return POST;
   }

//========================================================================

   /*!
   @function getParameters()
   */
   function getParameters()
   {
      return array( 'ids' => $this->ids );
   }

//========================================================================

   /*!
   @function getInputFieldNames()
   */
   function getInputFieldNames()
   {
      return array( 'favItemSet' );
   }

//========================================================================

   /*!
   @function _createField( $name )
   */
   function &_createField( $name )
   {
      importClass( 'Shared.User' );
      $curUser =& User::getCurrentUser();

      importClass( 'BugUI.OtherComponents.FavoriteItemSetField' );
      $field =& new FavoriteItemSetField(
         $curUser->getFavoriteItemSets(),
         $name, 'Favorite Group' );
      $field->setRequired( true );
      return $field;
   }

//========================================================================

   /*!
   @function getFavoriteItemSetField()
   */

   function &getFavoriteItemSetField()
   {
      return $this->getField( 'favItemSet' );
   }

//========================================================================

   /*!
   @function _getBodyHTML()
   */

   function _getBodyHTML()
   {
      importClass( 'HTMLComponents.Table.TwoColumnTable' );
      $table =& new TwoColumnTable();
      $field =& $this->getFavoriteItemSetField();
      $table->addRow( $field->getDisplayName(), $field );
      return $table->getHTML();
   }

//========================================================================

   /*!
   @function _execute()
   */
   function _execute()
   {
      $field =& $this->getFavoriteItemSetField();
      $favSet =& $field->getValue();
      $favSet->addDevelopmentItemsByIDs( $this->ids );

      importClass( 'Shared.User' );
      $curUser =& User::getCurrentUser();
      $curUser->storeFavoriteItemSet( $favSet );
   }

//========================================================================

   /*!
   @function getNextView()
   */
   function &getNextView()
   {
      importClass( 'BugUI.Views.CloseView' );
      return CloseView::getInstance();
   }

//========================================================================

};

?>