<?php

/*
AttachmentIteratorView
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/07/09 19:57:45 $
$Log: AttachmentIteratorView.php,v $
Revision 1.1  2003/07/09 19:57:45  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'CollectionUI.AIteratorView' );

//========================================================================

/*!
@class AttachmentIteratorView
@abstract -
*/

class AttachmentIteratorView extends AIteratorView
{

//========================================================================

   /*!
   @function AttachmentIteratorView()
   @discussion - constructs a new AttachmentIteratorView object
   @result - constructs a new AttachmentIteratorView object
   */

   function AttachmentIteratorView()
   {
      $this->AIteratorView();
      $this->sawItems = false;
   }

//========================================================================

   /*!
   @function _getPrototype()
   */

   function &_getPrototype()
   {
      importClass( 'Bugs.Comment' );
      return Comment::getPrototype();
   }

//========================================================================

   /*!
   @function getNumRows()
   */

   function getNumRows()
   {
      return 1000000;
   }

//========================================================================

   /*!
   @function _startHTMLGeneration()
   */

   function _startHTMLGeneration()
   {
      importClass( 'HTMLComponents.ItemList' );
      $this->itemList =& new ItemList();
   }

//========================================================================

   /*!
   @function _handleCurrent( $attachment )
   */

   function _handleCurrent( &$attachment )
   {
      $this->sawItems = true;

      importClass( 'HTMLComponents.CompositeHTMLComponent' );
      $composite =& new CompositeHTMLComponent( '' );

      //------------------------------------------------------------------

      $name = $attachment->getFileName();

      importClass( 'HTMLComponents.Text' );
      $nameText =& new Text( $name.NL );
      importClass( 'Display.Color' );
      $nameText->setColor( Color::getColor( 12, 12, 122) );
      importClass( 'Display.Font' );
      $nameText->setFont( Font::getFont( 'Tahoma', '11pt', true, false ) );

      $composite->add( $attachment->getLink() );

      //------------------------------------------------------------------

      $composite->add( new Text( ' - ' . $attachment->getFileSize() ) );

      //------------------------------------------------------------------

      $submitter =& $attachment->getSubmitter();
      $composite->add( new Text( ' - Submitted By: ' . $submitter->getIdentifyingString() . ' on ' ) );

      //------------------------------------------------------------------

      $composite->add( new Text( getFormattedDBTimeStamp( $attachment->getDateCreated() ) . NL ) );

      //------------------------------------------------------------------

      $desc = $attachment->getDescription();
      $composite->add( new Text( $desc ) );

      //------------------------------------------------------------------

      $this->itemList->addItem( $composite );
   }

//========================================================================

   /*!
   @function _getGeneratedHTML()
   */

   function _getGeneratedHTML()
   {
      if ( ! $this->sawItems )
      {
         return 'No attachments found for this Item';
      }

      return $this->itemList->getHTML();
   }

//========================================================================

};

?>