<?php

/*
CommentIteratorView
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/07/09 19:57:45 $
$Log: CommentIteratorView.php,v $
Revision 1.1  2003/07/09 19:57:45  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'CollectionUI.AIteratorView' );

//========================================================================

/*!
@class CommentIteratorView
@abstract -
*/

class CommentIteratorView extends AIteratorView
{

//========================================================================

   /*!
   @function CommentIteratorView()
   @discussion - constructs a new CommentIteratorView object
   @result - constructs a new CommentIteratorView object
   */

   function CommentIteratorView()
   {
      $this->AIteratorView();
   }

//========================================================================

   /*!
   @function _getPrototype()
   */

   function &_getPrototype()
   {
      importClass( 'Bugs.Comment' );
      return Comment::getPrototype();
   }

//========================================================================

   /*!
   @function getNumRows()
   */

   function getNumRows()
   {
      return 1000000;
   }

//========================================================================

   /*!
   @function _startHTMLGeneration()
   */

   function _startHTMLGeneration()
   {
      importClass( 'HTMLComponents.Table.Table' );

      importClass( 'HTMLComponents.Text' );
      $this->text =& new Text( '' );
      importClass( 'Display.Color' );
      $this->text->setColor( Color::getColor( 255,255,255 ) );

      $this->table = new Table();
      $this->table->setCellPadding( 2 );
      $this->table->setWidth( '100%' );
   }

//========================================================================

   /*!
   @function _handleCurrent( $comment )
   */

   function _handleCurrent( &$comment )
   {
      // imports done in _startHTML...
      $user =& $comment->getCreator();
      $commentType =& $comment->getCommentType();


      $thisColor =& Color::getColorFromHexTriplet( $commentType->getColor() );

      $this->table->startRow( $thisColor );

      $this->text->_setText( $user->getName() );
      $this->table->addCell( $this->text );

      $this->text->_setText( getFormattedDBTimeStamp( $comment->getDateCreated() ) );
      $this->table->addCell( $this->text );

      $this->text->_setText( $commentType->getName() );
      $this->table->addCell( $this->text );

      $this->table->startRow();

      $this->table->addCell( new Text( $comment->getComments() ), UNSPECIFIED, INFINITY  );

      $this->table->addSpacerRow( $thisColor );

   }

//========================================================================

   /*!
   @function _getGeneratedHTML()
   */

   function _getGeneratedHTML()
   {
      unset( $this->text );
      $html = $this->table->getHTML();
      unset( $this->table );
      return $html;
   }

//========================================================================

};

?>