<?php

/*
DevelopmentItemDetailsView
$Author: millz $
$Revision: 1.10 $
$Date: 2004/08/06 15:11:48 $
$Log: DevelopmentItemDetailsView.php,v $
Revision 1.10  2004/08/06 15:11:48  millz
- small font size change

Revision 1.9  2004/06/16 21:51:25  millz
- added a few fields to the big table

Revision 1.8  2004/05/19 14:29:52  dougqh
- Reenabled duedate

Revision 1.7  2004/01/13 21:32:26  millz
- reformatting checkboxes

Revision 1.6  2004/01/13 18:03:48  dougqh
- Cleaned up code by adding createFromRequest.

Revision 1.5  2004/01/06 15:42:15  millz
- nothing

Revision 1.4  2003/09/15 13:01:11  millz
- added client type filed to table

Revision 1.3  2003/08/29 19:42:34  dougqh
- Modifications to account for moving of BugPort specific HTMLComponents out of HTMLComponents into BugUI.OtherComponents.

Revision 1.2  2003/07/23 22:57:49  millz
- added some colored fields

Revision 1.1  2003/07/09 19:57:45  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.AView' );

//========================================================================

/*!
@class DevelopmentItemDetailsView
@abstract -
*/

class DevelopmentItemDetailsView extends AView
{

//========================================================================

   var $isWrapped;
   var $prefixComponent;

//========================================================================

   /*!
   @function DevelopmentItemDetailsView()
   @discussion - constructs a new DevelopmentItemDetailsView object
   @result - constructs a new DevelopmentItemDetailsView object
   */

   function DevelopmentItemDetailsView( $isWrapped = false  )
   {
      $this->isWrapped = $isWrapped;
      $this->AView();
   }

//========================================================================

   /*!
   @function createFromRequest()
   */
   function &createFromRequest()
   {
      $view =& new DevelopmentItemDetailsView();
      if ( isset( $_REQUEST{ 'devItemID' } ) )
      {
         importClass( 'Bugs.ADevelopmentItem' );
         $view->setDevelopmentItem(
            ADevelopmentItem::getFromPrimaryID( $_REQUEST{ 'devItemID' } ) );
      }
      return $view;
   }

//========================================================================

   /*!
   @function create( $devItem )
   @param $devItem - ADevelopmentItem
   @discussion - creats an ADevelopmentItemDetailsView for the
      provided ADevelopmentItem
   @result - returns an ADevelopmentItemDetailsView
   */

   function &create( &$devItem )
   {
      $view =& new DevelopmentItemDetailsView();
      $view->setDevelopmentItem( $devItem );
      return $view;
   }

//========================================================================

   /*!
   @function setDevelopmentItem( $devItem )
   @param $devItem - a ADevelopmentItem
   @discussion - sets the ADevelopmentItem that this View will display
   */

   function setDevelopmentItem( &$devItem )
   {
      $this->devItem =& $devItem;
   }

//========================================================================

   /*!
   @function getParameters()
   */

   function getParameters()
   {
      return array( 'devItemID' => $this->devItem->getPrimaryID() );
   }

//========================================================================

   /*!
   @function getTitle()
   @discussion - gets the title for the home page
   @return - string, title of page
   */

   function getTitle()
   {
      return $this->devItem->getPrimaryID() . ' Details';
   }

//========================================================================

   /*!
   @function setTitlePrefixComponent( &$htmlComponent )
   @discussion this will be put just before the title in my HTML
   */

    function setTitlePrefixComponent( &$htmlComponent )
    {
        $this->prefixComponent =& $htmlComponent;
    }

//========================================================================

   /*!
   @function getHTML()
   @discussion - produces HTML about this ADevelopmentItem
   */

   function getHTML()
   {
      if ( $this->devItem->isNull() )
      {
         // A little ugly
         return '<b>Development Item not found</b>' . BR . BR;
      }

      // the user actually wants some HTML, eh?  Well then they are viewing this
      // let's save this info to the recently viewed list
      importClass( 'Shared.User' );
      $thisUser =& User::getCurrentUser();
      $recentItemSet =& $thisUser->getRecentItems();
      $recentItemSet->addDevelopmentItem( $this->devItem );
      $recentItemSet->_store();

      importClass( 'HTMLComponents.Table.Table' );
      $outerTable =& new Table();
      $outerTable->setCellPadding( 1 ) ;
      $outerTable->setRequestedDimensions(
         $this->getDimensions() );

      $outerTable->setRequestedWidth( '100%' );

      importClass( 'BugUI.OtherComponents.DevelopmentItemLinks' );
      $linkComp =& new DevelopmentItemLinks( $this->devItem, true );

      $outerTable->startRow();
      // $outerTable->setBorder( 1 );
      $outerTable->addCell( $linkComp, CENTER );

      //imported earlier
      $innerTable =& new Table();

      $innerTable->setRequestedWidth( '100%' );

      // DO WE HAVE checkboxes to add?
      if ( isset( $this->prefixComponent ) )
      {
        $innerTable->addCell( $this->prefixComponent  );
        $innerTable->startRow();
      }

      //default alignment - span all columns

      DevelopmentItemDetailsView::_addLargeText(
         $innerTable,
         'Subject', $this->devItem->getSubject(), INFINITY, '+2' );  // &$table, $label0, $value0, $cellSpan = INFINITY, $valueTextRelativeSize = '-1' 

      $innerTable->addSpacerRow();

      $innerTable->addCell( $this->_getFourColumnTable(), UNSPECIFIED, 2);

      $innerTable->addSpacerRow();

      DevelopmentItemDetailsView::_addLargeText(
         $innerTable,
         'Report', $this->devItem->getReport() );

      $innerTable->addSpacerRow();
      //Dynamic detection is NOT a great way to do this, but for
      //now it will do.
      if ( method_exists( $this->devItem, 'getStepsToReproduce' ) )
      {
         DevelopmentItemDetailsView::_addLargeText(
            $innerTable,
            'Steps to Reproduce',
            $this->devItem->getStepsToReproduce() );
      }

      $innerTable->addSpacerRow();
      DevelopmentItemDetailsView::_addLargeText(
         $innerTable,
         'Development Plan',
         $this->devItem->getDevelopmentPlan() );

      $innerTable->addSpacerRow();

      $outerTable->startRow();
      $outerTable->addCell( $innerTable );

      //------------------------------------------------------------------

      $outerTable->addSpacerRow();

      $outerTable->startRow();

      importClass( 'HTMLComponents.Text' );
      $text =& new Text( '' );
      importClass( 'Display.Font' );
      $text->setFont( Font::getFont( 'Tahoma', '+1', true, true ) );

      //------------------------------------------------------------------

      $outerTable->addSpacerRow();

      $outerTable->startRow();

      $text->_setText( 'Comments' );
      $outerTable->addCell( $text, UNSPECIFIED, INFINITY );
      $outerTable->startRow();

      importClass( 'BugUI.Views.CommentIteratorView' );
      $commentView =& new CommentIteratorView(  );
      $commentView->setIterator( $this->devItem->getComments() );
      $outerTable->addCell($commentView);

      //------------------------------------------------------------------

      $outerTable->addSpacerRow();

      $outerTable->startRow();

      $text->_setText( 'Attachments' );
      $outerTable->addCell( $text, UNSPECIFIED, INFINITY );

      importClass( 'BugUI.Views.AttachmentIteratorView' );
      $outerTable->startRow();
      $attachView =& new AttachmentIteratorView();
      $attachView->setIterator( $this->devItem->getAttachments() );
      $outerTable->addCell( $attachView );

      //------------------------------------------------------------------

      $outerTable->addSpacerRow();

      importClass( 'BugUI.Portlets.DevelopmentItemListPortlet' );
      $portlet =& new DevelopmentItemListPortlet( 'Related Items' );
      $portlet->setIterator( $this->devItem->getRelated() );
      $outerTable->startRow();
      $outerTable->addCell( $portlet );

      //------------------------------------------------------------------

      $outerTable->addSpacerRow();

      $outerTable->startRow();
      $outerTable->addCell( $linkComp, CENTER, INFINITY );

      return $outerTable->getHTML();
   }

//========================================================================

   /*!
   @function _getFourColumnTable()
   @discussion - produces HTML
   */

   function &_getFourColumnTable()
   {
      importClass( 'BugUI.OtherComponents.ReportIDHTMLComponent' );
      $leftList[] = array( 'TR-ID', new ReportIDHTMLComponent($this->devItem->getID() )  );
      $state =& $this->devItem->getState();
      $leftList[] = array( 'State', $state->getIdentifyingString() );

      $frequency =& $this->devItem->getFrequency();
      $severity =& $this->devItem->getSeverity();
      $priority =& $this->devItem->getPriority();
      importClass( 'BugUI.OtherComponents.PriorityHTMLComponent' );
      $leftList[]  = array( 'Priority', new PriorityHTMLComponent($priority->getIdentifyingString())  );

      $leftList[]  = array( 'Frequency', $frequency->getIdentifyingString()   );
      $leftList[]  = array( 'Severity', $severity->getIdentifyingString()   );


      $category =& $this->devItem->getCategory();
      $leftList[]  = array( 'Category', $category->getIdentifyingString()  );
      $subProject =& $this->devItem->getSubProject();
      $leftList[]  = array( 'Sub-Project', $subProject->getIdentifyingString()  );

      importClass( 'BugUI.OtherComponents.UserNameHTMLComponent' );
      $submitter =& $this->devItem->getSubmitter();
      $leftList[]  = array( 'Submitter', new UserNameHTMLComponent($submitter->getIdentifyingString())  );
      $tester =& $this->devItem->getTester();
      $leftList[]  = array( 'Tester', new UserNameHTMLComponent($tester->getIdentifyingString() ) );
      $developer =& $this->devItem->getDeveloper();
      $leftList[]  = array( 'Developer', new UserNameHTMLComponent($developer->getIdentifyingString() ) );
      $designer =& $this->devItem->getDesigner();
      $leftList[]  = array( 'Designer', new UserNameHTMLComponent($designer->getIdentifyingString() ) );
      $project =& $this->devItem->getProject();
      $leftList[]  = array( 'Project', $project->getIdentifyingString()  );
      $leftList[]  = array( 'Type', $this->devItem->getReportType());

      $rightList[] = array( 'Date Submitted', getFormattedDBTimeStamp( $this->devItem->getDateCreated() )  );
      $rightList[] = array( 'Date Assigned', getFormattedDBTimeStamp( $this->devItem->getDateAssigned()  )  );
      $rightList[] = array( 'Date Due', getFormattedDBTimeStamp( $this->devItem->getDueDate() )  );
      $rightList[] = array( 'Date Closed', getFormattedDBTimeStamp( $this->devItem->getDateClosed() ) );
      $rightList[] = array( 'State Changed Date', getFormattedDBTimeStamp( $this->devItem->getDateStateLastChanged() ) );
      $rightList[] = array( 'Est. Code Hours', $this->devItem->getEstimatedCodeHours() );
      $rightList[] = array( 'Code Hours', $this->devItem->getTotalCodeHours() );
      $rightList[] = array( 'Testing Hours', $this->devItem->getTotalTestHours() );
      $rightList[] = array( 'Est. Misc Hours', $this->devItem->getEstimatedMiscHours() );
      $rightList[] = array( 'Misc Hours', $this->devItem->getTotalMiscHours() );
      $rightList[] = array( 'Design Hours', $this->devItem->getDesignHours() );

      $clientType =& $this->devItem->getClientType();
      $rightList[] = array( 'Client Type', $clientType->getIdentifyingString()  );

      $detectedClientVersion =& $this->devItem->getDetectedClientVersion();
      $rightList[] = array( 'Issue Detected in Client Version', $detectedClientVersion->getIdentifyingString()  );

      $detectedServerVersion =& $this->devItem->getDetectedServerVersion();
      $rightList[] = array( 'Issue Detected in Server Version', $detectedServerVersion->getIdentifyingString()  );
      $fixedClientVersion =& $this->devItem->getFixedClientVersion();
      $rightList[] = array( 'Fixed Client Version', $fixedClientVersion->getIdentifyingString()  );
      $fixedServerVersion =& $this->devItem->getFixedServerVersion();
      $rightList[] = array( 'Fixed Server Version', $fixedServerVersion->getIdentifyingString()  );
      $serverInstance =& $this->devItem->getServerInstance();
      $leftList[] = array( 'Server Instance', $serverInstance->getIdentifyingString()  );
      $serverPlatform =& $this->devItem->getServerPlatform();
      $leftList[] = array( 'Server Platform', $serverPlatform->getIdentifyingString()  );
      $clientPlatform =& $this->devItem->getClientPlatform();
      $leftList[] = array( 'Client Platform', $clientPlatform->getIdentifyingString()  );

      //------------------------------------------------------------------------------------------------------------------
      // OK, let's actually add those fields to the HTML

      importClass( 'Display.Color' );

      $fourColTable = new Table( 'fourColTable' );
      $fourColTable->setWidth( '100%' );
      $numberRows = max( count( $leftList ), count( $rightList )) - 1;
      $lightGrey =& Color::getColor( 232,232,232 );

      for( $i =0; $i <= $numberRows; ++$i )
      {
         if ( !($i % 2) ){$fourColTable->startRow();}
         else{$fourColTable->startRow($lightGrey);}

         if( isset($leftList[$i]) && isset($rightList[$i]) )
         {
            DevelopmentItemDetailsView::_addRow(
            $fourColTable,
            $leftList[$i][0], $leftList[$i][1] ,
            $rightList[$i][0], $rightList[$i][1] );
         }
         elseif( isset($leftList[$i])  )
         {
            DevelopmentItemDetailsView::_addRow(
            $fourColTable,
            $leftList[$i][0], $leftList[$i][1] ,
            '', '' );
         }
         else
         {
            DevelopmentItemDetailsView::_addRow(
            $fourColTable,
            '', '' ,
            $rightList[$i][0], $rightList[$i][1]);
         }

      }

      return $fourColTable;
   }

//========================================================================

   /*!
   @function _addRow( $table, $label0, $value0, $label1, $value1 )
   @param $table - a Table
   @param $label0 - a String
   @param $value0 - a String or HTMLComp
   @param $label1 - a String
   @param $value1 - a String or HTMLComp
   @discussion - adds the label value pairs in a single row
      to the provided Table.

      $label1 may '' if no cell should be added.
   */

   /* static */
   function _addRow( &$table, $label0, $value0, $label1, $value1 )
   {

      importClass( 'HTMLComponents.Text' );
      importClass( 'HTMLComponents.Table.Table' );
      importClass( 'HTMLComponents.Table.TableCell' );

      if ( $label0 != '' )
      {
         $textObj =& new Text( $label0 . ':' );
         $textObj->setFont( Font::getFont( 'Tahoma', '11pt',TRUE,FALSE ) );

         $cell =& new TableCell( $textObj );
         $cell->disableWrapping();
         $table->addCell( $cell );

         if( isInstanceOf( $value0, 'AHTMLComponent' ) )
         {
            $table->addCell( $value0 );
         }
         else
         {
            $table->addCell( new Text( $value0 ) );
         }

      }
      else
      {
         $table->addSpacerCell();
         $table->addSpacerCell();
      }

      if ( $label1 != '' )
      {
         $textObj =& new Text( $label1 . ':' );
         $textObj->setFont( Font::getFont( 'Tahoma', '11pt',TRUE,FALSE ) );
         $cell =& new TableCell( $textObj );
         $cell->disableWrapping();
         $table->addCell( $cell );

         if( isInstanceOf( $value1, 'AHTMLComponent' ) )
         {
            $table->addCell( $value1 );
         }
         else
         {
            $table->addCell( new Text( $value1 ) );
         }

      }
   }

//========================================================================

   /*!
   @function _addLargeText( &$table, $label, $value )
   @param $table - a Table
   @param $label - a String
   @param $text - a String
   @discussion - adds a cell that spans all columns of the Table
      containing the provided $text
   */

   function _addLargeText( &$table, $label0, $value0, $cellSpan = INFINITY, $valueTextRelativeSize = '-1' )
   {
      importClass( 'HTMLComponents.Text' );
      $textObj =& new Text( $label0 );
      $textObj->setFont( Font::getFont( 'Tahoma', '+1', TRUE,TRUE ) );

      $table->startRow();
      $table->addCell( $textObj, UNSPECIFIED, $cellSpan );

      importClass( 'HTMLComponents.LongText' );
      $textObj =& new LongText( $value0, 2 * STANDARD_MAX_LINE_LENGTH );
      $textObj->setFont( Font::getFont( 'Tahoma', $valueTextRelativeSize ) );

      $table->startRow();
      $table->addCell( $textObj, UNSPECIFIED, $cellSpan );
   }

//========================================================================

};

?>