<?php

/*
DevelopmentItemSummaryView
$Author: millz $
$Revision: 1.7 $
$Date: 2004/11/18 17:11:04 $
$Log: DevelopmentItemSummaryView.php,v $
Revision 1.7  2004/11/18 17:11:04  millz
*** empty log message ***

Revision 1.6  2004/01/13 21:32:20  millz
- reformatting checkboxes

Revision 1.5  2003/08/29 19:42:40  dougqh
- Modifications to account for moving of BugPort specific HTMLComponents out of HTMLComponents into BugUI.OtherComponents.

Revision 1.4  2003/08/05 03:02:12  millz
- made title row colors dynamic by reportType

Revision 1.3  2003/07/23 22:58:23  millz
- added some colored fields

Revision 1.2  2003/07/14 16:59:52  dougqh
- Fix for 3049

Revision 1.1  2003/07/09 19:57:45  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.AView' );

//========================================================================

define( 'SUMMARY_MAX_REPORT_DISPLAY_LENGTH', 300 );

//========================================================================

/*!
@class DevelopmentItemSummaryView
@abstract -
*/

class DevelopmentItemSummaryView extends AView
{

    var $prefixComponent;

//========================================================================

   /*!
   @function DevelopmentItemSummaryView()
   @discussion - constructs a new DevelopmentItemSummaryView object
   @result - constructs a new DevelopmentItemSummaryView object
   */

   function DevelopmentItemSummaryView()
   {
      if ( isset( $_REQUEST{ 'devItemID' } ) )
      {
         importClass( 'Bugs.ADevelopmentItem' );
         $this->setDevelopmentItem(
            ADevelopmentItem::getFromPrimaryID( $_REQUEST{ 'devItemID' } ) );
      }
   }

//========================================================================

   /*!
   @function setDevelopmentItem( $devItem )
   @param $devItem - a ADevelopmentItem
   @discussion - sets the ADevelopmentItem that this View will display
   */

   function setDevelopmentItem( &$devItem )
   {
      $this->devItem =& $devItem;
   }

//========================================================================

   /*!
   @function getParameters()
   */

   function getParameters()
   {
      return array( 'devItemID' => $this->devItem->getPrimaryID() );
   }

//========================================================================

   /*!
   @function setTitlePrefixComponent( &$htmlComponent )
   @discussion this will be put just before the title in my HTML
   */

    function setTitlePrefixComponent( &$htmlComponent )
    {
        $this->prefixComponent =& $htmlComponent;
    }

//========================================================================

   /*!
   @function getTitle()
   @discussion - gets the title for the home page
   @return - string, title of page
   */

   function getTitle()
   {
      return 'Item Details';
   }

//========================================================================

   /*!
   @function _getFirstRowColor()
   @discussion - returns a color
   */

   function _getFirstRowColor()
   {
      if( isInstanceOf( $this->devItem, 'Defect' ) )   return Color::getColor( 240,225,225 );
      if( isInstanceOf( $this->devItem, 'FeatureRequest' ) )   return Color::getColor( 225,225,240 );
      return Color::getColor( 240,240,240 );
   }

//========================================================================

   /*!
   @function getHTML()
   @discussion - produces HTML about this ADevelopmentItem
   */

   function getHTML()
   {
      importClass( 'HTMLComponents.Table.Table' );
      $this->table =& new Table();
      $this->table->setRequestedDimensions(
         $this->getDimensions() );
      $this->table->setWidth( '620' );
        // $this->table->setBorder(1);
      importClass( 'Display.Color' );
      $this->table->startRow( $this->_getFirstRowColor() );

      //default alignment - span all columns
      $subText =& new Text( $this->devItem->getSubject().' ('.$this->devItem->getReportTypeName().')' );
      $subText->setFont( Font::getFont( 'Tahoma', '12pt', true, false ) );
      importClass( 'HTMLComponents.Text' );
      
      $titleTable =& new Table();
      // $titleTable->setBorder( 1 );
      // $titleTable->setWidth( '100%' );

      if ( isset( $this->prefixComponent ) ) 
      { 
        // this cell width stuff is likely optional
        importClass( 'HTMLComponents.Table.TableCell' );
        $cell =& new TableCell( $this->prefixComponent  );
        $cell->setWidth( 1 );
        $titleTable->addCell( $cell  ); 
      }
      
      $titleTable->addCell( $subText );
      
      $this->table->addCell( $titleTable, UNSPECIFIED, 4 );

      importClass( 'BugUI.OtherComponents.DevelopmentItemLinks' );
      $linkComp =& new DevelopmentItemLinks( $this->devItem );
      //$linkComp->setShowAll();
      $this->table->addCell( $linkComp, RIGHT, 1 );

      importClass( 'BugUI.OtherComponents.ReportIDHTMLComponent' );
      $this->_addRow(
         'TR-ID', new ReportIDHTMLComponent( $this->devItem->getID() ),
         'Date Submitted', getFormattedDBTimeStamp( $this->devItem->getDateCreated() ) );

      $category =& $this->devItem->getCategory();
      $submitter =& $this->devItem->getSubmitter();

      importClass( 'BugUI.OtherComponents.UserNameHTMLComponent' );
      $this->_addRow(
         //'Category', $category->getIdentifyingString(),
         'Submitter', new UserNameHTMLComponent($submitter->getIdentifyingString()),
         'Date Assigned', getFormattedDBTimeStamp( $this->devItem->getDateAssigned() ) );

      $developer =& $this->devItem->getDeveloper();
      $this->_addRow(
         'Developer', new UserNameHTMLComponent( $developer->getIdentifyingString() ),
         'Date Closed', getFormattedDBTimeStamp( $this->devItem->getDateClosed() ) );

      importClass( 'BugUI.OtherComponents.PriorityHTMLComponent' );
      $priority =& $this->devItem->getPriority();
      $this->_addRow(
         'Priority', new PriorityHTMLComponent( $priority->getIdentifyingString() ),'','' );

      $state =& $this->devItem->getState();
      $this->_addRow(
         'State', $state->getIdentifyingString() ,'','' );

      $this->table->startRow();

      //default alignment - span all columns
      //importClass( 'HTMLComponents.LongText' );
      $report = $this->devItem->getReport() ;
//      $this->table->addCell(
//         new LongText( $this->devItem->getReport() ),
//         UNSPECIFIED,
//         INFINITY );
      if ( strlen( $report ) > SUMMARY_MAX_REPORT_DISPLAY_LENGTH )
      {
         $report = substr( $report, 0 , SUMMARY_MAX_REPORT_DISPLAY_LENGTH ) . '...';
      }
      $reportTextObj =& new Text( $report );
      $reportTextObj->setFont( Font::getFont( 'Tahoma', '-1' ) );

      $this->table->addCell( $reportTextObj, UNSPECIFIED, INFINITY );

      $html = $this->table->getHTML();
      //free the Table
      unset( $this->table );
      return $html;
   }

//========================================================================

   /*!
   @function _addRow( $table, $label0, $value0, $label1, $value1 )
   @param $table - a Table
   @param $label0 - a String
   @param $value0 - a String  or HTMLComp
   @param $label1 - a String
   @param $value1 - a String  or HTMLComp
   @discussion - adds the label value pairs in a single row
      to the provided Table.

      $label1 may '' if no cell should be added.
   */

   function _addRow( $label0, $value0, $label1, $value1 )
   {
      //This is a little messy, but we're calling it in a loop
      //so the increased speed is definitely worth the effort.

      $labelCell =& DevelopmentItemSummaryView::_getLabelCell();
      $dataCell =& DevelopmentItemSummaryView::_getDataCell();
      $smallDataCell =& DevelopmentItemSummaryView::_getSmallDataCell();
      $text =& DevelopmentItemSummaryView::_getText();

      $this->table->startRow();

      $text->_setText( $label0 . ':' );
      $labelCell->_setHTMLComponent( $text );
      $this->table->_addCell( $labelCell );

      importClass( 'HTMLComponents.Text' );
      if( isInstanceOf( $value0, 'AHTMLComponent' ) )
      {
         $smallDataCell->_setHTMLComponent( $value0 );
      }
      else
      {
         $smallDataCell->_setHTMLComponent( new Text( $value0 ) );
      }

      $this->table->_addCell( $smallDataCell );

      if ( $label1 != '' )
      {
         $text->_setText( $label1 . ':' );
         $labelCell->_setHTMLComponent( $text );
         $this->table->_addCell( $labelCell );

         //imported above
         if( isInstanceOf( $value1, 'AHTMLComponent' ) )
         {
            $dataCell->_setHTMLComponent( $value1 );
         }
         else
         {
            $dataCell->_setHTMLComponent( new Text( $value1 ) );
         }

         $this->table->_addCell( $dataCell );
      }
   }

//========================================================================

   /*!
   @function _getLabelCell()
   @discussion - produces the TableCell used by _addRow
   @result - returns a TableCell
   */

   function &_getLabelCell()
   {
      static $cellArray;

      if ( ! isset( $cellArray ) )
      {
         importClass( 'HTMLComponents.Table.TableCell' );
         $cellArray[ 0 ] =& new TableCell( toRef( NULL ) );
         $cellArray[ 0 ]->setWidth( '15%' );
         $cellArray[ 0 ]->disableWrapping();
         $cellArray[ 0 ]->setVerticalAlignment( TOP );
      }

      return $cellArray[ 0 ];
   }

//========================================================================

   /*!
   @function _getDataCell()
   @discussion - produces the TableCell used by _addRow
   @result - returns a TableCell
   */

   function &_getDataCell()
   {
      static $cellArray;

      if ( ! isset( $cellArray ) )
      {
         importClass( 'HTMLComponents.Table.TableCell' );
         $cellArray[ 0 ] =& new TableCell( toRef( NULL ) );
         $cellArray[ 0 ]->setWidth( '45%' );
         $cellArray[ 0 ]->setVerticalAlignment( TOP );
      }

      return $cellArray[ 0 ];
   }

//========================================================================

   /*!
   @function _getSmallDataCell()
   @discussion - produces the TableCell used by _addRow
   @result - returns a TableCell
   */

   function &_getSmallDataCell()
   {
      static $cellArray;

      if ( ! isset( $cellArray ) )
      {
         importClass( 'HTMLComponents.Table.TableCell' );
         $cellArray[ 0 ] =& new TableCell( toRef( NULL ) );
         $cellArray[ 0 ]->setWidth( '25%' );
         $cellArray[ 0 ]->setVerticalAlignment( TOP );
      }

      return $cellArray[ 0 ];
   }

//========================================================================

   /*!
   @function _getText()
   @discussion - produces the Text used by _addRow
   @result - returns a Text
   */

   function &_getText()
   {
      static $textArray;

      if ( ! isset( $textArray ) )
      {
         importClass( 'HTMLComponents.Text' );
         $textArray[ 0 ] =& new Text( '' );
         importClass( 'Display.Font' );
         $textArray[ 0 ]->setFont( Font::getFont( 'Tahoma', '11pt', true, false ) );
      }

      return $textArray[ 0 ];
   }

//========================================================================

   /*!
   @function _addLargeText( &$table, $label, $value )
   @param $table - a Table
   @param $label - a String
   @param $text - a String
   @discussion - adds a cell that spans all columns of the Table
      containing the provided $text
   */

   function _addLargeText( &$table, $label0, $value0 )
   {
      importClass( 'HTMLComponents.Text' );
      $table->startRow();
      $table->addCell( new Text( $label0 ), UNSPECIFIED, INFINITY );
      $table->startRow();
      $table->addCell( new Text( $value0 ),UNSPECIFIED, INFINITY );
   }

//========================================================================

};

?>