<?php

/*
HistoryView
$Author: millz $
$Revision: 1.2 $
$Date: 2004/11/18 17:10:47 $
$Log: HistoryView.php,v $
Revision 1.2  2004/11/18 17:10:47  millz
*** empty log message ***

Revision 1.1  2003/07/29 14:39:01  millz
-



IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

define( 'STAT_HIST_DATE_REQUEST_VAR', 'statHistDateValue' );
define( 'STAT_HIST_COLUMN_REQUEST_VAR', 'statHistColValue' );

define( 'MAX_GRAPH_WIDTH_PIXELS', '700' );

//========================================================================

importClass( 'BugUI.AView' );

//========================================================================

/*!
@class HistoryView
@abstract -
*/

class HistoryView extends AView
{

//========================================================================

   /*!
   @function HistoryView()
   @discussion - constructs a new HistoryView object
   @result - constructs a new HistoryView object
   */

   function HistoryView()
   {
      if(isset($_REQUEST{STAT_HIST_DATE_REQUEST_VAR}))
      {
         $this->dayToUse = $_REQUEST{STAT_HIST_DATE_REQUEST_VAR};
      }
      else
      {
         $this->dayToUse = date('Y-m-d', time() - 60*60*24 );  // yesterday
      }
      
      if(isset($_REQUEST{STAT_HIST_COLUMN_REQUEST_VAR}))
      {
         $this->columnToUse =  $_REQUEST{STAT_HIST_COLUMN_REQUEST_VAR};
      }
      else
      {
         $this->columnToUse = 1;
      }      
      
      $this->AView();
   }

//========================================================================

   /*!
   @function getHTML()
   */

   function getHTML()
   {
      //TODO: Change the way queries are created because passing that
      // much information is unsafe

      
      importClass( 'HTMLComponents.RawHTML' );

      
      
      importClass( 'Shared.User' );
      $currentUser =& User::getCurrentUser();
      $this->currProject =& $currentUser->getCurrentProject();
      
      importClass( 'Database.DBConnectionProvider' );
      $this->conn =& DBConnectionProvider::getReadOnlyConnection();
      
      $sql = 'select * from stathistory where statcolumn_id = '.$this->conn->qstr($this->columnToUse).
               ' and DATE_FORMAT(date_in, \'%Y-%m-%d\') = '.$this->conn->qstr($this->dayToUse).' and '.
               'project_id = '.$this->conn->qstr($this->currProject->getPrimaryID());

      importClass( 'Database.StandardCacheHandler' );
      $cacheHandler =& StandardCacheHandler::create( 'stathistory' );
      
      $cacheTime = $cacheHandler->getMultipleCacheTime();
      
      $recordSet =
            $this->conn->CacheExecute(
               $cacheTime,
               $sql );

      // print "Running $sql". BR_NL;

      if ( $recordSet === false )
      {
         unreachablePoint(
            'Error in running query in HistoryView::getHTML - tried to run -> ['.$sql.']'.BR_NL.$this->conn->ErrorMsg() );
      }
      
      $innerTable =& new Table();
      
      $foundData = false;
      
      while ( !$recordSet->EOF)
      {
         $foundData = true;
         // get title for entry, if possible
         $sql = 'select viewClass from statcolumn where statcolumn_id = '.$this->conn->qstr($this->columnToUse);
         $cacheHandler =& StandardCacheHandler::create( 'statcolumn' );
         
         $cacheTime = $cacheHandler->getMultipleCacheTime();
         
         $innerRS =
            $this->conn->CacheExecute(
               $cacheTime,
               $sql );         
         
         if(tryImportClass($innerRS->fields['viewClass']))
         {
            $classToCreate = absoluteClassToClass($innerRS->fields['viewClass']);
            // $thisObj =& new $classToCreate();
         }
         
         $innerTable->startRow();
         
         if(!isset($classToCreate))
         {
            $innerTable->addCell( new Text($recordSet->fields['value']) );
         }
         else
         {
            $obj =& callStaticMethod( $classToCreate, 'getFromPrimaryID', new_array($recordSet->fields['value']) );
            // $classToCreate::getFromPrimaryID();
            $innerTable->addCell( new Text( $obj->getIdentifyingString() ) );
         }
         
         //ceiling( / MAX_GRAPH_WIDTH_PIXELS )
         
         $innerTable->addCell( new RawHTML('<img src=../images/onePixel.gif height=9 width='.$recordSet->fields['count'].'> '.$recordSet->fields['count']) );
         //$innerTable->addCell( new Text() );
         $recordSet->MoveNext();
         // exit;
      }

      if(!$foundData){ $innerTable->startRow(); $innerTable->addCell( new Text( 'No data found for this project from '.$this->dayToUse.' for that column' ) ); }

      $formHTMLComp =& $this->_getFormHTML();

      $raw =& new RawHTML( $formHTMLComp->getHTML().$innerTable->getHTML().$formHTMLComp->getHTML() );

      return $raw->getHTML();
   }

//========================================================================

   function _getFormHTML()
   {
      if(!isset($this->formHTMLComp))
      {
         importClass( 'HTMLComponents.Text' );
         importClass( 'HTMLComponents.RawHTML' );
         importClass( 'HTMLComponents.Table.Table' );
         $table =& new Table();
   
         $sql = 'select distinct DATE_FORMAT(date_in, \'%Y-%m-%d\') one,DATE_FORMAT(date_in, \'%a, %M %d, %Y\') two from stathistory where project_id = '.$this->conn->qstr($this->currProject->getPrimaryID()).' order by date_in';
         $select =& html::getDropDownByQuery( STAT_HIST_DATE_REQUEST_VAR, $sql, 'two', 'one', 'stathistory',$this->dayToUse );
   
         $table->startRow();
         
         $table->addCell( new Text('View counts by day:') );
         $table->addCell( $select );
   
         $sql = 'select distinct name,statcolumn_id from statcolumn order by name';
         $select =& html::getDropDownByQuery( STAT_HIST_COLUMN_REQUEST_VAR, $sql, 'name', 'statcolumn_id', 'statcolumn',$this->columnToUse );
   
         $table->addSpacerCell();
         $table->addCell( new Text('Grouped By:') );
         $table->addCell( $select );
         
         $table->addCell( new RawHTML( '<input type=hidden name=view value=HistoryView><input type=submit value=View>'  ) );
         
         $this->formHTMLComp =& new RawHTML( '<form method=get>'.$table->getHTML().'</form>' );
      }
      
      return $this->formHTMLComp;
   }

//========================================================================

   /*!
   @function getTitle()
   */

   function getTitle()
   {
      return 'View Historic Data';
   }

//========================================================================

};

?>