<?php

/*
ProjectView
$Author: millz $
$Revision: 1.5 $
$Date: 2004/01/06 15:43:03 $
$Log: ProjectView.php,v $
Revision 1.5  2004/01/06 15:43:03  millz
- added recent and fav portlets

Revision 1.4  2003/09/04 17:38:45  millz
- removed stats portlets

Revision 1.3  2003/08/05 03:02:31  millz
- let designers see my verif items

Revision 1.2  2003/07/17 20:51:52  millz
- updated for removed func in Project

Revision 1.1  2003/07/09 19:57:45  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.AView' );

//========================================================================

class ProjectView extends AView
{

//========================================================================

   var $project;

//========================================================================
   /*!
   @function ProjectView(  $project_id = UNSPECIFIED  )
   @discussion - ProjectView constructor
   */

   function ProjectView()
   {
      importClass( 'Shared.User' );
      $thisUser =& User::getCurrentUser();
      $this->project =& $thisUser->getCurrentProject();
   }

//========================================================================

   /*!
   @function setProject( $project )
   @param $project -
   */

   function setProject( &$project )
   {
      $this->project =& $project;
   }

//========================================================================

   /*!
   @function getTitle()
   @discussion - gets the title for the home page
   @return - string, title of page
   */

   function getTitle()
   {
      return 'My Project Information';
   }

//========================================================================

   /*!
   @function getHTML()
   @discussion - gets the html for the home page
   @return - string, html for the home page
   */

   function getHTML()
   {
      importClass( 'HTMLComponents.Table.Table' );

      importClass( 'BugUI.Portlets.DevelopmentItemListPortlet' );
      $portlets = new_array();

      $table =& new Table( 'Project View Main Table' );
      $table->setCellPadding(2);
      $table->startRow();
      $table->setWidth('100%');

      importClass( 'HTMLComponents.Text' );
      $table->addCell( new Text( $this->getEnglishDescription() ), LEFT, 2 );

      // $table->addSpacerRow();

      importClass( 'Shared.User' );
      $user =& User::getCurrentUser();

      $portlets = array();
      $numPortlets = 0;

      if ( $this->project->isDesigner( $user ) )
      {
         $portlets[ $numPortlets++ ] =&
            DevelopmentItemListPortlet::create(
               'New Items to Address (Submitted-New/ReOpened)',
               $this->project->getNewDevelopmentItems() );

         $portlets[ $numPortlets++ ] =&
            DevelopmentItemListPortlet::create(
               'Unassigned Issues (No Developer)',
               $this->project->getUnassignedDevelopmentItems() );

         $portlets[ $numPortlets++ ] =&
            DevelopmentItemListPortlet::create(
               'All Active Items',
               $this->project->getAllActiveDevelopmentItems() );
      }

      if ( $this->project->isDesigner( $user ) || $this->project->isQALead( $user ) )
      {
         $portlets[ $numPortlets++ ] =&
            DevelopmentItemListPortlet::create(
               'Verification Requested',
               $this->project->getVerificationRequestedDevelopmentItems() );
      }

      if ( $this->project->isDeveloper( $user ) )
      {
         $portlets[ $numPortlets++ ] =&
            DevelopmentItemListPortlet::create(
               'My Development Items',
               $this->project->getDevelopmentItemsAssignedTo( $user ) );
      }

      if ( $this->project->isDesigner( $user ) || $this->project->isQA( $user ) )
      {
         $portlets[ $numPortlets++ ] =&
            DevelopmentItemListPortlet::create(
               'Items Needing My Verification',
               $this->project->getVerificationRequestedDevelopmentItemsFor( $user ) );
      }

      if ( $this->project->isQA( $user ) )
      {
         $portlets[ $numPortlets++ ] =&
            DevelopmentItemListPortlet::create(
               'Issues Needing More Information (any project)',
               $user->getUsersIncompleteDevelopmentItems() );
      }

      
      importClass( 'BugUI.Portlets.FavoriteItemSetPortlet' );
      $portlets[ $numPortlets++ ] =& FavoriteItemSetPortlet::createCurrentUserFavoriteItemSetPortlet();

      // $recentItemSet =& $user->getRecentItems();

      importClass( 'BugUI.Portlets.RecentItemSetPortlet' );
      $portlets[ $numPortlets++ ] =& RecentItemSetPortlet::createCurrentUserRecentItemSetPortlet();


      for ( $i = 0; $i < $numPortlets; ++$i )
      {
         if( $i % 2 == 0 )
         {
            $table->addSpacerRow();
            $table->startRow();
         }

         $tableCell =& new TableCell( $portlets[ $i ] );
         $tableCell->setVerticalAlignment( TOP );
         $tableCell->setWidth('50%');

         $table->addCell( $tableCell );
      }

      return $table->getHTML();
   }

//========================================================================

   /*!
   @function getEnglishDescription()
   */

   function getEnglishDescription()
   {
      importClass( 'Shared.User' );

      $user =& User::getCurrentUser();

      $name = $user->getFirstName();

      $out = 'Welcome, '.$name.'. ';

      if ( isset( $this->project ) && ( ! $this->project->isNull() ) )
      {
         return $out . 'You are viewing information for project: "' . $this->project->getName() . '"';
      }
      else
      {
         return $out . 'You are viewing information from all projects.';
      }
   }

//========================================================================

};

?>