<?php

/*
RssView
$Author: dougqh $
$Revision: 1.2 $
$Date: 2004/11/15 15:11:04 $
$Log: RssView.php,v $
Revision 1.2  2004/11/15 15:11:04  dougqh
- Minor corrections

Revision 1.10  2004/02/09 15:04:36  dougqh
- 4041

Revision 1.9  2004/01/13 21:32:13  millz
- reformatting checkboxes

Revision 1.8  2004/01/13 19:00:48  dougqh
- Refactored to work AFavoriteItemSetActions

Revision 1.7  2004/01/08 19:48:02  millz
- altered getSubmitText

Revision 1.6  2004/01/08 16:35:11  dougqh
- Minor corrections - now using AddToFavoriteItemSetView

Revision 1.5  2004/01/08 15:30:00  dougqh
- ?

Revision 1.4  2004/01/07 22:18:29  millz
- getting favorite ids

Revision 1.3  2003/12/31 16:02:48  dougqh
- 3923

Revision 1.2  2003/12/17 14:40:58  dougqh
- 3910

Revision 1.1  2003/07/09 19:57:45  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

// importClass( 'CollectionUI.AIteratorView' );
importClass( 'BugUI.AView' );

//imported for parameter constants
importClass( 'BugUI.Views.DevelopmentItemResultsView' );

class RssView extends AView // AIteratorView
{

//========================================================================

   var $view;
   var $favSetAction;


//========================================================================

   /*!
   @function RssView()
   @discussion - RssView cunstructor
   */

   function RssView(  )
   {
      $this->AView();
      $this->usedSetIterator = true; //as opposed to setIterator2

      $this->firstTime = true;
      $this->hasItem = true;
   }

//========================================================================

   /*!
   @function createFromRequest()
   */
   function &createFromRequest()
   {
      if ( isset( $_REQUEST{ DEV_RESULTS_WHERE_PAIR_PARAM } ) )
      {
         $wherePair = $_REQUEST{ DEV_RESULTS_WHERE_PAIR_PARAM };
         if ( ! isset( $wherePair[ 1 ] ) )
         {
            $wherePair[ 1 ] = array();
         }
         if ( ! is_array( $wherePair ) )
         {
            print_r( $wherePair );
            unreachablePoint(
               'Bad wherePair in RssView::createFromRequest' );
         }
      }
      $joinComments = isset( $_REQUEST{ DEV_RESULTS_JOIN_PARAM } );
      if ( isset( $_REQUEST{ DEV_RESULTS_ORDER_PARAM } ) )
      {
         $order = $_REQUEST{ DEV_RESULTS_ORDER_PARAM };
      }
      else
      {
         $order = UNSPECIFIED;
      }

      if ( ! isset( $wherePair ) )
      {
         $view =& new RssView();
         importClass('Database.QueryResultsIterator');
         importClass('Bugs.ADevelopmentItem');
         $view->_setIterator(
            QueryResultsIterator::createFromRequest(
               ADevelopmentItem::getPrototype() ) );

      }
      else
      {
         $view =& new RssView();
         $view->_setIterator2( $wherePair, $order, $joinComments );
      }


      return $view;
   }


//========================================================================

   /*!
   @function getContentType()
   @discussion - indicates the http content-type, such as text/html.
   @result - returns a string
   */

   function getContentType()
   {
      return 'text/xml';
   }

//========================================================================

   /*!
   @function create( $wherePair, [ $order ], [ $joinStruct ], [ $useDetails ] )
   @param $wherePair - a WherePair for ADevelopmentItems
      (without a project specification)
   @param $useDetails - a boolean - indicating if DevelopmentItemDetailsView
      should be used for each row
   @discussion - provides a DevelopmentResultsView for the provided
      IIterator
   @result - returns a RssView
   */

   function &create( $wherePair, $order = UNSPECIFIED,
      $joinStruct = UNSPECIFIED, $useDetails = UNSPECIFIED )
   {
      if ( $useDetails === UNSPECIFIED ) $useDetails = false;

      $view =& new RssView( false );
      $view->_setIterator2( $wherePair, $order, $joinStruct );
      if ( $useDetails ) $view->_useDetails();
      return $view;
   }

//========================================================================

   /*!
   @function _getBodyHTML()
   @discussion - generates html
   @return - returns string of raw html
   */

   function getHtml()
   {
      importClass( 'FileGenerators.UniversalFeedCreator' );
      
      $this->rss = new UniversalFeedCreator(); 
      
      importLibrary( 'URL' );
      
      $this->rss->title = "BugPort Search Results"; 
      $this->rss->description = "This feed contains the results from a BugPort search";
      $this->rss->link = htmlspecialchars(getAbsoluteURL($_SERVER['PHP_SELF'] . '?' . $_SERVER['QUERY_STRING']));
      $this->rss->syndicationURL = htmlspecialchars(getAbsoluteURL($_SERVER['PHP_SELF']));
      
      $image = new FeedImage(); 
      $image->title = "INCOGEN logo"; 
      $image->url = getAbsoluteBugPortURL("images/icon.gif"); 
      $image->link = getAbsoluteBugPortURL(""); 
      $image->description = "Feed provided by INCOGEN's BugPort. Click to visit."; 
      $this->rss->image = $image; 
      
      $maxCount = $this->getNumRows();

      for (
         $this->iterator->reset(), $count = 0;
         ! $this->iterator->isEnd() && $count < $maxCount;
         $this->iterator->moveNext(), ++$count )
      {

         $this->_handleCurrent( $this->iterator->getCurrent() );
      }
      
      return $this->rss->createFeed();
      
   }

//========================================================================

   /*!
   @function _setIterator( &$iterator )
   @param $iterator - an IIterator
   @discussion - sets the IIterator for this View
   */

   function _setIterator( &$iterator )
   {
      $this->iterator =& $iterator;
   }

//========================================================================

   /*!
   @function &create2( &$iter )
   */
    function &create2( &$iter )
    {
        $view =& new RssView();
        $view->_setIterator( $iter );
        return $view;
    }

//========================================================================

   /*!
   @function _setIterator2( $wherePair, [$order], [$joinComments] )
   */

   function _setIterator2( &$wherePair, $order = UNSPECIFIED, $joinComments = UNSPECIFIED )
   {
      $this->usedSetIterator = false;

      importClass( 'Shared.User' );
      $user =& User::getCurrentUser();
      $project =& $user->getCurrentProject();
      //print 'Project: ' . $project->getPrimaryID();

      if ( $joinComments && ( $joinComments !== UNSPECIFIED ) )
      {
         importClass( 'Database.Join' );
         importClass( 'Bugs.Comment' );
         $joinStruct =& Join::createOuter(
               'comment',
               'report.report_id=comment.report_id',
               true,
               Comment::getPrototype() );
      }
      else
      {
         $joinStruct = UNSPECIFIED;
      }

      $this->_setIterator(
         $project->searchDevelopmentItems(
            $wherePair, $order, $joinStruct ) );

      $this->wherePair = $wherePair;
      $this->joinComments = $joinComments;
      $this->order = $order;
   }



//========================================================================

   /*!
   @function getNumRows()
   @discussion - provides an integer containing the maximum number
      of rows to display
   @result - returns an integer
   */

   function getNumRows()
   {
      return INFINITY;
   }


//========================================================================

   /*!
   @function _handleCurrent( $object )
   @param $object - an Object of the type provided by the IIterator
   @discussion - called for each Object provided by the IIterator
      in a loop
   */

   function _handleCurrent( &$object )
   {
          $item = new FeedItem(); 
          $item->title = $object->getSubject(); 
          
          importClass( 'BugUI.Views.DevelopmentItemDetailsView' );
          
          $detailsView =& DevelopmentItemDetailsView::create( $object );
          $viewDetailsOp =& $detailsView->getDisplayOperation();
          $viewDetailsLink =& $viewDetailsOp->getLink();
          $viewDetailsURL =& $viewDetailsLink->getURL();
          
          
          
          $item->link = getAbsoluteURL($viewDetailsURL->getURLString());
          
          importClass( 'BugUI.Views.DevelopmentItemSummaryView' );  // for constant
          $report = $object->getReport();
          if ( strlen( $report ) > SUMMARY_MAX_REPORT_DISPLAY_LENGTH )
          {
               $report = substr( $report, 0 , SUMMARY_MAX_REPORT_DISPLAY_LENGTH ) . '...';
          }
           
          $item->description = $report; 
          
          importClass( 'Database.DBConnectionProvider' );
          $dbcon =& DBConnectionProvider::getReadOnlyConnection();
          
          $item->date = $dbcon->UnixTimeStamp( $object->getDateCreated() ); 
          $item->source = "INCOGEN's BugPort"; 
          $user =& $object->getSubmitter(); 
          $item->author = $user->getName();
          $this->rss->addItem($item); 
   }
   
//========================================================================

	/*!
	@function getTitle()
	*/
	function getTitle()
	{
		 return 'RSS';
	}   

//========================================================================

   /*!
   @function getParameters()
   */
   function getParameters()
   {
      if ( $this->usedSetIterator )
      {
         $params = $this->iterator->getParameters();
      }
      else
      {
         $params = array();
         if ( $this->useDetails ) $params{ DETAILS_VIEW_PARAM } = '1';
         if ( $this->order && $this->order !== UNSPECIFIED )
         {
            $params{ DEV_RESULTS_ORDER_PARAM } = $this->order;
         }
         if ( isset( $this->wherePair ) )
         {
            $params{ DEV_RESULTS_WHERE_PAIR_PARAM } = $this->wherePair;
            if ( isset( $this->joinComments ) && ( $this->joinComments ) )
            {
               $params{ DEV_RESULTS_JOIN_PARAM } = true;
            }
            if ( isset( $this->joinStruct ) && ( $this->joinStruct != UNSPECIFIED ) )
            {
               $params{ DEV_RESULTS_JOIN_PARAM } = $this->joinStruct;
            }
         }
      }
      return $params;
   }

//========================================================================

};

?>