<?php

/*
SearchForm
$Author: millz $
$Revision: 1.19 $
$Date: 2004/11/18 17:10:38 $
$Log: SearchForm.php,v $
Revision 1.19  2004/11/18 17:10:38  millz
*** empty log message ***

Revision 1.18  2004/06/14 20:22:05  dougqh
- Fixed 4463

Revision 1.17  2004/06/07 18:40:14  dougqh
- Fix for 4457

Revision 1.16  2004/05/19 13:04:47  millz
- added duedate as sort column choice

Revision 1.15  2004/05/19 12:51:19  dougqh
?

Revision 1.14  2004/01/07 21:48:02  dougqh
- ?

Revision 1.13  2003/12/17 15:13:03  dougqh
- 3913

Revision 1.12  2003/12/17 14:41:06  dougqh
- 3910

Revision 1.11  2003/12/11 18:09:24  millz
- correcting comment search bugs

Revision 1.10  2003/12/03 21:01:44  millz
- changed default order by

Revision 1.9  2003/11/05 14:18:41  millz
- added report age field

Revision 1.8  2003/10/20 18:21:21  dougqh
- Fix for 3621

Revision 1.7  2003/07/23 19:05:43  millz
- added new field for reporttype

Revision 1.6  2003/07/22 14:33:31  millz
- add two fields for orderBy

Revision 1.5  2003/07/21 22:21:16  millz
- fixing redundancy bug

Revision 1.4  2003/07/18 13:44:08  millz
- more doc updates

Revision 1.3  2003/07/10 18:55:00  dawn
-

Revision 1.2  2003/07/10 17:59:23  dawn
-

Revision 1.1  2003/07/09 19:57:45  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

define( 'ANY_USER_LABEL', '----Any User----' );
define( 'ANY_LABEL', '----Any----' );

define( 'SUMMARY_VIEW_REQUEST_NAME', 'summary' );
define( 'DETAILED_VIEW_REQUEST_NAME', 'detailed' );

define( 'PERFORM_LIKE_SEARCH_PARAM', 'doLike' );

define( 'SUBMITTED_DATE_AGE_PARAM', 'date_in_age' );
define( 'SUBMITTED_DATE_COLUMN', 'report.date_in' );
define( 'SUBMITTED_DATE_AGE_OP', 'submittedDateAgeOp' );

//========================================================================

importClass( 'BugUI.AForm' );

//========================================================================

/*!
@class SearchForm
@abstract -
*/

class SearchForm extends AForm
{

//========================================================================

   /*!
   @function SearchForm()
   @discussion - constructs a new SearchForm object
   @result - constructs a new SearchForm object
   */

   function SearchForm()
   {
      $this->AForm();
   }

//========================================================================

   /*!
   @function &_createReportAgeField()
   @result - returns a TimeDurationField
   */
   function &_createReportAgeField()
   {
      importClass( 'TimeUI.TimeDurationField' );
      importConstants( 'Time' );
      return new TimeDurationField( SUBMITTED_DATE_AGE_PARAM, 'Submitted Date', DAY_UNIT );
   }

//========================================================================

   /*!
   @function _execute()
   @result - returns an AView
   */

   function _execute()
   {
      if ( isset( $_REQUEST{ 'quickSearch' } ) )
      {
         print 'Quick Search' . BR_NL;
         $this->_doQuickSearch();
      }
      else
      {
         $this->_doRegularSearch();
      }

      //----------------------------------------------------------------------------------------

   }

//========================================================================

   /*!
   @function _doQuickSearch()
   */

   function _doQuickSearch()
   {
      $quickClause = trim( $_REQUEST{ 'quickSearch' } );
      if ( isInteger( $quickClause ) )
      {
         importClass( 'BugUI.Views.DevelopmentItemDetailsView' );
         importClass( 'Bugs.ADevelopmentItem' );
         $this->nextView =& DevelopmentItemDetailsView::create(
            ADevelopmentItem::getFromPrimaryID( $quickClause ) );
      }
      else
      {
         //joinComments (the third element) in the triplet will NEVER be
         //true here, so this is fine
         $containsPair =
            SearchForm::_getContainsWhereTriplet(
               $quickClause, false );
               
         
         // add that the state is < closed
         importClass( 'Bugs.State' );
         $arrayOfWherePairs = array( State::_getActiveStateWherePair(), $containsPair );

         $pairToUse = ADatabaseItem::_getAndWherePairs( $arrayOfWherePairs );

         importClass( 'BugUI.Views.DevelopmentItemResultsView' );
         $this->nextView =&
            DevelopmentItemResultsView::create( $pairToUse );
      }
   }

//========================================================================

   /*!
   @function _doRegularSearch()
   */

   function _doRegularSearch()
   {
      //start by filtering on the current project
      $whereParts = array();
      $binds = array();

      //------------------------------------------------------------------
      //read the normal restrictions from the REQUEST
      importClass( 'Database.QueryResultsIterator' );
      $order = QueryResultsIterator::getOrderFromRequest( $proto );
      $wherePair = QueryResultsIterator::getWherePairFromRequest( $proto );
      if ( ! isEmpty( $wherePair[ 0 ] ) )
      {
         $whereParts[] = $wherePair[ 0 ];
      }
      $binds = array_merge_compat( $binds, $wherePair[ 1 ] );

      //------------------------------------------------------------------
      //handle contains

      // importConstants( 'TimeUI' );
      $reportAgeField =& $this->_createReportAgeField();
      $reportAgeField->loadFormData();

      if ( ! $reportAgeField->isEmpty() )
      {
         // print "Adding clause for date field!";
         importClass( 'Database.QueryUtils' );
         importClass( 'Database.DBConnectionProvider' );

         // TODO - deal with unset $_REQUEST{SUBMITTED_DATE_AGE_OP}
         $submitDateAgeWherePair =& QueryUtils::getDateOlderWherePair(
            DBConnectionProvider::getReadOnlyConnection(),
            SUBMITTED_DATE_COLUMN,
            $_REQUEST{ SUBMITTED_DATE_AGE_OP },
            $reportAgeField->getValue() );

         $whereParts[] = $submitDateAgeWherePair[ 0 ];
         $binds = array_merge_compat( $binds, $submitDateAgeWherePair[ 1 ] );
      }

      if ( isset( $_REQUEST{ 'contains' } ) )
      {
         $contains = $_REQUEST{ 'contains' };
      }
      else
      {
         $contains = '';
      }

      if ( isset( $_REQUEST{ 'includeComments' } ) )
      {
         $includeComments = $_REQUEST{ 'includeComments' };
      }
      else
      {
         $includeComments = false;
      }

      list( $containsWhere, $containsBinds, $joinComments ) =
         SearchForm::_getContainsWhereTriplet(
            $contains, $includeComments );

      if ( ! isEmpty( $containsWhere ) )
      {
         $whereParts[] = $containsWhere;
         $binds = array_merge_compat( $binds, $containsBinds );
      }

      //------------------------------------------------------------------

      $where = trim( implode( ' AND ', $whereParts ) );

      //------------------------------------------------------------------
      //Let's determine which view the user wants (listing style, really)

      $proto =&  $this->_getPrototype();
      importClass( 'BugUI.Views.DevelopmentItemResultsView' );

      $this->nextView =&
         DevelopmentItemResultsView::create(
            array( $where, $binds ),
            $order,
            $joinComments,
            isset( $_REQUEST{ 'useView' } ) &&
               ( $_REQUEST{ 'useView' } == DETAILED_VIEW_REQUEST_NAME ) );
   }

//========================================================================

   /*!
   @function _getContainsWhereTriplet( $contains, $includeComments )
   @param $contains - a String to search for - may be empty
   @param $includeComments - boolean indicating if comments should
      be included in the search
   @discussion -
   @result - returns a Where triplet
      - i.e. Query, Binds, JoinStruct
   */

   function _getContainsWhereTriplet( $contains, $includeComments )
   {
      $contains = trim( $contains );
      $performLikeSearch = false;

      if( strlen($contains) <= 3  ||
          ( isset($_REQUEST{ PERFORM_LIKE_SEARCH_PARAM }) && $_REQUEST{ PERFORM_LIKE_SEARCH_PARAM } )
        )
        { $performLikeSearch = true; }

      importClass( 'Database.DBConnectionProvider' );
      $dbcon =& DBConnectionProvider::getReadOnlyConnection();

      if ( isEmpty( $contains ) )
      {
         return array( '', array(), false );
      }
      else
      {
         $columns = array( 'report','subject','develplan','fixednotes','repsteps' );
         $joinComments = false;
         if ( $includeComments )
         {
            $columns[] = 'comment.comments';
            $joinComments = true;
         }

         //---------------------------------

         if( $performLikeSearch )
         {
            $where = " (";
            $where .= implode( " like ". $dbcon->qstr( '%'.$contains.'%', get_magic_quotes_gpc() )."  OR ", $columns  );
            $where .= " like ". $dbcon->qstr( '%'.$contains.'%', get_magic_quotes_gpc() )." )";

            $binds = array();
         }
         else
         {
            $where = " MATCH (";
            $where .= implode( ",", $columns );
            $where .= ") AGAINST (?  IN BOOLEAN MODE)";

            $binds = array( $contains );
         }

         return array( $where, $binds, $joinComments );
      }
   }

//========================================================================

   /*!
   @function getNextView()
   */

   function &getNextView()
   {
      return $this->nextView;
   }

//========================================================================

   /*!
   @function useNextViewAfterDuplicateSubmission()
   @discussion - determing the next View is dependent on running
      execute, so clearly this cannot return true.

      Of course, SearchForm accepts duplicate submissions so
      there will never be a problem.
   */

   function useNextViewAfterDuplicateSubmission()
   {
      return false;
   }

//========================================================================

   /*!
   @function _getPrototype()
   @discussion - provides an ADatabaseItem prototype
   @result - returns an ADatabaseItem
   */

   function &_getPrototype()
   {
      importClass( 'Bugs.ADevelopmentItem' );

      $proto =& ADevelopmentItem::getPrototype();

      return $proto;
   }

//========================================================================

   /*!
   @function getMethod()
   */

   function getMethod()
   {
      return GET;
   }

//========================================================================

   /*!
   @function allowDuplicateSubmissions()
   */

   function allowDuplicateSubmissions()
   {
      return true;
   }

//========================================================================

   /*!
   @function _getBodyHTML()
   */

   function _getBodyHTML()
   {
      //TODO: Change the way queries are created because passing that
      // much information is unsafe

      importClass( 'HTMLComponents.Text' );
      importClass( 'HTMLComponents.RawHTML' );

      importClass( 'HTMLComponents.Table.TwoColumnTable' );
      $table =& new TwoColumnTable();

      importClass( 'HTMLComponents.LightForms.SelectComponent' );

      $select =& new SelectComponent(
          COLUMN_HASH_NAME . '[report.report_id][' . COLUMN_HASH_KEY_COMP_NAME . ']',
          false );
      $select->addOption( '=', '=', true );
      $select->addOption( '<=', '<=' );
      $select->addOption( '>=', '>=' );

      importClass( 'HTMLComponents.LightForms.TextComponent' );

      $textField =& new TextComponent(
         COLUMN_HASH_NAME . '[report.report_id][' . COLUMN_HASH_KEY_VAL_NAME . ']',
         '' );

      importClass( 'HTMLComponents.CompositeHTMLComponent' );

      $compHTML =& new CompositeHTMLComponent( '' );
      $compHTML->add( $select );
      $compHTML->add( $textField );

      $table->addRow( 'Report ID', $compHTML );

      importClass( 'HTMLComponents.LightForms.CheckBox' );
      $containsTextBox =& new TextComponent( 'contains', '', 35 );
      $includeCommentsCheck =& new CheckBox( 'includeComments' );
      $includeCommentText =& new Text( 'Include Comments in "Contains" Search' );

      $doLikeCheck =& new CheckBox( PERFORM_LIKE_SEARCH_PARAM );
      $doLikeText =& new Text( 'Perform "like" search instead of keyword search' );

      $text =& new Text( '[?]' );
      importClass( 'HTMLComponents.Links.ExternalLink' );
      $link =& new ExternalLink( 'searchHelp.html', $text );
      $link->setOnClick( 'window.open("searchHelp.html",null,"height=300,resizable=yes,scrollbars=yes,width=550,status=yes,toolbar=no,menubar=no,location=no"); return false;' );

      $table->addRow(
         'Contains Text',
         new RawHTML(
            $containsTextBox->getHTML() . $link->getHTML() .
            BR_NL .
            $includeCommentsCheck->getHTML() .
            $includeCommentText->getHTML() .
            BR_NL .
            $doLikeCheck->getHTML() .
            $doLikeText->getHTML()
            ) );

      //$table->addSpacerRow();

      $table->addRow(
         'State',
         html::getDevelItemDropDown(
            'state',
            'state_id',
            true ) );

      //------------------------------------------------------------------

      $table->addSpacerRow();


      $table->addRow(
         'Type',
         html::getDevelItemDropDown(
            'ReportType',
            'reporttype_id',
            true ) );

      //------------------------------------------------------------------

      $table->addSpacerRow();

      // $table->addRow( 'Version', html::getDevelItemDropDown( 'version', UNSPECIFIED, false, UNSPECIFIED, ANY_LABEL ) );

      // $table->addRow( 'Project', html::getDevelItemDropDown( 'project', UNSPECIFIED, false, UNSPECIFIED, ANY_LABEL ) );

      $table->addRow( 'Priority', html::getDevelItemDropDown( 'priority', 'priority_id', true ) );

      //------------------------------------------------------------------

      $table->addSpacerRow();

      importClass( 'Shared.User' );
      $user =& User::getCurrentUser();
      $project =& $user->getCurrentProject();

      importClass( 'CollectionUI.IteratorSelectComponent' );
      $table->addRow(
         'Submitter',
         new IteratorSelectComponent(
            $project->getSubmitters(),
            COLUMN_HASH_NAME . '[submitter_id][' . COLUMN_HASH_KEY_VAL_NAME . ']',
            MULTIPLE_SELECT ) );

      $table->addSpacerRow();

      //importClass( 'CollectionUI.IteratorSelectComponent' );
      $table->addRow(
         'Tester',
         new IteratorSelectComponent(
            $project->getTesters(),
            COLUMN_HASH_NAME . '[tester_id][' . COLUMN_HASH_KEY_VAL_NAME . ']',
            MULTIPLE_SELECT ) );

      $table->addSpacerRow();

      //importClass( 'CollectionUI.IteratorSelectComponent' );
      $table->addRow(
         'Developer',
         new IteratorSelectComponent(
            $project->getDevelopers(),
            COLUMN_HASH_NAME . '[developer_id][' . COLUMN_HASH_KEY_VAL_NAME . ']',
            MULTIPLE_SELECT ) );

      $table->addSpacerRow();

      //importClass( 'CollectionUI.IteratorSelectComponent' );
      $table->addRow(
         'Designer',
         new IteratorSelectComponent(
            $project->getDesigners(),
            COLUMN_HASH_NAME . '[designer_id][' . COLUMN_HASH_KEY_VAL_NAME . ']',
            MULTIPLE_SELECT ) );

      //------------------------------------------------------------------
      $table->addSpacerRow();
      // $submittedDateField =& ;

      $select =& new SelectComponent(
          SUBMITTED_DATE_AGE_OP,
          false );
         $select->addOption( LESS_THAN, LESS_THAN, true );
         $select->addOption( GREATER_THAN, GREATER_THAN );
         $select->addOption( LESS_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL  );
         $select->addOption( GREATER_THAN_OR_EQUAL, GREATER_THAN_OR_EQUAL  );

      $compHTML =& new CompositeHTMLComponent( '' );
      $compHTML->add( $select );
      $compHTML->add( $this->_createReportAgeField() );

      $table->addRow(
         'Report Age',
         $compHTML );
//      if ( RUN_EXPERIMENTAL )
//      {
//         $table->addSpacerRow();
//
//         $compHTML =& new CompositeHTMLComponent( BR );
//
//         importClass( 'HTMLComponents.LightForms.RadioGroup' );
//         $radioGrp =& new RadioGroup( 'useDate' , 0);
//         $radioGrp->addRadio( 0 );
//         $radioGrp->addRadio( 1 );
//
//         $radio1 = $radioGrp->getRadioAt(0);
//         $radio2 = $radioGrp->getRadioAt(1);
//
//         $compHTML->add(new RawHTML( $radio1->getHTML().'Allow Any Submission Date' )  );
//         $compHTML->add( new RawHTML( $radio2->getHTML().'Or Only Submissions Between:' ) );
//         $compHTML->add( html::getDateDropDown( 'start' ) );
//         $compHTML->add( new RawHTML( '&nbsp;&nbsp;&nbsp;&nbsp;and' ) );
//         $compHTML->add( html::getDateDropDown( 'start', 2 ) );
//
//         $table->addRow( 'Date Created', $compHTML );
//      }

      //------------------------------------------------------------------
      $table->addSpacerRow();
      importClass( 'HTMLComponents.LightForms.RadioGroup' );
      $radioGrp =& new RadioGroup( 'useView' , SUMMARY_VIEW_REQUEST_NAME);
      $radioGrp->addRadio(SUMMARY_VIEW_REQUEST_NAME);
      $radioGrp->addRadio(DETAILED_VIEW_REQUEST_NAME);

      $radio1 = $radioGrp->getRadioAt(0);
      $radio2 = $radioGrp->getRadioAt(1);
      $compHTML =& new CompositeHTMLComponent( BR );
      $compHTML->add(new RawHTML( $radio1->getHTML().'Summary' )  );
      $compHTML->add( new RawHTML( $radio2->getHTML().'Detailed' ) );

      $table->addRow( 'Listing Style', $compHTML );

      //------------------------------------------------------------------
      $table->addSpacerRow();

      $compHTML =& new CompositeHTMLComponent( '' );

      $colSelect =& new SelectComponent( 'orderBy', false );
      $colSelect->addOption( 'report.priority_id', 'Priority' );
      $colSelect->addOption( 'report.report_id', 'Report ID', true );
      $colSelect->addOption( 'report.state_id', 'State' );
      $colSelect->addOption( 'report.frequency_id', 'Frequency' );
      $colSelect->addOption( 'report.duedate', 'Date Due' );

      $compHTML->add( $colSelect );

      $dirSelect =& new SelectComponent( 'orderByDirection', false );
      $dirSelect->addOption( 'ASC', 'Ascending' );
      $dirSelect->addOption( 'DESC', 'Descending', true );

      $compHTML->add( $dirSelect );

      $table->addRow( 'Order By', $compHTML );

      importClass( 'HTMLComponents.LightForms.HiddenFormField' );
      $processorViewHidden =& new HiddenFormField( 'view', 'SearchForm' );

      $table->addRow( '', $processorViewHidden );

      return $table->getHTML();
   }

//========================================================================

   /*!
   @function getTitle()
   */

   function getTitle()
   {
      return 'Search';
   }

//========================================================================

   /*!
   @function _loadData()
   */

   function _loadData()
   {
   }

//========================================================================

};

?>