<?php

/*
ADevelopmentItem
$Author: dougqh $
$Revision: 1.14 $
$Date: 2004/06/17 19:17:47 $
$Log: ADevelopmentItem.php,v $
Revision 1.14  2004/06/17 19:17:47  dougqh
- Fix for 4571

Revision 1.13  2004/05/19 14:19:25  dougqh
- Added method getDueDateEpoch which returns the date due in UNIX epoch time

Revision 1.12  2004/03/17 22:06:43  dawn
- modified getAssociatedUsers for decet 4177

Revision 1.11  2003/12/18 20:40:41  dougqh
Updated to work under PHP 4.2

Revision 1.10  2003/12/09 19:31:26  dougqh
- 3894

Revision 1.9  2003/11/05 14:15:37  dougqh
- Feature 3754

Revision 1.8  2003/11/04 15:49:49  dougqh
- Fixing 3750

Revision 1.7  2003/11/03 19:41:44  dougqh
- Fixed 3747

Revision 1.6  2003/11/03 19:09:04  dougqh
- Feature 3744

Revision 1.5  2003/08/13 22:10:31  dougqh
- Changed isDesigned to check against develplan

Revision 1.4  2003/08/05 14:03:07  dougqh
- Changed this- to user in isTester check of fixed method.

Revision 1.3  2003/08/05 13:39:16  millz
- bug fix to _setProject

Revision 1.2  2003/08/05 03:01:15  millz
- worked on new task logic and added getReportTypeName

Revision 1.1  2003/07/09 20:34:36  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'Database.ADatabaseItem' );

//========================================================================

//imported for its constants
importClass( 'Bugs.State' );

//========================================================================

//TODO: Get rid of the one set of constants.  Probably, best to
//get rid of DEFECT_ID, TASK_ID, FEATURE_REQUEST_ID, since they
//are less widely used.
define( 'DEFECT_ID' ,1 );
define( 'TASK_ID', 3 );
define( 'FEATURE_REQUEST_ID', 2 );

define( 'DEFECT', 1 );
define( 'FEATURE_REQUEST', 2 );
define( 'TASK', 3 );

//========================================================================

importConstants( 'Time' );
define( 'DEFAULT_DEV_ITEM_TIME_UNIT', MIN_UNIT );
//Do NOT EVER change
define( 'STORE_DEV_ITEM_TIME_UNIT', HR_UNIT );

//========================================================================

/*!
@class ADevelopmentItem
@discussion - ADevelopmentItem is not really abstract because
   it can be directly instantiated to create a prototypical
   ADevelopmentItem.  Other than the prototype only
   instances of Bug, Task, and FeatureRequest should exist.

   Note ADevelopmentItem does contain a small number of abstract
   methods, but none of those methods should be called on the
   prototypical instance.

   Admittedly, this is NOT the cleanest design.
*/

class ADevelopmentItem extends ADatabaseItem
{

//========================================================================

   /*!
   @function ADevelopmentItem( [ $primary_id ] )
   @discussion - constructs a new ADevelopmentItem object
   @result - constructs a new ADevelopmentItem object
   */

   function ADevelopmentItem( $primary_id = UNSPECIFIED )
   {
      //State imported at top of file
      $this->state_id = SUBMITTED_NEW_STATE_ID;
      $this->ADatabaseItem( $primary_id );
   }

//========================================================================

   /*!
   @function createNew( array( $devItemType ) )
   */

   function &createNew( $args )
   {
      list( $devItemType ) = $args;

      //ADevelopmentItem was imported at the top of the file, so
      //the constants are definitely loaded.
      switch ( $devItemType )
      {
         case TASK:
         importClass( 'Bugs.Task' );
         return new Task();

         case FEATURE_REQUEST:
         importClass( 'Bugs.FeatureRequest' );
         return new FeatureRequest();

         case DEFECT:
         importClass( 'Bugs.Defect' );
         return new Defect();

         default:
         unreachablePoint(
            getLocation() . NL .
            'Invalid DevItemType: ' . $devItemType );
         break;
      };
   }

//========================================================================

   /*!
   @function getPrototype()
   @discussion - provides a prototype ADevelopmentItem
   @result - returns an ADevelopmentItem
   */

   function &getPrototype()
   {
      static $prototype;

      if ( ! isset( $prototype ) )
      {
         //no =& to avoid garbage collection
         $prototype = new ADevelopmentItem();
      }

      return $prototype;
   }

//========================================================================

   /*!
   @function getFromPrimaryID( $primary_id )
   */

   /* static */
   function &getFromPrimaryID( $primary_id )
   {
      return ADevelopmentItem::_getFromPrimaryID(
         ADevelopmentItem::getPrototype(),
         $primary_id );
   }

//========================================================================

   /*!
   @function getTable()
   @discussion - provides the table name (with schema if necessary)
   @result - returns a String
   */

   function getTable()
   {
      return 'report';
   }

//========================================================================

   /*!
   @function getAllColumns()
   @discussion - returns the columns for this item's row
   */

   function getAllColumns()
   {
      return array(
         $this->getPrimaryColumn(),
         'reporttype_id',
         'initClientVersion_id',
         'clientPlatform_id',
         'project_id',
         'state_id',
         'severity_id',
         'date_in',
         'report',
         'submitter_id',
         'designer_id',
         'developer_id',
         'tester_id',
         'assignedDate',
         'develplan',
         'testHours',
         'esttesthours',
         'codeHours',
         'estCodeHours',
         'miscHours',
         'estMiscHours',
         'designHours',
         'fixedDate',
         'fixednotes',
         'priority_id',
         'frequency_id',
         'dueDate',
         'serverFixedVersion_id',
         'clientFixedVersion_id',
         'clientType_id',
         'subproject_id',
         'category_id',
         'serverPlatform_id',
         'subject',
         'serverInstance_id',
         'repsteps',
         'initServerVersion_id',
         'date_state' );
   }

//========================================================================

   /*!
   @function getID()
   @discussion - provides a user presentable ID
      - similar to getPrimaryID but prefixes the project name
   @result - returns a String
   */

   function getID()
   {
      $project =& $this->getProject();
      return $project->getName() . ' - ' . $this->getPrimaryID();
   }

//========================================================================

   /*!
   @function _setBasics( $subject, $report, $subproject, $category, $submitter )
   @param $subject - a non-empty String
   @param $report - a non-empty String
   @param $subproject - a Subproject - to which this ADevelopmentItem
      applies
   @param $category - a Category - to which this ADevelopmentItem
      applies
   @param $submitter - a User - which entered this ADevelopmentItem
   @discussion - sets the basic information for this ADevelopmentItem
   */

   function _setBasics(
      $subject,
      $report,
      &$subproject,
      &$category,
      &$submitter )
   {
      $this->subject = $subject;
      $this->report = $report;
      $this->subproject_id = $subproject->getPrimaryID();
      $this->category_id = $category->getPrimaryID();
      $this->submitter_id = $submitter->getPrimaryID();
   }

//========================================================================

   /*!
   @function _getRegularIdentifyingString()
   */

   function _getRegularIdentifyingString()
   {
      return $this->getSubject();
   }

//========================================================================

   /*!
   @function getReport()
   @discussion - provides the report
   @result - returns a non-empty String
   */

   function getReport()
   {
      return $this->report;
   }

//========================================================================
   /*!
   @function getRepSteps()
   @discussion - provides the steps to reproduce
   @result - returns a non-empty String
   */

   function getRepSteps()
   {
      if ( isset( $this->repsteps ) )
      {
         return $this->repsteps;
      }
      else
      {
         return '';
      }
   }

//========================================================================

   /*!
   @function getSeverity()
   @discussion - a normal get function
   @result - returns Severity object for this object
   */

   function &getSeverity()
   {
      importClass( 'Bugs.Severity' );
      if ( empty( $this->severity_id ) )
      {
         return Severity::getFromPrimaryID( NULL );
      }
      else
      {
         return Severity::getFromPrimaryID( $this->severity_id );
      }
   }

//========================================================================

   /*!
   @function _setSeverity( $severity )
   @param $severity - the Severity obj
   @discussion - a normal set function
   @result - returns nothing
   */

   function _setSeverity( &$severity )
   {
      $this->severity_id = $severity->getPrimaryID();
      //$this->_setChanged( true );
   }

//========================================================================

   /*!
   @function getFrequency()
   @discussion - a normal get function
   @result - returns Frequency object for this object
   */

   function &getFrequency()
   {
      importClass( 'Bugs.Frequency' );
      if ( empty( $this->frequency_id ) )
      {
         return Frequency::getFromPrimaryID( NULL );
      }
      else
      {
         return Frequency::getFromPrimaryID( $this->frequency_id );
      }
   }

//========================================================================

   /*!
   @function _setFrequency( &$frequency )
   @param $Frequency - the Frequency obj
   @discussion - a normal set function
   @result - returns nothing
   */

   function _setFrequency( &$frequency )
   {
      $this->frequency_id = $frequency->getPrimaryID();
   }

//========================================================================

   /*!
   @function getDevelopmentPlan()
   @discussion - a normal get function
   @result - returns project item for this object
   */

   function getDevelopmentPlan()
   {
      if ( isset( $this->develplan ) )
      {
         return $this->develplan;
      }
      else
      {
         return '';
      }
   }

//========================================================================

   /*!
   @function _setDesign( $develplan, $designDuration, $estCodeDuration, $estMiscDuration, $designer )
   @param $develplan - a non-empty String
   @param $designDuration - a TimeDuration
   @param $estCodeDuration - a TimeDuration
   @param $estMiscDuration - a TimeDuration
   @param $designer - a User
   @discussion - sets both the development plan and the designer
      of this ADevelopmentItem
   */
   function _setDesign( $develplan, &$designDuration, &$estCodeDuration, &$estMiscDuration, &$designer )
   {
      $this->develplan = $develplan;
      $this->designHours = $designDuration->getHours();
      $this->estCodeHours = $estCodeDuration->getHours();
      $this->estMiscHours = $estMiscDuration->getHours();
      $this->designer_id = $designer->getPrimaryID();
   }

//========================================================================

   /*!
   @function getProject()
   @discussion - provides the Project to which this ADevelopmentItem belongs
   @result - returns a Project
   */

   function &getProject()
   {
      importClass( 'Shared.Project' );
      return Project::getFromPrimaryID( $this->project_id );
   }

//========================================================================

   /*!
   @function _setProject( $project )
   @param $project - a Project
   @discussion - This method is called by Project::addDevelopmentItem.
   */

   function _setProject( &$project )
   {
      //This must be done first subsequent calls may need project_id
      //to be set
      $this->project_id = $project->getPrimaryID();

      if ( ! isset( $this->tester_id ) )
      {
         //more than likely its not set
         $submitter =& $this->getSubmitter();
         if ( $this->canBeTester( $submitter ) )
         {
            //If the submitter is QA, then use the submitter
            $this->_setTester( $submitter );
         }
         else
         {
            //If the submitter is not QA, then use the default tester
            //for the Project
            $this->_setTester( $this->_getDefaultTester() );
         }
         // print_r( $this );
      }
   }

//========================================================================

   /*!
   @function getState()
   @discussion - a normal get function
   @result - returns state item for this object
   */

   function &getState()
   {
      importClass( 'Bugs.State' );
      return State::getFromPrimaryID( $this->state_id );
   }

//========================================================================

   /*!
   @function _setState( $state )
   @param $state - the value to set the state member to
   @discussion - a normal set function
   @result - returns nothing
   */

   function _setState( &$state )
   {
      $this->state_id = $state->getPrimaryID();
   }

//========================================================================

   /*!
   @function getDateCreated()
   @discussion - a normal get function
   @result - returns dateCreated item for this object
   */

   function getDateCreated()
   {
      return $this->date_in;
   }

//========================================================================

   /*!
   @function getPriority()
   @discussion - a normal get function
   @result - returns priority item for this object
   */

   function &getPriority()
   {
      importClass( 'Bugs.Priority' );
      return Priority::getFromPrimaryID( $this->priority_id );
   }

//========================================================================

   /*!
   @function _setPriority( $priority, [ $allowStateChange ] )
   @param $priority - the value to set the priority member to
   @param $allowStateChange - a boolean - indicates if this
      method is allowed to change the state

      The allowStateChange parameter is for internal use of
      this class only.
   @discussion - sets the Priority of this ADevelopmentItem.
      The State of this ADevelopmentItem may also change.
   */

   function _setPriority( &$priority, $allowStateChange = true )
   {
      $this->priority_id = $priority->getPrimaryID();

      //only change the state to reviewed if its currently in
      // "Submitted-New" or "Submitted-ReOpened"?

      //Do NOT use === here because state_id will be String if
      //it came from the database.
      if (
         ( $this->state_id == SUBMITTED_NEW_STATE_ID ||
           $this->state_id == SUBMITTED_REOPENED_STATE_ID ) &&
         $allowStateChange )
      {
         $this->state_id = SUBMITTED_REVIEWED_STATE_ID;
      }

      //print 'New State: ' . $this->state_id . BR_NL;
   }

//========================================================================

   /*!
   @function getAssociatedUsers()
   @discussion - provides an IIterator of all associated Users
   @result - returns an IIterator< User >
   */

   function &getAssociatedUsers()
   {
      $recipients = array();
      $associatedUsersIteratorArray = array();

      $recipients[] =& $this->getTester();
      $recipients[] =& $this->getDeveloper();

      $associatedUsersIteratorArray[] =& IteratorFactory::getHashIterator(
            $recipients );

      importClass( 'Collections.IteratorFactory' );
      $project =& $this->getProject();
      $associatedUsersIteratorArray[] =& $project->getDesigners();
      $associatedUsersIteratorArray[] =& $project->getQALeads();

      return IteratorFactory::getMergeIterator( $associatedUsersIteratorArray );
   }

//========================================================================

   /*!
   @function getSubmitter()
   @discussion - a normal get function
   @result - returns submitter item for this object
   */

   function &getSubmitter()
   {
      importClass( 'Shared.User' );
      return User::getFromPrimaryID( $this->submitter_id );
   }

//========================================================================

   /*!
   @function getDesigner()
   @discussion - provides the designer of this Project or NULL
      if the designer is not set
   @result - returns a User
   */

   function &getDesigner()
   {
      importClass( 'Shared.User' );

      //empty is slightly different than ! isset
      //it will return true for NULL
      if ( empty( $this->designer_id ) )
      {
         return User::getFromPrimaryID( NULL );
      }
      else
      {
         return User::getFromPrimaryID( $this->designer_id );
      }
   }

//========================================================================

   /*!
   @function _setTester( $tester )
   @param $tester - a User
   @discussion - sets the User that will verify this ADevelopmentItem
   */

   function _setTester( &$tester )
   {
      $this->tester_id = $tester->getPrimaryID();
   }

//========================================================================

   /*!
   @function getTester()
   @discussion - a normal get function
   @result - returns designer item for this object
   */

   function &getTester()
   {
      importClass( 'Shared.User' );
      return User::getFromPrimaryID( $this->tester_id );
   }

//========================================================================

   /*!
   @function getDeveloper()
   @discussion - a normal get function
   @result - returns developer item for this object
   */

   function &getDeveloper()
   {
      importClass( 'Shared.User' );

      //empty is slightly different than ! isset
      //it will return true for NULL
      if ( empty( $this->developer_id ) )
      {
         return User::getFromPrimaryID( NULL );
      }
      else
      {
         return User::getFromPrimaryID( $this->developer_id );
      }
   }

//========================================================================

   /*!
   @function isDeveloper( $user )
   @discussion - indicates if the provided User is the developer for
      this ADevelopmentItem

      Primarily for convenience.
   @result - returns a boolean
   */

   function isDeveloper( &$user )
   {
      return (
         FORCE_DEVELOPER ||
         ( isset( $this->developer_id ) &&
           ( $user->getPrimaryID() == $this->developer_id ) ) );
   }

//========================================================================

   /*!
   @function isTester( $user )
   @discussion - indicates if the provided User is the tester for
      this ADevelopmentItem
      Primarily for convenience.
   @result - returns a boolean
   */

   function isTester( &$user )
   {
      return ( $this->tester_id == $user->getPrimaryID() );
   }

//========================================================================

   /*!
   @function canVerify( &$user )
   @param $user - the user to test with
   @discussion -
   @result - returns bool - whether $user can verify this issue
   */

   function canVerify( &$user )
   {
      if ( ENABLE_STRICT_VERIFICATION )
      {
         return $this->isTester( $user );
      }
      else
      {
         $project =& $this->getProject();
         return $project->isQA( $user );
      }
   }

//========================================================================

   /*!
   @function canBeTester( &$user )
   @discussion - indicates if the current user can be the tester
      for this development item -- not that they are the tester
   @result - returns a boolean
   */

   function canBeTester( &$user )
   {
      $project =& $this->getProject();
      return $project->isQA( $user );
   }

//========================================================================

   /*!
   @function _setDeveloper( $developer )
   @param $developer - the value to set the developer member
      - developer may be NULL if this ADevelopmentItem is being
        unassigned
   @discussion - a normal set function
   @result - returns nothing
   */

   function _setDeveloper( &$developer )
   {
      if ( $developer === NULL || $developer->isNull() )
      {
         unset( $this->developer_id );
         $this->assignedDate = DB_NULL;

         if (
          ( $this->state_id == SUBMITTED_ASSIGNED_STATE_ID ) ||
          ( $this->state_id == SUBMITTED_MORE_INFORMATION_GIVEN_STATE_ID ) ||
          ( $this->state_id == UNDER_DEVELOPMENT_ASSIGNED_STATE_ID ) ||
          ( $this->state_id == UNDER_DEVELOPMENT_MORE_INFO_GIVEN_STATE_ID ) ||
          ( $this->state_id == UNDER_DEVELOPMENT_FIX_FAILED_STATE_ID ) )
         {
            //I will put it back into Submitted-Reviewed b/c
            //some has looked at it - if it was previously assigned

            $this->state_id = SUBMITTED_REVIEWED_STATE_ID;
         }

         //leave the state_id alone, it should get handled _setPriority
      }
      else
      {
         $user_id = $developer->getPrimaryID();

         //Don't want to change the assignedDate if its the same person
         if ( ! isset( $this->developer_id ) || ( $user_id != $this->developer_id ) )
         {
            $this->developer_id = $developer->getPrimaryID();
            $this->assignedDate = time();

            //Changed the developer, so go to Submitted-Assigned
            $this->state_id = SUBMITTED_ASSIGNED_STATE_ID;
         }
         elseif (
            ( $this->state_id == SUBMITTED_NEW_STATE_ID ) ||
            ( $this->state_id == SUBMITTED_MORE_INFORMATION_GIVEN_STATE_ID ) ||
            ( $this->state_id == SUBMITTED_REOPENED_STATE_ID ) ||
            ( $this->state_id == SUBMITTED_REVIEWED_STATE_ID ) )
         {
            //Changed to Submitted-Assigned if the state is correct, even if
            //the developer is the same
            $this->state_id = SUBMITTED_ASSIGNED_STATE_ID;
         }
      }
   }

//========================================================================

   /*!
   @function _setInitialServerInfo( $platform, $instance, $version )
   @param $platform - a Platform - platform of the server
   @param $instance - a ServerInstance - instance of the server
   @param $version - a Version - detected version of the server
   @discussion - sets the initial information about the server
   */

   function _setInitialServerInfo(
      &$platform,
      &$instance,
      &$version )
   {
      $this->serverPlatform_id = $platform->getPrimaryID();
      $this->serverInstance_id = $instance->getPrimaryID();

      if ( $version->isNew() )
      {
         $this->initServerVersion =& $version;
      }
      else
      {
         $this->initServerVersion_id = $version->getPrimaryID();
      }
   }

//========================================================================

   /*!
   @function getServerPlatform()
   @discussion - provides the server platform of this ADevelopmentItem
   @result - returns a Platform
   */

   function &getServerPlatform()
   {
      importClass( 'Bugs.Platform' );
      return Platform::getFromPrimaryID( $this->serverPlatform_id );
   }

//========================================================================

   /*!
   @function getServerInstance()
   @discussion - provides the ServerInstance of this ADevelopmentItem
   @result - returns a ServerInstance
   */

   function &getServerInstance()
   {
      importClass( 'Bugs.ServerInstance' );
      return ServerInstance::getFromPrimaryID( $this->serverInstance_id );
   }

//========================================================================

   /*!
   @function getDetectedServerVersion()
   @discussion - provides the server Version in which this ADevelopmentItem
      was initially detected
   @result - returns a Version
   */

   function &getDetectedServerVersion()
   {
      importClass( 'Bugs.Version' );
      return Version::getFromPrimaryID( $this->initServerVersion_id );
   }

//========================================================================

   /*!
   @function getFixedServerVersion()
   @discussion - provides the server Version in which this ADevelopmentItem
      was actually fixed
   @result - returns a Version
   */

   function &getFixedServerVersion()
   {
      importClass( 'Bugs.Version' );
      if ( empty( $this->serverFixedVersion_id ) )
      {
         return Version::getFromPrimaryID( NULL );
      }
      else
      {
         return Version::getFromPrimaryID( $this->serverFixedVersion_id );
      }
   }

//========================================================================

   /*!
   @function _setInitialClientInfo( $platform, $type, $version )
   @param $platform - a Platform -
   @param $type - a ClientType -
   @param $version - a Version - the version of the client in
      which this ADevelopmentItem was detected
   @discussion - sets the initial information about the client
   */

   function _setInitialClientInfo( &$platform, &$type, &$version )
   {
      $this->clientPlatform_id = $platform->getPrimaryID();
      $this->clientType_id = $type->getPrimaryID();

      if ( $version->isNew() )
      {
         $this->initClientVersion =& $version;
      }
      else
      {
         $this->initClientVersion_id = $version->getPrimaryID();
      }
   }

//========================================================================

   /*!
   @function getClientPlatform()
   @discussion - provides the client platform of this ADevelopmentItem
   @result - returns a Platform
   */

   function &getClientPlatform()
   {
      importClass( 'Bugs.Platform' );
      return Platform::getFromPrimaryID( $this->clientPlatform_id );
   }


//========================================================================

   /*!
   @function getSubProject()
   @discussion - provides the Subproject  of this ADevelopmentItem
   @result - returns a Subproject
   */

   function &getSubProject()
   {
      importClass( 'Bugs.Subproject' );
      return Subproject::getFromPrimaryID( $this->subproject_id );
   }

//========================================================================

   /*!
   @function _setSubproject( &$subproject )
   @param $SubProject - the value to set the SubProject ID member to
   @discussion - a normal set function
   @result - returns nothing
   */

   function _setSubproject( &$subproject )
   {
      $this->subproject_id = $subproject->getPrimaryID();
   }

//========================================================================

   /*!
   @function getCategory()
   @discussion - provides the Category  of this ADevelopmentItem
   @result - returns a Category
   */

   function &getCategory()
   {
      importClass( 'Bugs.Category' );
      return Category::getFromPrimaryID( $this->category_id );
   }

//========================================================================

   /*!
   @function _setCategory( &$category )
   @param $Category - the value to set the Category ID member to
   @discussion - a normal set function
   @result - returns nothing
   */

   function _setCategory( &$category )
   {
      $this->category_id = $category->getPrimaryID();
   }

//========================================================================

   /*!
   @function getClientType()
   @discussion - provides the ClientType of this ADevelopmentItem
   @result - returns a ClientType
   */

   function &getClientType()
   {
      importClass( 'Bugs.ClientType' );
      return ClientType::getFromPrimaryID( $this->clientType_id );
   }

//========================================================================

   /*!
   @function getDetectedClientVersion()
   @discussion - provides the client Version in which this ADevelopmentItem
      was initially detected
   @result - returns a Version
   */

   function &getDetectedClientVersion()
   {
      importClass( 'Bugs.Version' );
      return Version::getFromPrimaryID( $this->initClientVersion_id );
   }

//========================================================================

   /*!
   @function getFixedClientVersion()
   @discussion - provides the client Version in which this ADevelopmentItem
      was actually fixed
   @result - returns a Version
   */

   function &getFixedClientVersion()
   {
      importClass( 'Bugs.Version' );
      if ( ! isset( $this->clientFixedVersion_id ) )
      {
         return Version::getFromPrimaryID( NULL );
      }
      else
      {
         return Version::getFromPrimaryID( $this->clientFixedVersion_id );
      }
   }

//========================================================================

   /*!
   @function getDateAssigned()
   @discussion - a normal get function
   @result - returns dateAssigned item for this object
   */

   function getDateAssigned()
   {
      if ( isset( $this->assignedDate ) )
      {
         return $this->assignedDate;
      }
      else
      {
         return NULL;
      }
   }

//========================================================================

   /*!
   @function getDateClosed()
   @discussion - a normal get function
   @result - returns dateAssigned item for this object
   */

   function getDateClosed()
   {
      if ( isset( $this->fixedDate ) )
      {
         return $this->fixedDate;
      }
      else
      {
         return NULL;
      }
   }

//========================================================================

   /*!
   @function getTotalCodeHours()
   @discussion - provides the total number of code hours logged for
      this ADevelopmentItem
   @result - returns an unsigned integer
   */

   function getTotalCodeHours()
   {
      return $this->codeHours;
   }

//========================================================================

   /*!
   @function isDesigned()
   @discussion - indicates if _setDesign has been called on this
      ADevelopmentItem
   @result - returns a boolean
   */

   function isDesigned()
   {
      return isset( $this->develplan );
   }

//========================================================================

   /*!
   @function getEstimatedHours()
   @discussion - provides the estimated coding hours for this
      ADevelopmentItem

      Should only be called if hasEstimatedCodeHours returned true.
   @result - returns an unsigned integer
   */

   function getEstimatedCodeHours()
   {
      if ( isset( $this->estCodeHours ) )
      {
         return $this->estCodeHours;
      }
      else
      {
         return NULL;
      }
   }

//========================================================================

   /*!
   @function getEstimatedCodeDuration()
   @discussion - provides a TimeDuration representing the estimated
      hours to implement / fix this item
   @result - returns a TimeDuration or NULL
   */

   function &getEstimatedCodeDuration()
   {
      if ( isset( $this->estCodeHours ) )
      {
         return ADevelopmentItem::_createDuration( $this->estCodeHours );
      }
      else
      {
         return NULL;
      }
   }

//========================================================================

   /*!
   @function getTotalMiscHours()
   @discussion - provides the total number of misc. hours logged for
      this ADevelopmentItem
   @result - returns an unsigned integer
   */

   function getTotalMiscHours()
   {
      return $this->miscHours;
   }

//========================================================================

   /*!
   @function getTotalMiscDuration()
   @discussion - provides a TimeDuration representing the total amount
      of misc time put towards this item
   @result - returns a TimeDuration
   */

   function &getTotalMiscDuration()
   {
      return ADevelopmentItem::_createDuration( $this->miscHours );
   }

//========================================================================

   /*!
   @function getEstimatedMiscHours()
   @discussion - a normal get function
   @result - returns estimatedMiscHours item for this object
   */

   function getEstimatedMiscHours()
   {
      if ( isset( $this->estMiscHours ) )
      {
         return $this->estMiscHours;
      }
      else
      {
         return NULL;
      }
   }

//========================================================================

   /*!
   @function getEstimatedMiscDuration()
   @discussion - provides a TimeDuration representing the estimated
      misc time required for this item
   @result - returns a TimeDuration or NULL
   */

   function getEstimatedMiscDuration()
   {
      if ( isset( $this->estMiscHours ) )
      {
         return ADevelopmentItem::_createDuration( $this->estMiscHours );
      }
      else
      {
         return NULL;
      }
   }

//========================================================================

   /*!
   @function getDesignHours()
   @discussion - a normal get function
   @result - returns designHours item for this object
   */

   function getDesignHours()
   {
      if ( isset( $this->designHours ) ) return $this->designHours;

      return NULL;

   }

//========================================================================

   /*!
   @function getDesignDuration()
   @discussion - provides a TimeDuration containing the time needed
      to design this item
   @result - returns a TimeDuration
   */

   function &getDesignDuration()
   {
      return ADevelopmentItem::_createDuration( $this->designHours );
   }

//========================================================================

   /*!
   @function getTotalTestHours()
   @discussion - a normal get function
   @result - returns designHours item for this object
   */

   function getTotalTestHours()
   {
      return $this->testHours;
   }

//========================================================================

   /*!
   @function getTotalTestDuration()
   @discussion - provides a TimeDuration representing the total number
      of hours spent testing this item
   @result - returns a TimeDuration
   */

   function &getTotalTestDuration()
   {
      return ADevelopmentItem::_createDuration( $this->testHours );
   }

//========================================================================

   /*!
   @function getDueDate()
   @discussion - a normal get function
   @result - returns dueDate item for this object
   */

   function getDueDate()
   {
      if ( isset( $this->dueDate ) )
      {
         return $this->dueDate;
      }
      else
      {
         return NULL;
      }
   }

//========================================================================

   /*!
   @function getDueDateEpoch()
   */
   function getDueDateEpoch()
   {
      if ( ! isset( $this->dueDate ) ) return NULL;

      if ( is_string( $this->dueDate ) )
      {
         return strtotime( $this->dueDate );
      }
      else
      {
         return $this->dueDate;
      }
   }

//========================================================================

   /*!
   @function _setDueDate( $dueDate )
   @param $dueDate - the value to set the dueDate member to
   @discussion - a normal set function
   @result - returns nothing
   */

   function _setDueDate( $dueDate )
   {
      //TODO: Do something with this?
      $this->dueDate = $dueDate;
   }

//========================================================================

   /*!
   @function getReportTypeName()
   @discussion - a normal get function
   @result - returns the type of item this is
   */

   function getReportTypeName()
   {
      if( isInstanceOf( $this, 'Defect' ) )   return 'Defect';
      if( isInstanceOf( $this, 'FeatureRequest' ) )   return 'Feature';
      return 'Task';
   }

//========================================================================

   /*!
   @function getSubject()
   @discussion - a normal get function
   @result - returns subject item for this object
   */

   function getSubject()
   {
      return $this->subject;
   }

//========================================================================

   /*!
   @function getDateStateLastChanged()
   @discussion - a normal get function
   @result - returns dateStateLastChanged item for this object
   */

   function getDateStateLastChanged()
   {
      if ( isset( $this->date_state ) )
      {
         return $this->date_state;
      }
      else
      {
         return NULL;
      }
   }

//========================================================================

   /*!
   @function getRelatedCacheHandler()
   @discussion - cache manager for the relatedBugs mapping table
   @result - returns a ADBCacheHandler
   */

   /* static */
   function &getRelatedCacheHandler()
   {
      importClass( 'Database.StandardCacheHandler' );
      return StandardCacheHandler::create( 'relatedbugs' );
   }

//========================================================================

   /*!
   @function addRelatedDevelopmentItem( &$devItem )
   @param $devItem - an ADevelopmentItem
   @discussion - records the relationship between this ADevelopmentItem
      and the provided ADevelopmentItem
   */

   function addRelatedDevelopmentItem( &$devItem )
   {
      $this->_addRelatedDevelopmentItem( $devItem );

      $cacheHandler =& ADevelopmentItem::getRelatedCacheHandler();
      $cacheHandler->markAllDirty();
   }

//========================================================================

   /*!
   @function addRelatedDevelopmentItems( &$iterator )
   @param $iterator - an IIterator< ADevelopmentItem >
   @discussion - adds the items in the IIterator as related to the
      current ADevelopmentItem
   */

   function addRelatedDevelopmentItems( &$iterator )
   {
      for ( $iterator->reset(); ! $iterator->isEnd(); $iterator->moveNext() )
      {
         $this->addRelatedDevelopmentItem( $iterator->getCurrent() );
      }

      $cacheHandler =& ADevelopmentItem::getRelatedCacheHandler();
      $cacheHandler->markAllDirty();
   }

//========================================================================

   /*!
   @function _addRelatedDevelopmentItem( &$devItem )
   @param $devItem - an ADevelopmentItem
   @discussion - records the relationship between this ADevelopmentItem
      and the provided ADevelopmentItem

      NOTE: This method does NOT mark the relatedbugs cache dirty.
      Outside callers should use addRelatedDevelopmentItem or
      addRelatedDevelopmentItems as appropriate.

   */

   function _addRelatedDevelopmentItem( &$devItem )
   {
      importClass( 'Database.DBConnectionProvider' );
      $conn =& DBConnectionProvider::getConnection();

      //getRelated uses DISTINCT, so duplicates are not a problem
      $stmt = $conn->Prepare( 'INSERT INTO relatedbugs VALUES (?,?)' );

      $conn->Execute(
         $stmt,
         array( $this->getPrimaryID(), $devItem->getPrimaryID() ) );

      $conn->Execute(
         $stmt,
         array( $devItem->getPrimaryID(), $this->getPrimaryID() ) );
   }

//========================================================================

   /*!
   @function getRelated()
   @discussion - this will return an iterator of related develItems for this item
   @result - an enum of develItems for you to play with
   */

   function &getRelated()
   {
      importClass( 'Database.DBConnectionProvider' );
      $dbcon =& DBConnectionProvider::getConnection();
      $dbcon->SetFetchMode( ADODB_FETCH_NUM );

      // WE WILL ASSUME that all mappings have been added in both directions
      // so we only need to check one direction, this assumption makes this
      // SQL statement faster but forces us to do an extra insert tatement
      // in ADevelopmentItem::addRelated.

      // determine related IDs
      // since we can't depend on sub-selects we have to do this goofy pre-select

      $proto =& ADevelopmentItem::getPrototype();

      $cacheHandler =& ADevelopmentItem::getRelatedCacheHandler();

      $allRelatedIDs = $dbcon->CacheGetCol(
         $cacheHandler->getMultipleCacheTime(),
         'SELECT DISTINCT(related_id) FROM relatedbugs WHERE report_id=?',
         array( $this->getPrimaryID() ) );

      return $proto->doIDSearch( $allRelatedIDs );
   }

//========================================================================

   /*!
   @function _getFromRecordSet( $hash )
   @param $hash - a hash of data from a DB row
   @discussion - provides an instance for that DB row
   */

   function &_getFromRecordSet( &$hash )
   {
      $primary_id = $hash{ $this->getPrimaryColumn() };

      switch ( $hash{ 'reporttype_id' } )
      {
         case DEFECT_ID:
         importClass( 'Bugs.Defect' );
         return new Defect( $primary_id );

         case FEATURE_REQUEST_ID:
         importClass( 'Bugs.FeatureRequest' );
         return new FeatureRequest( $primary_id );

         case TASK_ID:
         importClass( 'Bugs.Task' );
         return new Task( $primary_id );

         default:
         unreachablePoint( 'Invalid defect type in ' . getLocation() );
         break;
      }
   }

//========================================================================

   /*!
   @function addAttachment( $attachment )
   @param $attachment - an Attachment about this ADevelopmentItem
   @discussion - adds an Attachment to this ADevelopmentItem
   */

   function addAttachment( &$attachment )
   {
      $attachment->_setDevelopmentItem( $this );
      $attachment->_store();
   }

//========================================================================

   /*!
   @function getAttachments()
   @discussion - provides the attachments of this ADevelopmentItem
   @result - returns an IIterator on Attachment
   */

   function &getAttachments()
   {
      importClass( 'Bugs.Attachment' );
      $prototype =& Attachment::getPrototype();
      return $prototype->doSearch(
         'report_id=?',
         array( $this->getPrimaryID() ) );
   }

//========================================================================

   /*!
   @function addComment( $comment )
   @param $comment - a Comment - which may have isNull = true
   @discussion - adds a comment to this ADevelopmentItem
   */

   function &addComment( &$comment )
   {
      $comment->_setDevelopmentItem( $this );
      $comment->_store();
   }

//========================================================================

   /*!
   @function getComments()
   @discussion - provides an IIterator accross the comments of
      this ADevelopmentItem
   @result - returns IIterator< Comment >
   */

   function &getComments()
   {
      importClass( 'Bugs.Comment' );
      $commentPrototype =& Comment::getPrototype();
      return $commentPrototype->doSearch(
         'report_id=?',
         array( $this->getPrimaryID() ) );
   }

//========================================================================

   /*!
   @function _getNewWherePair()
   @discussion - where, bind pair to find "new" defects
   @result - returns a WherePair
   */

   /* static */
   function _getNewWherePair()
   {
      //imported State at top of file
      return array(
         '(state_id=? OR state_id=?)',
         array( SUBMITTED_NEW_STATE_ID, SUBMITTED_REOPENED_STATE_ID ) );
   }

//========================================================================

   /*!
   @function _getVerificationRequestedWherePair()
   @discussion - where, bind pair to find "verf_req" defects
   @result - returns a WherePair
   */

   /* static */
   function _getVerificationRequestedWherePair()
   {
      //imported State at top of file
      return array(
         'state_id=?',
         array( VERIFICATION_REQUESTED_STATE_ID ) );
   }

//========================================================================

   /*!
   @function _getVerificationRequestedWherePairForProject( $project )
   @param - $project defines which project to get VR bugs for
   @discussion - where, bind pair to find "verf_req" defects for specified project
   @result - returns a WherePair
   */

   /* static */
   function _getVerificationRequestedWherePairForProject( $project )
   {
      //imported State at top of file
      return array(
         'state_id=? AND project_id=?',
         array( VERIFICATION_REQUESTED_STATE_ID, $project->getPrimaryID() ) );
   }

//========================================================================

   /*!
   @function _getUnassignedWherePair()
   @discussion - where, bind pair to find "new" defects
   @result - returns a WherePair
   */

   /* static */
   function _getUnassignedWherePair()
   {
      return array(
         'developer_id IS NULL',
         array() );
   }

//========================================================================

   /*!
   @function _getProjectWherePair( $project )
   @param $project - a Project
   @discussion - provides a where pair for all the ADevelopmentItems
      in the specified Project
   @result - returns a WherePair
   */

   /* static */
   function _getProjectWherePair( &$project )
   {
      // print_r( $project );

      return array(
         'project_id = ?',
         array( $project->getPrimaryID() ));
   }

//========================================================================

   /*!
   @function getDefaultOrderBy()
   */

   function getDefaultOrderBy()
   {
      return 'priority_id DESC';
   }

//========================================================================

   /*!
   @function _getDefaultTester( )
   @discussion - returns user to act as the default tester for this issue
            the Project must be set
            before &_getDefaultTester is called.
   @result - returns a user obj
   */

   function _getDefaultTester()
   {
      $project =& $this->getProject();
      return $project->getDefaultTester();
   }

//========================================================================

   /*!
   @function _getDefaultValue()
   */

   function _getDefaultValue( $column )
   {
      switch ( $column )
      {
         //----------------------------------------------------------------
         case 'priority_id':
         //This will set priority_id ...
         $this->_setPriority( $this->_getDefaultPriority(), false );
         //... but it still needs to be returned
         return $this->priority_id;

         //----------------------------------------------------------------

         case 'reporttype_id':
         return $this->_getReportTypeID();

         //----------------------------------------------------------------

         case 'testHours':
         case 'estTestHours':
         case 'codeHours':
         case 'miscHours':
         case 'estMiscHours':
         case 'designHours':
         //no 'estCodeHours' here because it should be left NULL
         return 0;

         //----------------------------------------------------------------

         case 'date_in':
         return time();

         //----------------------------------------------------------------

         //TODO: Clean up version handling

         //first parameter is ...
         //true requires that the Version be set
         //false allows the Version to not be set - in which case it
         //  is considered null

         case 'initClientVersion_id':
         importClass( 'Bugs.Version' );
         return $this->_storeVersion(
            'initClientVersion',
            true,
            CLIENT_VERSION_TYPE );

         case 'initServerVersion_id':
         importClass( 'Bugs.Version' );
         return $this->_storeVersion(
            'initServerVersion',
            true,
            SERVER_VERSION_TYPE );

         case 'clientFixedVersion_id':
         importClass( 'Bugs.Version' );
         return $this->_storeVersion(
            'clientFixedVersion',
            false,
            CLIENT_VERSION_TYPE );

         case 'serverFixedVersion_id':
         importClass( 'Bugs.Version' );
         return $this->_storeVersion(
            'serverFixedVersion',
            false,
            SERVER_VERSION_TYPE );

         //----------------------------------------------------------------

         default:
         return parent::_getDefaultValue( $column );

         //----------------------------------------------------------------
      }
   }

//========================================================================

   /*!
   @function _storeVersion( $objMember, $isRequired, $versionType )
   @param $objMember - a String - containing a member variable name to a Version
   @param $isRequired - a boolean - indicates if the specified
      Version variable is required to be set.
   @param $versionType - one of CLIENT_VERSION_TYPE or SERVER_VERSION_TYPE
   @discussion - handles calling _store on the specified member
      variable

      Also, performs some sanity checks just for safety reasons.
   @result - returns a RowID
   */

   function _storeVersion( $objMember, $isRequired, $versionType )
   {
      //if the columnMember is NOT set then
      //objMember should contain a new Version

      if ( isset( $this->$objMember ) )
      {
         //TODO: Make sure this is correct

         //if its set, it better be new
         $error = ( ! $this->$objMember->isNew() );
      }
      else
      {
         //if its not set and it is required then there's a problem
         $error = $isRequired;
      }

      if ( $error )
      {
         unreachablePoint( 'Invalid Version: ' . $objMember );
      }

      if ( isset( $this->$objMember ) )
      {
         $project =& $this->getProject();
         $project->_addVersion( $this->$objMember, $versionType );

         return $this->$objMember->getPrimaryID();
      }
      else
      {
         return DB_NULL;
      }
   }

//========================================================================

   /*!
   @function isMoreInfoNeeded()
   @discussion - indicates if this ADevelopmentItem needs more
      information
   @result - returns a boolean
   */

   function isMoreInfoNeeded()
   {
      $state =& $this->getState();
      return $state->isMoreInfoNeeded();
   }

//========================================================================

   /*!
   @function isVerficationRequested()
   @discussion - indicates if this ADevelopmentItem needs verification
   @result - returns a boolean
   */

   function isVerificationRequested()
   {
      //TODO: Clean up this method
      return ( $this->state_id == VERIFICATION_REQUESTED_STATE_ID );
   }

//========================================================================

   /*!
   @function isClosed()
   @discussion - indicates this ADevelopmentItem is closed
   @result - returns a boolean
   */

   function isClosed()
   {
      $state =& $this->getState();
      return $state->isClosed();
   }

//========================================================================

   /*!
   @function setDevelopmentStatus( $isUnderDevelopment )
   @param $isUnderDevelopment - a boolean indicating if this ADevelopmentItem
      is actively under development
   @discussion - changes the under development status of this
      ADevelopmentItem
   */

   function setDevelopmentStatus( $isUnderDevelopment )
   {
      //print getLocation() . BR_NL;

      if ( $this->isUnderDevelopment() )
      {
         if ( ! $isUnderDevelopment )
         {
            $this->state_id = SUBMITTED_ASSIGNED_STATE_ID;
            $this->_store();
         }
      }
      elseif ( $this->isNotUnderDevelopment() )
      {
         //NOTE: The check of isNotUnderDevelopment is necessary because
         //( ! $this->isUnderDevelopment() ) is not the same $this->isNotUnderDevelopment()

         if ( $isUnderDevelopment )
         {
            $this->state_id = UNDER_DEVELOPMENT_ASSIGNED_STATE_ID;
            $this->_store();
         }
      }
   }

//========================================================================

   /*!
   @function isUnderDevelopment()
   @discussion - indicates if this ADevelopmentItem is active under
      development

      NOTE: ! isUnderDevelopment() is not always equal to isNotUnderDevelopment()
   @result - returns a boolean
   */

   function isUnderDevelopment()
   {
      //TODO: Clean up this method
      return
         ( $this->state_id == UNDER_DEVELOPMENT_ASSIGNED_STATE_ID ) ||
         ( $this->state_id == UNDER_DEVELOPMENT_MORE_INFO_GIVEN_STATE_ID ) ||
         ( $this->state_id == UNDER_DEVELOPMENT_FIX_FAILED_STATE_ID );
   }

//========================================================================

   /*!
   @function isNotUnderDevelopment()
   @discussion - indicates if this ADevelopmentItem is not actively under
      development

      NOTE: ! isUnderDevelopment() is not always equal to isNotUnderDevelopment()
   @result - returns a boolean
   */

   function isNotUnderDevelopment()
   {
      //TODO: Clean up this method
      return ( $this->state_id == SUBMITTED_ASSIGNED_STATE_ID );
   }

//========================================================================

   /*!
   @function getColumnValue( $column )
   */

   function getColumnValue( $column )
   {
      switch ( $column )
      {
         case 'date_state':
         return time();

         default:
         return parent::getColumnValue( $column );
      };
   }

//========================================================================

   /*!
   @function _getReportTypeID()
   @discussion - provides the reporttype_id for this
      ADevelopmentItem
   @result - returns a RowID
   */

   /* abstract function _getReportTypeID(); */

//========================================================================

   /*!
   @function _getDefaultPriority()
   @discussion - provides a default priority score for this
      ADevelopmentItem
   @result - returns an double in [0,1]
   */

   /* abstract function _getDefaultPriority(); */

//========================================================================

   /*!
   @function getDisplayName()
   @discussion - provides user-presentable name for this action
   @result - returns a user-presentable String
   */

   /* abstract function getDisplayName(); */

//========================================================================

   /*!
   @function getTypeDisplayName( $devItemType )
   @param $devItemType - a DevItemType constant
   @discussion - provides a user-presentable name for the specified
      type
   @result - returns a user-presentable String
   */

   /* static */
   function getTypeDisplayName( $devItemType )
   {
      switch ( $devItemType )
      {
         case TASK:
         return 'Task';

         case FEATURE_REQUEST:
         return 'Feature';

         case DEFECT:
         return 'Defect';

         default:
         unreachablePoint(
            getLocation() .
            'Unknown DevItemType: ' . $devItemType );
      };
   }

//========================================================================

   /*!
   @function &getVerificationStates()
   @discussion - returns iterator of verification states for a dev item
   */

   function &getVerificationStates()
   {
      // Default implementation is ...
      importClass( 'Bugs.State' );
      return State::getQAClosingStates();
   }

//========================================================================

   /*!
   @function &getDefaultVerificationState()
   @discussion - returns default verification state for a dev item
   */

   function &getDefaultVerificationState()
   {
      $iterator =& $this->getVerificationStates();
      $iterator->reset();
      return $iterator->getCurrent();
   }

//========================================================================

   /*!
   @function giveMoreInfo( $user, $comment )
   @param $user - a User - the user who provided the comment
   @param $comment - a String - the comment
   @discussion - makes database entries as appropriate
   */

   function giveMoreInfo( &$user, $comment )
   {
      importClass( 'Bugs.State' ); // for the precious global defines, mmmmmmmm
      $soonToBeOldState = $this->getState();
      $soonToBeOldStateID = $soonToBeOldState->getPrimaryID();

      //check to see if they are QA
      //This is a little nebulous - maybe it would be better to
      //call DevItem->canBeTester?
      $project =& $this->getProject();
      if ( $project->isQA( $user ) )
      {
         if( $soonToBeOldStateID == DEVELOPER_NEEDS_MORE_INFO_STATE_ID )
         {
            $nextStateID = UNDER_DEVELOPMENT_MORE_INFO_GIVEN_STATE_ID;
         }
         elseif( $soonToBeOldStateID == DESIGNER_NEEDS_MORE_INFO_STATE_ID )
         {
            $nextStateID = SUBMITTED_MORE_INFORMATION_GIVEN_STATE_ID;
         }
      }

      if ( ! isset( $nextStateID ) )
      {
         unreachablePoint( 'ADevelopmentItem::giveMoreInfo was called when the current state of the bug is not *MORE_INFO_NEEDED!' );
      }

      // Set the new state based on logic above
      $nextState =& State::getFromPrimaryID( $nextStateID );

      $this->_setState( $nextState );

      // Add a comment with the appropriate comment type to this ADevelopmentItem
      importClass( 'Bugs.Comment' );
      $this->addComment(
         Comment::createMoreInfoGivenComment( $user, $comment ) );

      //changed this->state_id, so _store does need to be called
      $this->_store();
   }

//========================================================================

   /*!
   @function canFix( $user )
   @param $user - a User
   @discussion - indicates if the provided User can "fix" this issue
   @result - returns a boolean
   */

   function canFix( &$user )
   {
      if ( $this->isDeveloper( $user ) ) return true;
      $project =& $this->getProject();
      return $project->isDesigner( $user );
   }

//========================================================================

   /*!
   @function fixed( $user, $codeDuration, $miscDuration, $serverFixedVersion,
      $clientFixedVersion, $comment )
   @param $user - the User that fixed this issue
   @param $codeDuration - a TimeDuration - representing code hours for this fix
   @param $miscDuration - a TimeDuration - representing misc. hours for this fix
   @param $serverFixedVersion - a Version - may be new
   @param $clientFixedVersion - a Version - may be new
   @discussion - marks this ADevelopmentItem as "fixed" by the developer
      (which means the ADevItem goes into "Verification Requested")
   */

   function fixed(
      &$user,
      &$codeDuration,
      &$miscDuration,
      &$serverFixedVersion,
      &$clientFixedVersion,
      $comment )
   {
      $this->codeHours += $codeDuration->getHours();
      $this->miscHours += $miscDuration->getHours();

      if ( ! isset( $this->developer_id ) )
      {
         $this->developer_id = $user->getPrimaryID();
      }

      if ( ! isset( $this->designer_id ) )
      {
         $this->designer_id = $user->getPrimaryID();
      }

      if ( $serverFixedVersion->isNew() )
      {
         $this->serverFixedVersion =& $serverFixedVersion;
         unset( $this->serverFixedVersion_id );
      }
      else
      {
         $this->serverFixedVersion_id = $serverFixedVersion->getPrimaryID();
      }

      if ( $clientFixedVersion->isNew() )
      {
         $this->clientFixedVersion =& $clientFixedVersion;
         unset( $this->clientFixedVersion_id );
      }
      else
      {
         $this->clientFixedVersion_id = $clientFixedVersion->getPrimaryID();
      }

      importClass( 'Bugs.Comment' );
      $this->addComment(
         Comment::createDeveloperComment( $user, $comment ) );

      if ( $this->isTester( $user ) )
      {
         $state =& $this->getDefaultVerificationState();
         $this->state_id = $state->getPrimaryID();
      }
      else
      {
         $this->state_id = VERIFICATION_REQUESTED_STATE_ID;
      }

      $this->_store();
   }

//========================================================================

   /*!
   @function reopen( &$user, $comment )
   @discussion - reopens this ADevelopmentItem
   */

   function reopen( &$user, $comment )
   {
      //TODO: Create a comment with previous state of the bug

      importClass( 'Bugs.Comment' );
      $this->addComment(
         Comment::createReOpenComment( $user, $comment ) );

      //TODO: Change version numbers?

      $this->state_id = SUBMITTED_REOPENED_STATE_ID;
      $this->_store();
   }

//========================================================================

   /*!
   @function requestMoreInfo( &$user, $comment )
   @param $user - the user who needs more info
   @param $comment - the comment about what they need
   @discussion - makes database entries as appropriate
   @result - returns nothing
   */

   function requestMoreInfo( &$user, $comment )
   {
      print_r( $user );

      // for the precious global defines, mmmmmmmm
      importClass( 'Bugs.State' );

      if ( $this->isDeveloper( $user ) )
      {
         $nextStateID =  DEVELOPER_NEEDS_MORE_INFO_STATE_ID;
      }
      else
      {
         //Should NOT be checking $this->getDesigner -
         //It should check Project->isDesigner

         $project =& $this->getProject();

         if ( $project->isDesigner( $user ) )
         {
            $nextStateID =  DESIGNER_NEEDS_MORE_INFO_STATE_ID;
         }
         else
         {
            unreachablePoint( 'ADevelopmentItem::requestMoreInfo was called when the user is neither the devel or the designer!' );
         }

      }

      // Set the new state based on logic above
      $nextState =& State::getFromPrimaryID( $nextStateID );

      $this->_setState( $nextState );

      // Add a comment with the appropriate comment type to this ADevelopmentItem
      importClass( 'Bugs.Comment' );
      $this->addComment(
         Comment::createMoreInfoNeededComment( $user, $comment ) );

      $this->_store();
   }

//========================================================================

   /*!
   @function close( $user, $comment, $state )
   @param $user - a User - the user closing this ADevelopmentItem
   @param $comment - a String - may be empty
   @param $state - a State - the new State of this ADevelopmentItem
   @discussion - marks this ADevelopmentItem as closed
   */

   function close( &$user, $comment, &$state )
   {
      importClass( 'Bugs.Comment' );
      $this->addComment(
         Comment::createReasonClosedComment( $user, $comment ) );

      $this->fixedDate = time();

      $this->state_id = $state->getPrimaryID();
      $this->_store();
   }

//========================================================================

   /*!
   @function verify( $user, $comment, $testDuration, $state )
   @param $user - a User - the user closing this ADevelopmentItem
   @param $comment - a String - may be empty
   @param $serverVersion - a Version - may be "new"
   @param $clientVersion - a Version - may be "new"
   @param $testDuration - a TimeDuration - representing time to verify this item
   @param $state - a State - the new State of this ADevelopmentItem
   @discussion - marks this ADevelopmentItem as closed
   */

   function verify(
      &$user,
      $comment,
      &$serverVersion,
      &$clientVersion,
      &$testDuration,
      &$state )
   {
      importClass( 'Bugs.Comment' );
      $this->addComment(
         Comment::createReasonClosedComment( $user, $comment ) );

      if ( $serverVersion->isNew() )
      {
         $this->serverFixedVersion =& $serverVersion;
         unset( $this->serverFixedVersion_id );
      }
      else
      {
         $this->serverFixedVersion_id = $serverVersion->getPrimaryID();
      }

      if ( $clientVersion->isNew() )
      {
         $this->clientFixedVersion =& $clientVersion;
         unset( $this->clientFixedVersion_id );
      }
      else
      {
         $this->clientFixedVersion_id = $clientVersion->getPrimaryID();
      }

      $this->testHours += $testDuration->getHours();

      $this->fixedDate = time();

      $this->state_id = $state->getPrimaryID();
      $this->_store();
   }

//========================================================================

   /*!
   @function fail( $user, $comment, $testDuration )
   @param $user - a User - failing this ADevelopmentItem
   @param $comment - a String
   @param $testDuration - a TimeDuration - representing time to verify this item
   @discussion - marks this ADevelopmentItem as "Fix Failed"
   */

   function fail( &$user, $comment, &$testDuration )
   {
      importClass( 'Bugs.Comment' );
      $this->addComment(
         Comment::createFailedComment( $user, $comment ) );

      $this->testHours += $testDuration->getHours();

      $this->state_id = UNDER_DEVELOPMENT_FIX_FAILED_STATE_ID;
      $this->_store();
   }

//========================================================================

   /*!
   @function getPrototypeClass()
   */

   function getPrototypeClass()
   {
      return 'ADevelopmentItem';
   }

//========================================================================

   /*!
   @function _store()
   */

   function _store()
   {
      $this->date_state = time();

      //Could send the email here, but I am not crazy about that
      //The other option is an email observer, but that's not pretty either

      parent::_store();
   }

//========================================================================

   /*!
   @function _createDuration( $hours )
   @param $hours - a float - a time duration in hours
   @discussion - a static helper method used to convert from the
      database storage format to a TimeDuration object
   @result - returns a TimeDuration
   */

   /* static */
   function &_createDuration( $hours )
   {
      importClass( 'Time.TimeDuration' );
      $time =& new TimeDuration( $hours, STORE_DEV_ITEM_TIME_UNIT );
      $time->setPreferredUnit( DEFAULT_DEV_ITEM_TIME_UNIT );
      return $time;
   }

//========================================================================

};

?>