<?php

/*
Comment
$Author: dougqh $
$Revision: 1.2 $
$Date: 2003/12/18 20:40:41 $
$Log: Comment.php,v $
Revision 1.2  2003/12/18 20:40:41  dougqh
Updated to work under PHP 4.2

Revision 1.1  2003/07/09 20:34:36  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'Database.ADatabaseItem' );

//========================================================================

importClass( 'Bugs.CommentType' );

//========================================================================

/*!
@class Comment
@abstract -
*/

class Comment extends ADatabaseItem
{

//========================================================================

   var $comments;
   var $dataCreated;
   var $relatedReport;
   var $creator;
   var $state;
   var $commentType;

//========================================================================

   /*!
   @function Comment( $primary_id )
   @discussion - constructs a new Comment object
   @result - constructs a new Comment object
   */

   function Comment( $primary_id = UNSPECIFIED )
   {
      $this->ADatabaseItem( $primary_id );
   }

//========================================================================

   /*!
   @function getPrototype()
   @discussion - provides the Comment prototype
   */

   /* static */
   function &getPrototype()
   {
      return Comment::_getPrototype( __FILE__ );
   }

//========================================================================

   /*!
   @function _createComment( $user, $comment, $commentTypeID )
   @param $user - the User - who added the comment
   @param $commentText - the actual body of the comment
      - empty String is acceptable, but will produce a "null" comment
   @param $commentTypeID - a CommentType RowID
   @discussion - creates a Comment
   @result - returns a Comment
   */

   function &_createComment( &$user, $commentText, $commentTypeID )
   {
      $comment =& new Comment();
      $comment->_setSubmitter( $user );
      $comment->_setComments( $commentText );
      $comment->_setCommentTypeID( $commentTypeID );

      return $comment;
   }

//========================================================================

   /*!
   @function createComment( $user, $comment, $commentType )
   @param $user - a User - who added the Comment
   @param $comment - the actual body of the comment
      - empty String is acceptable, but will produce a "null" comment
   @discussion - creates a Comment
   @result - returns a Comment
   */

   function &createComment( &$user, $comment, &$commentType )
   {
      return Comment::_createComment(
         $user,
         $comment,
         $commentType->getPrimaryID() );
   }

//========================================================================

   /*!
   @function createMoreInfoGivenComment( $user, $comment )
   @param $user - the User - who added the comment
   @param $comment - the actual body of the comment
   @discussion - creates a "More Info" comment
   @result - returns a Comment
   */

   function &createMoreInfoGivenComment( &$user, $comment )
   {
      //imported CommentType at top of file
      return Comment::_createComment(
         $user, $comment, MORE_INFORMATION_COMMENT_TYPE_ID );
   }

//========================================================================

   /*!
   @function createMoreInfoNeededComment( &$user, $comment )
   @param $user - the User - who added the comment
   @param $comment - the actual body of the comment
   @discussion - creates a "More Info Needed" comment
   @result - returns a Comment
   */

   function &createMoreInfoNeededComment( &$user, $comment )
   {
      return Comment::_createComment(
         $user, $comment, MORE_INFORMATION_NEEDED_COMMENT_TYPE_ID );
   }

//========================================================================

   /*!
   @function createDeveloperComment( $user, $comment )
   @param $user - the User - who added the comment
   @param $comment - the actual body of the comment
      - empty String is acceptable, but will produce a "null" comment
   @discussion - creates a "Developer" comment
   @result - returns a Comment
   */

   function &createDeveloperComment( &$user, $comment )
   {
      //imported CommentType at top of file
      return Comment::_createComment(
         $user, $comment, DEVELOPER_COMMENT_COMMENT_TYPE_ID );
   }

//========================================================================

   /*!
   @function createReopenComment( $user, $comment )
   @param $user - the User - who added the comment
   @param $comment - the actual body of the comment
   @discussion - creates a "ReOpen" comment
   @result - returns a Comment
   */

   function &createReopenComment( &$user, $comment )
   {
      return Comment::_createComment(
         $user, $comment, REASON_REOPENED_COMMENT_TYPE_ID );
   }

//========================================================================

   /*!
   @function createReasonClosedComment( $user, $comment )
   @param $user - a User - the user who added the comment
   @param $comment - the actual body of the comment
   @discussion - creates a "Reason Closed" comment
   @result - returns a Comment
   */

   function &createReasonClosedComment( &$user, $comment )
   {
      return Comment::_createComment(
         $user, $comment, REASON_CLOSED_COMMENT_TYPE_ID );
   }

//========================================================================

   /*!
   @function createFailedComment( $user, $comment )
   @param $user - a User - the user who added the comment
   @param $comment - the actual body of the comment
   @discussion - creates a "Reason Closed" comment
   @result - returns a Comment
   */

   function &createFailedComment( &$user, $comment )
   {
      return Comment::_createComment(
         $user, $comment, BUG_FIXED_FAILED_COMMENT_TYPE_ID );
   }

//========================================================================

   /*!
   @function isNull()
   @discussion - Comments are consider "null" if the "comments" member
      is an empty string

      If the Comment isNull, then calling _store on the comment will have
      no effect.
   */

   function isNull()
   {
      return parent::isNull() || isEmpty( $this->comments );
   }

//========================================================================

   /*!
   @function getTable()
   @discussion - provides the table name (with schema if necessary)
   @result - returns a String
   */

   function getTable()
   {
      return 'comment';
   }

//========================================================================

   /*!
   @function getComments()
   @discussion - a normal get function
   @result - returns comments item for this object
   */

   function getComments()
   {
      return $this->comments;
   }

//========================================================================

   /*!
   @function _setComments( $comments )
   @param $comments - the value to set the comments member to
   @discussion - a normal set function
   @result - returns nothing
   */

   function _setComments( $comments )
   {
      $this->comments = $comments;
   }

//========================================================================

   /*!
   @function getDateCreated()
   @discussion - a normal get function
   @result - returns dataCreated item for this object
   */

   function getDateCreated()
   {
      return $this->date_in;
   }

//========================================================================

   /*!
   @function getAllColumns()
   @discussion - returns the columns for this item's row
   */

   function getAllColumns()
   {
      return array(
         $this->getPrimaryColumn(),
         'date_in',
         'comments',
         'report_id',
         'user_id',
         'commentType_id' );
   }

//========================================================================

   /*!
   @function _setDevelopmentItem( $developmentItem )
   @param $developmentItem - a ADevelopmentItem
   */

   function _setDevelopmentItem( &$developmentItem )
   {
      $this->report_id = $developmentItem->getPrimaryID();
      $this->_setChanged( true );
   }

//========================================================================

   /*!
   @function getCreator()
   @discussion - a normal get function
   @result - returns creator item for this object
   */

   function &getCreator()
   {
      importClass( 'Shared.User' );
      return User::getFromPrimaryID( $this->user_id );
   }

//========================================================================

   /*!
   @function setCreator( $creator )
   @param $creator - the value to set the creator member to
   @discussion - a normal set function
   @result - returns nothing
   */

   function _setCreator( &$creator )
   {
      $this->user_id = $creator->getPrimaryID();
   }

//========================================================================

   /*!
   @function getCommentType()
   @discussion - a normal get function
   @result - returns commentType item for this object
   */

   function &getCommentType()
   {
      importClass( 'Bugs.CommentType' );
      return CommentType::getFromPrimaryID( $this->commentType_id );
   }

//========================================================================

   /*!
   @function _setSubmitter( $submitter )
   @param $submitter - a User
   @discussion - sets the Submitter for this Attachment
   */

   function _setSubmitter( $user = UNSPECIFIED )
   {
      if( $user === UNSPECIFIED )
      {
         importClass( 'Shared.User' );
         $user =& User::getCurrentUser();
      }

      $this->user_id = $user->getPrimaryID();
   }


//========================================================================

   /*!
   @function _getDefaultValue( $column )
   */

   function _getDefaultValue( $column )
   {
      switch ( $column )
      {
         case 'date_in':
         return time();

         default:
         return parent::_getDefaultValue( $column );
      };
   }

//========================================================================

   /*!
   @function _setCommentTypeID( $commentType_id )
   @param $commentType_id - an integer
   @discussion - a normal set function
   @result - returns nothing
   */

   function _setCommentTypeID( $commentType_id )
   {
      $this->commentType_id = $commentType_id;
      $this->_setChanged( true );
   }

//========================================================================

   /*!
   @function getDefaultOrderBy()
   */

   function getDefaultOrderBy()
   {
      return 'date_in DESC';
   }

//========================================================================

};

?>