<?php

/*
CommentType
$Author: dougqh $
$Revision: 1.2 $
$Date: 2003/12/18 20:40:41 $
$Log: CommentType.php,v $
Revision 1.2  2003/12/18 20:40:41  dougqh
Updated to work under PHP 4.2

Revision 1.1  2003/07/09 20:34:36  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

define( 'BUG_ALERT_COMMENT_TYPE_ID'                ,1 );
define( 'DESIGN_ALERT_COMMENT_TYPE_ID'             ,2 );
//define( 'FILES_MODIFIED_COMMENT_TYPE_ID'           ,3 );
define( 'MORE_INFORMATION_COMMENT_TYPE_ID'         ,4 );
define( 'DEVELOPER_COMMENT_COMMENT_TYPE_ID'        ,5 );
define( 'DESIGNER_COMMENT_COMMENT_TYPE_ID'         ,6 );
define( 'OTHER_COMMENT_TYPE_ID'                    ,7 );
define( 'STEPS_TO_REPRODUCE_COMMENT_TYPE_ID'       ,8 );
define( 'MORE_INFORMATION_NEEDED_COMMENT_TYPE_ID'  ,9 );
define( 'BUG_FIXED_FAILED_COMMENT_TYPE_ID'         ,10 );
define( 'REASON_CLOSED_COMMENT_TYPE_ID'            ,11 );
define( 'REASON_REOPENED_COMMENT_TYPE_ID'          ,12 );

//========================================================================

importClass( 'Database.ATrivialDatabaseItem' );

class CommentType extends ATrivialDatabaseItem
{

//========================================================================

   /*!
   @function CommentType()
   @discussion - CommentType databse item constructor
   */

   function CommentType( $primary_id = UNSPECIFIED )
   {
      $this->ATrivialDatabaseItem( $primary_id );
   }

//========================================================================

   /*!
   @function getAllColumns()
   @discussion - returns the columns for this item's row
   */

   function getAllColumns()
   {
      return array( $this->getPrimaryColumn(), 'name', 'color');
   }

//========================================================================

   /*!
   @function getPrototype()
   @discussion - provides the CommentType prototype
   */

   /* static */
   function &getPrototype()
   {
      return CommentType::_getPrototype( __FILE__ );
   }

//========================================================================

   /*!
   @function getFromPrimaryID( $primary_id )
   */

   /* static */
   function &getFromPrimaryID( $primary_id )
   {
      return CommentType::_getFromPrimaryID(
         CommentType::getPrototype(),
         $primary_id );
   }

//========================================================================

   /*!
   @function getColor()
   @discussion - returns the color - useful in the HTML view for a comment of this type
   @return - returns a hex-triplet, 6-char string
   */

   function getColor()
   {
      return $this->color;
   }

//========================================================================

   /*!
   @function getName()
   @discussion - returns the name
   @return - returns a string
   */

   function getName()
   {
      return $this->name;
   }

//========================================================================

   /*!
   @function getTable()
   @discussion - returns the table that this class gets its data from
   @return - returns a string
   */

   function getTable()
   {
      return 'commenttype';
   }

//========================================================================

   /*!
   @function getCommentTypes( $user, $devItem )
   @param $user - a User
   @param $devItem - an ADevelopmentItem
   @discussion - provides a list of CommentTypes available to the
      specified User for the given ADevelopmentItem
   @result - returns an IIterator< CommentType >
   */

   /* static */
   function &getCommentTypes( &$user, &$devItem )
   {
      $ids = array();

      $project =& $devItem->getProject();
      if ( $project->isQA( $user ) )
      {
         $ids[] = BUG_ALERT_COMMENT_TYPE_ID;
         $ids[] = STEPS_TO_REPRODUCE_COMMENT_TYPE_ID;
      }

      if ( $project->isDesigner( $user ) )
      {
         $ids[] = DESIGNER_COMMENT_COMMENT_TYPE_ID;
      }

      if ( $project->isDeveloper( $user ) )
      {
         $ids[] = DEVELOPER_COMMENT_COMMENT_TYPE_ID;
      }

      $ids[] = OTHER_COMMENT_TYPE_ID;

      $prototype =& CommentType::getPrototype();
      return $prototype->doSearch(
         'commenttype_id IN (' . implode( ',', $ids ) . ')',
         array() );
   }

//========================================================================

};

?>