<?php

/*
FavoriteItemSet
$Author: dougqh $
$Revision: 1.4 $
$Date: 2004/01/13 19:00:00 $
$Log: FavoriteItemSet.php,v $
Revision 1.4  2004/01/13 19:00:00  dougqh
- Add method removeDevelopmentItemsByIDs

Revision 1.3  2004/01/13 14:43:01  dougqh
- Added additional static creation methods

Revision 1.2  2004/01/08 15:29:20  dougqh
- Added staticCreateNew - overriding getIdentifyingString

Revision 1.1  2004/01/06 15:47:12  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'Shared.AConfigWrappingItem' );

//========================================================================

/*!
@class FavoriteItemSet
@abstract -
*/

class FavoriteItemSet extends AConfigWrappingItem
{

//========================================================================

   var $ids;

//========================================================================

    /*!
    @function FavoriteItemSet()
    @discussion - constructs a new FavoriteItemSet object
    @result - constructs a new FavoriteItemSet object
    */

    function FavoriteItemSet( &$config )
    {
        $this->AConfigWrappingItem( $config );
        // $this->ids =& $config->getValueRef();
    }

//========================================================================

    /*!
    @function staticCreateNew( $desc )
    @param $desc - a String
    @discussion - creates a new FavoriteItemSet with the specified description
    */

    function &staticCreateNew( $desc )
    {
        $favSet =& new FavoriteItemSet( toRef( NULL ) );
        $favSet->setDescription( $desc );
        return $favSet;
    }

//========================================================================

    /*!
    @function &getPrototype()
    */
    /* static */
    function &getPrototype()
    {
      return AConfigWrappingItem::_getPrototype( __FILE__ );
    }

//========================================================================

    /*!
    @function &getFromPrimaryID( $id )
    */
    /*static*/
    function &getFromPrimaryID( $id )
    {
        $proto =& FavoriteItemSet::getPrototype();
        $iter =& $proto->doIDSearch( array( $id ) );

        $iter->reset();
        return $iter->getCurrent();
    }

//========================================================================

    /*!
    @function _getConfigType()
    */
    function _getConfigType()
    {
        return 'favoriteItemSet';
    }

//========================================================================

    /*!
    @function getDevelopmentItemIds()
    */
    function getDevelopmentItemIds()
    {
        return $this->config->getValue();
    }

//========================================================================

    /*!
    @function addDevelopmentItem( &$devItem )
    */
    function addDevelopmentItem( &$devItem )
    {
        $idSet = $this->config->getValue();
        $idSet{ $devItem->getPrimaryID() } = true;
        $this->config->setValue( $idSet );
    }

//========================================================================

    /*!
    @function addDevelopmentItems( &$iter )
    */
    function addDevelopmentItems( &$iter )
    {
        $idSet = $this->config->getValue();

        $iter->reset();

        for( $iter->reset(); ! $iter->isEnd(); $iter->moveNext() )
        {
            $devItem =& $iter->getCurrent();
            $idSet{ $devItem->getPrimaryID() } = true;
        }

        $this->config->setValue( $idSet );
    }

//========================================================================

   /*!
   @function addDevelopmentItemsByIDs( $ids )
   */

   function addDevelopmentItemsByIDs( $ids )
   {
      $idSet = $this->config->getValue();
      foreach ( $ids as $curId )
      {
         $idSet{ $curId } = true;
      }

      $this->config->setValue( $idSet );
   }

//========================================================================

    /*!
    @function removeDevelopmentItem( &$devItem )
    */
    function removeDevelopmentItem( &$devItem )
    {
        $idSet = $this->config->getValue();
        unset( $idSet{ $devItem->getPrimaryID() } );
        $this->config->setValue( $idSet );
    }

//========================================================================

    /*!
    @function removeDevelopmentItems( &$iter )
    */
    function removeDevelopmentItems( &$iter )
    {
        $idSet = $this->config->getValue();

        for( $iter->reset(); ! $iter->isEnd(); $iter->moveNext() )
        {
            $devItem =& $iter->getCurrent();
            unset( $idSet{ $devItem->getPrimaryID() } );
        }

        $this->config->setValue( $idSet );
    }

//========================================================================

   /*!
   @function removeDevelopmentItemsByIDs( $ids )
   */
   function removeDevelopmentItemsByIDs( $ids )
   {
      $idSet = $this->config->getValue();

      foreach ( $ids as $curId )
      {
         unset( $idSet{ $curId } );
      }

      $this->config->setValue( $idSet );
   }

//========================================================================

    /*!
    @function getCount()
    */
    function getCount()
    {
        return count( $this->config->getValue() );
    }

//========================================================================

    /*!
    @function &getDevelomentItems()
    */
    function &getDevelomentItems()
    {
        importClass( 'Bugs.ADevelopmentItem' );
        $proto =& ADevelopmentItem::getPrototype();
        return $proto->doIDSearch( array_keys( $this->config->getValue() ) );
    }

//========================================================================

    /*!
    @function &createNew()
    */
    function &createNew()
    {
        return new FavoriteItemSet( toRef( NULL ) );
    }

//========================================================================

    /*!
    @function &_createConfig()
    */
    function &_createConfig()
    {
        importClass( 'Shared.Config' );
        return Config::staticCreateNew( $this->_getConfigType(), array() );
    }

//========================================================================

   /*!
   @function getIdentifyingString()
   */
   function getIdentifyingString()
   {
      return $this->getDescription();
   }

//========================================================================

};

?>