<?php

/*
Frequency
$Author: dougqh $
$Revision: 1.2 $
$Date: 2003/12/18 20:40:41 $
$Log: Frequency.php,v $
Revision 1.2  2003/12/18 20:40:41  dougqh
Updated to work under PHP 4.2

Revision 1.1  2003/07/09 20:34:36  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'Database.ATrivialDatabaseItem' );

//========================================================================

define( 'MAX_FREQUENCY', 5 );
define( 'MIN_FREQUENCY', 1 );

//========================================================================

class Frequency extends ATrivialDatabaseItem
{

//========================================================================

   /*!
   @function Frequency()
   @discussion - constructor for the frequency database item
   */

   function Frequency( $primary_id = UNSPECIFIED )
   {
      $this->ATrivialDatabaseItem( $primary_id );
   }

//========================================================================

   /*!
   @function getPrototype()
   @discussion - provides the Frequency prototype
   */

   /* static */
   function &getPrototype()
   {
      return Frequency::_getPrototype( __FILE__ );
   }

//========================================================================

   /*!
   @function getFromPrimaryID( $primary_id )
   */

   /* static */
   function &getFromPrimaryID( $primary_id )
   {
      return Frequency::_getFromPrimaryID(
         Frequency::getPrototype(),
         $primary_id );
   }

//========================================================================

   /*!
   @function getTable()
   @discussion - returns the table that this class gets its data from
   @return - returns a string
   */

   function getTable()
   {
      return 'frequency';
   }

//========================================================================

   /*!
   @function getDefaultOrderBy()
   @discussion -
   @result - returns a String
   */

   function getDefaultOrderBy()
   {
      return 'name DESC';
   }

//========================================================================

   /*!
   @function getScore()
   @discussion - provides a score in [0,1] where increasing frequency
      yields a higher score
   @result - returns a double in [0,1]
   */

   function getScore()
   {
      //Frequency is an int in [1,5] convert to int in [0,4] / 4
      //to convert to real in [0,1]

      return ( $this->primary_id - 1 ) / ( MAX_FREQUENCY - 1 );
   }

//========================================================================

};

?>