<?php

/*
Platform
$Author: dougqh $
$Revision: 1.3 $
$Date: 2003/12/18 20:40:41 $
$Log: Platform.php,v $
Revision 1.3  2003/12/18 20:40:41  dougqh
Updated to work under PHP 4.2

Revision 1.2  2003/09/04 19:45:18  dawn
- playing with sorting

Revision 1.1  2003/07/09 20:34:36  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

importClass( 'Database.ADatabaseItem' );

class Platform extends ADatabaseItem
{

//========================================================================

   /*!
   @function Platform()
   @discussion - constructor for the platform database item
   */

   function Platform( $primary_id = UNSPECIFIED )
   {
      $this->ADatabaseItem( $primary_id );
   }

//========================================================================

   /*!
   @function getPrototype()
   @discussion - constructs a Platform prototype
   */

   /* static */
   function &getPrototype()
   {
      return Platform::_getPrototype( __FILE__ );
   }

//========================================================================

   /*!
   @function getFromPrimaryID( $primary_id )
   */

   /* static */
   function &getFromPrimaryID( $primary_id )
   {
      return Platform::_getFromPrimaryID(
         Platform::getPrototype(),
         $primary_id) ;
   }

//========================================================================

   /*!
   @function getTable()
   @discussion - returns the table that this class gets its data from
   @return - returns a string
   */

   function getTable()
   {
      return 'platform';
   }

//========================================================================

   /*!
   @function getArchitecture()
   @discussion - provides a String containing the Architecture of this
      Platform
   @result - returns a String
   */

   function getArchitecture()
   {
      return $this->architecture;
   }

//========================================================================

   /*!
   @function getOS()
   @discussion - provides a String containing the OS of this Platform
   @result - returns a String
   */

   function getOS()
   {
      return $this->os;
   }

//========================================================================

   /*!
   @function getIdentifyingString()
   @discussion - concatenatse the architecture and OS
   */

   function _getRegularIdentifyingString()
   {
      return $this->getArchitecture() . ' - ' . $this->getOS();
   }

//========================================================================

   /*!
   @function getAllColumns()
   */

   function getAllColumns()
   {
      return array(
         $this->getPrimaryColumn(),
         'architecture',
         'os' );
   }


//========================================================================

   /*!
   @function _getClientWherePair()
   @discussion - provides a where pair that retrieves client versions
   @result - returns a WherePair
   */

   /* static */
   function _getClientWherePair()
   {
      return array( 'isClient=?', array( 1 ) );
   }

//========================================================================

   /*!
   @function _getServerWherePair()
   @discussion - provides a where pair that retrieves server versions
   @result - returns a WherePair
   */

   /* static */
   function _getServerWherePair()
   {
      return array( 'isClient=?', array( 0 ) );
   }

//========================================================================

};

?>