<?php

/*
Priority
$Author: dougqh $
$Revision: 1.3 $
$Date: 2003/12/18 20:40:41 $
$Log: Priority.php,v $
Revision 1.3  2003/12/18 20:40:41  dougqh
Updated to work under PHP 4.2

Revision 1.2  2003/07/17 14:57:45  millz
- made new constants

Revision 1.1  2003/07/09 20:34:36  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'Database.ATrivialDatabaseItem' );

//========================================================================

define( 'MAX_PRIORITY', 6 );
define( 'MIN_PRIORITY', 1 );

define( 'VERY_URGENT_PRIORITY_ID', 6 );
define( 'URGENT_PRIORITY_ID', 5 );

//========================================================================

class Priority extends ATrivialDatabaseItem
{

//========================================================================

   /*!
   @function Priority( [ $primary_id ] )
   @discussion - constructor for the Priority database item
   */

   function Priority( $primary_id = UNSPECIFIED )
   {
      $this->ATrivialDatabaseItem( $primary_id );
   }

//========================================================================

   /*!
   @function getPrototype()
   @discussion - provides the Priority prototype
   */

   /* static */
   function &getPrototype()
   {
      return Priority::_getPrototype( __FILE__ );
   }

//========================================================================

   /*!
   @function getFromPrimaryID( $primary_id )
   */

   /* static */
   function &getFromPrimaryID( $primary_id )
   {
      return Priority::_getFromPrimaryID(
         Priority::getPrototype(),
         $primary_id );
   }

//========================================================================

   /*!
   @function compute2( $frequency, $severity )
   @param $frequency - a Frequency
   @param $severity - a Severity
   @discussion - computes a Priority level based on
      Frequency and Severity
   @result - returns a Priority
   */

   /* static */
   function &compute2( &$frequency, &$severity )
   {
      $score =
         ( 0.33 * $frequency->getScore() ) +
         ( 0.67 * $severity->getScore() );

      //score is double in [0-1] multiply by 5 and take floor to
      //get an int in [0-5] add one to get an int in [1-6]

      return Priority::getFromPrimaryID(
         floor( $score * ( MAX_PRIORITY - MIN_PRIORITY ) ) + MIN_PRIORITY );
   }

//========================================================================

   /*!
   @function compute( $frequency )
   @param $frequency - a Frequency
   @discussion - computes a Priority level based solely on
      Frequency
   @result - returns a Priority
   */

   /* static */
   function &compute( &$frequency )
   {
      $score = ( 0.5 * $frequency->getScore() );

      return Priority::getFromPrimaryID(
         floor( $score * ( MAX_PRIORITY - MIN_PRIORITY ) ) + MIN_PRIORITY );
   }

//========================================================================

   /*!
   @function getTable()
   */

   function getTable()
   {
      return 'priority';
   }

//========================================================================

   /*!
   @function getDefaultOrderBy()
   */

   function getDefaultOrderBy()
   {
      return 'name DESC';
   }

//========================================================================

};

?>