<?php

/*
RecentItemSet
$Author: millz $
$Revision: 1.2 $
$Date: 2004/01/19 19:48:22 $
$Log: RecentItemSet.php,v $
Revision 1.2  2004/01/19 19:48:22  millz
- fix for addDevelItem

Revision 1.1  2004/01/06 15:38:14  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

importClass( 'Shared.AConfigWrappingItem' );

//========================================================================

    define( 'MAX_RECENT_ITEMS', 40 );

//========================================================================

/*!
@class RecentItemSet
@abstract - 
*/

class RecentItemSet extends AConfigWrappingItem
{

//========================================================================

   var $ids;

//========================================================================

    /*!
    @function RecentItemSet()
    @discussion - constructs a new RecentItemSet object
    @result - constructs a new RecentItemSet object
    */
   
    function RecentItemSet( &$config )
    {
        $this->AConfigWrappingItem( $config );
        // $this->ids =& $config->getValueRef();
    }
    
//========================================================================

    /*!
    @function &getPrototype()
    */
    /* static */
    function &getPrototype()
    {
      return AConfigWrappingItem::_getPrototype( __FILE__ );
    }
    
//========================================================================

    /*!
    @function &getFromPrimaryID( $id )
    */
    /*static*/
    function &getFromPrimaryID( $id )
    {
        $proto =& RecentItemSet::getPrototype();
        $iter =& $proto->doIDSearch( array( $id ) );
        
        $iter->reset();
        return $iter->getCurrent();
    }    
    
//========================================================================

    /*!
    @function _getConfigType()
    */
    function _getConfigType()
    {
        return 'recentItemSet';
    }
    
//========================================================================

    /*!
    @function getDevelopmentItemIds()
    */
    function getDevelopmentItemIds()
    {
        return array_keys( $this->config->getValue() );
    }
    
//========================================================================

    /*!
    @function addDevelopmentItem( &$devItem )
    */
    function addDevelopmentItem( &$devItem )
    {
        $idSet = $this->config->getValue();
        
        unset( $idSet{ $devItem->getPrimaryID() } );
        $idSet{ $devItem->getPrimaryID() } = time();  // we may want to know the time viewed later

        // array_shift was NOT preserving keys - which would hose the value set
        // so this weirdness was done to preserve keys and reduce size to MAX_RECENT_ITEMS
        // ALL the TRUEs are there to preserve
        $tempArray = array_chunk( array_reverse( $idSet, true ), MAX_RECENT_ITEMS, true);
        $idSet = array_reverse( $tempArray[0], true );

        $this->config->setValue( $idSet );
    }
    
//========================================================================

    /*!
    @function addDevelopmentItems( &$iter )
    */
    function addDevelopmentItems( &$iter )
    {
        $iter->reset();
        
        for( $iter->reset(); ! $iter->isEnd(); $iter->moveNext() )
        {
            $devItem =& $iter->getCurrent();
            $this->addDevelopmentItem( $devItem );
        }

    }
    
//========================================================================

    /*!
    @function removeDevelopmentItem( &$devItem )
    */
    function removeDevelopmentItem( &$devItem )
    {
        $idSet = $this->config->getValue();
        unset( $idSet{ $devItem->getPrimaryID() } );
        $this->config->setValue( $idSet );
    }
    
//========================================================================

    /*!
    @function removeDevelopmentItems( &$iter )
    */
    function removeDevelopmentItems( &$iter )
    {
        $idSet = $this->config->getValue();
        
        for( $iter->reset(); ! $iter->isEnd(); $iter->moveNext() )
        {
            $devItem =& $iter->getCurrent();
            unset( $idSet{ $devItem->getPrimaryID() } );
        }
        
        $this->config->setValue( $idSet );
    }
    
//========================================================================

    /*!
    @function getCount()
    */
    function getCount()
    {
        return count( $this->config->getValue() );
    }
    
//========================================================================

    /*!
    @function &getDevelomentIDIterator()
    */
    function &getDevelomentIDIterator()
    {
        importClass( 'Collections.IteratorFactory' );
        return IteratorFactory::getHashIterator( array_reverse( $this->config->getValue(), true ) );
    }

//========================================================================

    /*!
    @function &getDevelomentItemIterator()
    */
    function &getDevelomentItemIterator()
    {
        importClass( 'Bugs.ADevelopmentItem' );
        $proto =& ADevelopmentItem::getPrototype();
        return $proto->doIDSearch( array_keys( $this->config->getValue() ) );
    }
    
//========================================================================

    /*!
    @function &createNew()
    */
    function &createNew()
    {
        return new RecentItemSet( toRef( NULL ) );
    }
    
//========================================================================
    
    /*!
    @function &_createConfig()
    */
    function &_createConfig()
    {
        importClass( 'Shared.Config' );
        return Config::staticCreateNew( $this->_getConfigType(), array() );
    } 
    
//========================================================================

};

?>