<?php

/*
SaveCountsExecutable
$Author: millz $
$Revision: 1.4 $
$Date: 2003/12/11 18:09:10 $
$Log: SaveCountsExecutable.php,v $
Revision 1.4  2003/12/11 18:09:10  millz
- dealing with multiple runs on the same day

Revision 1.3  2003/09/03 14:16:57  dougqh
- Correcting header comments

Revision 1.2  2003/07/29 15:44:55  dougqh
- millz - added cache handling logic

Revision 1.1  2003/07/10 13:14:11  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'Executable.Executable' );

//========================================================================

/*!
@class SaveCountsExecutable
@abstract -
*/

class SaveCountsExecutable extends Executable
{

//========================================================================

   /*!
   @function SaveCountsExecutable( $argumentsHash )
   @param $argumentsHash - a hash of arguments used to run this Executable
      Keys are argument names
      Values are argument values.
   @discussion - constructs a new SaveCountsExecutable object
   @result - constructs a new SaveCountsExecutable object
   */

   function SaveCountsExecutable( $argumentsHash = UNSPECIFIED )
   {
      $this->Executable( $argumentsHash );
   }

//========================================================================

   /*!
   @function getArguments()
   @discussion - no arguments needed
   @result - return an empty array
   */

   function getArguments()
   {
      return array();
   }

//========================================================================

   /*!
   @function _execute()
   */

   function _execute()
   {

      importClass( 'Database.DBConnectionProvider' );
      $dbcon =& DBConnectionProvider::getConnection();

      $timeToUse = time();

      print '--------------------------' . BR_NL;

      $sql = 'SELECT statcolumn_id, name FROM statcolumn';

      $columnResultSet = $dbcon->GetAll( $sql );

      importClass( 'Database.StandardCacheHandler' );
      $cacheHandler =& StandardCacheHandler::create( 'stathistory' );
      $cacheHandler->markAllDirty();


      // remove entries that have the same date as now() (day only, not time)
      // kill where date_in greater than the previous midnight
      $date = $dbcon->DBDate( date ( 'Y-m-d', $timeToUse ) );
      $deleteSQL = 'delete from stathistory where date_in > '.$date;
      print $deleteSQL.BR_NL;
      $dbcon->Execute( $deleteSQL );


      foreach( $columnResultSet as $colEntry )
      {

         // alias name cannot be same as that used in group by
         $sql =
            'SELECT COUNT(*) count, MAX(project_id) proj_id,' .
            ' MAX('.  $colEntry{ 'name' }. ') col_value, ' .
            '\'' . $colEntry{ 'statcolumn_id' } . '\' statcolumn_id ' .
            'FROM report ' .
            'GROUP BY ' . $colEntry{ 'name' } . ' , project_id';
         print $sql .NL;

         $recordSetArray = $dbcon->GetAll($sql);

         if ( ! $recordSetArray )
         {
            unreachablePoint( 'Unable to run '.$sql.': '. $dbcon->ErrorMsg() );
         }

         // Select an empty record from the database
         $sql = 'SELECT * FROM stathistory WHERE stathistory_id = -1';

         $rs = $dbcon->Execute($sql); // Execute the query and get the empty recordset



         foreach( $recordSetArray as $recordSet )
         {
            $record = array(); // Initialize an array to hold the record data to insert

            // Set the values for the fields in the record
            // Note that field names are case-insensitive
            $record{ 'value' } = $recordSet{ 'col_value' };
            $record{ 'count' } = $recordSet{ 'count' };
            $record{ 'project_id' } = $recordSet{ 'proj_id' };
            $record{ 'date_in' } = $timeToUse;
            $record{ 'statcolumn_id' } = $recordSet{ 'statcolumn_id' };

            // Pass the empty recordset and the array containing the data to insert
            // into the GetInsertSQL function. The function will process the data and return
            // a fully formatted insert sql statement.
            $insertSQL = $dbcon->GetInsertSQL($rs, $record);
            print $insertSQL . NL;
            $dbcon->Execute( $insertSQL ); // Insert the record into the database
         }
      }
   }

//========================================================================

};

?>