<?php

/*
StandardVersionFormatter
$Author: millz $
$Revision: 1.2 $
$Date: 2003/12/17 21:37:13 $
$Log: StandardVersionFormatter.php,v $
Revision 1.2  2003/12/17 21:37:13  millz
- removing duplicate preg_split logic

Revision 1.1  2003/09/29 17:02:08  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'Bugs.AVersionFormatter' );

//========================================================================

/*!
@class StandardVersionFormatter
*/

class StandardVersionFormatter extends AVersionFormatter
{

//========================================================================

   /*!
   @function StandardVersionFormatter( $digitSpecs )
   @param $digitSpecs - unsigned int[] - specifies the number of digits
      required for each portion of the version format
      Must contain at least one element.

      Only the first position is allowed to exceed the specified number of
      digits.
   */

   function StandardVersionFormatter( $digitSpecs )
   {
      $this->AVersionFormatter();

      $this->digitSpecs = $digitSpecs;

      $format = '%' . $this->digitSpecs[ 0 ] . 'd';
      for ( $i = 1; $i < count( $this->digitSpecs ); ++$i )
      {
         $format .= '.%0' . $this->digitSpecs[ $i ] . 'd';
      }

      $this->sprintfCall = '$result = sprintf( \'' . $format . '\'';
      for ( $i = 0; $i < count( $this->digitSpecs ); ++$i )
      {
         $this->sprintfCall .= ', $parts[' . $i . ']';
      }
      $this->sprintfCall .= ');';
   }

//========================================================================

   /*!
   @function create( $numMajorDigits, [ $numMinorDigits, [ $numRevDigits ] ] )
   @param $numMajorDigits - an unsigned int
   @param $numMinorDigits - an unsigned int - number of digits required for
      the minor number

      If ommitted then there is no minor number.

   @param $numRevDigits - an unsigned int - number of digits required for
      the revision number

      If ommitted then there is no revision number.
   @discussion - provides a StandardVersionFormatter that major, minor, revision
      format checking
   @result - returns a boolean
   */

   function &create( $numMajorDigits, $numMinorDigits = UNSPECIFIED, $numRevDigits = UNSPECIFIED )
   {
      $digitSpecs[] = $numMajorDigits;
      if ( $numMinorDigits ) $digitSpecs[] = $numMinorDigits;
      if ( $numRevDigits ) $digitSpecs[] = $numRevDigits;

      return new StandardVersionFormatter( $digitSpecs );
   }

//========================================================================

   /*!
   @function _isValid( $string )
   */

   function _isValid( $string )
   {
      $parts = getNumericIDArrayFromString( $string );

      //print_r( $parts );

      if ( count( $parts ) != count( $this->digitSpecs ) )
      {
         return false;
      }

      //The first portion is allowed to be grow, so start at the second
      for ( $i = 1; $i < count( $this->digitSpecs ); ++$i )
      {
         //log10 roughly provides number digits needed for the current part
         //if its greater than or equal to the number digits allowed then its a no go
         //why >= ?
         //Consider 1000 with digit limit 3
         //log10( 1000 ) = 3, but 1000 takes four digits to display
         if ( log10( intval( $parts[ $i ] ) ) >= $this->digitSpecs[ $i ] ) return false;
      }

      return true;
   }

//========================================================================

   /*!
   @function format( $string )
   @discussion - produces the format specified at construction with
      "." separating the portions of the version number
   */

   function format( $string )
   {
      $parts = getNumericIDArrayFromString( $string );
      eval( $this->sprintfCall );
      return $result;
   }


//========================================================================

};

?>