<?php

/*
State
$Author: dawn $
$Revision: 1.5 $
$Date: 2004/04/27 15:23:15 $
$Log: State.php,v $
Revision 1.5  2004/04/27 15:23:15  dawn
- FR 3228: added submitted-reopened state to notifyTester

Revision 1.4  2004/03/17 20:55:11  dawn
- added notifyQALeads function

Revision 1.3  2003/12/18 20:40:41  dougqh
Updated to work under PHP 4.2

Revision 1.2  2003/08/05 03:02:53  millz
- added getTaskClosingStates

Revision 1.1  2003/07/09 20:34:36  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

importClass( 'Database.ATrivialDatabaseItem' );

//TODO: Name the constants in a more consistent fashion
define( 'SUBMITTED_NEW_STATE_ID', 200 );
define( 'SUBMITTED_MORE_INFORMATION_GIVEN_STATE_ID', 201  );
define( 'SUBMITTED_REOPENED_STATE_ID', 202 );
define( 'SUBMITTED_REVIEWED_STATE_ID', 203 );
define( 'SUBMITTED_ASSIGNED_STATE_ID', 204 );
define( 'UNDER_DEVELOPMENT_ASSIGNED_STATE_ID', 210 );
define( 'UNDER_DEVELOPMENT_MORE_INFO_GIVEN_STATE_ID', 211  );
define( 'UNDER_DEVELOPMENT_FIX_FAILED_STATE_ID', 212 );
define( 'VERIFICATION_REQUESTED_STATE_ID', 220 );
define( 'DESIGNER_NEEDS_MORE_INFO_STATE_ID', 230 );
define( 'NOT_REPRODUCIBLE_STATE_ID', 231 );
define( 'DEVELOPER_NEEDS_MORE_INFO_STATE_ID', 232 );
define( 'CLOSED_FIXED_STATE_ID', 240 );
define( 'CLOSED_DUPLICATE_STATE_ID', 241 );
define( 'WILL_NOT_IMPLEMENT_STATE_ID', 242 );
define( 'ERRATA_STATE_ID', 243 );
define( 'CLOSED_TASK_COMPLETED_STATE_ID', 244 );
define( 'NOT_A_BUG_STATE_ID', 245 );
define( 'CLOSED_NOT_REPRODUCIBLE_STATE_ID', 246 );



class State extends ATrivialDatabaseItem
{

//========================================================================

   /*!
   @function State()
   @discussion /*!
   @discussion - constructor for the state database item
   */

   function State( $primary_id = UNSPECIFIED )
   {
      $this->ATrivialDatabaseItem( $primary_id );
   }

//========================================================================

   /*!
   @function getPrototype()
   @discussion - provides the State prototype
   */

   /* static */
   function &getPrototype()
   {
      return State::_getPrototype( __FILE__ );
   }

//========================================================================

   /*!
   @function getTaskClosingStates()
   @discussion - provides the State prototype
   @result - an iterator for all task Closing states
   */

   /* static */
   function getTaskClosingStates()
   {
      $proto =& State::getPrototype();
      return $proto->doSearch(
            'state_id=?',
            array( CLOSED_TASK_COMPLETED_STATE_ID ) );
   }

//========================================================================

   /*!
   @function getFromPrimaryID( $primary_id )
   */

   /* static */
   function &getFromPrimaryID( $primary_id )
   {
      return State::_getFromPrimaryID(
         State::getPrototype(),
         $primary_id );
   }

//========================================================================

   /*!
   @function isAssigned()
   @discussion - indicates if this is an "assigned" State
   @result - returns a boolean
   */

   function isAssigned()
   {
      return ( $this->getPrimaryID() == UNDER_DEVELOPMENT_ASSIGNED_STATE_ID ||
               $this->getPrimaryID() == SUBMITTED_ASSIGNED_STATE_ID);
   }

//========================================================================

   /*!
   @function isUnderDevelopment()
   @discussion - indicates if this an "Under Development" State
   @result - returns a boolean
   */

   function isUnderDevelopment()
   {
      return ( $this->getPrimaryID() >= UNDER_DEVELOPMENT_ASSIGNED_STATE_ID &&
               $this->getPrimaryID() <= UNDER_DEVELOPMENT_FIX_FAILED_STATE_ID  );
   }

//========================================================================

   /*!
   @funciton isSubmitted()
   @discussion - indicates if this is a NEWLY "Submitted" State
   @result - returns a boolean
   */

   function isSubmitted()
   {
      return ( $this->getPrimaryID() >= SUBMITTED_NEW_STATE_ID &&
               $this->getPrimaryID() <= SUBMITTED_REOPENED_STATE_ID  );
   }

//========================================================================

   /*!
   @function isMoreInfoNeeded()
   @discussion - indicates if this is a "More Info Needed" State
   @result - returns a boolean
   */

   function isMoreInfoNeeded()
   {
      return ( $this->getPrimaryID() == DESIGNER_NEEDS_MORE_INFO_STATE_ID ||
               $this->getPrimaryID() == DEVELOPER_NEEDS_MORE_INFO_STATE_ID  );
   }

//========================================================================

   /*!
   @function isClosed()
   @discussion - indicates if this State is a "Closed" State
   @result - returns a boolean
   */

   function isClosed()
   {
      return ( $this->getPrimaryID() >= CLOSED_FIXED_STATE_ID );
   }

//========================================================================

   /*!
   @function _getActiveStateWherePair()
   @discussion - provides a where pair that list active States
   @result - returns a WherePair
   */

   function _getActiveStateWherePair()
   {
      //TODO: See if an array can be bound
      return array(
         'state_id < ? ',
         array( CLOSED_FIXED_STATE_ID ) );
   }

//========================================================================

   /*!
   @function _getActiveNonVRStateWherePair()
   @discussion - provides a where pair that list active States
   @result - returns a WherePair
   */

   function _getActiveNonVRStateWherePair()
   {
      //TODO: See if an array can be bound
      return array(
         'state_id < ? AND state_id!=?',
         array( CLOSED_FIXED_STATE_ID, VERIFICATION_REQUESTED_STATE_ID ) );
   }

//========================================================================

   /*!
   @function getDefaultOrderBy()
   @discussion - returns a string for the column(s) to order by and
      in what direction

      Do NOT prefix the String with 'ORDER BY' that will be done
      automatically.
   @result - String
   */

   function getDefaultOrderBy()
   {
      return $this->getPrimaryColumn();
   }

//========================================================================

   /*!
   @function getTable()
   @discussion - returns the table that this class gets its data from
   @return - returns a string
   */

   function getTable()
   {
      return 'state';
   }

//========================================================================

   /*!
   @function getQAClosingStates()
   @discussion - provides the set of viable states that QA may
      place an ADevelopmentItem into from "Verification Requested"
   @result - returns an IIterator< State >
   */

   /* static */
   function &getQAClosingStates()
   {
      $proto =& State::getPrototype();
      return $proto->doSearch(
         'state_id IN (?,?)',
         array(
            CLOSED_FIXED_STATE_ID,
            CLOSED_NOT_REPRODUCIBLE_STATE_ID ) );
   }

//========================================================================

   /*!
   @function getDesignerCloseStates()
   @discussion - provides the set of closing states that a designer may
      use
   @result - returns an IIterator< State >
   */

   function &getDesignerCloseStates()
   {
      $proto =& State::getPrototype();
      return $proto->doSearch(
         'state_id IN (?,?,?,?)',
         array(
            WILL_NOT_IMPLEMENT_STATE_ID,
            ERRATA_STATE_ID,
            NOT_A_BUG_STATE_ID,
            CLOSED_DUPLICATE_STATE_ID ) );
   }

//========================================================================

   /*!
   @function notifyDesigners()
   @discussion - indicates if the designer should be notified when
      an ADevelopmentItem is placed in this State
   @result - returns a boolean
   */

   function notifyDesigners()
   {
      return ( $this->isSubmitted() ||
               $this->getPrimaryID() == UNDER_DEVELOPMENT_ASSIGNED_STATE_ID ||
               $this->isClosed() );
      //return true;
   }

//========================================================================

   /*!
   @function notifyDeveloper()
   @discussion - indicates if the developer should be notified when
      an ADevelopmentItem is placed in this State
   @result - returns a boolean
   */

   function notifyDeveloper()
   {
      //TODO: Fill these out as appropriate
      return ( $this->getPrimaryID() == SUBMITTED_ASSIGNED_STATE_ID ||
               $this->getPrimaryID() == UNDER_DEVELOPMENT_MORE_INFO_GIVEN_STATE_ID ||
               $this->getPrimaryID() == UNDER_DEVELOPMENT_FIX_FAILED_STATE_ID ||
               $this->isClosed() );
      //return true;
   }

//========================================================================

   /*!
   @function notifyTester()
   @discussion - indicates if the tester should be notified when
      an ADevelopmentItem is placed in this State
   @result - returns a boolean
   */

   function notifyTester()
   {
      //TODO: Fill these out as appropriate
      return ( $this->isClosed() ||
               $this->getPrimaryID() == VERIFICATION_REQUESTED_STATE_ID ||
               $this->isMoreInfoNeeded() ||
               $this->getPrimaryID() == SUBMITTED_REVIEWED_STATE_ID ||
               $this->getPrimaryID() == SUBMITTED_REOPENED_STATE_ID );
      //return true;
   }

//========================================================================

   /*!
   @function notifyQALeads()
   @discussion - indicates if the QA Leads should be notified when
      an ADevelopmentItem is placed in this State
   @result - returns a boolean
   */

   function notifyQALeads()
   {
      return ( $this->getPrimaryID() == SUBMITTED_NEW_STATE_ID ||
               $this->getPrimaryID() == SUBMITTED_REOPENED_STATE_ID ||
               $this->getPrimaryID() == VERIFICATION_REQUESTED_STATE_ID ||
               $this->isClosed() );
   }

//========================================================================

};

?>