<?php

/*
Task
$Author: dougqh $
$Revision: 1.4 $
$Date: 2003/11/04 15:49:40 $
$Log: Task.php,v $
Revision 1.4  2003/11/04 15:49:40  dougqh
- Fixing 3750

Revision 1.3  2003/08/05 14:00:55  dougqh
- Spelling correct in the method name getVerificationStates

Revision 1.2  2003/08/05 03:01:42  millz
- worked on task logic

Revision 1.1  2003/07/09 20:34:36  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'Bugs.ADevelopmentItem' );

//========================================================================

/*!
@class Task
@abstract -
*/

class Task extends ADevelopmentItem
{

//========================================================================

   /*!
   @function Task()
   @discussion - constructs a new Task object
   @result - constructs a new Task object
   */

   function Task( $primary_id = UNSPECIFIED )
   {
      $this->ADevelopmentItem( $primary_id );
   }

//========================================================================

   /*!
   @function canVerify( &$user )
   */

   function canVerify( &$user )
   {
      return $this->canBeTester( $user );
   }

//========================================================================

   /*!
   @function canBeTester( $user )
   */

   function canBeTester( &$user )
   {
      $project =& $this->getProject();
      return $project->isDesigner( $user );
   }

//========================================================================

   /*!
   @function &getVerificationStates()
   @discussion -
   @result - returns Iterator of state objs
   */

   function &getVerificationStates()
   {
      importClass( 'Bugs.State' );
      return State::getTaskClosingStates();
   }

//========================================================================

   /*!
   @function _getDefaultTester( )
   @discussion - returns user to act as the default tester for this issue
            the Project must be set
            before &_getDefaultTester is called.
   @result - returns a user obj
   */

   function &_getDefaultTester()
   {
         unreachablePoint( 'Bugs.Task::_getDefaultTester() -> Task not submitted by designer' );
   }

//========================================================================

   /*!
   @function getReportType()
   @discussion - a normal get function
   @result - returns report type string for this object
   */

   function getReportType()
   {
      return 'Task';
   }

//========================================================================

   /*!
   @function _getReportTypeID()
   @discussion - provides the reporttype_id for this
      ADevelopmentItem
   @result - returns a RowID
   */

   function _getReportTypeID()
   {
      return TASK_ID;
   }

//========================================================================

};

?>