<?php

/*
AIteratorView
$Author: dougqh $
$Revision: 1.3 $
$Date: 2003/12/18 20:43:29 $
$Log: AIteratorView.php,v $
Revision 1.3  2003/12/18 20:43:29  dougqh
- Updated to work under PHP 4.2

Revision 1.2  2003/12/17 14:41:36  dougqh
- 3910

Revision 1.1  2003/07/09 21:48:28  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

importClass( 'BugUI.AView' );

class AIteratorView extends AView
{

//========================================================================

   var $iterator;

//========================================================================

   /*!
   @function AIteratorView()
   @discussion - AIteratorView cunstructor
   */

   function AIteratorView( $ignoreRequest = false )
   {
      $this->AView();

      if ( ! $ignoreRequest )
      {
         importClass( 'Database.QueryResultsIterator' );
         $this->setIterator(
            QueryResultsIterator::createFromRequest( $this->_getPrototype() ) );
      }
   }

//========================================================================

   /*!
   @function setIterator( &$iterator )
   @param $iterator - an IIterator
   @discussion - sets the IIterator for this View
   */

   function setIterator( &$iterator )
   {
      $this->iterator =& $iterator;
   }

//========================================================================

   /*!
   @function _getPrototype()
   @discussion - provides an ADatabaseItem prototype
   @result - returns an ADatabaseItem
   */

   /* abstract function &_getPrototype(); */

//========================================================================

   /*!
   @function getNumRows()
   @discussion - provides an integer containing the maximum number
      of rows to display
   @result - returns an integer
   */

   /* abstract function getNumRows(); */

//========================================================================

   /*!
   @function getHTML()
   @discussion - generates html
   @return - returns string of raw html
   */

   function getHTML()
   {
      $this->_startHTMLGeneration();

      $maxCount = $this->getNumRows();

      for (
         $this->iterator->reset(), $count = 0;
         ! $this->iterator->isEnd() && $count < $maxCount;
         $this->iterator->moveNext(), ++$count )
      {

         $this->_handleCurrent( $this->iterator->getCurrent() );
      }

      return $this->_getGeneratedHTML();
   }

//========================================================================

   /*!
   @function _startHTMLGeneration
   @discussion - called before the iteration is started to
      prepare for the HTML generation
   */

   /* abstract function _startHTMLGeneration(); */

//========================================================================

   /*!
   @function _handleCurrent( $object )
   @param $object - an Object of the type provided by the IIterator
   @discussion - called for each Object provided by the IIterator
      in a loop
   */

   /* abstract function _handleCurrent( &$object ); */

//========================================================================

   /*!
   @function _getGeneratedHTML()
   @discussion - called after the iteration is complete to
      get the HTML that has been produced and to do any necessary
      clean-up
   @result - returns a String of HTML
   */

   /* abstract function _getGeneratedHTML(); */

//========================================================================

   /*!
   @function getParameters()
   */

   function getParameters()
   {
      return $this->iterator->getParameters();
   }

//========================================================================

};

?>