<?php

/*
IteratorSelectComponent
$Author: dougqh $
$Revision: 1.2 $
$Date: 2003/10/21 15:13:25 $
$Log: IteratorSelectComponent.php,v $
Revision 1.2  2003/10/21 15:13:25  dougqh
- Added support for a no selection entry

Revision 1.1  2003/07/09 21:49:36  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

importClass( 'HTMLComponents.AHTMLComponent' );

//========================================================================

//imported early for its constants
importClass( 'HTMLComponents.LightForms.SelectComponent' );

//========================================================================

define( 'NO_SELECT_VALUE', '' );
define( 'NULL_SELECT_VALUE', 'nil' );

//========================================================================

class IteratorSelectComponent extends AHTMLComponent
{

//========================================================================

   /*!
   @function IteratorSelectComponent( $iterator, $name, $isMultiple, [ $nullLabel ] )
   @param $iterator - IIterator of ADatabaseItems
   @param $name - a String
   @param $isMultiple - a boolean
   @param $nullLabel - optional label for a NULL item - if not provided no null will be added
   @param $noSelectLabel -
   @discussion IteratorSelectComponent constructor
   */

   function IteratorSelectComponent(
      &$iterator,
      $name,
      $isMultiple,
      $nullLabel = UNSPECIFIED,
      $noSelectLabel = UNSPECIFIED )
   {
      $this->iterator =& $iterator;
      $this->name = $name;
      $this->isMultiple = $isMultiple;

      $this->nullLabel = ( $nullLabel === UNSPECIFIED ) ? '' : $nullLabel;

      $this->noSelectLabel = ( $noSelectLabel === UNSPECIFIED ) ? '' : $noSelectLabel;
      $this->issetSelected = false;

      $this->onChange = NULL;
   }

//========================================================================

   /*!
   @function setSelected( $object )
   @param $object - an Object
   @discussison - sets the selected Object
      Can be set to NULL if no item should be selected.
   */

   function setSelected( &$object )
   {
      $this->issetSelected = true;
      $this->selectedObject =& $object;
   }

//========================================================================

   /*!
   @function setOnChange( $onChangeText )
   @param $onChangeText - text for the onChange event
   @discussison -
   */

   function setOnChange( $onChangeText )
   {
      $this->onChange = $onChangeText;
   }

//========================================================================

   /*!
   @function getName()
   @discussion - returns the name of the IteratorSelectComponent
   @return - returns a string, name of IteratorSelectComponent
   */

   function getName()
   {
      return $this->name;
   }

//========================================================================

   /*!
   @function getHTML()
   @discussion gets the html for a select form field using a database entry
   */

   function getHTML()
   {
      //imported at top of file - for its constants
      $select =& new SelectComponent(
         $this->getName(),
         $this->isMultiple );

      $select->setRequestedDimensions( $this->getDimensions() );

      if ( ! empty( $this->noSelectLabel ) )
      {
         //TODO: clean up convoluted boolean condition
         $select->addOption(
            '',
            $this->noSelectLabel,
            ! $this->issetSelected );
      }

      if ( ! empty( $this->nullLabel ) )
      {
         $nullSelected =
            $this->issetSelected &&
               ( $this->selectedObject === NULL ||
                 $this->selectedObject->isNull() );

         $select->addOption(
            NO_SELECT_VALUE,
            $this->nullLabel,
            $nullSelected );
      }

      $count = 0;
      for (
         $this->iterator->reset();
         ! $this->iterator->isEnd();
         $this->iterator->moveNext() )
      {
         $cur =& $this->iterator->getCurrent();

         $selected = $this->issetSelected &&
            compare::equals( $cur, $this->selectedObject );

         //add to SelectComponent
         //label is getIdentifyingString() value is the primary_id
         $val = $cur->getPrimaryID();
         $select->addOption(
            $val,
            $cur->getIdentifyingString(),
            $selected );
      }

      if ( $this->onChange != '' && $this->onChange != NULL )
      {
         $select->setOnChange( $this->onChange );
      }

      return $select->getHTML();
   }

//========================================================================

};

?>