<?php

/*
IteratorFactory
$Author: dougqh $
$Revision: 1.4 $
$Date: 2004/01/07 21:50:39 $
$Log: IteratorFactory.php,v $
Revision 1.4  2004/01/07 21:50:39  dougqh
- Better error message when calling unreachablePoint

Revision 1.3  2004/01/06 15:45:29  millz
- added getConstructorIter

Revision 1.2  2003/10/21 13:56:48  dougqh
Added support for ScalarIterator

Revision 1.1  2003/10/21 13:16:06  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

/*!
@class IteratorFactory
@abstract -
*/

class IteratorFactory extends Object
{

//========================================================================

   /*!
   @function IteratorFactory()
   */

   function IteratorFactory()
   {
      unreachablePoint(
         'IteratorFactory is a utility class and should NOT be instantiated' );
   }

//========================================================================

   /*!
   @function getNullIterator()
   @discussion - provides an empty IIterator
   @result - returns an IIterator
   */

   function &getNullIterator()
   {
      static $instanceArray;

      if ( is_null( $instanceArray ) )
      {
         importClass( 'Collections.NullIterator' );
         $instanceArray[ 0 ] =& new NullIterator();
      }

      return $instanceArray[ 0 ];
   }

//========================================================================

   /*!
   @function getHashIterator( $hash )
   @param $hash - an array / hash
   @discussion - creates an IIterator accross the items in
      the array / hash
   @result - returns an IIterator
   */

   /* static */
   function &getHashIterator( &$hash )
   {
      if ( empty( $hash ) )
      {
         return IteratorFactory::getNullIterator();
      }
      else
      {
         importClass( 'Collections.HashIterator' );
         return new HashIterator( $hash );
      }
   }

//========================================================================

   /*!
   @function getMergeIterator( $iterators )
   @param $iterators - an array of IIterators
   @discussion - provides an IIterator that iterates accross the
      elements in all the provided IIterators
   @result - returns an IIterator
   */

   /* static */
   function &getMergeIterator( &$iterators )
   {
      importClass( 'Collections.MergeIterator' );
      return new MergeIterator( $iterators );
   }

//========================================================================

   /*!
   @function getMergeIterator2( $iter0, $iter1 )
   @param $iter0 - an IIterator
   @param $iter1 - an IIterator
   @discussion - provides an IIterator accross the elemenets in iter0
      and iter1
   @result - returns an IIterator
   */

   /* static */
   function &getMergeIterator2( &$iter0, &$iter1 )
   {
      $iters = array();
      $iters[ 0 ] =& $iter0;
      $iters[ 1 ] =& $iter1;

      importClass( 'Collections.MergeIterator' );
      return new MergeIterator( $iters );
   }

//========================================================================

   /*!
   @function getMergeIterator3( $iter, $value )
   @param $iter - an IIterator< T >
   @param $value - a value of type T
   @discussion - provides an IIterator that provides all the
      elements in iter and then provides value
   @result - returns an IIterator
   */

   function &getMergeIterator3( &$iter, &$value )
   {
      return IteratorFactory::getMergeIterator2(
         $iter,
         IteratorFactory::getScalarIterator( $value ) );
   }

//========================================================================

   /*!
   @function getConstructorIterator( $className, &$iter )
   @result - returns an IIterator that will return $className objects with each
            element of the iter being passed to the constructor of the className
   */

   function &getConstructorIterator( $className, &$iter )
   {
      importClass( 'Collections.ConstructorIterator' );
      return new ConstructorIterator( $className, $iter );
   }


//========================================================================

   /*!
   @function getScalarIterator( $value )
   @param $value - Any
   @discussion - provides an IIterator whose sole element in
      $value
   @result - returns an IIterator
   */

   function &getScalarIterator( &$value )
   {
      importClass( 'Collections.ScalarIterator' );
      return new ScalarIterator( $value );
   }

//========================================================================

};

?>