<?php

/*
MergeIterator
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/10/21 13:16:06 $
$Log: MergeIterator.php,v $
Revision 1.1  2003/10/21 13:16:06  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'Collections.IIterator' );

//========================================================================

/*!
@class MergeIterator
@abstract - an IIterator that merges one or more IIterators
*/

class MergeIterator extends Object /* implements IIterator */
{

//========================================================================

   /*!
   @function MergeIterator()
   */

   function MergeIterator( &$iterators )
   {
      $this->Object();

      importClass( 'Collections.IteratorFactory' );
      $this->iterIter =& IteratorFactory::getHashIterator( $iterators );
   }

//========================================================================

   /*!
   @function reset()
   */

   function reset()
   {
      $this->iterIter->reset();

      //prime the member variables
      $this->curIter =& $this->iterIter->getCurrent();
      $this->curIter->reset();

      //checkCurIterator will be called by the other methods
   }

//========================================================================

   /*!
   @function _checkCurIterator()
   @discussion - helper method that handles getting the next
      current Iterator
   */

   function _checkCurIterator()
   {
      if ( $this->curIter->isEnd() )
      {
         $this->iterIter->moveNext();

         //have to find the next non-empty IIterator
         while ( ! $this->iterIter->isEnd() )
         {
            $this->curIter =& $this->iterIter->getCurrent();
            $this->curIter->reset();

            if ( $this->curIter->isEnd() )
            {
               $this->iterIter->moveNext();
            }
            else
            {
               break;
            }
         }
      }
   }

//========================================================================

   /*!
   @function isEnd()
   */

   function isEnd()
   {
      $this->_checkCurIterator();
      return $this->iterIter->isEnd();
   }

//========================================================================

   /*!
   @function moveNext()
   */

   function moveNext()
   {
      $this->_checkCurIterator();
      $this->curIter->moveNext();
   }

//========================================================================

   /*!
   @function getCurrent()
   */

   function &getCurrent()
   {
      $this->_checkCurIterator();
      return $this->curIter->getCurrent();
   }

//========================================================================

};

?>