<?php

/*
HeavyObject
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/10/20 21:01:13 $
$Log: HeavyObject.php,v $
Revision 1.1  2003/10/20 21:01:13  dougqh
Initial revision

Revision 1.16  2003/07/09 22:18:30  dougqh
Killed unnecessary member variables

Revision 1.15  2003/07/09 22:14:26  dougqh
Ported from GP and killed the unnecessary code

Revision 1.10  2002/12/13 13:53:59  millz
- added _clearExcludedVariablesCache

Revision 1.9  2002/10/18 21:39:06  dougqh
Hooking into the new systemMethods library.

Revision 1.8  2002/09/26 18:56:03  dougqh
Fixing bug in _createObjectLocators.

Revision 1.7  2002/09/25 21:33:35  dougqh
Removed caching because of problems with existing code.

Revision 1.6  2002/09/25 21:31:33  dougqh
Added some caching to _createObjectLocators.

Revision 1.5  2002/09/24 20:03:42  dougqh
Changing quotes to ticks.

Revision 1.4  2002/08/14 22:27:06  dougqh
Added invariant call to HeavyObject::_onDeserialize.

Revision 1.3  2002/08/13 13:31:59  dougqh
Modifications to work with new Serializer.

Revision 1.2  2002/08/05 15:03:49  dougqh
.

Revision 1.1  2002/07/23 18:49:00  dougqh
.

Revision 1.4  2002/07/18 17:44:48  dougqh
Added support getting a default ObjectLocator when ObjectLocator has
been set.
Added caching to getClass and getAbsoluteClass.
Added caching to speed up finalize re-registering.
Added caching to speed up wake for Objects without auto-recovered variables.

Revision 1.3  2002/07/12 13:44:30  dougqh
Comment out some debug statements.

Revision 1.2  2002/07/04 18:12:57  dougqh
Added _setAllowSerialized copies method. The functionality provided by this method is needed by ToolOperation.

Revision 1.1  2002/07/01 19:30:21  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importLibrary( 'systemMethods' );

//========================================================================

/*!
@class Object
@abstract - the abstract base class for all Objects
@discussion - This class defines the basic mechanisms for serializing
   and finalizing Objects.
*/

/* abstract */
class HeavyObject extends Object
{

//========================================================================

   /*!
   @function HeavyObject( [ $allowSerializedCopies ] )
   @param $allowSerializedCopies - a boolean indicating if this Object
      allows itself to be copied into multiple StorageGroups
      - defaults to false
   @discussion - constructs a new Object object
   @result - constructs a new Object object
   */

   function HeavyObject()
   {
      $this->Object();

      $this->changed = false;
      //Order of these three lines is important
      //Both hasFinalize and isRegisterFinalizeable must be set before calling
      //  _reregisterFinalizeable

      $this->_tryRegister();
   }

//========================================================================

   /*!
   @function _tryRegister()
   @discussion - registers this Object as implementing various system
      methods as appropriate
   */

   function _tryRegister()
   {
      deprecated( 'Object::_reregisterFinalizeable' );

      systemMethods::tryRegisterObject( $this );
   }

//========================================================================

   /*!
   @function _finalize()
   @discussion - invoked at script termination if defined by a child class
      NOTE: This method does not have to be defined.  It should NOT be
         defined unless this class needs to be finalized in some way.
   */

   /* abstract function _finalize(); */

//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */

   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>