<?php

/*
Cookie
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/29 15:12:43 $
$Log: Cookie.php,v $
Revision 1.1  2003/09/29 15:12:43  dougqh
Initial revision

Revision 1.2  2002/11/21 19:44:28  millz
updated to extend ScriptSingleton and updated the getInstance to work with that

Revision 1.1  2002/11/21 18:15:01  millz
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/


//========================================================================

define( 'GENEPORT_COOKIE_NAME', 'gpCookie' . VERSION_TYPE );
define( 'GENEPORT_COOKIE_LIFE', intval( 365.25 * 24 * 60 * 60 ) /* seconds - one year*/ );

//========================================================================

importClass( "Common.Utilities.ScriptSingleton" );

/*!
@class Cookie
@abstract - This class handles all management for Cookies in GenePort
*/
class Cookie extends ScriptSingleton
{

//========================================================================

   var $cookieContents;

//========================================================================

   /*!
   @function Cookie( )
   @discussion - constructs a new Cookie object
   @result - constructs a new Cookie object
   */
   
   function Cookie( )
   {
      //require
      {

      }
      //body
      {
             
         if( isset( $_COOKIE{ GENEPORT_COOKIE_NAME } ) )
         {
            $this->cookieContents = unserialize( $_COOKIE{ GENEPORT_COOKIE_NAME } );  
         }
         else
         {
            $this->cookieContents = new_hash();
         }
         
         $this->ScriptSingleton( 'Cookie' );
      }
      //ensure
      {
         assert( "\$this->_invariant()" );
      }
   }


//========================================================================

   /*!
   @function getInstance()
   @discussion - provides the instance of this ScriptSingleton
      NOTE: The child should define a getInstance that looks
         EXACTLY like this the commented out implementation below.         
   @result - returns the instance of this ScriptSingleton
   */   
   
 
   function &getInstance()
   {
      return ScriptSingleton::_getInstance( 'Cookie' );
   }

   
//========================================================================

   /*!
   @function isset( $_name )
   @param $_name - the name of the variable to test
   @discussion - see result
   @result - returns boolean to indicate if var is set in GP cookie
   */

   function isSetValue( $_name )
   {
      return isset ( $this->cookieContents{$_name} );
   }

//========================================================================

   /*!
   @function getValue( $_name )
   @param $_name - the name of the variable to get a value from
   @discussion - see result
   @result - returns the value of the variable named from the GP cookie
   */

   function getValue( $_name )
   {
      return $this->cookieContents{$_name};
   }

//========================================================================

   /*!
   @function setValue( $_name, $_value )
   @param $_name - the name of the variable to set as $_value
   @param $_value - the value to load into the var, cannot be an object!
   @discussion - saves change into the hash managed by this obj
   @result - nothing
   */

   function setValue( $_name, $_value )
   {
      {
         assert ( '! isInstanceOf($_value, "Object")' );
         assert ( '! isInstanceOf($_value, "Object[]")' );
         assert ( '! isInstanceOf($_value, "Object{}")' );
      }
      // print "Set value called: wanting $_name to equal $_value<br />";
      $this->cookieContents{$_name} = $_value;
   }

//========================================================================

   /*!
   @function _finalize( )
   @discussion - saves the current cookie value into the real client-side cookie (or at least tells PHP
      that we need to do so)
   @result - nothing
   */

   function _finalize( )
   {
     
      $serializedValue = serialize( $this->cookieContents );
     // print $serializedValue;
      //kill the old cookie
      setcookie( GENEPORT_COOKIE_NAME );      
      
      //create a new cookie
      $success = setcookie(
         GENEPORT_COOKIE_NAME,
         $serializedValue,
         time() + GENEPORT_COOKIE_LIFE,
         '/' );
      
      if ( ! $success )
      {
         print 'Saving the GENEPORT_COOKIE_NAME cookie failed in Common.Utils.Cookie::finalize() <br />';
      }     
//      else
//      {
//         print 'Saved entire cookie ';   
//      } 
         
      // not needed - $_COOKIE{ GENEPORT_COOKIE_NAME } = $serializedValue;
   }
   
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant() &&
            isInstanceOf($this->cookieContents, 'Any{}');
   }

//========================================================================

};

?>