<?php

/*
URL
$Author: dougqh $
$Revision: 1.2 $
$Date: 2003/09/29 18:13:50 $
$Log: URL.php,v $
Revision 1.2  2003/09/29 18:13:50  dougqh
- Replaced short PHP tag with long PHP tag

Revision 1.1  2003/09/29 15:12:43  dougqh
Initial revision

Revision 1.3  2002/09/24 22:08:49  dougqh
Changing quotes to ticks.

Revision 1.2  2002/09/16 16:09:28  dougqh
Fixed a typo

Revision 1.1  2002/07/01 19:44:57  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

define( 'NULL_URL', 'NULL_URL' );

//========================================================================

/*!
@class URL
@abstract - an object that represents a basic URL
*/

class URL extends Object
{
//========================================================================

   var $url;

   var $hasQuestionMark;

//========================================================================

   /*!
   @function URL( $url )
   @param $url - a string containing a URL
   @discussion - constructs a new URL whose base URL is $url
   @result - constructs a new URL object
   */

   function URL( $url )
   {
      $this->url = fileSlashesToURLSlashes( $url );

      $this->hasQuestionMark = ( strpos( $this->url, '?' ) !== false );

      $this->Object();
   }

//========================================================================

   /*!
   @function getNullURL()
   @discussion - provides a Null URL object
      Null URL objects return empty Strings from their getURLString and
      getAbsoluteURLString methods.  The isNull method also returns true.
   @result - returns a URL object
   */

   function &getNullURL()
   {
      static $GL_nullURL;

      if ( ! isset( $GL_nullURL ) )
      {
         $GL_nullURL = new URL( NULL_URL );
      }

      return $GL_nullURL;
   }

//========================================================================

   /*!
   @function addParameter( $parameterName, $value )
   @param $parameterName - the name of the parameter being added
   @param $value - a string containing a value to be added
   @discussion - adds an additional parameter to be passed through the
      GET of this URL

      NOTE: The value will be urlencoded by this method.
   */

   function addParameter( $parameterName, $value )
   {
      //require
      {
         assert( '$this->_invariant()' );
      }
      //body
      {
         if ( $this->hasQuestionMark )
         {
            $this->url .= '&';
         }
         else
         {
            $this->url .= '?';
            $this->hasQuestionMark = true;
         }

         $this->url .= $parameterName . '=' . urlencode( $value );
      }
      //ensure
      {
         assert( '$this->_invariant()' );
      }
   }

//========================================================================

   /*!
   @function getURLString()
   @discussion - provides a string representing this URL
   @result - returns a string containing this URL
   */

   function getURLString()
   {
      assert( '$this->_invariant()' );

      if ( $this->isNull() )
      {
         return '';
      }
      //else

      return $this->url;
   }

//========================================================================

   /*!
   @function getAbsoluteURLString()
   @discussion - provides a String containing the absolute URL represented
      by this URL object
   @result - returns a String containing an absolute URL
   */

   function getAbsoluteURLString()
   {
      assert( '$this->_invariant()' );

      if ( $this->isNull() )
      {
         return '';
      }
      //else

      return getAbsoluteURL( $this->url );
   }

//========================================================================

   /*!
   @function isNull()
   @discussion - indicates if this is a Null URL
   @result - returns true if this URL is "null"; otherwise returns false
   */

   function isNull()
   {
      assert( '$this->_invariant()' );

      return ( $this->url == NULL_URL );
   }

//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */

   function _invariant()
   {
      return ( $this->url != '' ) &&
             parent::_invariant();
   }

//========================================================================

};
