<?php

/*
ADatabaseItem
$Author: millz $
$Revision: 1.8 $
$Date: 2004/04/01 22:10:30 $
$Log: ADatabaseItem.php,v $
Revision 1.8  2004/04/01 22:10:30  millz
added  ability for the insert logic to avoid id conflicts

Revision 1.7  2004/03/17 22:35:26  millz
- n

Revision 1.6  2003/12/18 20:41:44  dougqh
Updated to work under PHP 4.2

Revision 1.5  2003/08/29 21:00:05  dougqh
- Remove constant definitions from this file - moved into configuration.php

Revision 1.4  2003/07/14 18:18:04  dawn
- Fix to empty array handling in doIDSearch.

Revision 1.3  2003/07/14 13:56:30  dougqh
- Changing printError calls to unreachablePoint calls.

Revision 1.2  2003/07/11 20:49:45  dougqh
- Profiling / trying out a fruitless speed-up

Revision 1.1  2003/07/09 21:57:17  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

if ( IS_DEVELOPMENT )
{
   define( 'SEQUENCE_PREFIX', 'test_' );
}
else
{
   define( 'SEQUENCE_PREFIX', '' );
}

define( 'SEQUENCE_SUFFIX', '_seq' );
define( 'ID_SUFFIX', '_id' );
define( 'MIN_ID', 1 );
define( 'NON_EXISTENT_ID', -1 );

//========================================================================

class ADatabaseItem extends Object
{

//========================================================================

   /*!
   @function ADatabaseItem( $primary_id )
   @param $primary_id - integer
   @discussion - constructs corresponding to a DB row
   */

   function ADatabaseItem( $primary_id = UNSPECIFIED )
   {
      $this->Object();

      if ( $primary_id === UNSPECIFIED )
      {
         $this->isNew = true;
      }
      else
      {
         $this->isNew = false;
         $this->primary_id = $primary_id;
      }

      $this->loadedData = false;
      $this->changed = false;

      $this->isNull = false;
   }

//========================================================================

   /*!
   @function createNew( [ $arguments ] )
   @discussion - can be called on the prototype to create a new instance
   */

   function &createNew( $arguments = array() )
   {
      $class = get_class( $this );
      return new $class();
   }

//========================================================================

   /*!
   @function getPrototype()
   @discussion - provides the prototypical instance of this class

      Usually implemented as ...

      function &getPrototype()
      {
         return <class>::_getPrototype( __FILE__ );
      }

   @result - returns an ADatabaseItem
   */

   /* abstract static function &getPrototype() */

//========================================================================

   /*!
   @function _getPrototype( $file )
   @param $file - a String containing a file name
      (from which a class name will be determined)
      - helper static method for use by child's getPrototype.
   @result - returns an ADatabaseItem
   */

   function &_getPrototype( $file )
   {
      $class = str_replace( '.php', '', getFileNameFromFullPath( $file ) );

      static $prototypesHash;

      if ( ! isset( $prototypesHash ) )
      {
         //initial assignmemnt by value to avoid GC
         $prototypesHash = array();
      }

      if ( ! isset( $prototypesHash{ $class } ) )
      {
         //can now use =& without worries about GC
         $prototypesHash{ $class } =& new $class();
      }

      return $prototypesHash{ $class };
   }

//========================================================================

   /*!
   @function _getFromPrimaryID( $prototype, $primary_id )
   @param $prototype - an ADatabaseItem
   @param $primary_id - a primary_id
   @discussion - constructs the object by using the prototype to
      create an ID-based query
   @result - returns an instance of the specified class
   */

   function &_getFromPrimaryID( &$prototype, $primary_id )
   {
      if ( isEmpty( $primary_id ) ) $primary_id = NULL;

      //TODO: Do not repeat this caching code which is also found
      // in getFromRecordSet

      static $dbItemsHash;

      $class = $prototype->getPrototypeClass();
      if ( ! isset( $dbItemsHash{ $class } ) )
      {
         //by value for the nested array
         $dbItemsHash{ $class } = array();
      }

      //guaranteed that dbItemsHash{ $class } isset
      if ( ! isset( $dbItemsHash{ $class }{ $primary_id } ) )
      {
         //print 'Cache Miss: ' . $class . ' ' . $primary_id . BR_NL;

         if ( $primary_id === NULL )
         {
            $dbItemsHash{ $class }{ $primary_id } =& $prototype->_createNullInstance();
            $dbItemsHash{ $class }{ $primary_id }->_markNull();
         }
         else
         {
            $iterator =&
               $prototype->doSearch(
                  $prototype->getPrimaryColumn() . '=?',
                  array( $primary_id ) );

            $iterator->reset();

            if ( $iterator->isEnd() )
            {
               $dbItemsHash{ $class }{ $primary_id } =& $prototype->_createNullInstance();
               $dbItemsHash{ $class }{ $primary_id }->_markNull();
            }
            else
            {
               //can use =& here without worrying about the GC
               $dbItemsHash{ $class }{ $primary_id } =& $iterator->getCurrent();
            }
         }
      }

      return $dbItemsHash{ $class }{ $primary_id };
   }

//========================================================================

   /*!
   @function _createNullInstance()
   @discussion - optional static method that constructs a "null" instance
      of the current class

      This method is called on a prototype by if the primary_id passed to
         _getFromPrimaryID isEmpty.

      Default implementation creates an instance by calling the default
      constructor of this class.

   @result - returns an instance of the class
   */

   function &_createNullInstance()
   {
      $class = $this->getPrototypeClass();
      return new $class();
   }

//========================================================================

   /*!
   @function getFromRecordSet( $hash )
   @param $hash - a hash of a data from a DB row
   @discussion - uses a hash of data from a record set to initialize
      create / find the appropriate instance

      Might override to use a lazy / cache loading system.
   @result - returns an ADatabaseItem
   */

   function &getFromRecordSet( &$hash )
   {
      $dbItem =& $this->_getFromRecordSet( $hash );
      $dbItem->_fillFromRecordSet( $hash );
      return $dbItem;
   }

//========================================================================

   /*!
   @function isNew()
   @discussion - indicates if this ADatabaseItem is a new ADatabaseItem
      that has not yet been stored in the database
   @result - returns a boolean
   */

   /* final */
   function isNew()
   {
      return $this->isNew;
   }

//========================================================================

   /*!
   @function delete()
   @discussion - will remove this item from the database
   @result - nothing
   */

   function delete()
   {
      // Add a delete method to ADatabaseItem
      if ( ! $this->isNew() )
      {
         //Produces and executes a
         //   DELETE FROM [this->getTable] WHERE [this->getPrimaryColumn] = [this->getPrimaryID]
         //Invalidates the cache
      }
   }

//========================================================================

   /*!
   @function isNull()
   @discussion - indicates if this ADatabaseItem is a null instance

      isNull is not final, but children overriding this method should
      call the parent instance.  If parent implementation indicates that
      the object isNull, then child implementation should also indicate
      that the object isNull.

      i.e.  Child should be something like ...
      return parent::isNull() || ...;

   @result - returns a boolean
   */

   function isNull()
   {
      return $this->isNull;
   }

//========================================================================

   /*!
   @function _markNull()
   @discussion - called to tag this ADatabaseItem as a null instance
   */

   function _markNull()
   {
      $this->isNull = true;
      $this->isNew = false;
   }

//========================================================================

   /*!
   @function _getMultipleRowCacheTime()
   @discussion - provides the number of seconds to cache data
   @result - returns an unsigned integer
   */

   /* deprecated */
   function _getMultipleRowCacheTime()
   {
      $cacheHandler =& $this->getCacheHandler();
      return $cacheHandler->getMultipleCacheTime();
   }

//========================================================================

   /*!
   @function _getSingleRowCacheTime()
   @discussion - provides the number of seconds to cache data

   @result - returns an unsigned integer
   */

   /* deprecated */
   function _getSingleRowCacheTime()
   {
      $cacheHandler =& $this->getCacheHandler();
      return $cacheHandler->getSingleCacheTime(
         $this->getPrimaryID() );
   }

//========================================================================

   /*!
   @function _getFromRecordSet( $hash )
   @param $hash - a hash of data from a DB row
   @discussion - provides an instance for that DB row
      Default implementation uses creates a new instance from
      the class of $this using the constructor
      _constructor( $primary_id ).
   */

   function &_getFromRecordSet( &$hash )
   {
      $class = $this->getPrototypeClass();
      return new $class( $hash{ $this->getPrimaryColumn() } );
   }

//========================================================================

   /*!
   @function _fillFromRecordSet( $hash, [ $useAll = false ] )
   @param $hash - a hash of data from a DB row
   @param $useAll - indicates if getAllColumns should be used to do the
      fill - defaults to false
   @discussion - default implementation sets member variables
      matching the column names return by getColumns
   */

   function _fillFromRecordSet( &$hash, $useAll = false )
   {
      if ( $this->loadedData ) return;

      //Looping over the hash was quite slow, so ...
      //The rather ugly solution is create a block of code
      //tailored specifically to this class.  Now, we have
      //to have to loop to create that block which is slow,
      //so its necessary to hold onto that code and reuse it.
      //The static variable fillCode holds the code to
      //fill an object of a given type.  I need different
      //code for different ADatabaseItem children, so use
      //getPrototypeClass to figure out what kind of
      //ADatabaseItem is being used.  If the code is not
      //yet available create it.  After I have the code,
      //just eval to fill the object.

      //I could use create_function instead of eval which
      //avoid repeatedly parsing the code, but the function
      //call seems to incur approximately equivalent overhead.

      static $fillCode;
      $class = $this->getPrototypeClass();
      if ( ! isset( $fillCode{ $class }{ $useAll } ) )
      {
         $fillCode{ $class }{ $useAll } =
            $this->_getFillCode( 'this', 'hash', $useAll );
      }

      eval( $fillCode{ $class }{ $useAll } );

      $this->loadedData = true;
   }

//========================================================================

   /*!
   @function _getFillCode( $objectName, $hashName, [ $useAll ] )
   @discussion - creates a block of PHP code that sets the member
      variables of this Object
   @result - returns a String containg PHP code
   */

   function _getFillCode( $objectName, $hashName, $useAll = false )
   {
      if ( $useAll )
      {
         $columns = $this->getAllColumns();
      }
      else
      {
         $columns = $this->getReadColumns();
      }

      $primary = $this->getPrimaryColumn();

      $code = '';
      foreach ( $columns as $column )
      {
         $memberName = ( $primary == $column ) ? 'primary_id' : $column;
         $targetVar = '$' . $hashName . '{ \'' . $column . '\' }';

         $code .= 'if ( isset( ' . $targetVar . ' ) )' . NL;
         $code .= '   $' . $objectName . '->' . $memberName . '=' . $targetVar . ';' . NL;
      }

      return $code;
   }

//========================================================================

   /*!
   @function getAllColumns()
   @discussion - provides the names of the columns
   @result - returns a String[]
   */

   /* abstract function getAllColumns(); */

//========================================================================

   /*!
   @function getReadColumns()
   @discussion - provides the columns needed to read in data
      about this ADatabaseItem

      Default implementation returns getAllColumns.
   @result - returns a String[]
   */

   function getReadColumns()
   {
      return $this->getAllColumns();
   }

//========================================================================

   /*!
   @function getTable()
   @discussion - provides the table name (with schema if necessary)
   @result - returns a String
   */

   /* abstract function getTable(); */

//========================================================================

   /*!
   @function getCacheHandler()
   @discussion - provides the cache handler for this table
   @result - returns a CacheHandler obj
   */

   function &getCacheHandler()
   {
      importClass( 'Database.StandardCacheHandler' );
      return StandardCacheHandler::create( $this->getTable() );
   }

//========================================================================

   /*!
   @function getColumnValue( $column )
   @discussion - provides the value of the DB value for this column
      Default implementation returns value of member variable named
      $column.

      Note the member variable corresponding to $column is guaranteed
      to be set after this method is called.
   @result - returns a String
   */

   /* final */
   function getColumnValue( $column )
   {
      if ( $column == $this->getPrimaryColumn() )
      {
         if ( $this->isNew )
         {
            importClass( 'Database.DBConnectionProvider' );
            $conn =& DBConnectionProvider::getConnection();
            $this->primary_id = $conn->GenID( $this->getSequence() );

            // let's try to handle ID collisions
            $maxTries = 20;
            $numTries = 0;
            while(true)
            {
                // see if this ID is already used for that table
                $sql = 'select 1 from '.$this->getTable().' where '.$this->getPrimaryColumn().' = '.$this->primary_id;
                $rs = $conn->Execute( $sql );
                if($rs->EOF) break;  // we have no collision and we are done!

                // the ID is already in use, let's find where to start with unused ones by finding the max ID in use
                $sql = 'select MAX('.$this->getPrimaryColumn().') max from '.$this->getTable();
                $rs = $conn->Execute( $sql );
                $maxID = $rs->fields['max'];

                // re-make the sequence starting at the max ID point
                $conn->DropSequence($this->getSequence());
                $this->primary_id = $conn->GenID( $this->getSequence(), $maxID+1 );


                // just a safeguard
                $numTries++;
                if($numTries >= $maxTries){print 'Unable to locate useable database ID for table: '.$this->getTable(); break;}
                // test ID again in case another user managed to grab that ID mid-stride
            }
         }

         return $this->primary_id;
      }
      else
      {
         //TODO: Consider cleaning this up
         if ( ! isset( $this->$column ) )
         {
            $value = $this->_getDefaultValue( $column );

            //Do NOT want to actually place the value in the member
            //variable if it is NULL
            if ( $value === DB_NULL ) return DB_NULL;

            $this->$column = $value;
         }

         return $this->$column;
      }
   }

//========================================================================

   /*!
   @function _getDataHash()
   @discussion - provides a hash of $column => $value data for
      this ADatabaseItem
   @result - returns a hash
   */

   /* final */
   function _getDataHash()
   {
      foreach ( $this->getAllColumns() as $column )
      {
         if ( ! $this->_ignoreColumn( $column ) )
         {
            $data{ $column } = $this->getColumnValue( $column );
         }
      }

      //print_r( $this );

      return $data;
   }

//========================================================================

   /*!
   @function _ignoreColumn( $column )
   @param $column - a String containing a column name
   @discussion - indicates if this column should be ignored
      during this insert / update

      Default implementation returns false if
      ( ! $isNew && $column == $this->getPrimaryColumn() ).

      Child classes that override this method should call the parent
      implementation.
   @result - returns a boolean
   */

   function _ignoreColumn( $column )
   {
      return
         ( ! $this->isNew ) &&
         ( $column == $this->getPrimaryColumn() );
   }

//========================================================================

   /*!
   @function _getDefaultValue( $column )
   @param $column - a String containing a column name
   @discussion - provides the default value for this column
      - called if the corresponding member variable is not set and
      the column is NOT being ignored.

      Default implementation calls unreachablePoint.  If any member
      variables may not be set and is NOT being ignored then this
      method should overridden.
   @result - returns a String
   */

   function _getDefaultValue( $column )
   {
      return DB_NULL;
   }

//========================================================================

   /*!
   @function _isIDColumn( $column )
   @param $column - a column name
   @discussion - indicates if the specified column is an ID column
      - i.e. its a foreign key
   @result - returns a boolean
   */

   function _isIDColumn( $column )
   {
      return endsWith( ID_SUFFIX, $column );
   }

//========================================================================

   /*!
   @function getIdentifyingString()
   @discussion - provides a descriptive String for this
      ADatabaseItem
   @result - returns a user-presentable String
   */

   /* final */
   function getIdentifyingString()
   {
      if ( $this->isNull() )
      {
         return $this->_getNullIdentifyingString();
      }
      else
      {
         return $this->_getRegularIdentifyingString();
      }
   }

//========================================================================

   /*!
   @function _getRegularIdentifyingString()
   @discussion - provides a descriptive String for this ADatbaseItem
   @result - returns a user-presentable String
   */

   /* abstract function _getRegularIdentifyingString(); */

//========================================================================

   /*!
   @function _getNullIdentifyingString()
   @discussion - provides a descriptive String for a null ADatabaseItem

      Default implementation always returns "None".
   @result - returns a user-presentable String
   */

   function _getNullIdentifyingString()
   {
      return 'None';
   }

//========================================================================

   /*!
   @function getPrimaryColumn()
   @discussion - provides the name of the primary column of this
      ADatabaseItem
   @result - returns a String
   */

   function getPrimaryColumn()
   {
      //use afterSubString to skip over the schema specifier
      return afterSubstring( '.', $this->getTable() ) . ID_SUFFIX;
   }

//========================================================================

   /*!
   @function _equals( $rhs )
   */

   function _equals( &$rhs )
   {
      if ( ! is_object( $rhs ) )
      {
         return $this->isNull() && ( $rhs === NULL );
      }
      else
      {
         //Do NOT use getPrototypeClass here
         return
            ( get_class( $this ) == get_class( $rhs ) ) &&
            ( $this->getPrimaryID() == $rhs->getPrimaryID() );
      }
   }

//========================================================================

   /*!
   @function getSequence()
   @discussion - the DB sequence that generates primary_ids
   @result - returns a String
   */

   function getSequence()
   {
      return SEQUENCE_SCHEMA . '.' .
         SEQUENCE_PREFIX . $this->getPrimaryColumn() . SEQUENCE_SUFFIX;
   }

//========================================================================

   /*!
   @function getPrimaryID()
   @discussion - provides the value of the primary_id of this
      ADatabaseItem
   @result - returns an integer
   */

   function getPrimaryID()
   {
      if ( ! isset( $this->primary_id ) || $this->isNull() )
      {
         return NULL;
      }
      else
      {
         return $this->primary_id;
      }
   }

//========================================================================

   /*!
   @function doSearch( [ $whereClause, [ $binds , [ $orderBy , [ $joinStruct ] ] ] ] )
   @param $whereClause - optional where clause - defaults to empty String, DO NOT USE THE "WHERE" keyword
   @param $binds - bind values for the where clause
   @param $orderBy - how to order the query, DO NOT USE THE "ORDER BY" keyword
   @discussion - executes a search
   @result - returns an IIterator
   */

   function &doSearch(
      $whereClause = UNSPECIFIED,
      $binds = UNSPECIFIED ,
      $orderBy = UNSPECIFIED,
      $joinStruct = UNSPECIFIED )
   {
      //Call to getPrototype is on $this, but that's okay.
      if( $binds !== UNSPECIFIED && ! is_array( $binds ) )
      {
         unreachablePoint(
            'A non-array was passed in for the bind values in ADatabaseItem::doSearch()!' );
      }

      if( $orderBy === UNSPECIFIED )
      {
         $orderBy = $this->getDefaultOrderBy();
      }

      importClass( 'Database.QueryResultsIterator' );
      return new QueryResultsIterator(
         $this->getPrototype(),
         $whereClause,
         $binds,
         $orderBy,
         $joinStruct );
   }

//========================================================================

   /*!
   @function doEmptySearch()
   @discussion - provides an empty IIterator for this type
   @result - returns an IIterator
   */

   function &doEmptySearch()
   {
      //TODO: Put in guards that prevents creating multiple instances
      return $this->doSearch(
         $this->getPrimaryColumn() . '=?',
         array( NON_EXISTENT_ID ) );
   }

//========================================================================

   /*!
   @function doIDSearch( $primaryIDs )
   @param $primaryIDs - a RowID[]
   @discussion - provides an IIterator for this type - performing
   @result - returns an IIterator
   */

   function &doIDSearch( $primaryIDs )
   {
      if ( is_array( $primaryIDs ) && ! empty( $primaryIDs ) )
      {
         return $this->doSearch(
            $this->getPrimaryColumn() . ' IN(' . implode( ',', $primaryIDs ) . ')' );
      }
      else
      {
         return $this->doEmptySearch();
      }
   }

//========================================================================

   /*!
   @function getDefaultOrderBy()
   @discussion - returns a string for the column(s) to order by and in what direction - do not return the 'ORDER BY'
   @result - string
   */

   function getDefaultOrderBy()
   {
      return $this->getTable() . '.' . $this->getPrimaryColumn();
   }

//========================================================================

   /*!
   @function _getAndWherePairs( $wherePairs )
   @param $wherePairs - an array of where clause pairs - i.e. where and its binds
   @discussion - ANDs the wherePairs together into a single wherePair
   @result - returns a pair( String, String[] )
   */

   /* static */
   function _getAndWherePairs( $wherePairs )
   {
      $where = '';
      $binds = array();
      foreach ( $wherePairs as $curPair )
      {
         if ( $curPair[ 0 ] != '' )
         {
            $where .= ' AND ' . $curPair[ 0 ];
            $binds = array_merge_compat( $binds, $curPair[ 1 ] );
         }
      }

      //strip the unnecessary leading ' AND '
      //5 - is strlen( ' AND ' );
      $where = substr( $where, 5 );

      return array( $where, $binds );
   }

//========================================================================

   /*!
   @function _store()
   @discussion - stores this ADatabaseItem
      _store is called is called by _finalize if hasChanged is true.
   @result - returns the primary_id of this item (unless the item isNull)
   */

   function _store()
   {
      //if its null then bail
      if ( $this->isNull() ) return;

      //------------------------------------------------------------------

      //At this point, the transaction has begun because secondary
      //types may be _store into the database.
      $data = $this->_getDataHash();

      //print_r( $this );

      //------------------------------------------------------------------

      // called before actual changes made to ensure that valid results are continuously received
      $cacheHandler =& $this->getCacheHandler();

      //Not sure this is working
      if ( $this->isNew )
      {
         $cacheHandler->markRowDirty( $data{ $this->getPrimaryColumn() } );
      }
      else
      {
         $cacheHandler->markRowDirty( $this->primary_id );
      }

      //------------------------------------------------------------------

      //build insert or update query and execute here
      importClass( 'Database.DBConnectionProvider' );
      $conn =& DBConnectionProvider::getConnection();

      //Need a record set to feed to Conn->GetInsertSQL / Conn->GetUpdateSQL
      $stmt = $conn->Prepare(
         'SELECT * FROM ' . $this->getTable() .
         ' WHERE ' . $this->getPrimaryColumn() . '=?' );

      if ( $this->isNew )
      {
         //generate an INSERT SQL
         $sql = $conn->GetInsertSQL(
            $conn->Execute( $stmt, array( NON_EXISTENT_ID ) ),
            $data );
      }
      else
      {
         //generate an UPDATE SQL
         //print 'updating user, please ignore this temp debug note';
         $sql = $conn->GetUpdateSQL(
            $conn->Execute( $stmt, array( $this->getPrimaryID() ) ),
            $data );

         // if no update is needed, just return
         if( $sql == '' ) return;
      }

      if ( PRINT_INSERT_UPDATE_SQL )
      {
         print 'ADatabaseItem::_store: ' . htmlentities( $sql ) . BR_NL;
      }

      //print $sql.BR_NL;

      //Odds of re-running this query are fairly slim, so just use Execute
      if ( $conn->Execute( $sql ) === false )
      {
         unreachablePoint(
            'ADatabaseItem::_store()' . NL .
            'DB Error: ' . $conn->ErrorMsg() );
      }

      //------------------------------------------------------------------

      return $this->primary_id;
   }

//========================================================================

   /*!
   @function getPrototypeClass()
   @discussion - provides the class name of the prototype
      Default implementation is sufficient for classes not overriding
      _getFromRecordSet to return different concrete classes.
   @result - returns a String
   */

   function getPrototypeClass()
   {
      return get_class( $this );
   }

//========================================================================

};

?>