<?php

/*
DBConnectionProvider
$Author: millz $
$Revision: 1.7 $
$Date: 2004/08/30 14:34:12 $
$Log: DBConnectionProvider.php,v $
Revision 1.7  2004/08/30 14:34:12  millz
- changed to normal non-persist conn

Revision 1.6  2003/10/20 18:10:42  dougqh
- nothing

Revision 1.5  2003/10/02 15:09:10  millz
- looking for errors at connect time

Revision 1.4  2003/08/29 20:59:38  dougqh
- Updated to ADO_DIR constant

Revision 1.3  2003/07/30 18:03:24  dougqh
- A little clean-up of getConnection. Added and commented out changing of ADODB_CACHE_DIR

Revision 1.2  2003/07/21 22:23:19  millz
- fixing redundancy issues

Revision 1.1  2003/07/09 21:57:17  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/


/*!
@class DBConnectionProvider
@abstract - an object that wraps database connections and queries
*/

class DBConnectionProvider extends Object
{

//========================================================================

   var $conn;

//========================================================================

   /*!
   @function getConnection()
   @discussion - returns an ADO conn that we can use for read/write purposes
   @result - returns an ADO conn
   */

   function &getConnection()
   {
      static $instanceArray;

      if ( is_null( $instanceArray ) )
      {
         $instanceArray[ 0 ] =& new DBConnectionProvider();
      }

      // this is here so that it can override any changes other peices of code
      // might have made to the current fetch mode
      $instanceArray[ 0 ]->conn->SetFetchMode( ADODB_FETCH_ASSOC );

      return $instanceArray[ 0 ]->conn;
   }

//========================================================================

   /*!
   @function createQualifiedAliasedSelectClause( $tableName, $colNames,$useGroupByStyle = false )
   @param $tableName - the name of the table for these columns
   @param - $colNames - array of strings - column names to be fully qualified
   @param - $useGroupByStyle - bool to tell whether to put a groupBy clause around each column name
   @discussion -
   @result - returns SQL select clause string
   */

   /* static */
   function createQualifiedAliasedSelectClause( $tableName, $colNames, $useGroupByStyle = false )
   {
      $count = count( $colNames );
      for($i = 0; $i < $count; ++$i)
      {
         $alias = $colNames[$i];
         $colNames[$i]  = $tableName.'.'.$colNames[$i];
         if($useGroupByStyle){$colNames[$i] = 'MAX('.$colNames[$i].')';}
         $colNames[$i] .= ' '.$alias;
      }

      return implode( ' , ', $colNames );
   }

//========================================================================

   /*!
   @function getReadOnlyConnection()
   @discussion - returns an ADO conn that we can use for read-only purposes
   @result - returns an ADO conn
   */

   function &getReadOnlyConnection()
   {
      return DBConnectionProvider::getConnection();
   }

//========================================================================

   /*
   @function DBConnectionProvider()
   @discussion Constructor - takes no params - should not be called directly
   */

   function DBConnectionProvider()
   {
   	$this->Object();

   	// it's ok if this does nothing, it is here for when we are hooked into oracle
   	//putenv( 'ORACLE_HOME=' . ORACLE_HOME );

   	//global $ADODB_CACHE_DIR;
   	//$ADODB_CACHE_DIR = '/var/run';

      require_once( ADO_DIR . 'adodb.inc.php' );

      $this->conn          = &ADONewConnection( DATABASE_TYPE );  # create a connection
      $this->conn->Connect(DATABASE_HOST, DATABASE_USER, DATABASE_PASSWORD, DEFAULT_SCHEMA);
      $this->conn->SetFetchMode(ADODB_FETCH_ASSOC);
      // $this->conn->cacheSecs = 666;  // this is overridden everywhere

      if( !isEmpty( $this->conn->ErrorMsg() ) )
      {
         print "Unable to connect to database! Host: ".DATABASE_HOST." User: ".DATABASE_USER;
         print BR_NL . BR_NL . "Please verify the settings in your ".BASE_DIRECTORY."conf".DIRECTORY_SEPARATOR."config.php file.";
         print BR_NL . "ADOdb says: " . $this->conn->ErrorMsg();
         exit;
      }

   }

//========================================================================

};



?>