<?php

/*
Join
$Author: dougqh $
$Revision: 1.6 $
$Date: 2004/01/07 21:51:10 $
$Log: Join.php,v $
Revision 1.6  2004/01/07 21:51:10  dougqh
- Better error message when calling unreachablePoint

Revision 1.5  2003/12/18 20:41:44  dougqh
Updated to work under PHP 4.2

Revision 1.4  2003/12/11 18:09:32  millz
- correcting comment search bugs

Revision 1.3  2003/10/21 13:57:54  dougqh
- Some reformatting

Revision 1.2  2003/07/21 22:12:03  millz
- added isXToMany relationship flag

Revision 1.1  2003/07/09 21:57:17  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

   define( 'INNER_JOIN_TYPE', 1 );
   define( 'OUTER_JOIN_TYPE', 2 );

   define( 'PROTOTYPE_HASH_KEY', 'prototype' );

//========================================================================

/*!
@class Join
@abstract -
*/

class Join extends Object
{


//========================================================================

   /*!
   @function Join()
   @discussion - constructs a new Join object
   @result - constructs a new Join object
   */

   function Join()
   {
      unreachablePoint( 'Join is a utility class and should NOT be instantiated' );
   }

//========================================================================

   /*!
   @function &createOuter( $table, $baseCrit, $additionalCrit = UNSPECIFIED, $isXtoMany = false)
   @param $table - the name of the table to join to
   @param $baseCrit - the criteria used for the join, such as: 'report.report_id = comment.report_id'
   @param $additionalCrit - any other criteria for the joined in table, such as: comment.comment_id is NULL
   @discussion - constructs a new Join struct for an OUTER JOIN
   @result - a new Join struct
   */

   /* static */
   function &createOuter( $table, $baseCrit, $isXtoMany = UNSPECIFIED,  $prototype = UNSPECIFIED)
   {
      return Join::_create( OUTER_JOIN_TYPE, $table, $baseCrit, $isXtoMany, $prototype );
   }

//========================================================================

   /*!
   @function &createInner( $table, $baseCrit, $additionalCrit = UNSPECIFIED, $isXtoMany = UNSPECIFIED)
   @param $table - the name of the table to join to
   @param $baseCrit - the criteria used for the join, such as: 'report.report_id = comment.report_id'
   @param $additionalCrit - any other criteria for the joined in table, such as: comment.comment is NOT NULL
   @discussion - constructs a new Join struct for an INNER JOIN
   @result - a new Join struct
   */

   /* static */
   function &createInner( $table, $baseCrit, $isXtoMany = UNSPECIFIED, $prototype = UNSPECIFIED)
   {
      return Join::_create( INNER_JOIN_TYPE, $table, $baseCrit, $isXtoMany, $prototype );
   }

//========================================================================

   /*!
   @function &_create( $type, $table, $baseCrit, $additionalCrit )
   @result - joinStruct
   */

   /* static */
   function &_create( $type, $table, $baseCrit, $isXtoMany, $prototype = UNSPECIFIED )
   {
      if($isXtoMany === UNSPECIFIED){ $isXtoMany = false; }

      $hash{ 'type' } = $type;
      $hash{ 'table' } = $table;
      $hash{ 'baseCriteria' } = $baseCrit;
      $hash{ 'isXtoMany' } = $isXtoMany;

      if( $prototype !== UNSPECIFIED ){ $hash{ PROTOTYPE_HASH_KEY } =& $prototype; }

      return $hash;
   }

//========================================================================

   /*!
   @function createSQL92Clause( [ $joinHash ] )
   @param - $joinHash - the struct that contains the info for the requested join
   @discussion -
   @result - SQL string to be inserted after the first table in your FROM clause -> select from iuser <THIS_STRING> where...
   */

   /* static */
   function createSQL92Clause( $joinHash = UNSPECIFIED )
   {
      if ( $joinHash === UNSPECIFIED ) return '';


      if( $joinHash{ 'type' } === OUTER_JOIN_TYPE )
      {
         // LEFT JOIN comment on (report.report_id = comment.report_id AND comment.comment_id is NULL )
         return ' LEFT JOIN ' . $joinHash{ 'table' } . ' ON (' .
            $joinHash{ 'baseCriteria' } . ') ';
      }
      else
      {
         // INNER JOIN comment on (report.report_id = comment.report_id AND MATCH (comments) AGAINST ('Unknown') )
         return ' INNER JOIN ' . $joinHash{ 'table' } . ' ON ('.
            $joinHash{ 'baseCriteria' } . ') ';
      }
   }

//========================================================================

};

?>