<?php

/*
QueryUtils
$Author: millz $
$Revision: 1.1 $
$Date: 2003/11/05 14:19:22 $
$Log: QueryUtils.php,v $
Revision 1.1  2003/11/05 14:19:22  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

// importClass( '<package>.<parent>' );

//========================================================================

/*!
@class QueryUtils
@abstract - 
*/

class QueryUtils extends Object
{

//========================================================================

   // <class vars>

//========================================================================

   /*!
   @function QueryUtils()
   @discussion - constructs a new QueryUtils object
   @result - constructs a new QueryUtils object
   */
   
   function QueryUtils()
   {
      unreachablepoint( 'QueryUtils is only meant for holding static helpers' );
   }
   
//========================================================================

   /*!
   @function getInverseOperator( $operatorString )
   @discussion - returns the opposite of the operator, for example the opposite of > is <=
   @result - operator string
   */
   /* static */
   function getInverseOperator( $operatorString )
   {
      // Need to handle inverses of all the basic ordering operators
      // ( <, <=, >, >= )
      switch ($operatorString) {
          case LESS_THAN:
              return GREATER_THAN_OR_EQUAL;
              break;
          case GREATER_THAN_OR_EQUAL:
              return LESS_THAN;
              break;
          case GREATER_THAN:
              return LESS_THAN_OR_EQUAL;
              break;
          case LESS_THAN_OR_EQUAL:
              return GREATER_THAN;
              break;
          default:
              unreachablepoint('QueryUtils.getInverseOperator does not understand the inputted operatorString');
      }
      
   }

//========================================================================

   /*!
   @function getNow( &$adodbConn )
   @discussion - 
   @result - string that represents "Now" for the current database's date type
   */
   /* static */
   function getNow( &$dbcon )
   {
      return $dbcon->sysTimeStamp;
   }
   
//========================================================================

   /*!
   @function getDateOlderWherePair( &$dbcon, $dateColumnName, $operator, &$timeDuration )
   @param $dbcon - an adodb conn
   @param $dateColumnName - the column name that is the date type in the db
   @param $operator - the operator - if you want the age to be "more than" the duration, pass in the > op
   @param $timeDuration - the timeduration obj
   @discussion - 
   @result - wherepair
   */
   /* static */
   function getDateOlderWherePair( &$dbcon, $dateColumnName, $operator, &$timeDuration )
   {
      return array(
          $dateColumnName .
          QueryUtils::getInverseOperator( $operator ) .
          QueryUtils::getNow( $dbcon ) . ' - INTERVAL ? day',
          array( $timeDuration->getDays() ) );
   }
   
//========================================================================

};

?>