<?php

/*
ADbItemAction
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/12/09 19:34:11 $
$Log: ADbItemAction.php,v $
Revision 1.1  2003/12/09 19:34:11  dougqh
Initial revision

Revision 1.3  2003/11/03 18:13:33  dougqh
- Feature 3743

Revision 1.2  2003/10/21 14:11:18  dougqh
Refactoring email handling

Revision 1.1  2003/07/09 20:09:49  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

/*!
@class ADbItemAction
@abstract -
*/

class ADbItemAction extends Object
{

//========================================================================

   /*!
   @function ADbItemAction()
   @discussion - constructs a new ADbItemAction object
   */

   function ADbItemAction()
   {
      $this->Object();
   }

//========================================================================

   /*!
   @function getAvailableFieldNames()
   @discussion - provides an array of field names that are available
      for use with this Action
   @result - returns String[]
   */

   /* abstract function getAvailableFieldNames(); */


//========================================================================

   /*!
   @function isRequired( $fieldName )
   @param $fieldName - a String - specifying a field name
   @discussion - indicates if that field is required for this action
   @result - returns a boolean
   */

   /* abstract function isRequired( $fieldName ); */

//========================================================================

   /*!
   @function isAdding()
   @discussion - indicates if this ADbItemAction is adding a new row
   @discussion - default implementation returns false
   @result - returns a boolean
   */

   function isAdding()
   {
      return false;
   }

//========================================================================

   /*!
   @function createDbItem()
   */

   function &createDbItem()
   {
      $proto =& $this->dbItemFormView->getItemPrototype();
      return $proto->createNew();
   }

//========================================================================

   /*!
   @function areAdditionalChecksValid()
   @discussion - indicates if the fields are in an acceptable
      state for this Action to be executed

      Note this method is not responsible for checking required fields.

      _addError should be called to add error message if a constraint
      is violated.

      Default implementation returns true.
   */

   function areAdditionalChecksValid()
   {
      return true;
   }

//========================================================================

   /*!
   @function execute()
   @discussion - actually performs the action

      Only called if all validation checks passed.
   */

   /* abstract function execute(); */

//========================================================================

   /*!
   @function isEnabled()
   @discussion - determines if this ADevItemAction isEnabled used
      by ADevelopmentItemController and then ADevelopmentItemFormView
      to determine if its enabled
   @result - returns a boolean
   */

   /* abstract function isEnabled(); */

//========================================================================

   /*!
   @function getMethod()
   @discussion - indicates how the form should be submitted
   @result - returns GET or POST
   */

   function getMethod()
   {
      return POST;
   }

//========================================================================

   /*!
   @function isUploader()
   @discussion - indicates if this form uses uploaded files
   @result - returns a boolean
   */

   function isUploader()
   {
      return false;
   }

//========================================================================

   /*!
   @function _setDbItemFormView( &$dbItemFormView )
   */

   function _setDbItemFormView( &$dbItemFormView )
   {
      //use this, so circular reference gets cleaned up at script termination
      $this->_setCircularReference(
         'dbItemFormView', $dbItemFormView );
   }

//========================================================================

   /*!
   @function getField( $name )
   */
   function &getField( $name )
   {
      return $this->dbItemFormView->getField( $name );
   }

//========================================================================

   /*!
   @function hasField( $name )
   */
   function hasField( $name )
   {
      return $this->dbItemFormView->hasField( $name );
   }

//========================================================================

   /*!
   @function getFieldValue( $name )
   */

   function &getFieldValue( $name )
   {
      $field =& $this->getField( $name );
      return $field->getValue();
   }

//========================================================================

   /*!
   @function getUser()
   @discussion - provides the User for which this ADbItemFieldFactory
      was created
   @result - returns a User
   */

   function &getUser()
   {
      return $this->dbItemFormView->getUser();
   }


//========================================================================

   /*!
   @function _setDbItem( $dbItem )
   */

   function _setDbItem( &$dbItem )
   {
      $this->dbItem =& $dbItem;
   }

//========================================================================

   /*!
   @function getDbItem()
   @discussion - provides the ADatabaseItem for which fields are being
     produced
   @result - returns an ADatabaseItem (or null if _creatingNew)
   */

   function &getDbItem()
   {
      if ( $this->isAdding() )
      {
         if ( ! isset( $this->dbItem ) )
         {
            $this->dbItem =& $this->createDbItem();
         }
         return $this->dbItem;
      }
      else
      {
         return $this->dbItem;
      }
   }

//========================================================================

   /*!
   @function isFieldEnabled( $fieldName )
   @discussion - indicates if the specified field should be enabled
   @result - returns a boolean
   */

   /* final */
   function isFieldEnabled( $fieldName )
   {
      if ( ! isset( $this->enabledHash ) )
      {
         $this->enabledHash =
            set::stringsToSet(
               $this->getAvailableFieldNames() );
      }

      return isset( $this->enabledHash{ $fieldName } );
   }

//========================================================================

   /*!
   @function _addError( $message )
   @param $message - a user-presentable String
   @discussion - records an error for presentation to the user
   */

   function _addError( $message )
   {
      $this->dbItemFormView->_addError( $message );
   }

//========================================================================

};

?>