<?php

/*
ADbItemFormView
$Author: millz $
$Revision: 1.5 $
$Date: 2004/04/01 22:11:14 $
$Log: ADbItemFormView.php,v $
Revision 1.5  2004/04/01 22:11:14  millz
small bug fixes

Revision 1.4  2004/04/01 18:08:55  dougqh
- Added support for using a TwoColumnTable instead of FourColumnTable

Revision 1.3  2004/01/07 22:19:21  millz
- refactor

Revision 1.2  2004/01/07 19:40:55  dougqh
- Header doc correction

Revision 1.1  2003/12/09 19:34:11  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'BugUI.ALightFormFieldForm' );

//========================================================================

define( 'ACTION_SPECIFIER_PARAM', 'action' );

//========================================================================

/*!
@class ADbItemFormView
@abstract -
*/

class ADbItemFormView extends ALightFormFieldForm
{

//========================================================================

   /*!
   @function ADbItemFormView()
   */

   function ADbItemFormView()
   {
      $this->ALightFormFieldForm();

   }

//========================================================================

   /*!
   @function _getAdditionalParameters()
   @discussion - called by getParameters to allow this class to store
      additional parameters needed to rebuild this ADbItemFormView
   */

   function _getAdditionalParameters()
   {
      return array();
   }

//========================================================================

   /*!
   @function _loadAdditionalParameters()
   @discussion - called by createFromRequest to read additional information
      added by getAdditionalParameters
   */

   function _loadAdditionalParameters()
   {
   }

//========================================================================

   /*!
   @function getDbItemClass()
   @discussion - provides the absolute class name of the ADatabaseItem
      class being manipulated
   @result - returns a String
   */

   /* abstract getDbItemClass(); */

//========================================================================

   /*!
   @function _createFieldFactory()
   @param $dbItem - an ADatabaseItem or NULL if its a creation form
   @discussion - creates the ADbItemFieldFactory used by this class
   @result - returns a NEW ADbItemFieldFactory
   */

   /* abstract function &_createFieldFactory( &$dbItem ); */

//========================================================================

   /*!
   @function _createAction( $actionSpecifier )
   @discussion - creates an ADbItemAction corresponding to the given
      actionSpecifier
   */

   /* abstract function &_createAction( $actionSpecifier ); */

//========================================================================

   /*!
   @function _createView( $actionSpecifier )
   @discussion - creates an ADbItemFormView for use with the given
      actionSpecifier
   */

//========================================================================

   /*!
   @function getNextView()
   */

   /* abstract function &getNextView(); */

//========================================================================

   /*!
   @function createFromRequest( $class )
   @discussion - called by Controller to create an instance of this
      view using information found in $_REQUEST
   @param $class - the Class being instantiated (in case its a subclass)
   @result - returns an ADbItemFormView
   */

   /* static */
   function &createFromRequest( $class )
   {
      $viewProto =& new $class();
      $viewProto->_loadAdditionalParameters();

      $itemProto =& $viewProto->getItemPrototype();

      $primaryColumn = $itemProto->getPrimaryColumn();
      if ( isset( $_REQUEST{ $primaryColumn } ) )
      {
         if ( isNumeric( $_REQUEST{ $primaryColumn } ) )
         {
            $dbItem =&
               $itemProto->_getFromPrimaryID( $itemProto,
                  $_REQUEST{ $primaryColumn } );
         }
         else
         {
            unreachablePoint( 'Bad primary ID' );
         }
      }

      if ( isset( $_REQUEST{ ACTION_SPECIFIER_PARAM } ) )
      {
         $actualView =& ADbItemFormView::_staticCreateView(
            $viewProto,
            $dbItem,
            $_REQUEST{ ACTION_SPECIFIER_PARAM } );
      }

      return $actualView;
   }

//========================================================================

   /*!
   @function getItemPrototype()
   */

   function &getItemPrototype()
   {
      $entityClass = $this->getDbItemClass();
      importClass( $entityClass );
      //by reference, so call callStaticMethod
      $itemProto =& callStaticMethod(
         absoluteClassToClass( $entityClass ),
         'getPrototype',
         new_array() );

      return $itemProto;
   }

//========================================================================

   /*!
   @function getParameters()
   */

   function getParameters()
   {
      $parameters = $this->_getAdditionalParameters();

      if ( ! $this->action->isAdding() )
      {
         $dbItem =& $this->getDbItem();
         $parameters{ $dbItem->getPrimaryColumn() } = $dbItem->getPrimaryID();
      }

      $parameters{ ACTION_SPECIFIER_PARAM } = $this->actionSpecifier;

      return $parameters;
   }

//========================================================================

   /*!
   @function _staticCreateView(
      $viewProto,
      $dbItem,
      $actionSpecifier )
   @discussion - helper method that initializes the concrete view to
      display
   */

   function &_staticCreateView(
      &$viewProto,
      &$dbItem,
      $actionSpecifier )
   {
      $action =& $viewProto->_createAction( $actionSpecifier );
      if ( ! is_null( $dbItem ) ) $action->_setDbItem( $dbItem );
      $view =& $viewProto->_createView( $actionSpecifier );
      $view->_setAction( $action, $actionSpecifier );
      return $view;
   }

//========================================================================

   /*!
   @function getInputFieldNames()
   */

   function getInputFieldNames()
   {
      return $this->action->getAvailableFieldNames();
   }

//========================================================================

   /*!
   @function _setAction( $action, $actionSpecifier )
   @discussion - private setter
   */

   function _setAction( &$action, $actionSpecifier )
   {
      if ( is_null( $action ) )
      {
         unreachablePoint();
      }

      $this->action =& $action;
      $this->actionSpecifier = $actionSpecifier;
      $this->action->_setDbItemFormView( $this );
   }

//========================================================================

   /*!
   @function useTwoColumnTable()
   @discussion - indicates if a TwoColumnTable should be used instead
      of a FourColumnTable to do formatting
   */
   function useTwoColumnTable()
   {
       return false;
   }

//========================================================================

   /*!
   @function _getBodyHTML()
   @discussion - provides the basic outline of this Form
   */

   function _getBodyHTML()
   {
      if ( $this->useTwoColumnTable() )
      {
          importClass( 'HTMLComponents.Table.TwoColumnTable' );
          $this->twoColTable =& new TwoColumnTable();
          $this->twoColTable->setRequestedWidth( 600 );

          unset( $this->fourColTable );
      }
      else
      {
          importClass( 'HTMLComponents.Table.FourColumnTable' );
          $this->fourColTable =& new FourColumnTable();
          $this->fourColTable->setRequestedWidth( 600 );

          unset( $this->twoColTable );
      }

      $this->addedFieldsSet = array();

      //------------------------------------------------------------------

      $this->_addHeaderFields();

      //------------------------------------------------------------------

      $this->_addFields();

      //------------------------------------------------------------------

      if ( isset( $this->twoColTable ) )
      {
          $html = $this->twoColTable->getHTML();
          unset( $this->twoColTable );
      }
      else
      {
          //Done with table, so get rid of it
          $html = $this->fourColTable->getHTML();
          unset( $this->fourColTable );
      }

      return $html;
   }

//========================================================================

   /*!
   @function _getTwoColumnTable()
   @discussion - provides the twoColTable being used by _getBodyHTML
      - can used by a child class inside of _addFields, but NOWHERE else.
   @result - returns a twoColTable
   */

   function &_getTwoColumnTable()
   {
      return $this->twoColTable;
   }

//========================================================================

   /*!
   @function _getFourColumnTable()
   @discussion - provides the FourColumnTable being used by _getBodyHTML
      - can used by a child class inside of _addFields, but NOWHERE else.
   @result - returns a FourColumnTable
   */

   function &_getFourColumnTable()
   {
      return $this->fourColTable;
   }

//========================================================================

   /*!
   @function _addHeaderFields()
   */
   function _addHeaderFields()
   {
   }

//========================================================================

   /*!
   @function _addFields()
   @discussion - called by _getBodyHTML, so that a concrete child
      can add any necessary fields using the various _add<X>
      methods
   */

   /* abstract function _addFields(); */

//========================================================================

   /*!
   @function _initialize( $action )
   @param $action - an Action object to performed by this ADbItemFormView
   @param $dbItem - the ADatabaseItem being manipulated
   */

   function _initialize( &$action, &$dbItem )
   {
      $this->action =& $action;
      importClass( 'Shared.User' );
      $this->action->_setUser( User::getCurrentUser() );
      $this->action->_setDbItem( $dbItem );
   }

//========================================================================

   /*!
   @function getDbItem()
   @discussion - provides the ADatabaseItem being manipulated
   @result - an ADatabaseItem
   */

   function &getDbItem()
   {
      return $this->action->getDbItem();
   }

//========================================================================

   /*!
   @function &_createField( $name )
   */
    function &_createField( $name )
    {
        $factory =& $this->_getFieldFactory();
        return $factory->createField( $name );
    }

//========================================================================

   /*!
   @function _areAdditionalChecksValid( )
   */
    function _areAdditionalChecksValid()
    {
         return $this->action->areAdditionalChecksValid();
    }
//========================================================================

   /*!
   @function _getFieldFactory()
   @discussion - provides the ADbItemFieldFactory used by this class
      - child class needs to define _createFieldFactory
   @result - returns a ADbItemFieldFactory
   */

   function &_getFieldFactory()
   {
      if ( ! isset( $this->fieldFactory ) )
      {
         $this->fieldFactory =& $this->_createFieldFactory();
         $this->fieldFactory->_setAction( $this->action );
      }
      return $this->fieldFactory;
   }

//========================================================================

   /*!
   @function _add( $name, [ $isFull ], [ $add ] )
   @param $name - a String - a field name
   @param $isFull - a boolean indicating if its a full width field
      - defaults to false
   @param $add - optional boolean - indicating if this
      field should really be added to the TwoColumnTable -
      defaults to true
   @discussion - helper method that does the
      basic table construction
   @result - returns the value of $add
   */

   function _add( $name, $isFull = UNSPECIFIED, $add = true )
   {
      $add = $add && ( ! isset( $this->addedFieldsSet{ $name } ) );
      $this->addedFieldsSet{ $name } = true;

      if ( $add )
      {
         $field =& $this->getField( $name );
         if ( is_null( $field ) ) unreachablePoint();

         if ( isset( $this->fourColTable ) )
         {
             $this->fourColTable->addField(
                $field,
                $isFull );
         }
         else
         {
             $this->twoColTable->addField( $field );
         }
      }
      else
      {
         //If we didn't add but would have typically added to
         //the right, then force the FourColumnTable to use
         //a new row to maintain the layout.

         if ( isset( $this->fourColTable ) && $this->fourColTable->isNextRight() )
         {
            $this->fourColTable->forceNewRow();
         }
      }

      return $add;
   }

//========================================================================

   /*!
   @function _addIfExistsEnabled( $name, [ $isFull ] )
   @param $name - a String - a field name
   @param $isFull - a boolean indicating if its a full width field
      - defaults to false
   @discussion - adds the field if the controller has the field
      and its enabled
   */

   function _addIfExistsEnabled( $name, $isFull = UNSPECIFIED )
   {
      $field =& $this->getField( $name );

      return
         $this->_add(
            $name,
            $isFull,
            $this->hasField( $name ) && $field->isEnabled() );
   }

//========================================================================

   /*!
   @function _addIfEnabled( $name, [ $isFull ] )
   @param $name - a String - a field name
   @param $isFull - a boolean indicating if its a full width field
      - defaults to false
   @discussion - adds the field if its enabled
   */

   function _addIfEnabled( $name, $isFull = UNSPECIFIED )
   {
      $field =& $this->getField( $name );

      return
         $this->_add(
            $name,
            $isFull,
            $field->isEnabled() );
   }

//========================================================================

   /*!
   @function _addIfExists( $name, [ $isFull ] )
   @param $name - a String - a field name
   @param $isFull - a boolean indicating if its a full width field
      - defaults to false
   @discussion - adds the field if it exists
   @result - returns true if the field was added
   */

   function _addIfExists( $name, $isFull = UNSPECIFIED )
   {
      $field =& $this->getField( $name );

      return
         $this->_add(
            $name,
            $isFull,
            $this->hasField( $name ) );
   }

//========================================================================

   /*!
   @function getMethod()
   @discussion - indicates how the form should be submitted
   @result - returns GET or POST
   */

   /* final */
   function getMethod()
   {
      return $this->action->getMethod();
   }

//========================================================================

   /*!
   @function isUploader()
   @discussion - indicates if this form uses uploaded files
   @result - returns a boolean
   */

   /* final */
   function isUploader()
   {
      return $this->action->isUploader();
   }

//========================================================================

   /*!
   @function getSubmitText()
   @discussion - returns text to use for submit button
   @result - returns a String
   */
   function getSubmitText()
   {
      return 'Save';
   }

//========================================================================

   /*!
   @function getSubmittingText()
   @discussion - returns text to use for submit button during the submission itself (after the user submits)
   @result - returns a String
   */
   function getSubmittingText()
   {
      return 'Saving';
   }

//========================================================================

   /*!
   @function _execute()
   */

   function &_execute()
   {
      $this->action->execute();
   }

//========================================================================

   /*!
   @function isEnabled()
   @discussion - just defer to the ADevItemController to determine enabled
      status
   */

   /* final */
   function isEnabled()
   {
      if ( ALWAYS_ENABLE_ALL_FORMS ) return true;

      return $this->action->isEnabled();
   }

//========================================================================

   /*!
   @function getTitle()
   @discussion - just defer to the ADbItemAction to determine the
      title
   */

   /* final */
   function getTitle()
   {
      return $this->action->getDisplayName();
   }

//========================================================================

   /*!
   @function getUser()
   */

   function &getUser()
   {
      importClass( 'Shared.User' );
      return User::getCurrentUser();
   }

//========================================================================
};

?>