<?php

/*
ALightExistingOrNewItemField
$Author: dougqh $
$Revision: 1.2 $
$Date: 2004/01/08 19:41:37 $
$Log: ALightExistingOrNewItemField.php,v $
Revision 1.2  2004/01/08 19:41:37  dougqh
- Fixed a bug in _createSelectComponent

Revision 1.1  2004/01/08 15:28:13  dougqh
- Base class for fields that need to allow user to select an existing item or create a new one

Revision 1.2  2004/01/07 19:44:08  dougqh
- Accepting iterator by reference in the constructor

Revision 1.1  2003/07/09 20:26:12  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.LightForms.ALightFormField' );

//========================================================================

/*!
@class ALightExistingOrNewItemField
@abstract -
*/

class ALightExistingOrNewItemField extends ALightFormField
{

//========================================================================

   /*!
   @function ALightExistingOrNewItemField( $iterator, $name, $displayName )
   @param $iterator - an Iterator< T >
      - if ever instantiated with non QueryResultsIterator< T > then
        _getPrototype needs to be overridden
   @param $name - an internal String
   @param $displayName - a user-presentable String
   */

   function ALightExistingOrNewItemField( &$iterator, $name, $displayName )
   {
      $this->ALightFormField( $name, $displayName );

      $this->iterator =& $iterator;
   }

//========================================================================

   /*!
   @function _getPrototype()
   */
   function &_getPrototype()
   {
      return $this->iterator->getPrototype();
   }

//========================================================================

   /*!
   @function _createSelectComponent()
   @discussion - provides an HTMLComponent to represent the listing
      of existing items (with a New->) selection
   */

   function &_createSelectComponent()
   {
      importClass( 'CollectionUI.IteratorSelectComponent' );
      $component =& new IteratorSelectComponent(
         $this->iterator,
         $this->getName() . '_list',
         SINGLE_SELECT,
         'New->' );

      $item =& $this->getValue();
      if ( $item !== NULL && ! $item->isNew() )
      {
         $component->setSelected( $item );
      }
      return $component;
   }

//========================================================================

   /*!
   @function _isValueNew()
   */

   function _isValueNew()
   {
      $item =& $this->getValue();
      return $item->isNew();
   }

//========================================================================

   /*!
   @function _createEntryComponent()
   */

   /* abstract function &_createEntryComponent() */

//========================================================================

   /*!
   @function _createNewItemFromRequest()
   @discussion - uses the information in the entry component to create
      a new item
   @result - returns a T - may return NULL if insufficient information
      was available to create a new T

   */

   /* abstract function &_createNewItemFromRequest() */

//========================================================================

   /*!
   @function _getEnabledHTML()
   */

   /* final */
   function _getEnabledHTML()
   {
      $selectComponent =& $this->_createSelectComponent();
      $entryComponent =& $this->_createEntryComponent();

      return $selectComponent->getHTML() . ' ' . $entryComponent->getHTML();
   }

//========================================================================

   /*!
   @function _getDisabledHTML()
   @discussion - may be overridden if so desired by the child
   */

   function _getDisabledHTML()
   {
      $value =& $this->getValue();

      importClass( 'HTMLComponents.Text' );
      $text =& new Text( $value->getIdentifyingString() );

      return $text->getHTML();
   }

//========================================================================

   /*!
   @function _getDefaultValue()
   */

   function &_getDefaultValue()
   {
      return toRef( NULL );
   }

//========================================================================

   /*!
   @function _getFormValue()
   */

   function &_getFormValue()
   {
      $valid = false;

      if ( isset( $_REQUEST{ $this->getName() . '_list' } ) )
      {
         $value = $_REQUEST{ $this->getName() . '_list' };
         $valid = isNumeric( $value );
         //TODO: Check that the ID is in the IIterator
      }

      if ( $valid )
      {
         $prototype =& $this->_getPrototype();
         return $prototype->getFromPrimaryID( $_REQUEST{ $this->getName() . '_list' } );
      }
      else
      {
         return $this->_createNewFromRequest();
      }
   }

//========================================================================

};

?>