<?php

/*
IDListField
$Author: millz $
$Revision: 1.4 $
$Date: 2003/12/17 21:37:19 $
$Log: IDListField.php,v $
Revision 1.4  2003/12/17 21:37:19  millz
- removing duplicate preg_split logic

Revision 1.3  2003/10/21 14:19:30  dougqh
- Removed some debugging

Revision 1.2  2003/07/22 13:45:06  millz
- updated to allow for any sep character for related items

Revision 1.1  2003/07/09 21:50:32  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.LightForms.ALightFormField' );

//========================================================================

/*!
@class IDListField
@abstract - a concrete ALightFormField that works with a list
   of IDs to produce an IIterator
*/

class IDListField extends ALightFormField
{

//========================================================================

   /*!
   @function IDListField( $name, $displayName, $prototype )
   @param $name - a String
   @param $displayName - a user-presentable String
   @param $prototype - an ADatabaseItem prototype
   @discussion - constructs a new IDListField object
   @result - constructs a new IDListField object
   */

   function IDListField(
      $name,
      $displayName,
      &$prototype )
   {
      $this->ALightFormField( $name, $displayName );

      $this->prototype =& $prototype;
   }

//========================================================================

   /*!
   @function getIDs()
   @discussion - provides an array of primary_ids of items in the IIterator
   @result - returns a RowID[]
   */

   function getIDs()
   {
      $ids = array();

      $iterator =& $this->getValue();
      for ( $iterator->reset(); ! $iterator->isEnd(); $iterator->moveNext() )
      {
         $cur =& $iterator->getCurrent();
         $ids[] = $cur->getPrimaryID();
      }

      return $ids;
   }

//========================================================================

   /*!
   @function _getEnabledHTML()
   */

   function _getEnabledHTML()
   {
      importClass( 'HTMLComponents.LightForms.TextComponent' );
      $comp =& new TextComponent(
         $this->getName(),
         implode( ', ', $this->getIDs() ),
         30, 30 );

      return $comp->getHTML();
   }

//========================================================================

   /*!
   @function _getDisabledHTML()
   */

   function _getDisabledHTML()
   {
      unreachablePoint( 'IDListField canNOT be disabled.' );
   }

//========================================================================

   /*!
   @function _getDefaultValue()
   */

   function &_getDefaultValue()
   {
      return $this->prototype->doEmptySearch();
   }

//========================================================================

   /*!
   @function _getFormValue()
   */

   function &_getFormValue()
   {
      if ( empty( $_REQUEST{ $this->getName() } ) )
      {
         //print 'Using the default value' . BR_NL;

         return $this->_getDefaultValue();
      }
      else
      {
         //print 'Doing an ID search' . BR_NL;

         return
            $this->prototype->doIDSearch( getNumericIDArrayFromString( $_REQUEST{$this->getName()} ) );
      }
   }

//========================================================================

};

?>