<?php

/*
LightIteratorSelectField
$Author: dougqh $
$Revision: 1.4 $
$Date: 2004/01/16 17:06:20 $
$Log: LightIteratorSelectField.php,v $
Revision 1.4  2004/01/16 17:06:20  dougqh
- Fixing user reported bug

Revision 1.3  2003/10/21 15:13:12  dougqh
- Started work on a no selection entry

Revision 1.2  2003/09/05 19:44:19  dawn
- no changes

Revision 1.1  2003/07/09 20:31:25  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.LightForms.ALightFormField' );

//========================================================================

//imported here for its constants
importClass( 'CollectionUI.IteratorSelectComponent' );

//========================================================================

/*!
@class LightIteratorSelectField
@abstract - an abstract class from concrete LightFormFields are derived
*/

class LightIteratorSelectField extends ALightFormField
{

//========================================================================

   /*!
   @function LightIteratorSelectField( $iterator, $name, $displayName, $isMultiple )
   @param $iterator - an QueryResultsIterator< ADatabaseItem >
   @param $name - an internal String
   @param $displayName - a user-presentable String
   @param $isMultiple - a boolean
   @discussion - constructs a new LightIteratorSelectField object
   @result - constructs a new LightIteratorSelectField object
   */

   function LightIteratorSelectField(
      &$iterator,
      $name,
      $displayName,
      $isMultiple )
   {
      $this->ALightFormField( $name, $displayName );

      $this->iterator =& $iterator;
      $this->isMultiple = $isMultiple;
      $this->nullOptionLabel = UNSPECIFIED;
   }

//========================================================================

   /*!
   @function setAllowNull( $nullOptionLabel )
   @param $nullOptionLabel - a user-presentable String
   @discussion - sets this LightIteratorSelectField to allow
      a null selection
   */

   function setAllowNull( $nullOptionLabel )
   {
      $this->nullOptionLabel = $nullOptionLabel;
   }

//========================================================================

   /*!
   @function _getIterator()
   @discussion - provides an QueryResultsIterator over the set of possible
      values
   @result - returns an QueryResultsIterator< T >
   */

   function &_getIterator()
   {
      return $this->iterator;
   }

//========================================================================

   /*!
   @function _getEnabledHTML()
   */

   function _getEnabledHTML()
   {
      //imported at top of file
      $selectComp =& new IteratorSelectComponent(
         $this->_getIterator(),
         $this->getName(),
         $this->isMultiple,
         $this->nullOptionLabel );

      $selectComp->setSelected( $this->getValue() );

      return $selectComp->getHTML();
   }

//========================================================================

   /*!
   @function _getDisabledHTML()
   */

   function _getDisabledHTML()
   {
      $value =& $this->getValue();
      importClass( 'HTMLComponents.Text' );
      $textComp =& new Text( $value->getIdentifyingString() );
      return $textComp->getHTML();
   }

//========================================================================

   /*!
   @function _getDefaultValue()
   */

   function &_getDefaultValue()
   {
      $iterator =& $this->_getIterator();
      $prototype =& $iterator->getPrototype();

      return $prototype->getFromPrimaryID( NULL );
   }

//========================================================================

   /*!
   @function _getFormValue()
   */

   function &_getFormValue()
   {
      if (
         isset( $_REQUEST{ $this->getName() } ) &&
         $_REQUEST{ $this->getName() } != NULL_SELECT_VALUE )
      {
         $iterator =& $this->_getIterator();
         $prototype =& $iterator->getPrototype();

         $primary_id = $_REQUEST{ $this->getName() };

         //not necessarily safe because its not guaranteed that prototype
         //has implemented getFromPrimaryID
         return $prototype->getFromPrimaryID( $primary_id );
      }
      else
      {
         //provides null
         return $this->_getDefaultValue();
      }
   }

//========================================================================

};

?>