<?php

/*
AHTMLComponent
$Author: dougqh $
$Revision: 1.2 $
$Date: 2003/12/18 20:42:54 $
$Log: AHTMLComponent.php,v $
Revision 1.2  2003/12/18 20:42:54  dougqh
Updated to work under PHP 4.2

Revision 1.1  2003/09/10 13:32:10  dougqh
Initial revision

Revision 1.7  2003/04/02 21:40:45  millz
- added funcs for determining if we are in a form

Revision 1.6  2003/04/01 22:04:09  millz
- debug

Revision 1.5  2003/03/28 15:39:24  millz
- added printDimensions and getDimensions

Revision 1.4  2003/03/27 19:16:00  millz
- made it extend heavy object

Revision 1.3  2003/03/26 21:55:54  millz
- dealing with swapped arg order for Dimensions

Revision 1.2  2003/03/26 20:36:34  millz
- first pass at this class

Revision 1.1  2003/03/26 19:32:09  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

   define( 'GLOBAL_FORM_NAME_STORE', 'GLOBAL_FORM_NAME_STORE'  );

//========================================================================

/*!
@class AHTMLComponent
@abstract -
*/

class AHTMLComponent extends HeavyObject
{

//========================================================================

   var $requestedHeight;
   var $requestedWidth;

//========================================================================

   /*!
   @function AHTMLComponent()
   @discussion - constructs a new AHTMLComponent object
   @result - constructs a new AHTMLComponent object
   */

   function AHTMLComponent()
   {
      //require
      {
         // assert( <stuff here> );
      }
      //body
      {

         $this->requestedHeight = UNSPECIFIED;
         $this->requestedWidth  = UNSPECIFIED;

         $this->HeavyObject();
      }
      //ensure
      {
         // <invariant here>
      }
   }

//========================================================================

   /*!
   @function startForm( $name )
   @discussion - used to let us know that a form tag has started
   @result -
   */

   /* static */
   function startForm( $name )
   {
      $GLOBALS[GLOBAL_FORM_NAME_STORE] = $name;
   }

//========================================================================

   /*!
   @function endForm( )
   @discussion - used to let us know that the form tag has ended
   @result -
   */

   /* static */
   function endForm()
   {
      unset($GLOBALS[GLOBAL_FORM_NAME_STORE]);
   }

//========================================================================

   /*!
   @function inForm( )
   @discussion - used to let us know that we are in a form tag
   @result -
   */

   /* static */
   function inForm()
   {
      return isset( $GLOBALS[GLOBAL_FORM_NAME_STORE] );
   }

//========================================================================

   /*!
   @function getFormName( )
   @discussion - used to let us know the name of the form we are currently in
   @result -
   */

   /* static */
   function getFormName()
   {
      if( isset($GLOBALS[GLOBAL_FORM_NAME_STORE]) )
      {
         return $GLOBALS[GLOBAL_FORM_NAME_STORE];
      }

      return UNSPECIFIED;
   }

//========================================================================

   /*
   @function setRequestedHeight( $height )
   @param $height - int to set req. height to
   @result - no return
   */

   function setRequestedHeight( $height )
   {
      assert( 'is_int($height)' );
      assert( '$height >= 0' );

      // print "Someone set my requested width!!" . BR_NL;

      $this->requestedHeight = $height;
   }

//========================================================================

   /*
   @function setRequestedWidth( $width )
   @param $width - int to set req. width to
   @result - no return
   */

   function setRequestedWidth( $width )
   {
      assert( 'is_int($width)' );
      assert( '$width >= 0' );

      // print 'someone called setRequestedWidth for ' . get_class($this) . BR_NL;

      $this->requestedWidth = $width;
   }

//========================================================================

   /*
   @function getRequestedHeight()
   @discussion -
   @result - returns an int for the req height for this component
   */

   function getRequestedHeight( )
   {
      return $this->requestedHeight;
   }

//========================================================================

   /*
   @function getRequestedWidth()
   @discussion -
   @result - returns an int for the req width for this component
   */

   function getRequestedWidth( )
   {
      return $this->requestedWidth;
   }

//========================================================================

   /*
   @function getPreferredHeight()
   @discussion -
   @result - returns UNSPECIFIED
   */

   function getPreferredHeight( )
   {
      return UNSPECIFIED;
   }

//========================================================================

   /*
   @function getPreferredWidth()
   @discussion -
   @result - returns UNSPECIFIED
   */

   function getPreferredWidth( )
   {
      return UNSPECIFIED;
   }

//========================================================================

   /*
   @function getHTML()
   @discussion - MUST BE OVERRIDDEN!!!!!!!!!!!!!!
   @result - returns UNSPECIFIED
   */

   function getHTML()
   {
      unreachablePoint( 'You are not supposed to call AHTMLComponent::getHTML - it is to be overridden!' );
      return UNSPECIFIED;
   }

//========================================================================

   /*
   @function getRequestedDimensions()
   @discussion -
   @result - returns a dimensions obj with the req height and width values filled into it
   */

   function &getRequestedDimensions()
   {
      importClass( 'Common.Utilities.Dimensions' );

      return new Dimensions( $this->requestedWidth, $this->requestedheight );
   }

//========================================================================

   /*
   @function setRequestedDimensions( &$dimObj )
   @discussion - sets the requested Width and height based on that in the passed in dimension obj
   @result - returns nothing
   */

   function setRequestedDimensions( &$dimObj )
   {

      // print 'someone called setRequestedDimensions for ' . get_class($this) . BR_NL;

      $this->requestedHeight = $dimObj->getHeight();

      $this->requestedWidth = $dimObj->getWidth();
   }

//========================================================================

   /*
   @function getHeight()
   @discussion - returns the height that should be used for this component
   @result - non-negative int
   */

   function getHeight()
   {
     if ( $this->requestedHeight !== UNSPECIFIED )
     {
       return $this->requestedHeight;
     }
     else
     {
       return $this->getPreferredHeight();
     }
   }

//========================================================================

   /*
   @function getWidth()
   @discussion - returns the width that should be used for this component
   @result - non-negative int
   */

   function getWidth()
   {
     if ( $this->requestedWidth !== UNSPECIFIED )
     {
       return $this->requestedWidth;
     }
     else
     {
       return $this->getPreferredWidth();
     }
   }

//========================================================================

   /*
   @function getDimensions()
   @discussion -
   @result - returns a dimensions obj with the req height and width values filled into it
   */

   function &getDimensions()
   {
      importClass( 'Common.Utilities.Dimensions' );

      return new Dimensions(
         $this->getWidth(),
         $this->getHeight() );
   }

//========================================================================

   /*!
   @function printDimensions()
   @discussion - prints width and height settings for this AHTMLComponent
   */

   function printDimensions()
   {
      print 'AHTMLComponent' . '::' . __FUNCTION__ . BR_NL;
      print 'this::width : ' . $this->getWidth() . BR_NL;
      print 'this::height: ' . $this->getHeight() . BR_NL;
      print BR_NL;
   }

//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */

   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================




};

?>