<?php

/*
AText
$Author: millz $
$Revision: 1.2 $
$Date: 2003/09/12 18:42:03 $
$Log: AText.php,v $
Revision 1.2  2003/09/12 18:42:03  millz
- added calls to htmlfilters

Revision 1.1  2003/09/10 13:32:19  dougqh
Initial revision

Revision 1.6  2003/08/05 14:10:28  dougqh
- Modified whitespace handling to handle multiple levels of indentation

Revision 1.5  2003/07/11 17:32:24  dawn
- leading whitepace fix - defect 909

Revision 1.4  2003/07/11 17:31:21  dawn
-

Revision 1.3  2003/07/11 17:29:33  dawn
-

Revision 1.2  2003/07/11 17:25:44  dawn
- leading whitespace issue

Revision 1.1  2003/07/09 21:43:01  dougqh
Initial revision

Revision 1.7  2003/03/27 19:56:37  millz
- bug fix

Revision 1.6  2003/03/27 19:20:03  millz
- updated to extend AHTMLComponent

Revision 1.5  2002/09/24 18:13:34  dougqh
Changing quotes to ticks.

Revision 1.4  2002/08/25 16:24:41  dougqh
Setting color to gray and changing text to none for empty Strings.

Revision 1.3  2002/08/01 16:28:53  dougqh
Debugging and a new invariant check.

Revision 1.2  2002/07/31 16:50:34  dougqh
Fixed some problems with HTML generation.

Revision 1.1  2002/07/01 20:13:07  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.AHTMLComponent' );

//========================================================================

define( 'MAX_CHARS_PER_LINE', 90 );

//========================================================================

/*!
@class AText
@abstract - a class that describes text
*/

class AText extends AHTMLComponent
{

//========================================================================

   /*!
   @function AText( $text )
   @param $text - a string containing the text to be displayed
   @discussion - constructs a new AText object containg the
      string $text
   @result - constructs a new AText object
   */

   function AText( $text )
   {
      $this->AHTMLComponent();

      $this->usingNoneColor = false;
      $this->_setText( $text );
   }

//========================================================================

   /*!
   @function _setText( $text )
   @param $text - the new contents of this AText object
   @discussion - provided for optimizing HTML generation
   */

   function _setText( $text )
   {
      if ( $text == '' )
      {
         importClass( 'Display.Color' );
         $this->color =& Color::getColor( 92, 92, 92 );
         $this->usingNoneColor = true;

         $text = 'None';
      }
      elseif ( $this->usingNoneColor )
      {
         $this->usingNoneColor = false;
         unset( $this->color );
      }

      $text = $this->_getFormattedText( $text );

//      //make sure every , has a space after it
//      $text = str_replace( ',', ', ', $text );
//      //might have introduce ",  " so clean those up
//      $text = str_replace( ',  ', ', ', $text );

      $text = str_replace( "\t", '   ', $text );

      $this->textHTML = nl2br( htmlentities( $text, ENT_QUOTES ) );

      //This adds approximately ~0.05 secs to the project page
      $this->textHTML =
         preg_replace_callback(
            '/([\n\r])( +)(\S)/',
            array( 'AText', 'pregCallBack' ),
            $this->textHTML );
   }

//========================================================================

   /*!
   @function pregCallBack( $matches )
   @discussion - callback function used by _setText
   @result - returns a String
   */

   function pregCallBack( $matches )
   {
      //matches[ 1 ] - is a \n or \r, so put it back in
      //matches[ 2 ] - is one or spaces - replace each space 1.5 &nbsp-s
      //  Luckily, str_repeat works nicely with floats
      //matches[ 3 ] - is the first non-whitespace character, so put it back in
      return
         $matches[ 1 ] .
         str_repeat( '&nbsp;', 1.5 * strlen( $matches[ 2 ] ) ) .
         $matches[ 3 ];
   }

//========================================================================

   /*!
   @function _getFormattedText( $text )
   @discussion - does any additional formatting necessary for this
      Text
   @result - returns a String - which is modified version of $text
      containing any necessary formatting
   */

   /* abstract function _getFormattedText(); */

//========================================================================

   /*!
   @function setFont( $font )
   @param $font - a Font object
   @discussion - sets the Font for this AText object
   */

   function setFont( &$font )
   {
      $this->font =& $font;
   }

//========================================================================

   /*!
   @function setColor( $color )
   @param $color - a Color object
   @discussion - sets the text Color for this AText object
   */

   function setColor( &$color )
   {
      $this->color =& $color;
      $this->usingNoneColor = false;
   }

//========================================================================

   /*!
   @function getHTML()
   @discussion - generates HTML that corresponds to this object
   @result - returns a string containg an HTML representation
      of this AText object
   */

   function getHTML()
   {
      if ( ! isset( $this->font ) )
      {
         importClass( 'Display.Font' );
         $this->font =& Font::getFont();
      }

      if ( isset( $this->color ) )
      {
         $fontHead = $this->font->getHTMLHead( $this->color->getHexString() );
      }
      else
      {
         $fontHead = $this->font->getHTMLHead();
      }

      // use the line (with the runHTMLFilters line commented) to bypass the filters
      // $filteredHTMLString = $this->textHTML;
      $filteredHTMLString = $this->runHTMLFilters( $this->textHTML );

      return $fontHead . $filteredHTMLString . $this->font->getHTMLTail();
   }

//========================================================================

   /*!
   @function runHTMLFilters( $htmlString )
   @discussion - runs html filters
   @result - htmlString
   */

   function runHTMLFilters( $htmlString )
   {
      importClass( 'HTMLComponents.Filters.HTMLFilterFactory' );
      $factory =& HTMLFilterFactory::getInstance();
      
      $filters =& $factory->getDefaultFilters();
      
      foreach($filters as $thisFilter)
      {
         $htmlString = $thisFilter->filter( $htmlString );
      }
      
      return $htmlString;
   }

//========================================================================
};

?>