<?php

/*
CompositeHTMLComponent
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/10 13:32:19 $
$Log: CompositeHTMLComponent.php,v $
Revision 1.1  2003/09/10 13:32:19  dougqh
Initial revision

Revision 1.6  2003/04/21 15:11:06  dougqh
Debugging

Revision 1.5  2003/03/27 19:56:05  millz
- bug fix

Revision 1.4  2003/03/27 19:19:59  millz
- updated to extend AHTMLComponent

Revision 1.3  2002/09/24 19:45:51  dougqh
Changing quotes to ticks.

Revision 1.2  2002/08/20 15:25:17  dougqh
Adding a new method setJoiner. Fixed problem with not being passed by reference to add.

Revision 1.1  2002/07/01 20:13:07  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( "HTMLComponents.AHTMLComponent" );

//========================================================================

/*!
@class CompositeHTMLComponent
@abstract - This class allows multiple HTML elements to be linked together
   used some common joining string
@discussion - This class is only intended to be used for the basic forms
   of aggregating information.  When appropriate use Table, ResultsTable,
   or ItemList classes instead of CompositeHTMLComponent
*/

class CompositeHTMLComponent extends AHTMLComponent
{

//========================================================================

   var $joiner;

   var $html;

//========================================================================

   /*!
   @function CompositeHTMLComponent( [ $joiner ] )
   @param $joiner - a string containing the characters that should
      be used to separate the entities added to this composite.  The
      string will be interpreted as raw HTML.
      Defaults to BR.
   @discussion - constructs a new CompositeHTMLComponent object
      - This form of the constructor constructs a Composite with no
        initial entries
   @result - constructs a new CompositeHTMLComponent object
   */

   function CompositeHTMLComponent( $joiner = UNSPECIFIED )
   {
      //require
      {
      }
      //body
      {
         //This line needs to be ahead of any calls to add later in the
         //constructor
         $this->html = '';

         if ( $joiner === UNSPECIFIED )
         {
            //If the joiner was omitted then default to <br/>

            $this->joiner = BR;
         }
         else
         {
            $this->joiner = $joiner;
         }

         $this->AHTMLComponent();
      }
      //ensure
      {
         assert( '$this->_invariant()' );
      }
   }

//========================================================================

   /*!
   @function setJoiner( $joiner )
   @param $joiner - a new String to use to join additional elements
      added to this CompositeHTMLComponent
   @discussion - changes the joining String between
   */

   function setJoiner( $joiner )
   {
      $this->joiner = $joiner;

      assert( '$this->_invariant()' );
   }

//========================================================================

   /*!
   @function add( $htmlComponent )
   @param $htmlComponent - a HTMLComponent to add to this Composite
   @discussion - adds an HTMLComponent to the end of this Composite
   */

   function add( &$htmlComponent )
   {
      $newHTML = $htmlComponent->getHTML();

      if ( $newHTML != '' )
      {
         if ( $this->html != '' )
         {
            $this->html .= $this->joiner;
         }

         $this->html .= $newHTML;
      }
   }

//========================================================================

   /*!
   @function getHMTL()
   @discussion - provides an HTML representation of this Composite
   @result - returns a string containing an HTML representation of this
      composite
   */

   function getHTML()
   {
      assert( '$this->_invariant()' );

      return $this->html;
   }

//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */

   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>