<?php

/*
EmailAddress
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/10 13:32:19 $
$Log: EmailAddress.php,v $
Revision 1.1  2003/09/10 13:32:19  dougqh
Initial revision

Revision 1.3  2003/03/27 19:58:27  millz
- bug fix

Revision 1.2  2003/03/27 19:19:20  millz
- updated to extend AHTMLComponent

Revision 1.1  2002/07/23 18:34:34  clay
Initial revision

Revision 1.1  2002/07/01 20:13:07  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

importClass( "HTMLComponents.AHTMLComponent" );

//========================================================================

/*!
@class EmailAddress
@abstract - a class that describes EmailAddress
*/

class EmailAddress extends AHTMLComponent
{

//========================================================================

   var $font;
   var $html;
   var $color;

//========================================================================

   /*!
   @function EmailAddress( $text )
   @param $text - a string containing the text to be displayed
   @discussion - constructs a new EmailAddress object containg the
      string $Email
   @result - constructs a new EmailAddress object
   */
   
   function EmailAddress( $text )
   {
      //require
      {
      }
      //body
      {
         $this->html = nl2br( htmlentities( $text, ENT_QUOTES ) );
         
         importClass( "Display.Font" );
         $this->font =& Font::getFont();
         
         $this->AHTMLComponent();
      }
      //ensure
      {
         assert( "\$this->_invariant()" );
      }
   }  

//========================================================================

   /*!
   @function _setEmailAddress( $text )
   @param $text - the new contents of this EmailAddress object
   @discussion - provided for optimizing HTML generation
   */
   
   function _setEmailAddress( $text )
   {
      $this->html = nl2br( htmlentities( $text, ENT_QUOTES ) );
   }
   
//========================================================================

   /*!
   @function setFont( $font )
   @param $font - a Font object
   @discussion - sets the Font for this EmailAddress object
   */
   
   function setFont( &$font )
   {
      //require
      {
         assert( "isInstanceOf( \$font, 'Font' )" );
         assert( "\$this->_invariant()" );
      }
      //body
      {
         $this->font =& $font;
      }
      //ensure
      {
         assert( "\$this->_invariant()" );
      }
   }

//========================================================================

   /*!
   @function setColor( $color )
   @param $color - a Color object
   @discussion - sets the text Color for this EmailAddress object
   */
   
   function setColor( &$color )
   {
      //require
      {
         assert( "\$this->_invariant()" );
      }
      //body
      {
         $this->color =& $color;
      }
      //ensure
      {
         assert( "\$this->_invariant()" );
      }
   }
   
//========================================================================

   /*!
   @function getHTML()
   @discussion - generates HTML that corresponds to this object
   @result - returns a string containg an HTML representation
      of this EmailAddress object
   */
   
   function getHTML()
   {
      //require
      {
         assert( "\$this->_invariant()" );
      }
      //body
      {
         $this->html = "<a href='mailto:".$this->html."'>".$this->html."</a>";
         
         if ( isset( $this->color ) )
         {
            $html = $this->font->getHTMLHead( $this->color->getHexString() );
         }
         else
         {
            $html = $this->font->getHTMLHead();
         }
         
         $html .= $this->html . $this->font->getHTMLTail();
      }
      //ensure
      {
         assert( "\$this->_invariant()" );
      }
      
      return $html;
   }

//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return isInstanceOf( $this->font, 'Font' ) &&
             ( ! isset( $this->color ) ||
               isInstanceOf( $this->color, 'Color' ) ) &&
             parent::_invariant();
   }

//========================================================================

};

?>