<?php

/*
HTMLFilterFactory
$Author: millz $
$Revision: 1.1 $
$Date: 2003/09/12 18:42:25 $
$Log: HTMLFilterFactory.php,v $
Revision 1.1  2003/09/12 18:42:25  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

define( 'HTMLFILTER_DIRECTORY', truePath( 'php_classes/HTMLComponents/Filters/HTMLFilters', true ) );
define( 'HTMLFILTER_PACKAGE', 'HTMLComponents.Filters.HTMLFilters' );

//========================================================================

/*!
@class HTMLFilterFactory
@abstract -
*/

class HTMLFilterFactory extends Object
{

//========================================================================

   /*!
   @function HTMLFilterFactory()
   @discussion - constructs a new HTMLFilterFactory object
   @result - constructs a new HTMLFilterFactory object
   */

   function HTMLFilterFactory()
   {
      $this->Object();
   }

//========================================================================

   /*!
   @function getInstance()
   */

   /* static */
   function &getInstance()
   {
      static $instance;

      if( !isset($instance[0]) )
      {
         $instance[0] =& new HTMLFilterFactory();
      }

      return $instance[0];
   }


//========================================================================

   /*
   @function &getFilter( $name )
   @discussion -
   @result - returns IHTMLFilter
   */

   function &getFilter( $name )
   {
      static $filterObjHash;

      if( !isset($filterObjHash{$name}) )
      {
         importClass( HTMLFILTER_PACKAGE . '.' . $name );
         $filterObjHash{$name} = new $name();
      }

      return $filterObjHash{$name};
   }

//========================================================================

   /*
   @function &getDefaultFilters()
   @discussion -
   @result - returns IHTMLFilter[]
   */

   function &getDefaultFilters()
   {
      static $defaultFilters;

      if( !isset($defaultFilters) )
      {
         $files = getDirectoryListing( HTMLFILTER_DIRECTORY, array( 'HTMLFilter.php' ) );

         foreach ($files as $thisName)
         {
            $thisName = preg_replace( '/\.php\Z/', '', $thisName );
            // print "Name is $thisName";
            if($thisName != 'AHTMLFilter'){ $defaultFilters[] =& $this->getFilter( $thisName );   }
         }
      }

      return $defaultFilters;
   }

//========================================================================

};

?>