<?php

/*
URLHTMLFilter
$Author: millz $
$Revision: 1.6 $
$Date: 2004/10/26 18:27:37 $
$Log: URLHTMLFilter.php,v $
Revision 1.6  2004/10/26 18:27:37  millz
- slight tweak to colon handling

Revision 1.5  2004/07/13 16:02:43  millz
- added /home/millz as a valid char

Revision 1.4  2004/06/16 21:51:09  millz
- needed another htmlentities call when finalizing the url html

Revision 1.3  2003/09/15 20:27:21  millz
- updated to deal with weird things like

Revision 1.2  2003/09/12 18:44:12  millz
-

Revision 1.1  2003/09/12 18:42:42  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

importClass( 'HTMLComponents.Filters.HTMLFilters.AHTMLFilter' );

//========================================================================

/*!
@class URLHTMLFilter
@abstract - 
*/

class URLHTMLFilter extends AHTMLFilter
{

//========================================================================

   // <class vars>

//========================================================================

   /*!
   @function URLHTMLFilter()
   @discussion - constructs a new URLHTMLFilter object
   @result - constructs a new URLHTMLFilter object
   */
   
   function URLHTMLFilter()
   {
      //require
      {
         // assert( <stuff here> );
      }
      //body
      {
         $this->AHTMLFilter();
      }
      //ensure
      {
         // <invariant here>
      }
   }

//========================================================================

   /*
   @function getRegularExpression()
   @discussion -
   @result - htmlString
   */

   function getRegularExpression()
   {
      // return '/http(s)?:\/\/(\?|\=|\:|\-|\%|\.|\w|\/|\&|\;|\+|\#)+/';
      return '"http(s)?://(\?|=|\w|:\d|-|~|%|\.|/|_|&|;|\+|#)+"';
   }
   
//========================================================================

   /*
   @function getReplacement($match)
   @param $htmlString - the html to filter
   @discussion -
   @result - htmlString
   */

   function getReplacement($match)
   {
      // $match has already had htmlenitites called on it
      // we have to deal with any &quot; types of things in the matched area
      // the only legal one like that is &amp; for & so we will manually replace that first
      
      $match = str_replace ( '&amp;', '&', $match );
      
      $temp = $match;
      $rest = '';
      if( strpos( $temp, ';' ) !== false )
      {
         // we may have some HTML like &quot; or &gt; at the end which needs to die
         // chop off at first ;
         $parts = explode ( ';', $temp);
         
         $validPart = $parts[0];

         $temp = substr ( $validPart, 0, strrpos( $validPart, '&' ));
         $rest = substr($match,strlen($temp));
      }
      
      // i believe that this htmlentities call will only be used to re-convert & to &amp;
      return "<a href=".html_entity_decode($temp,ENT_QUOTES).">".htmlentities($temp)."</a>".$rest;

   }
   
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>