<?php

/*
ABackgroundGeneratedImage
$Author: dougqh $
$Revision: 1.2 $
$Date: 2003/09/29 17:01:29 $
$Log: ABackgroundGeneratedImage.php,v $
Revision 1.2  2003/09/29 17:01:29  dougqh
Updated file path handling to work under Windows

Revision 1.1  2003/09/10 13:33:22  dougqh
Initial revision

Revision 1.2  2003/03/26 23:37:17  millz
- added getPreferredHeight and width

Revision 1.1  2003/03/26 22:39:16  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.Images.AGeneratedImage' );

//========================================================================

/*!
@class ABackgroundGeneratedImage
@abstract -
*/

class ABackgroundGeneratedImage extends AGeneratedImage
{

//========================================================================

   // <class vars>

//========================================================================

   /*!
   @function ABackgroundGeneratedImage()
   @discussion - constructs a new ABackgroundGeneratedImage object
   @result - constructs a new ABackgroundGeneratedImage object
   */

   function ABackgroundGeneratedImage()
   {
      $this->AGeneratedImage();
   }

//========================================================================

   /*
   @function getBaseImageFileName( )
   @discussion - returns the name of the background file, relative to the baseImages dir
   @result - string path
   */

   /* abstract function getBaseImageFileName(); */

//========================================================================

   /*
   @function getAbsoluteBaseImageFileName( )
   @discussion -
   @result - full path to background image on disk
   */

   function getAbsoluteBaseImageFileName()
   {
      return trueApachePath( 'images' ) . BASE_IMAGES_SUB_DIR . $this->getBaseImageFileName() ;
   }

//========================================================================

   /*
   @function _generateImage( )
   @discussion - generate image
   @result - image handle
   */

   function _generateImage()
   {
      $image = loadImage( $this->getAbsoluteBaseImageFileName() );

      $this->_finishGenerateImage( $image );

      return $image;
   }

//========================================================================

   /*
   @function _finishGenerateImage( &$image )
   @param $image - ref to imagehandle
   @discussion - this will do any more work that is needed to create the image - this is to be overridden
   @result - nothing, will modify the ref'd image
   */

   function _finishGenerateImage( &$image )
   {
      unreachablepoint( 'ABackgroundGeneratedImage::_finishGenerateImage needs to be overridden!' );
   }

//========================================================================

   /*
   @function _loadDimensions()
   @discussion - determines what dimensions the image has
   @result - returns nothing
   */

   function _loadDimensions()
   {
      if( ! isset( $this->width ) )
      {
         $imageSizeArray = getimagesize( $this->getAbsoluteBaseImageFileName() );

         $this->width = $imageSizeArray[0];
      }

      if( ! isset( $this->height ) )
      {
         if( !isset($imageSizeArray) ){ $imageSizeArray = getimagesize( $this->getAbsoluteBaseImageFileName() ); }

         $this->height = $imageSizeArray[1];
      }
   }

//========================================================================

   /*
   @function getPreferredWidth()
   @discussion - get the width we want to be
   @result - returns non-negative int
   */

   function getPreferredWidth()
   {
      $this->_loadDimensions();

      return $this->width;
   }

//========================================================================

   /*
   @function getPreferredHeight()
   @discussion - get the height we want to be
   @result - returns non-negative int
   */

   function getPreferredHeight()
   {
      $this->_loadDimensions();

      return $this->height;
   }

//========================================================================

};

?>