<?php

/*
AImage
$Author: dougqh $
$Revision: 1.3 $
$Date: 2003/09/29 17:01:29 $
$Log: AImage.php,v $
Revision 1.3  2003/09/29 17:01:29  dougqh
Updated file path handling to work under Windows

Revision 1.2  2003/09/10 13:45:58  dougqh
- Fixed tooltip display in Gecko browsers.

Revision 1.1  2003/09/10 13:33:22  dougqh
Initial revision

Revision 1.4  2003/07/09 21:40:15  dougqh
?

Revision 1.3  2003/03/26 23:37:30  millz
- some more updates for image maps and mouseovers

Revision 1.2  2003/03/26 21:30:18  millz
- commenting

Revision 1.1  2003/03/26 21:28:33  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.AHTMLComponent' );

//========================================================================

/*!
@class AImage
@abstract -
*/

class AImage extends AHTMLComponent
{

//========================================================================

   var $onMouseOut;
   var $onMouseOver;
   var $name;

   var $imageMapHTML;
   var $imageMapName;

//========================================================================

   /*!
   @function AImage()
   @discussion - constructs a new AImage object
   @result - constructs a new AImage object
   */

   function AImage()
   {
      $this->AHTMLComponent();
   }

//========================================================================

   /*!
   @function getAlternateText()
   @discussion - will be used for the alt attrib of the img html tag
   @result - user-presentable text
   */

   /* abstract function getAlternateText(); */

//========================================================================

   /*!
   @function getSrc()
   @discussion - abstract
   @result - partial/full URL string
   */

   /* abstract function getSrc() */

//========================================================================

   /*!
   @function getBorderSize()
   @discussion - returns the size of the border for the image when it is a link
   @result - int
   */

   function getBorderSize()
   {
      return 0;
   }

//========================================================================

   /*!
   @function getHTML()
   @discussion - builds the html for the image to show in the web page
   @result - string - an img HTML tag
   */

   function getHTML()
   {
      $out = '';

      $attribs[] = 'border="'.$this->getBorderSize().'"';

      $attribs[] = 'src="'.$this->getSrc().'"';

      $attribs[] = 'alt="'.addslashes( $this->getAlternateText() ) . '"';

      $attribs[] = 'title="' . addslashes( $this->getAlternateText() ) . '"';

      if( isset($this->name) ){ $attribs[] = 'name="'.$this->name.'"'; }

      if( isset($this->onMouseOut) ){ $attribs[] = 'onMouseOut="'.$this->onMouseOut.'"'; }

      if( isset($this->onMouseOver) ){ $attribs[] = 'onMouseOver="'.$this->onMouseOver.'"'; }

      if ( isset( $this->imageMapName ) )
      {
         $attribs[] = ' usemap="#' . $this->imageMapName . '"';
         $out .= $this->imageMapHTML;
      }

      $width = $this->getWidth();
      if($width !== UNSPECIFIED){ $attribs[] = 'width="'.$width.'"'; }

      $height = $this->getHeight();
      if($height !== UNSPECIFIED){ $attribs[] = 'height="'.$height.'"'; }

      //------------

      // we need .= b/c out might be set above
      $out .= '<img '.implode(' ', $attribs).' />';

      return $out;
   }

//========================================================================

   /*!
   @function setName( $name )
   @param $name - name to use
   @discussion - lets you set the name of hte image in the html
   */

   function setName( $name )
   {
      $this->name = $name;
   }


//========================================================================

   /*!
   @function setOnMouseOver( $codeString )
   @param $codeString - the string of code to execute on image's mouseOver
   @discussion - will add this to the image's tag
   */

   function setOnMouseOver( $codeString )
   {
      $this->onMouseOver = $codeString;
   }

//========================================================================

   /*!
   @function setOnMouseOut( $codeString )
   @param $codeString - the string of code to execute on image's mouseOut
   @discussion - will add this to the image's tag
   */

   function setOnMouseOut( $codeString )
   {
      $this->onMouseOut = $codeString;
   }

//========================================================================

   /*!
   @function setImageMap( &$imageMap )
   @param $imageMap - an ImageMap to use with this Image
   @discussion - sets this Image to use an ImageMap
   */

   function setImageMap( &$imageMap )
   {
      assert( '$this->_invariant()' );

      $this->imageMapName = $imageMap->getName();
      $this->imageMapHTML = $imageMap->getMapHTML();
   }

//========================================================================

};

?>