<?php

/*
ArrowImage
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/10 13:33:22 $
$Log: ArrowImage.php,v $
Revision 1.1  2003/09/10 13:33:22  dougqh
Initial revision

Revision 1.4  2003/03/26 23:46:34  millz
- updated for new StaticInternalImage

Revision 1.3  2002/08/24 19:41:41  millz
bug fixes to arrow filenames and file formats

Revision 1.2  2002/08/21 13:17:20  millz
added constants, made isDisabled optional, documentation fix

Revision 1.1  2002/08/20 21:47:11  millz
Initial revision

Revision 1.1  2002/07/01 20:14:03  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

importClass( "HTMLComponents.Images.StaticInternalImage" );

//========================================================================

define("RIGHT_ARROW","right");
define("LEFT_ARROW","left");
define("UP_ARROW","up");
define("DOWN_ARROW","down");

//========================================================================

/*!
@class ArrowImage
@abstract - a concrete Image class which represents static images
   stored in this GenePort's images directory
*/

class ArrowImage extends StaticInternalImage
{
//========================================================================

   /*!
   @function ArrowImage( $direction, $alternateText,[ $isDisabled ] )
   @param $direction - the direction that the arrow should point, 
      possible values are from the constants RIGHT_ARROW, LEFT_ARROW, DOWN_ARROW, UP_ARROW
   @param $alternateText - the text displayed on mouse over or if the
      Image can not be displayed
   @param $isDisabled - whether this arrow image should look "disabled" - defaults to FALSE
   @discussion - constructs a new ArrowImage object
   @result - constructs a new ArrowImage object
   */
   
   function ArrowImage( $direction, $alternateText, $isDisabled = UNSPECIFIED )
   {
      //require
      {
         assert( "preg_match('/(UP|DOWN|RIGHT|LEFT)/i', \$direction)" );
         assert( "\$alternateText != ''" );
      }
      //body
      {
         
         $isDisabled = ( $isDisabled === UNSPECIFIED ) ? FALSE : $isDisabled;
         
         if( $isDisabled ){ $extraName = "_disabled"; }
         else { $extraName = ""; }
         
         // sample name: down_arrow_disabled.gif
         $lowerDirection = strtolower($direction);
         $imageFile = "baseImages/".$lowerDirection."_arrow".$extraName.".png";
         
         $this->StaticInternalImage( $imageFile, $alternateText );
      }
      //ensure
      {
         assert( "\$this->_invariant()" );
      }
   }
   
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>