<?php

/*
CircleShape
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/10 13:33:22 $
$Log: CircleShape.php,v $
Revision 1.1  2003/09/10 13:33:22  dougqh
Initial revision

Revision 1.2  2003/07/09 21:40:15  dougqh
?

Revision 1.1  2002/07/22 18:42:45  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

importClass( "HTMLComponents.Images.Shape" );

//========================================================================

/*!
@class CircleShape
@abstract - a concrete Shape class
*/

class CircleShape extends Shape
{

//========================================================================

   var $centerX;
   var $centerY;
   var $radius;

//========================================================================

   /*!
   @function CircleShape( $centerX, $centerY, $radius )
   @param $centerX - x-coordinate of the center of the circle
   @param $centerY - y-coordinate of the center of the circle
   @param $radius - the radius of the circle
   @discussion - constructs a new CircleShape object
   @result - constructs a new CircleShape object
   */
   
   function CircleShape( $centerX, $centerY, $radius)
   {
      //require
      {
         assert( "\$radius >= 0" );
         assert( "( \$centerX >= 0 )&& ( \$centerX >= \$radius )" );
         assert( "( \$centerY >= 0 )&& ( \$centerY >= \$radius )" );
      }
      //body
      {
         $this->centerX = $centerX;
         $this->centerY = $centerY;
         $this->radius = $radius;
         
         $this->Shape();
      }
      //ensure
      {
         assert( "\$this->_invariant()" );
      }
   }

//========================================================================

   /*!
   @function getMapShape()
   @discussion - provides the image map shape identifier for this Shape
   @result - returns "rectangle"
   */
   
   function getMapShape()
   {
      return "circle";
   }

//========================================================================

   /*!
   @function getMapCoordinates()
   @discussion - provides a coordinate String to use in a map area
   @result - returns a non-empty String
   */
   
   function getMapCoordinates()
   {   
      return $this->centerX . "," . $this->centerY . "," . $this->radius;
   }
         
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant() &&
         ( $this->radius >= 0 ) &&
         ( $this->centerX >= 0 ) && ( $this->centerX >= $this->radius ) &&
         ( $this->centerY >= 0 )&& ( $this->centerY >= $this->radius );
   }

//========================================================================

};

?>