<?php

/*
RectangleShape
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/10 13:33:22 $
$Log: RectangleShape.php,v $
Revision 1.1  2003/09/10 13:33:22  dougqh
Initial revision

Revision 1.2  2003/02/14 15:40:00  millz
fix to use correct cords

Revision 1.1  2002/07/22 18:42:32  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

importClass( "HTMLComponents.Images.Shape" );

//========================================================================

/*!
@class RectangleShape
@abstract - a concrete Shape class
*/

class RectangleShape extends Shape
{

//========================================================================

   var $upperLeftX;
   var $upperLeftY;
   var $lowerRightX;
   var $lowerRightY;

//========================================================================

   /*!
   @function RectangleShape( $upperLeftX, $upperLeftY, $lowerRightX, $lowerRightY )
   @param $upperLeftX - the x-coordinate of the upper left corner
   @param $upperLeftY - the y-coordinate of the upper left corner
   @param $lowerRightX - the x-coordinate of the lower right corner
   @param $lowerRightY - the y-coordinate of the lower right corner
   @discussion - constructs a new RectangleShape object
   @result - constructs a new RectangleShape object
   */
   
   function RectangleShape( $upperLeftX, $upperLeftY, $lowerRightX, $lowerRightY )
   {
      //require
      {
         assert( "\$upperLeftX >= 0" );
         assert( "\$upperLeftY >= 0" );
         assert( "\$lowerRightX >= 0" );
         assert( "\$lowerRightX >= 0" );
      }
      //body
      {
         $this->upperLeftX = $upperLeftX;
         $this->upperLeftY = $upperLeftY;
         $this->lowerRightX = $lowerRightX;
         $this->lowerRightY = $lowerRightY;

         $this->Shape();
      }
      //ensure
      {
         assert( "\$this->_invariant()" );
      }
   }

//========================================================================

   /*!
   @function getMapShape()
   @discussion - provides the image map shape identifier for this Shape
   @result - returns "rectangle"
   */
   
   function getMapShape()
   {
      return "rect";
   }

//========================================================================

   /*!
   @function getMapCoordinates()
   @discussion - provides a coordinate String to use in a map are
   @result - returns a non-empty String
   */
   
   function getMapCoordinates()
   {   
      return $this->upperLeftX . "," . $this->upperLeftY . "," .
             $this->lowerRightX . "," . $this->lowerRightY;
   }
         
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant() &&
             ( $this->upperLeftX >= 0 ) &&
             ( $this->upperLeftY >= 0 ) &&
             ( $this->lowerRightX >= 0 ) &&
             ( $this->lowerRightX >= 0 );
   }

//========================================================================

};

?>
