<?php

/*
RollOverImage
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/10 13:33:22 $
$Log: RollOverImage.php,v $
Revision 1.1  2003/09/10 13:33:22  dougqh
Initial revision

Revision 1.3  2003/07/09 21:40:15  dougqh
?

Revision 1.2  2003/03/26 22:47:05  millz
- changed StaticImage calls to StaticInternalImage

Revision 1.1  2003/02/18 18:30:04  millz
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

define( 'FUNC_NAME', 'changeImgSrc' );

//========================================================================

   importClass( 'HTMLComponents.Images.StaticInternalImage' );

//========================================================================

/*!
@class RollOverImage
@abstract - 
*/

class RollOverImage extends StaticInternalImage
{

//========================================================================

   var $overImage;
   var $normalImage;
   

//========================================================================

   /*!
   @function RollOverImage()
   @discussion - constructs a new RollOverImage object
   @result - constructs a new RollOverImage object
   */
   
   function RollOverImage( $normalImage, $overImage, $altText )
   {
      //require
      {
         // assert( <stuff here> );
      }
      //body
      {
         $this->overImage = $overImage;
         $this->normalImage = $normalImage;
         
         $this->StaticInternalImage($normalImage,$altText);
      }
      //ensure
      {
         // <invariant here>
      }
   }

//========================================================================

   /*!
   @function getHTML()
   @discussion - returns the HTML for this obj
   @result - html text
   */

   function getHTML()
   {

      RollOverImage::_addJavaScriptFunction();
      
      $name = 'img_'.rand(0,2000000);
      
      $this->setOnMouseOut( FUNC_NAME.'(\''.$name.'\',\'../images/'.$this->normalImage.'\');' );
      $this->setOnMouseOver( FUNC_NAME.'(\''.$name.'\',\'../images/'.$this->overImage.'\');' );
      
      $this->setName($name);
      
      return parent::getHTML();
      
   }

//========================================================================

   /*!
   @function _addJavaScriptFunction()
   @discussion - helper function to set up the javascript needed to rollover the image
   @result - no return
   */

   function _addJavaScriptFunction()
   {
      static $added;
      
      if( !isset( $added ) )
      {
         $added = true;
         
         importClass( 'HTMLComponents.Scripting.ScriptBlock' );
         importClass( 'HTMLComponents.Scripting.ScriptFunction' );
         
         // add to script block - make new js func for each image, later we will reuse funcs properly 
         $paramNameArray = new_array( 'name', 'newSrc' );
         $thisFunc =& ScriptFunction::createJavaScriptFunction( FUNC_NAME, $paramNameArray );
         $thisFunc->addCode( 'if(document.images[name]) { document.images[name].src = newSrc; }' );

         $jsBlock =& ScriptBlock::createJavaScriptBlock();
         $jsBlock->addFunction( $thisFunc );    
         
         $jsBlock->addToPageHead();
         
      }
   }
   
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>