<?php

/*
RotatingImage
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/10 13:33:22 $
$Log: RotatingImage.php,v $
Revision 1.1  2003/09/10 13:33:22  dougqh
Initial revision

Revision 1.2  2003/03/26 22:47:09  millz
- changed StaticImage calls to StaticInternalImage

Revision 1.1  2003/02/18 18:30:04  millz
Initial revision

Revision 1.2  2002/10/01 23:46:31  dougqh
Taking advantage of Image::getRotatingImageAbsoluteURL.

Revision 1.1  2002/07/01 20:14:03  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

importClass( "HTMLComponents.Images.StaticInternalImage" );

//========================================================================

/*!
@class RotatingImage
@abstract - a rotating image is one that is chosen randomly from a set (memoryless)
*/

class RotatingImage extends StaticInternalImage
{
//========================================================================

   /*!
   @function RotatingImage( $imageFileArray, $alternateText )
   @param $imageFileArray - array of possible names of the file that contains the Image
      i.e. foo.gif - one will be chosen randomly
   @param $alternateText - the text displayed on mouse over or if the
      Image can not be displayed
   @discussion - constructs a new RotatingImage object
   @result - constructs a new RotatingImage object
   */
   
   function RotatingImage( $imageFileArray, $alternateText )
   {
      //require
      {
         assert( 'count($imageFileArray) > 0' );
      }
      //body
      {
         
         // choose a random, valid index
         
                
         $this->StaticInternalImage( 
            $imageFileArray[rand( 0 , count($imageFileArray)-1 )],
            $alternateText );
      }
      //ensure
      {
         assert( "\$this->_invariant()" );
      }
   }
   
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>