<?php

/*
StaticInternalImage
$Author: dougqh $
$Revision: 1.2 $
$Date: 2003/09/29 17:01:29 $
$Log: StaticInternalImage.php,v $
Revision 1.2  2003/09/29 17:01:29  dougqh
Updated file path handling to work under Windows

Revision 1.1  2003/09/10 13:33:22  dougqh
Initial revision

Revision 1.2  2003/07/09 21:40:15  dougqh
?

Revision 1.1  2003/03/26 23:46:57  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.Images.AInternalImage' );

//========================================================================

/*!
@class StaticInternalImage
@abstract -
*/

class StaticInternalImage extends AInternalImage
{

//========================================================================

   var $fileName;
   var $altText;
   var $width;
   var $height;

//========================================================================

   /*!
   @function StaticInternalImage( $fileName, $altText, $width = UNSPECIFIED, $height = UNSPECIFIED )
   @param - $fileName - the name of the image file - relative to the images dir
   @param - $altText - the alt text for the image in the html - the tooltip basically
   @param - $width - the optional width of this image
   @param - $height - the optional height of this image
   @discussion - !!! DO NOT CALL THIS CONSTRUCTOR - USE THE STATIC createImage() below  !!!!!!!!!!!!
   @result - constructs a new StaticInternalImage object
   */

   function StaticInternalImage( $fileName, $altText, $width = UNSPECIFIED, $height = UNSPECIFIED )
   {
      $this->fileName = $fileName ;
      $this->altText = $altText;

      if( $width !== UNSPECIFIED ){ $this->width = $width; }

      if( $height !== UNSPECIFIED ){ $this->height = $height; }

      $this->AInternalImage();
   }

//========================================================================

   /*
   @function &createImage(  $fileName, $altText, $width = UNSPECIFIED, $height = UNSPECIFIED )
   @param - $fileName - the name of the image file - relative to the images dir
   @param - $altText - the alt text for the image in the html - the tooltip basically
   @param - $width - the optional width of this image
   @param - $height - the optional height of this image
   @discussion - this is the static to call to get a new staticInternalImage
   @result - returns StaticInternalImage
   */

   function &createImage(  $fileName, $altText, $width = UNSPECIFIED, $height = UNSPECIFIED )
   {
      return new StaticInternalImage( $fileName, $altText, $width, $height );
   }

//========================================================================

   /*
   @function getFileName()
   @discussion -
   @result - returns string of path relative to images dir
   */

   function getFileName()
   {
      return $this->fileName;
   }

//========================================================================

   /*
   @function getAlternateText()
   @discussion -
   @result - returns string
   */

   function getAlternateText()
   {
      return $this->altText;
   }

//========================================================================

   /*
   @function _loadDimensions()
   @discussion - determines what dimensions the image has
   @result - returns nothing
   */

   function _loadDimensions()
   {
      if(    !file_exists( $this->getAbsoluteFileName() )    )
               {return;}

      if( ! isset( $this->width ) )
      {
         $imageSizeArray = getimagesize( $this->getAbsoluteFileName() );

         $this->width = $imageSizeArray[0];
      }

      if( ! isset( $this->height ) )
      {
         if( !isset($imageSizeArray) ){ $imageSizeArray = getimagesize( $this->getAbsoluteFileName() ); }

         $this->height = $imageSizeArray[1];
      }
   }

//========================================================================

   /*
   @function getPreferredWidth()
   @discussion - get the width we want to be
   @result - returns non-negative int
   */

   function getPreferredWidth()
   {
      $this->_loadDimensions();

      return $this->width;
   }

//========================================================================

   /*
   @function getPreferredHeight()
   @discussion - get the height we want to be
   @result - returns non-negative int
   */

   function getPreferredHeight()
   {
      $this->_loadDimensions();

      return $this->height;
   }

//========================================================================

};

?>