<?php

/*
ItemList
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/10 13:32:19 $
$Log: ItemList.php,v $
Revision 1.1  2003/09/10 13:32:19  dougqh
Initial revision

Revision 1.7  2003/07/09 21:43:01  dougqh
?

Revision 1.6  2003/03/27 19:56:21  millz
- bug fix

Revision 1.5  2003/03/27 19:19:15  millz
- updated to extend AHTMLComponent

Revision 1.4  2002/09/24 19:35:13  dougqh
Switching quotes to ticks.

Revision 1.3  2002/07/30 22:13:53  dougqh
Changed getList to getBulletedList.

Revision 1.2  2002/07/26 19:39:37  dougqh
Added new static methods getList and getNumberedList.

Revision 1.1  2002/07/01 20:13:07  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.AHTMLComponent' );

//========================================================================

/*!
@class ItemList
@abstract - this is class that aids in the creation of HTML lists
   - it implements HTMLComponent
*/

class ItemList extends AHTMLComponent
{

//========================================================================
   
   var $headHTML;
   var $tailHTML;
   var $itemsHTML;

//========================================================================

   /*!
   @function ItemList( $ordered )
   @param $ordered - an optional boolean parameter indicating that this
      is an ordered list
   @discussion - constructs a new ItemList object
      
      Do NOT call this constructor directly.
      Call getList or getNumberedList as appropriate.
      
   @result - constructs a new ItemList object
   */
   
   /* private */
   function ItemList( $ordered = FALSE )
   {
      //require
      {
      }
      //body
      {
         if ( $ordered )
         {
            $this->headHTML = '<ol>';
            $this->tailHTML = '</ol>';
         }
         else
         {
            $this->headHTML = '<ul>';
            $this->tailHTML = '</ul>';
         }
         
         $this->itemsHTML = '';
         
         $this->AHTMLComponent();
      }
      //ensure
      {
         assert( '$this->_invariant()' );
      }
   }

//========================================================================

   /*!
   @function getBulletedList()
   @discussion - provides a new ItemList which is an HTML unordered list
   @result - returns an ItemList
   */
   
   /* static deprecated */
   function &getBulletedList()
   {
      return new ItemList( false );
   }

//========================================================================

   /*!
   @function createBulletedList()
   @discussion - provides a new ItemList which is an HTML unordered list
   @result - returns an ItemList
   */
   
   /* static */
   function &createBulletedList()
   {
      return new ItemList( false );
   }
   
//========================================================================

   /*!
   @function getNumberedList()
   @discussion - provides a new ItemList which is an HTML ordered list
   @result - returns an ItemList
   */
   
   /* static deprecated */
   function &getNumberedList()
   {
      return new ItemList( true );
   }

//========================================================================

   /*!
   @function createNumberedList()
   @discussion - provides a new ItemList which is an HTML ordered list
   @result - returns an ItemList
   */
   
   /* static */
   function &createNumberedList()
   {
      return new ItemList( true );
   }
   
//========================================================================

   /*!
   @function addItem( $htmlComponent )
   @param $htmlComponent - an object that implements the HTMLComponent interface
   @discussion - adds another list item to the list
   */
   
   function addItem( &$htmlComponent )
   {
      //require
      {
         assert( '$this->_invariant()' );
      }
      //body
      {
         $itemHTML = $htmlComponent->getHTML();
         
         if ( $itemHTML != '' )
         {
            $this->itemsHTML .= '<li>' . $itemHTML . '</li>' . NL;
         }
      }
      //ensure
      {
         assert( '$this->_invariant()' );
      }
   }

//========================================================================

   /*!
   @function getHTML()
   @discussion - generates an HTML representation of this object
   @result - returns a string containing an HTML representation of this
      object
   */
   
   function getHTML()
   {
      assert( '$this->_invariant()' );

      return $this->headHTML . $this->itemsHTML . $this->tailHTML . NL;
   }
   
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};
