<?php

/*
AlterCheckBoxGroupOperation
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/29 18:12:30 $
$Log: AlterCheckBoxGroupOperation.php,v $
Revision 1.1  2003/09/29 18:12:30  dougqh
Initial revision

Revision 1.5  2003/01/07 16:24:22  dougqh
- Overriding _isWrappable to return false.

Revision 1.4  2002/11/22 16:43:29  millz
changed name of getJavaScriptBlock to createJavaScriptBlock

Revision 1.3  2002/10/18 20:09:15  millz
renamed class and updated constructor and _impGetLink to use FormName member var

Revision 1.2  2002/10/03 19:01:07  millz
minor fixes

Revision 1.1  2002/10/03 17:45:49  millz
Initial revision



IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

define( 'CHECK_BOX_OP_CHECKALL', 1 );
define( 'CHECK_BOX_OP_UNCHECKALL', 2 );

//========================================================================

/*!
@class AlterCheckBoxGroupOperation
@abstract - an abstract class that defines the basics of an AlterCheckBoxGroupOperation
@discussion - AlterCheckBoxGroupOperation handles generation of links to uncheck or check all checkboxes
   in a checkboxgroup
*/

importClass( 'Operations.Operation' );

/* abstract */
class AlterCheckBoxGroupOperation extends Operation
{
//========================================================================

   var $name;
   var $mode;
   var $checkBoxGroup;
   var $formName;

//========================================================================

   /*!
   @function AlterCheckBoxGroupOperation( &$checkBoxGroup, $formName, $mode )
   @param CheckBoxGroup - the group to operate on
   @param formName - the formName that has the checks
   @param $mode - what op we should do, such as check all or uncheck all, use constants defined in this class
   @discussion - constructs a new name AlterCheckBoxGroupOperation object
   @result - constructs a new AlterCheckBoxGroupOperation object
   */
   
   /* protected */
   function AlterCheckBoxGroupOperation( &$checkBoxGroup, $formName, $mode )
   {
      //require
      {
         assert( 'isInstanceOf( $checkBoxGroup, "CheckBoxGroup" )' );
      }
      //body
      {         
         if( $mode == CHECK_BOX_OP_CHECKALL ){ $this->name = 'Check All'; }
         if( $mode == CHECK_BOX_OP_UNCHECKALL ){ $this->name = 'Uncheck All'; }

         $this->checkBoxGroup = $checkBoxGroup;
         $this->formName = $formName;
         $this->mode = $mode;
         
         $this->Operation( $this->name );
      }
      //ensure
      {

      }
   } 

//========================================================================

   /*!
   @function _implementedGetLink()
   @discussion - this will build a link to call the javascript function
      which will actually perform the operation on the client side
      the javascript will also be created and added to the "page head" when this is called
   */
   
   function &_implementedGetLink()
   {
      if( $this->mode == CHECK_BOX_OP_CHECKALL )
            { $jsFuncName = $this->checkBoxGroup->getName().'_checkAll'; $setChecksTo = 'true'; }
      elseif( $this->mode == CHECK_BOX_OP_UNCHECKALL )
            { $jsFuncName = $this->checkBoxGroup->getName().'_uncheckAll'; $setChecksTo = 'false'; }
      
      //------------------
      
      importClass( 'HTMLComponents.Scripting.ScriptBlock' );
      $myScriptBlock =& ScriptBlock::createJavaScriptBlock();
      
      importClass( 'HTMLComponents.Scripting.ScriptFunction' );
      $myScriptFunc =& ScriptFunction::createJavaScriptFunction( $jsFuncName );
      
      $myScriptFunc->addCode( 'elements = window.document.forms.'.$this->formName.'.elements;' );
      
      $checkBoxes =& $this->checkBoxGroup->getCheckBoxes();
      
      $numBoxes = count( $checkBoxes );
      for( $i = 0; $i < $numBoxes; $i++)
      {
         $myScriptFunc->addCode( 'elements.'.$checkBoxes[$i]->getName().
                                 '.checked = '.$setChecksTo.';' );
      }
      
      $myScriptBlock->addFunction( $myScriptFunc );
      
      $myScriptBlock->addToPageHead();
      
      //-----------------
      
      importClass( 'HTMLComponents.Links.ExternalLink' );
      $myLink =& new ExternalLink( '#' );
   
      $myLink->setOnClick( $jsFuncName.'(); return false;' );
      
      return $myLink;
   
   }   

//========================================================================

   /*!
   @function _isWrappable( $wrappingOperation )
   @param $wrappingOperation - a WrappingOperation
   @discussion - indicates if this Operation can be wrapped by
      the specified WrappingOperation
   @result - returns a boolean
   */
   
   function _isWrappable( &$wrappingOperation )
   {
      return false;
   }
   
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant();      
   }

//========================================================================

};

?>
