<?php

/*
LightFileField
$Author: dougqh $
$Revision: 1.3 $
$Date: 2004/04/01 22:05:35 $
$Log: LightFileField.php,v $
Revision 1.3  2004/04/01 22:05:35  dougqh
- Fixed 4217

Revision 1.2  2003/12/30 14:25:51  dougqh
- 3925

Revision 1.1  2003/09/29 18:12:30  dougqh
Initial revision

Revision 1.1  2003/07/09 22:24:07  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.LightForms.ALightFormField' );

//========================================================================

/*!
@class LightFileField
@abstract - a concrete ALightFormField that uses a standard
   input type="file"
*/

class LightFileField extends ALightFormField
{

//========================================================================

   /*!
   @function LightFileField( $name, $displayName )
   @param $name - a String
   @param $displayName - a user-presentable String
   @discussion - constructs a new LightFileField object
   @result - constructs a new LightFileField object
   */

   function LightFileField(
      $name,
      $displayName,
      $width = UNSPECIFIED,
      $height = UNSPECIFIED )
   {
      $this->ALightFormField( $name, $displayName );
   }

//========================================================================

   /*!
   @function _getEnabledHTML()
   */

   function _getEnabledHTML()
   {
      importClass( 'HTMLComponents.LightForms.FileComponent' );
      $comp =& new FileComponent( $this->getName() );

      return $comp->getHTML();
   }

//========================================================================

   /*!
   @function _getDisabledHTML()
   */

   function _getDisabledHTML()
   {
      unreachablePoint( 'LightFileField canNOT be disabled.' );
   }

//========================================================================

   /*!
   @function _getDefaultValue()
   */

   function &_getDefaultValue()
   {
      return array();
   }

//========================================================================

   /*!
   @function _getFormValue()
   */

   function &_getFormValue()
   {
      if ( isset( $_FILES ) && isset( $_FILES{ $this->getName() } ) )
      {
         return $_FILES{ $this->getName() };
      }
      else
      {
         return array();
      }
   }

//========================================================================

   /*!
   @function isEmpty()
   */

   function isEmpty()
   {
      $value = $this->getValue();
      return (
         empty( $value{ 'name' } ) ||
         empty( $value{ 'tmp_name' } ) ||
         ! is_uploaded_file( $value{ 'tmp_name' } ) ||
         ( filesize( $value{ 'tmp_name' } ) == 0 ) );
   }

//========================================================================

};

?>