<?php

/*
LightForm
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/29 18:12:30 $
$Log: LightForm.php,v $
Revision 1.1  2003/09/29 18:12:30  dougqh
Initial revision

Revision 1.8  2003/07/09 22:24:07  dougqh
..

Revision 1.7  2003/04/02 21:40:54  millz
- updates to dynamically use the form tag

Revision 1.6  2003/03/27 19:57:50  millz
- bug fix

Revision 1.5  2003/03/27 19:40:10  millz
- made it extend AHTMLComponent

Revision 1.4  2002/12/12 17:12:49  dougqh
- A little clean-up - pass by reference for getOperation and setBody.

Revision 1.3  2002/10/18 17:18:30  dougqh
Minor update to handle GET and POST.

Revision 1.2  2002/10/03 19:39:49  millz
made operation optional and added setOperation

Revision 1.1  2002/10/03 19:14:56  millz
Initial revision



IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.AHTMLComponent' );

//Just to get the method type constants
importClass( 'Common.Utilities.FormSubmitMethod' );

//========================================================================

/*!
@class LightForm
@abstract - an HTMLComponent that represents a string of LightForm
@discussion -
   NOTE: The use of this class is highly discouraged.  More
      HTMLComponents should be written whenever possible to avoid
      using this class.
*/

class LightForm extends AHTMLComponent
{

//========================================================================

   var $html;
   var $name;
   var $method;
   var $actionURL;

//========================================================================

   /*!
   @function LightForm( $name, [ $method = GET ] )
   @param $name - the form name to use
   @param $method - the submit method to use, optional, defaults to GET
   @discussion - constructs a new LightForm object
   @result - constructs a new LightForm object
   */

   function LightForm( $name, $method = GET )
   {
      //require
      {
      }
      //body
      {
         $this->html = '';
         $this->name = $name;
         $this->method = $method;

         $this->actionURL = '';
         $this->hidden = '';

         $this->AHTMLComponent();
      }
      //ensure
      {
         assert( 'invariant( $this )' );
      }
   }

//========================================================================

   /*!
   @function setOperation( $operation )
   @param $operation - the operation to extract a URL from for the action of the form
   @discussion - I'll be damned, this sets the operation ('action' member)
   @result - no return
   */

   function setOperation( &$operation )
   {
      $myLink =& $operation->getLink();
      $url =& $myLink->getURL();

      if ( $this->method == GET )
      {
         $this->actionURL = $url->getURLString();

         $this->hidden = '';
         foreach ( getParametersFromURL( $url->getURLString() ) as $name => $value )
         {
            $this->hidden .= '<input type="hidden" name="' . $name . '" value="' . $value . '" />' . NL;
         }
      }
      else
      {
         $this->actionURL = $url->getURLString();
      }
   }

//========================================================================

   /*!
   @function getName( )
   @discussion - I'll be damned, this retrieves the name member
   @result - name string
   */

   function getName()
   {
      return $this->name;
   }

//========================================================================

   /*!
   @function setMethod( $method )
   @param $method - the submit method to use
   @discussion - I'll be damned, this sets the method member
   @result - no return
   */

   function setMethod( $method )
   {
      $this->method = $method;
   }

//========================================================================

   /*!
   @function setBody( $htmlComponent )
   @param $htmlComponent - the htmlComponent from which this will
      extract the getHTML() to act as the 'body' of the form
   @discussion - sets the HTML of this form body to the ->getHTML() of the input var
   @result - no return
   */

   function setBody( &$htmlComponent )
   {
      AHTMLComponent::startForm( $this->getName() );

      $this->setBodyHTML( $htmlComponent->getHTML() );

      AHTMLComponent::endForm();
   }

//========================================================================

   /*!
   @function setBodyHTML( $htmlString )
   @param $htmlString - the string of HTML to act as the 'body' of the form
   @discussion - sets the HTML of this form body to the input var
   @result - no return
   */

   function setBodyHTML( $htmlString )
   {
      $this->html = $htmlString;
   }

//========================================================================

   /*!
   @function getHTML()
   @discussion - provides an HTML representation of this LightForm object
   @result - returns the raw HTML string provided at the time of this
      object's instantiation
   */

   function getHTML()
   {
      assert( 'invariant( $this )' );

      importClass( 'Common.Utilities.FormSubmitMethod' );

      $method = ( $this->method == GET ) ? 'GET' : 'POST';

      // this very goofy and annoying <table> tag setup brought to you
      // by "Stupid Form Tag Rendering 1.0" - the </form> tag causes an un-wanted BR-type extra line
      // unless the table is done illegally like the below

      $result = '<table><tr><td>' . NL;
      $result .= '<form name="' . $this->name . '" action="' . $this->actionURL . '" method="' . $method.'">' . NL;
      $result .= $this->hidden;
      $result .= $this->html.NL;
      $result .= '</td></tr></form></table>'.NL;

      return $result;
   }

//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */

   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>