<?php

/*
LightTextAreaField
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/29 18:12:30 $
$Log: LightTextAreaField.php,v $
Revision 1.1  2003/09/29 18:12:30  dougqh
Initial revision

Revision 1.1  2003/07/09 22:24:07  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.LightForms.ALightFormField' );

//========================================================================

/*!
@class LightTextAreaField
@abstract - a concrete ALightFormField that uses a standard
   textarea
*/

class LightTextAreaField extends ALightFormField
{

//========================================================================

   /*!
   @function LightTextAreaField( $name, $displayName, [ $width, [ $height ] ] )
   @param $name - a String
   @param $displayName - a user-presentable String
   @param $width - a positive integer - optional
   @param $height - a positive integer - optional
   @discussion - constructs a new LightTextAreaField object
   @result - constructs a new LightTextAreaField object
   */

   function LightTextAreaField(
      $name,
      $displayName,
      $width = UNSPECIFIED,
      $height = UNSPECIFIED )
   {
      $this->ALightFormField( $name, $displayName );

      $this->width = $width;
      $this->height = $height;
   }

//========================================================================

   /*!
   @function _getEnabledHTML()
   */

   function _getEnabledHTML()
   {
      importClass( 'HTMLComponents.LightForms.TextAreaComponent' );
      $textComp =& new TextAreaComponent(
         $this->getName(), $this->getValue(),
         $this->width, $this->height );

      return $textComp->getHTML();
   }

//========================================================================

   /*!
   @function _getDisabledHTML()
   */

   function _getDisabledHTML()
   {
//      importClass( 'HTMLComponents.Text' );
//      $text =& new Text( $this->getValue() );
//      return $text->getHTML();

//Can't use LongTextBox without some implementation of DisplaySettingsSystem
//      //'' - no name
//      //false - do not truncate the text
//
      importClass( 'HTMLComponents.LongTextBox2' );
      $textComp =& new LongTextBox2( '', $this->getValue() );
      return $textComp->getHTML();
   }

//========================================================================

   /*!
   @function _getDefaultValue()
   */

   function _getDefaultValue()
   {
      return '';
   }

//========================================================================

   /*!
   @function _getFormValue()
   */

   function _getFormValue()
   {
      return
         ( isset( $_REQUEST{ $this->getName() } ) ) ?
         $_REQUEST{ $this->name } :
         $this->_getDefaultValue();
   }

//========================================================================

};

?>