<?php

/*
Checkbox
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/29 18:12:30 $
$Log: CheckBox.php,v $
Revision 1.1  2003/09/29 18:12:30  dougqh
Initial revision

Revision 1.4  2003/07/09 22:24:07  dougqh
..

Revision 1.3  2002/10/03 19:40:09  millz
bug fix to constructor

Revision 1.2  2002/10/03 18:28:36  millz
added value and name to getHTML ouput

Revision 1.1  2002/10/03 18:05:53  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

importClass( 'HTMLComponents.AHTMLComponent' );

//========================================================================

/*!
@class CheckBox
@abstract - an HTMLComponent that represents a checkbox
*/

class CheckBox extends AHTMLComponent /* implements HTMLComponent */
{

//========================================================================

   var $checked;
   var $name;

//========================================================================

   /*!
   @function CheckBox( $name, [ $checked ] )
   @param $name - a String containing a name for this checkbox
   @param $checked - a boolean indicating if this checkbox is checked - defaults to false
   @discussion - constructs a new Checkbox object
   @result - constructs a new Checkbox object
   */
   
   function CheckBox( $name, $checked = UNSPECIFIED )
   {
      //require
      {
      }
      //body
      {
         $this->checked = ( $checked === UNSPECIFIED ) ? false : $checked;
         $this->name = $name;
         
         $this->Object();
      }
      //ensure
      {
         assert( '$this->_invariant()' );
      }
   }

//========================================================================

   /*!
   @function setChecked( $checked )
   @param $checked - a boolean
   @discussion - sets whether or not this checked box is checked
   */
   
   function setChecked( $checked )
   {    
      $this->checked = $checked;
      
      assert( '$this->_invariant()' );
   }

//========================================================================

   /*!
   @function isChecked()
   @discussion - indicates if this checkBox is checked
   @result - returns a boolean
   */
   
   function isChecked()
   {
      assert( '$this->_invariant()' );
      
      return $this->checked;
   }

//========================================================================

   /*!
   @function loadValue( $submitMethod )
   @discussion - loads the value of this checkBox from the submitted
      form variables
   */
   
   function loadValue( $submitMethod )
   {      
      if ( $submitMethod == GET )
      {         
         $this->checked = isset( $_GET{ $this->name } );
         //print 'GET ' . $this->name . ' ' . getStringDepiction( $this->checked ) . '<br />' . NL;
      }
      else
      {         
         $this->checked = isset( $_POST{ $this->name } );
         //print 'POST ' . $this->name . ' ' . getStringDepiction( $this->checked ) . '<br />' . NL;
      }      
   }

//========================================================================

   /*!
   @function getName()
   @discussion - provides the name of this CheckBox
   @result - returns the name of this CheckBox
   */
   
   function getName()
   {
      assert( '$this->_invariant()' );
      
      return $this->name;
   }

//========================================================================

   /*!
   @function getHTML()
   @discussion - provides the HTML of this CheckBox
   @result - returns a String of HTML
   */
   
   function getHTML()
   {
      if ( $this->checked )
      {
         $checked = ' checked="checked"';
      }
      else
      {
         $checked = '';
      }
      
      return '<input name="'.$this->name.'" type="checkbox" value="1" ' . $checked . ' />';
   }
      
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>