<?php

/*
RadioGroup
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/29 18:12:30 $
$Log: RadioGroup.php,v $
Revision 1.1  2003/09/29 18:12:30  dougqh
Initial revision

Revision 1.3  2003/01/11 22:33:43  millz
- rewrite

Revision 1.2  2003/01/07 16:59:03  clay
*** empty log message ***

Revision 1.1  2003/01/07 16:58:38  clay
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.LightForms.Radio' );

//========================================================================

/*!
@class RadioGroup
@abstract - a LightForm element that represents a series of Radios
*/

class RadioGroup extends Object
{

//========================================================================

   var $radioHash;
   var $radios;
   var $numRadios;
   var $name;
   var $value;
   
//========================================================================

   /*!
   @function RadioGroup( $name )
   @discussion - constructs a new RadioGroup object
   @result - constructs a new RadioGroup object
   */
   
   function RadioGroup( $name, $value = UNSPECIFIED )
   {
      //require
      {
      }
      //body
      {
         $this->name = $name;
         
         $this->radioHash = new_hash();
         $this->radios = new_array();
         $this->numRadios = 0;
         $this->value = $value;
         
         $this->Object();
      }
      //ensure
      {
         assert( '$this->_invariant()' );
      }
   }

//========================================================================

   /*!
   @function getName()
   @discussion - provides the name of this RadioGroup
   @result - returns a String
   */
   
   function getName()
   {
      assert( '$this->_invariant()' );
      
      return $this->name;
   }
   

//========================================================================

   /*!
   @function addRadio( $name, [ $checked ] )
   @param $name - a name for the new Radio
   @param $checked - a boolean indicating if the box is checked
   @discussion - adds a new Radio to this RadioGroup
   */
   
   function addRadio( $value )
   {
      //imported Radio unconditionally at top of file
      $radio =& new Radio( $this->name, $value );
      $this->radios[ $this->numRadios++ ] =& $radio;
   }

//========================================================================

   /*!
   @function getRadioAt( $i )
   @param $i - index of the Radio in this group
   @discussion - provides the Radio at the specified index
   @result - returns a Radio
   */
   
   function &getRadioAt( $i )
   {
      $this->radios[ $i ]->setCheckedByValue( $this->value );
      return $this->radios[ $i ];
   }


//========================================================================

   /*!
   @function loadValue( $submitMethod )
   @param $submitMethod - a FormSubmitMethod - GET or POST
   @discussion - loads all the values of the check boxes
   */
   
   function loadValue( $submitMethod )
   {
      if ( $submitMethod == GET )
      {         
         $this->value = $_GET{ $this->name };
      }
      else
      {         
         $this->value = $_POST{ $this->name };
      }  
   }

//========================================================================

   /*!
   @function getValue()
   @discussion - 
   @result - returns the value of this radiogroup - call loadValue first if getting user selection from form
   */

   function getValue()
   {
      return $this->value;
   }

//========================================================================

   /*!
   @function setValue( $value )
   @param $value - the value to set this radiogroup to
   @discussion - saves value
   */

   function setValue( $value )
   {
      $this->value = $value;
   }

  
//========================================================================

   /*!
   @function getLastRadio()
   @discussion - provides the last Radio added to this RadioGroup
   @result - returns a Radio
   */
   
   function &getLastRadio()
   {
      assert( '$this->_invariant()' );
      
      return $this->getRadioAt( $this->numRadios - 1 );
   }
   
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>