<?php

/*
SelectComponent
$Author: dougqh $
$Revision: 1.3 $
$Date: 2004/05/14 19:18:15 $
$Log: SelectComponent.php,v $
Revision 1.3  2004/05/14 19:18:15  dougqh
Fixed bug with not using htmlentities

Revision 1.2  2003/09/29 18:14:13  dougqh
- Replaced short PHP tag with long PHP tag

Revision 1.1  2003/09/29 18:12:30  dougqh
Initial revision

Revision 1.1  2003/07/09 22:24:07  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

define( 'SINGLE_SELECT', false );
define( 'MULTIPLE_SELECT', true );

/*!
*/

class SelectComponent extends AHTMLComponent
{

//========================================================================

   /*!
   @function SelectComponent( $name, $isMultiple, [ $onchange ] )
   @param $name - String name of the select html component
   @param $isMultiple -  bool mutliple or single selection
   @param $onchange - JavaScript onchange event
   @discussion - constructs a SelectComponent object
   */

   function SelectComponent( $name, $isMultiple = false, $onChange = '' )
   {
      $this->name = $name;

      $mulHTML = '';

      if ( $isMultiple )
      {
         $htmlName = $name. '[]';
         $mulHTML = ' multiple="multiple" ';
      }
      else
      {
         $htmlName = $name;
      }

      $this->htmlName = $htmlName;
      $this->mulHTML = $mulHTML;
      $this->onChange = $onChange;

      $this->optionHTML = '';

      $this->html = '<select name="' . $htmlName . '" '.$mulHTML.' onchange="' . $onChange . '">';
   }

//========================================================================

   /*!
   @function setOnChange( $onChangeText )
   @param $onChangeText - text for the onChange event
   @discussison -
   */

   function setOnChange( &$onChangeText )
   {
      $this->onChange =& $onChangeText;
   }

//========================================================================

   /*!
   @function getName()
   @discussion returns the name of the selectCompnent
   @return name of select component, string.
   */

   function getName()
   {
      return $this->name;
   }

//========================================================================

   /*!
   @function addOption( $value, $label, $isSelected = false )
   @discussion adds an option to the select component
   */
   function addOption( $value, $label, $isSelected = false )
   {
      $this->optionHTML .= '<option value="' . htmlentities( $value, ENT_QUOTES ) . '"';

      if  ( $isSelected )
      {
         $this->optionHTML .= ' selected="true"';
      }

      $this->optionHTML .= '>' . htmlentities( $label, ENT_QUOTES ) . '</option>';
   }

//========================================================================

   /*!
   @function getHTML()
   @discussion returns the html for the select component
   @return returns string of html for select component
   */

   function getHTML()
   {
      $this->html =
         '<select name="' . htmlentities( $this->htmlName, ENT_QUOTES ) .
          '" '.$this->mulHTML.' onchange="' . $this->onChange . '">';


      return $this->html . $this->optionHTML . '</select>' . "\n";
   }

//========================================================================

};

?>