<?php

/*
TextComponent
$Author: dougqh $
$Revision: 1.2 $
$Date: 2004/05/14 19:18:15 $
$Log: TextComponent.php,v $
Revision 1.2  2004/05/14 19:18:15  dougqh
Fixed bug with not using htmlentities

Revision 1.1  2003/09/29 18:12:30  dougqh
Initial revision

Revision 1.1  2003/07/09 22:24:07  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.AHTMLComponent' );

//========================================================================

/*!
@class TextComponent
@abstract -
*/

class TextComponent extends AHTMLComponent
{

//========================================================================

   var $name;
   var $value;
   var $size;
   var $maxLength;

//========================================================================

   /*!
   @function TextComponent(  $name, $value, [$size = 10, [$maxLength = 100]]  )
   @param $name - the name of this form field
   @param $value - the default value for it
   @param $size - the size in columns
   @param $maxLength - the max number of characters accepted
   @discussion - constructs a new TextComponent object
   @result - constructs a new TextComponent object
   */

   function TextComponent( $name, $value, $size = 10, $maxLength = 100)
   {
      //require
      {
         // assert( <stuff here> );
      }
      //body
      {
         $this->AHTMLComponent();

         $this->name = $name;
         $this->value = $value;
         $this->size = $size;
         $this->maxLength = $maxLength;
      }
      //ensure
      {
         // <invariant here>
      }
   }

//========================================================================

   /*
   @function getHTML()
   @discussion - builds and returns the html rep of this component
   @result - html string
   */

   function getHTML()
   {
      $out = '<input type="text" ';

      $out .= ' value="' . htmlentities( $this->value, ENT_QUOTES ) . '" ';

      $out .= ' name="' . htmlentities( $this->name, ENT_QUOTES ) . '" ';

      if( $this->size > 0 && is_int($this->size) )
      {
         $out .= ' size="'.$this->size.'" ';
      }

      $out .= ' />' . "\n";

      return $out;
   }

//========================================================================

   /*
   @function getValue()
   @discussion -
   @result - returns string for the value of this component
   */

   function getValue()
   {
      return $this->value;
   }

//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */

   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>