<?php

/*
ExternalLink
$Author: dougqh $
$Revision: 1.6 $
$Date: 2003/07/09 21:45:36 $
$Log: ExternalLink.php,v $
Revision 1.6  2003/07/09 21:45:36  dougqh
*** empty log message ***

Revision 1.5  2002/10/03 13:16:21  millz
fix hasOnClick

Revision 1.4  2002/10/03 01:54:34  millz
added hasOnClick

Revision 1.3  2002/09/24 19:00:16  dougqh
Changing quotes to ticks.

Revision 1.2  2002/07/08 21:59:18  dougqh
Minor change to HTML generation, so that it looks correct when the body is an Image.

Revision 1.1  2002/07/01 20:13:45  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.Links.Link' );

//========================================================================

define( 'CURRENT_PAGE', 'CURRENT_PAGE' );

//========================================================================

/*!
@class ExternalLink
@abstract - a class that represents an HTML link including its
   URL, onclick javascript, and link body
*/

class ExternalLink extends Link
{

//========================================================================

   var $url;
   var $target;
   var $onclick;

//========================================================================

   /*!
   @function ExternalLink( [ $url, [ $linkBody ] ] )
   @param $url - a String containing a URL or a URL object

      CURRENT_PAGE will be used if a URL is not specified.
   @discussion - creates a new ExternalLink object
   */

   function ExternalLink( $url = UNSPECIFIED, $linkBody = UNSPECIFIED )
   {
      //require
      {
      }
      //body
      {
         if ( ( $url === CURRENT_PAGE ) || ( $url === UNSPECIFIED ) )
         {
            $url = getCurrentPage();
         }

         if ( is_object( $url ) )
         {
            $this->url =& $url;
         }
         else
         {
            importClass( 'Common.Utilities.URL' );

            $this->url =& new URL( $url );
         }

         $this->Link();

         if ( $linkBody != UNSPECIFIED )
         {
            $this->setLinkBody( $linkBody );
         }
      }
      //ensure
      {
         assert( '$this->_invariant()' );
      }
   }

//========================================================================

   /*!
   @function createFromCurrentBaseURL()
   @discussion - provides an ExternalLink built using the current URL
      without any arguments
   @result - returns an ExternalLink
   */

   function &createFromCurrentBaseURL()
   {
      return new ExternalLink( $_SERVER{ 'PHP_SELF' } );
   }

//========================================================================

   /*!
   @function setOnClick( $onclick )
   @param $onclick - a string containing the new javascript used
      for this links onclick event
   @discussion - sets the onclick javascript for this ExternalLink object
   */

   function setOnClick( $onclick )
   {
      //require
      {
         assert( '$this->_invariant()' );
      }
      //body
      {
         $this->onclick = str_replace( '"', '\'', $onclick );
      }
      //ensure
      {
         assert( "\$this->_invariant()" );
      }
   }

//========================================================================

   /*!
   @function setTarget( $target )
   @param $target - a string identifying the target window
   @discussion - sets the target window of this LInk
   */

   function setTarget( $target )
   {
      $this->target = $target;

      assert( '$this->_invariant()' );
   }

//========================================================================

   /*!
   @param $parameter - a String containing the name of a parameter to
      add to the URL of this Link
   @param $value - a value of Any type to add to the value of the URL
      of this Link
   @discussion - adds a parameter value pair to the end of the URL of
      this Link
   */

   function addParameter( $parameter, $value )
   {
      assert( '$this->_invariant()' );

      //debug( 'ExternalLink::addParameter', 'Parameter', $parameter );
      //debug( 'ExternalLink::addParameter', 'Value', $value );

      $this->url->addParameter( $parameter, $value );
   }

//========================================================================

   /*!
   @function _implementedGetHTML()
   @discussion - generates an HTML representation of this ExternalLink object
   @result - returns a string containing an HTML representation of this
      ExternalLink object
   */

   function _implementedGetHTML()
   {
      //Everything should be clean except for spaces, so just
      //replace spaces
      $html = '<a href="' . str_replace( ' ', '%20', $this->url->getURLString() ) . '"';

      if ( isset( $this->onclick ) )
      {
         $html .= ' onclick="' . $this->onclick . '"';
      }

      if ( isset( $this->target ) )
      {
         $html .= ' target="' . $this->target . '"';
      }

      $html .= '>' . $this->_getLinkBodyHTML() . '</a>';

      return $html;
   }

//========================================================================

   /*!
   @function _implementedGetURL()
   @discussion - provides a URL object that this Link would trigger
   @result - returns a URL object
   */

   function &_implementedGetURL()
   {
      return $this->url;
   }

//========================================================================

   /*!
   @function hasOnClick()
   @discussion - returns boolean to indicate whether this has an onClick javascript event
   */

   function hasOnClick()
   {
      return ( isset( $this->onclick ) );
   }

//========================================================================

   /*!
   @function getOnClick()
   @discussion - provides the onclick javascript for this Link
   @result - returns a String
   */

   function getOnClick()
   {
      assert( '$this->_invariant()' );

      return $this->onclick;
   }

//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */

   function _invariant()
   {
      return isInstanceOf( $this->url, 'URL' ) &&
             parent::_invariant();
   }

//========================================================================

};
