<?php

/*
Link
$Author: dougqh $
$Revision: 1.7 $
$Date: 2003/04/09 22:07:26 $
$Log: Link.php,v $
Revision 1.7  2003/04/09 22:07:26  dougqh
- Added isVisible and isEnabled methods.

Revision 1.6  2003/04/01 22:03:05  millz
- added getPreferredWidth

Revision 1.5  2003/03/27 19:57:36  millz
- bug fix

Revision 1.4  2003/03/27 19:20:08  millz
- updated to extend AHTMLComponent

Revision 1.3  2002/10/03 01:45:55  millz
added abstract hasOnClick

Revision 1.2  2002/07/17 14:01:22  dougqh
Turned off some debugging.

Revision 1.1  2002/07/01 20:13:45  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( "HTMLComponents.AHTMLComponent" );

//========================================================================

/*!
@class Link
@abstract - an abstract class that specifies the basic of interface of
   all Link objects
*/

/* abstract */
class Link extends AHTMLComponent
{

//========================================================================

   var $isEnabled;
   var $isVisible;

   var $linkBody;

//========================================================================

   function Link()
   {
      //require
      {
         assert( "isConcrete( \$this, 'Link',
               new_array(
                  'addParameter',
                   '_implementedGetURL',
                   '_implementedGetHTML',
                   'hasOnClick',
                   'getOnClick' ) )" );

         //assert( "isInstanceOf( \$this, 'HTMLComponent' )" );
      }
      //body
      {
         $this->isEnabled = true;
         $this->isVisible = true;

         $this->AHTMLComponent();
      }
      //ensure
      {
      }
   }

//========================================================================

   /*
   @function getPreferredWidth()
   @discussion - 
   @result - returns UNSPECIFIED
   */

   function getPreferredWidth()
   {
      if( isset($this->linkBody) )
      {
         return $this->linkBody->getPreferredWidth();
      }
      else
      {
         return UNSPECIFIED;
      }
   }

//========================================================================

   /*!
   @function isComplete()
   @discussion - indicates if this Link is ready to be translated into HTML
   @result - returns true if this Link is ready to be translated into HTML
      otherwise returns false
   */

   function isComplete()
   {
      assert( "\$this->_invariant()" );

      return ( ! $this->isVisible ) || ( isset( $this->linkBody ) );
   }

//========================================================================

   /*!
   @function setLinkBody( &$htmlComponent )
   @param $htmlComponent - an HTMLComponent that provides the visual
      representation of this link
   @discussion - sets the visual representation of this link
      object
   */

   function setLinkBody( &$linkBody )
   {
      //require
      {
         assert( "isInstanceOf( \$linkBody, 'HTMLComponent' )" );

         assert( "\$this->_invariant()" );
      }
      //body
      {
         $this->linkBody =& $linkBody;
      }
      //ensure
      {
         assert( "\$this->_invariant()" );
      }
   }

//========================================================================

   /*!
   @function _getLinkBody()
   @discussion - provides the HTMLComponent that is the body of this Link
   @result - returns an HTMLComponent
   */

   function &_getLinkBody()
   {
      assert( "\$this->isComplete()" );

      return $this->linkBody;
   }

//========================================================================

   /*!
   @function _getLinkBodyHTML()
   @discussion - should be called by the _implementedGetHTML methods
      of concrete child classes when generating Links
   @result - returns a String containing HTML
   */

   function _getLinkBodyHTML()
   {
      assert( "\$this->isComplete()" );

      return $this->linkBody->getHTML();
   }

//========================================================================

   /*!
   @function setEnabled( $isEnabled )
   @param $isEnabled - a boolean that specifies the new enabled status
      of this Link
   @discussion - sets the enabled status of this Link
      by default all links are enabled at creation
   */

   function setEnabled( $isEnabled )
   {
      $this->isEnabled = $isEnabled;

      assert( "\$this->_invariant()" );
   }

//========================================================================

   /*!
   @function setVisible( $isVisible )
   @param $isVisible - a boolean that specifies the new visible status
      of this Link
   @discussion - sets the new visible status of this Link
   */

   function setVisible( $isVisible )
   {
      $this->isVisible = $isVisible;

      assert( "\$this->_invariant()" );
   }

//========================================================================

   /*!
   @function hasOnClick()
   @discussion - returns boolean to indicate whether this has an onClick javascript event
   */

   /* abstract function hasOnClick(); */

//========================================================================

   /*!
   @function addParameter( $parameter, $value )
   @param $parameter - a String containing the name of a parameter to
      add to the URL of this Link
   @param $value - a value of Any type to add to the value of the URL
      of this Link
   @discussion - adds a parameter value pair to the end of the URL of
      this Link
   */

   /* abstract function addParameter( $parameter, $value ); */

//========================================================================

   /*!
   @function getHTML()
   @discussion -
      NOTE: Disabled Links return their link body's HTML representation
         without a link around it.  Active links return their link body's
         HTML with an anchor tag surrounding it.

      NOTE: Invisible Links return an empty String.
   @result - returns a String containing HTML
   */

   function getHTML()
   {
      assert( "\$this->_invariant()" );

      //debug( "Link::getHTML", "isVisible", $this->isVisible );
      //debug( "Link::getHTML", "isEnabled", $this->isEnabled );

      if ( $this->isVisible )
      {
         if ( $this->isEnabled )
         {
            return $this->_implementedGetHTML();
         }
         else
         {
            return $this->_getLinkBodyHTML();
         }
      }
      else
      {
         return "";
      }
   }

//========================================================================

   /*!
   @function _implementedGetHTML()
   @discussion - provides an HTML representation of this Link
   @result - returns a String of HTML
   */

   /* abstract function _implementedGetHTML(); */

//========================================================================

   /*!
   @function getURL()
   @discussion - provides a URL object that this Link would trigger
      - the URL object may be a null URL object
   @result - returns a URL object
   */

   function getURL()
   {
      //require
      {
         assert( "\$this->_invariant()" );
      }
      //body
      {
         if ( $this->isEnabled )
         {
            $url =& $this->_implementedGetURL();
         }
         else
         {
            importClass( "Common.Utilities.URL" );
            $url =& URL::getNullURL();
         }
      }
      //ensure
      {
         assert( "isInstanceOf( \$url, 'URL' )" );

         assert( "\$this->_invariant()" );
      }

      return $url;
   }

//========================================================================

   /*!
   @function _implementedGetURL()
   @discussion - provides a URL object that this Link would trigger
   @result - returns a URL object
   */

   /* abstract function &_implementedGetURL(); */

//========================================================================

   /*!
   @function getOnClick()
   @discussion - provides the onClick action for this Link
   @result - returns a String
   */

   /* abstract function getOnClick(); */

//========================================================================

   /*!
   @function isVisible()
   @discussion - indicates if this Link is actually visible
   @result - returns a boolean
   */

   function isVisible()
   {
      return $this->isVisible;
   }

//========================================================================

   /*!
   @function isEnabled()
   @discussion - indicates if this Link is enabled
   @result - returns a boolean
   */

   function isEnabled()
   {
      return $this->isEnabled;
   }

//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */

   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>