<?php

/*
RawHTML
$Author: dougqh $
$Revision: 1.3 $
$Date: 2004/01/06 17:34:24 $
$Log: RawHTML.php,v $
Revision 1.3  2004/01/06 17:34:24  dougqh
- Correction to my last change.

Revision 1.2  2004/01/06 16:55:43  dougqh
- Minor clean-up

Revision 1.1  2003/09/10 13:32:19  dougqh
Initial revision

Revision 1.6  2003/03/27 19:59:49  millz
- bug fix

Revision 1.5  2003/03/27 19:19:45  millz
- updated to extend AHTMLComponent

Revision 1.4  2002/07/30 20:10:20  dougqh
Added capability to specify a count when calling the static methods
getBreak and getNonBreakingSpace.

Revision 1.3  2002/07/15 17:04:43  dougqh
Added the static methods getBreak and getNonBreakingSpace to RawHTML

Revision 1.2  2002/07/09 13:44:24  dougqh
RawHTML was not extending Object (directly or indirectly).  It now directly
extends Object.

Revision 1.1  2002/07/01 20:13:07  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( "HTMLComponents.AHTMLComponent" );

//========================================================================

/*!
@class RawHTML
@abstract - an HTMLComponent that represents a string of RawHTML
@discussion -
   NOTE: The use of this class is highly discouraged.  More
      HTMLComponents should be written whenever possible to avoid
      using this class.
*/

class RawHTML extends AHTMLComponent
{

//========================================================================

   var $html;

//========================================================================

   /*!
   @function RawHTML( $html )
   @param $html - a string of HTML
   @discussion - constructs a new RawHTML object
   @result - constructs a new RawHTML object
   */

   function RawHTML( $html )
   {
      $this->AHTMLComponent();
      $this->html = $html;
   }

//========================================================================

   /*!
   @function getNonBreakingSpace( [ $count ] )
   @param $count - optional number of NBSPs to use - defaults to 1
   @discusion - provides an HTMLComponent whose getHTML is one or more &nbsp;'s
   @result - returns an HTMLComponent
   */

   /* static */
   function &getNonBreakingSpace( $count = UNSPECIFIED )
   {
      if ( $count === UNSPECIFIED )
      {
         static $nbsp;

         if ( ! isset( $nbsp ) )
         {
            $nbsp = new RawHTML( NBSP );
         }
      }
      else
      {
         $nbsp =& new RawHTML( str_repeat( NBSP, $count ) );
      }

      return $nbsp;
   }

//========================================================================

   /*!
   @function getBreak( [ $count ] )
   @param $count - optional number of BRs to use - defaults to 1
   @discussion - provides an HTMLComponent whose getHTML is a <br />
   @result - returns an HTMLCompoent
   */

   /* static */
   function &getBreak( $count = UNSPECIFIED )
   {
      if ( $count === UNSPECIFIED )
      {
         static $br;

         if ( ! isset( $br ) )
         {
            $br = new RawHTML( BR );
         }
      }
      else
      {
         $br =& new RawHTML( str_repeat( BR, $count ) );
      }

      return $br;
   }

//========================================================================

   /*!
   @function getHTML()
   @discussion - provides an HTML representation of this RawHTML object
   @result - returns the raw HTML string provided at the time of this
      object's instantiation
   */

   function getHTML()
   {
      return $this->html;
   }

//========================================================================

};

?>