<?php

/*
JavaScriptFunction
$Author: dougqh $
$Revision: 1.2 $
$Date: 2003/07/09 21:41:56 $
$Log: JavaScriptFunction.php,v $
Revision 1.2  2003/07/09 21:41:56  dougqh
?

Revision 1.1  2002/07/02 14:55:49  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

importClass( "HTMLComponents.Scripting.ScriptFunction" );

//========================================================================

/*!
@class JavaScriptFunction
@abstract - a concrete ScriptFunction class is used for 
@discussion - 
*/

class JavaScriptFunction extends ScriptFunction
{

//========================================================================

   /*!
   @function JavaScriptFunction( $name, [ $parameters ] )   
   @param $name - a non-empty String containing a name for this ScriptFunction
   @param $parameters - an optional array of Strings that contains the names of
      the parameters for this ScriptFunction
   @discussion - creates a new JavaScriptFunction
      NOTE: This constructor should not be called directly.
         Call ScriptFunction::getJavaScriptFunction instead.
   @result - constructs a new JavaScriptFunction object
   */
   
   function JavaScriptFunction( $name, $parameters = UNSPECIFIED )
   {
      //precondition
      {
      }
      //body
      {
         $this->ScriptFunction( $name, $parameters );
      }
      //postcondition
      {
         assert( "\$this->_invariant()" );
      }
   }

//========================================================================

   /*!
   @function getScriptingLanguage()
   @discussion - being a JavaScriptFunction returns JAVASCRIPT
   @result - returns JAVASCRIPT
   */
   
   function getScriptingLanguage()
   {
      assert( "\$this->_invariant()" );
      
      return JAVASCRIPT;
   }

//========================================================================

   /*!
   @function _getFunctionHead()
   @discussion - provides the portions of the function that follow the
      body of the function
   @result - returns a String
   */
      
   function _getFunctionHead()
   {
      return "function " . $this->name . "( " . $this->_getParameterList() . " ) {";
   }

//========================================================================

   /*!
   @function _getFunctionTail()
   @discussion - provides the portions of the function that follow the
      body of the function
   @result - returns a String
   */
   
   function _getFunctionTail()
   {
      return "}";
   }
         
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>