<?php

/*
SimpleBorderDecorator
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/10 13:32:19 $
$Log: SimpleBorderDecorator.php,v $
Revision 1.1  2003/09/10 13:32:19  dougqh
Initial revision

Revision 1.1  2003/07/09 21:43:01  dougqh
Initial revision


Revision 1.1  2002/07/15 20:27:34  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

importClass( "HTMLComponents.AHTMLComponent" );

//========================================================================

/*!
@class SimpleBorderDecorator
@abstract - An HTMLComponent that encases another HTMLComponent in
   a thin border - based off of the Decorator pattern
*/

class SimpleBorderDecorator extends AHTMLComponent
{

//========================================================================

   var $htmlComponent;
   
//========================================================================

   /*!
   @function SimpleBorderDecorator( &$htmlComponent )
   @param $htmlComponent - an HTMLComponent to encase in a border
   @discussion - constructs a new SimpleBorderDecorator object
   @result - constructs a new SimpleBorderDecorator object
   */
   
   function SimpleBorderDecorator( &$htmlComponent )
   {
      //require
      {
         assert( "isInstanceOf( \$htmlComponent, 'HTMLComponent' )" );
      }
      //body
      {
         $this->htmlComponent =& $htmlComponent;
         
         $this->AHTMLComponent();
         
         $this->setRequestedDimensions( $htmlComponent->getDimensions() );
      }
      //ensure
      {
         assert( 'invariant( $this )' );
      }
   }
   
//========================================================================

   /*!
   @function getHTML()
   @discussuion - provides an HTML representation of this
      HTMLComponent
   @result - returns a String containing HTML
   */
   
   function getHTML()
   {
      assert( 'invariant( $this )' );
      
      // $this->htmlComponent->setRequestedDimensions( $this->getDimensions() );
      
      importClass( 'HTMLComponents.Table.Table' );
      $table =& new Table( 'SimpleBorderDecorator' );
      
      $table->addCell( $this->htmlComponent );
      $table->setBorder( 1 );
      $table->setRequestedDimensions( $this->getDimensions() );
      
      return $table->getHTML();
   }
      
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>