<?php

//This file contains package constants for the HTMLComponents package

//========================================================================

//Alignment constants
define( 'CENTER', 'center' );
define( 'LEFT', 'left' );
define( 'RIGHT', 'right' );

define( 'TOP', 'top' );
define( 'BOTTOM', 'bottom' );

define( 'MINIMUM_WIDTH', '1%' );
define( 'COLUMN_SPAN_REMAINDER', 'COLUMN_SPAN_REMAINDER' );

//========================================================================

/*!
@function isHorizontalAlignment( $value )
@param $value - a string
@discussion - checks to see if $value is a horizontal alignment specifier
@result - returns true if $value is a horizontal alignment specifier
   otherwise returns false
*/

function isHorizontalAlignment( $value )
{
   return in_array( $value, new_array( LEFT, CENTER, RIGHT ) );
}

//========================================================================

/*!
@function isVerticalAlignment( $value )
@param $value - a string
@discussion - checks to see if $value is a vertical alignment specifier
@result - returns true if $value is a vertical alignment specifier
   otherwise returns false
*/

function isVerticalAlignment( $value )
{
   return in_array( $value, new_array( TOP, CENTER, BOTTOM ) );
}

//========================================================================
?>