<?php

/*
ResultsTable
$Author: apache $
$Revision: 1.1 $
$Date: 2003/12/18 20:39:26 $
$Log: ResultsTable.php,v $
Revision 1.1  2003/12/18 20:39:26  apache
Initial revision

Revision 1.6  2003/01/10 22:17:35  millz
- fix for bug 328 - made implicit row colors be explicitly white

Revision 1.5  2002/08/22 14:22:18  dougqh
addSpacerRow was still using the now non-existent -

Revision 1.4  2002/08/21 22:17:24  dougqh
Not specified row color on even rows to work with color averaging of Table.

Revision 1.3  2002/08/05 14:09:28  dougqh
Changed default cell spacing.

Revision 1.2  2002/07/15 19:21:47  dougqh
Added method addSpacerRow.

Revision 1.1  2002/07/01 20:14:25  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

importClass( "HTMLComponents.Table.Table" );

//========================================================================

/*!
@class ResultsTable
@abstract - an extension to the basic Table that alternates
   the background color of rows automatically
*/

class ResultsTable extends Table
{

//========================================================================

   var $isEven;
   
//========================================================================

   /*!
   @function ResultsTable()
   @discussion - constructs a new ResultsTable object
   @result - constructs a new ResultsTable object
   */
   
   function ResultsTable()
   {
      //require
      {
      }
      //body
      {
         $this->Table();
         
         importClass( "Display.DisplaySettingsSystem" );         
         $displaySettingsSystem =& DisplaySettingsSystem::getInstance();         
         
         $this->standardOddColor =& $displaySettingsSystem->getAlternateBackgroundColor();
         
         $this->standardEvenColor =& $displaySettingsSystem->getBackgroundColor();
         
         $this->isEven = true;    
      }
      //ensure
      {
         assert( "\$this->_invariant()" );
      }
      
      $this->setCellPadding( 2 );
      $this->setCellSpacing( 0 );
   }

//========================================================================

   /*!
   @function addSpacerRow( [ $color ] )
   @param $color - an optional background Color for this row
      - defaults to no Color specification
   @discussion - adds a spacer row to this Table
   */
   
   function addSpacerRow( $color = UNSPECIFIED )
   {
      if ( $color === UNSPECIFIED )
      {
         parent::addSpacerRow( $this->standardEvenColor );
      }
      else
      {
         parent::addSpacerRow( $color );
      }      
   }
    
//========================================================================

   /*!
   @function startRow( [ $color ] )
   @param $color - optional parameter specifying the background color
      of the new row
   @discussion - starts a new row for this Table
      - if no background color is specified the background colors will
      be alternated in accordance with the current user's preferences
   */
   
   function startRow( $color = UNSPECIFIED )
   {
      if ( $color === UNSPECIFIED )
      {
         if ( $this->isEven )
         {
            parent::startRow( $this->standardEvenColor );
         }
         else
         {
            parent::startRow( $this->standardOddColor );
         }
      }
      
      $this->isEven = ( ! $this->isEven );
   }
   
//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */
    
   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>