<?php

/*
TableCell
$Author: apache $
$Revision: 1.1 $
$Date: 2003/12/18 20:39:26 $
$Log: TableCell.php,v $
Revision 1.1  2003/12/18 20:39:26  apache
Initial revision

Revision 1.16  2003/07/09 21:46:24  dougqh
Minor tweaks

Revision 1.15  2003/04/10 14:14:50  dougqh
- Overriding setRequestedWidth to forward to setWidth. Tagged setWidth as deprecated.

Revision 1.14  2003/03/28 15:29:32  millz
- added ability to enableWrapping

Revision 1.13  2003/03/27 19:57:41  millz
- bug fix

Revision 1.12  2003/03/27 19:20:45  millz
- updated to extend AHTMLComponent

Revision 1.11  2002/12/30 21:23:08  dougqh
- Correction to header comment

Revision 1.10  2002/11/06 20:29:14  dougqh
Headers no longer force nowrap.
Deprecated getHeader and getCell in favor of new createHeader and createCell.

Revision 1.9  2002/09/24 17:48:27  dougqh
Changing quotes to ticks.

Revision 1.8  2002/08/19 21:22:51  millz
added unSetBackgroundColor

Revision 1.7  2002/08/19 20:33:06  millz
added support for background color

Revision 1.6  2002/08/05 14:07:58  dougqh
Fixed problem with handling of vertical alignment.
Header cells now default to having word wrap disabled.

Revision 1.5  2002/07/30 22:13:15  dougqh
Fixed problem with support for rowSpan.

Revision 1.4  2002/07/29 22:39:12  dougqh
Added support for generating header tags and spanning the remaining
columns in a row.

Revision 1.3  2002/07/08 21:24:44  dougqh
Added a new _setHTMLComponent method that can be used by friend
classes to speed up their HTML generation.

Revision 1.2  2002/07/08 19:41:22  dougqh
Fixed nowrap handling, so HTML is XHTML compliant.

Revision 1.1  2002/07/01 20:14:25  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.AHTMLComponent' );

//========================================================================

/*!
@class TableCell
@abstract - a class that describes a cell in a Table
*/

class TableCell extends AHTMLComponent
{

//========================================================================

//   var $innerHTML;
//
//   var $rowSpan;
//   var $colSpan;
//
//   var $horizAlignment;
//   var $vertAlignment;
//
//   var $noWrap;
//
//   var $bgColor;  // color object version of the color to set as the background
//
//   var $width;
//
//   var $isHeader;

//========================================================================

   /*!
   @function TableCell( $htmlComponent, $isHeader )
   @param $htmlComponent - an HTMLComponent
   @param $isHeader - an optional boolean parameter indicating that
      this Cell is a header - defaults to false
   @discussion - constructs a new TableCell object whose
      contents are $htmlComponent
   @result - constructs a new TableCell object
   */

   function TableCell( &$htmlComponent, $isHeader = false )
   {
      $this->isHeader = $isHeader;
      //$this->isHeader = ( $isHeader === UNSPECIFIED ) ? false : $isHeader;

      if ( is_null( $htmlComponent ) )
      {
         $this->innerHTML = '';
      }
      else
      {
         $this->innerHTML = $htmlComponent->getHTML();
      }

      $this->AHTMLComponent();
   }

//========================================================================

   /*!
   @function getCell( &$htmlComponent )
   @param $htmlComponent - an HTMLComponent
   @discussion - provides a new TableCell configured to act as a regular cell
      DEPRECATED
   @result - returns a new TableCell
   */

   /* deprecated */
   function &getCell( &$htmlComponent )
   {
      deprecated( 'TableCell::getCell', 'TableCell::createCell' );
      return new TableCell( $htmlComponent, false );
   }

//========================================================================

   /*!
   @function createCell( &$htmlComponent )
   @param $htmlComponent - an HTMLComponent
   @discussion - provides a new TableCell configured to act as a regular cell
   @result - returns a new TableCell
   */

   function &createCell( &$htmlComponent )
   {
      return new TableCell( $htmlComponent, false );
   }

//========================================================================

   /*!
   @function getHeader( $htmlComponent )
   @param $htmlComponent - an HTMLComponent
   @discussion - provides a new TableCell configured to act as a header
      DEPRECATED
   @result - returns a new TableCell
   */

   /* deprecated */
   function &getHeader( &$htmlComponent )
   {
      deprecated( 'TableCell::getHeader', 'TableCell::createHeader' );
      return new TableCell( $htmlComponent, true );
   }

//========================================================================

   /*!
   @function createHeader( $htmlComponent )
   @param $htmlComponent - an HTMLComponent
   @discussion - provides a new TableCell configured to act as a header
   @result - returns a new TableCell
   */

   function &createHeader( &$htmlComponent )
   {
      return new TableCell( $htmlComponent, true );
   }

//========================================================================

   /*!
   @function setColumnSpan( $numColumns )
   @param $numColumns - the number of columns this cell should span
   @discussion - sets the number of columns that this TableCell will span
      - INFINITY is acceptable and will ensure that the cells spans all
        remaining columns in the row.
   */

   function setColumnSpan( $numColumns )
   {
      //COLUMN_SPAN_ALL will be magically replaced by Table::getHTML
      $this->colSpan = ( $numColumns == INFINITY ) ? COLUMN_SPAN_REMAINDER : $numColumns;
   }

//========================================================================

   /*!
   @function setRowSpan( $numRows )
   @param $numRows - the number of rows this cell should span
   @discussion - sets the number of rows that this TableCell will span
   */

   function setRowSpan( $numRows )
   {
      $this->rowSpan = $numRows;
   }

//========================================================================

   /*!
   @function setBackgroundColor( $color )
   @param $color - the color object to set the cell BG to
   @discussion - sets the cell bgcolor of this TableCell
   */

   function setBackgroundColor( &$color )
   {
     $this->bgColor =& $color;
   }

//========================================================================

   /*!
   @function unsetBackgroundColor( )
   @param $color - the color object to set the cell BG to
   @discussion - sets the cell bgcolor of this TableCell
   */

   function unsetBackgroundColor( )
   {
      //require
      unset( $this->bgColor );
   }

//========================================================================

   /*!
   @function setRequestedWidth( $width )
   @param $width - the cell width in pixels
   @discussion - sets the requested width of this TableCell
   */

//   function setRequestedWidth( $width )
//   {
//      parent::setRequestedWidth( $width );
//   }

//========================================================================

   /*!
   @function setWidth( $width )
   @param $width - the cell width in pixels or as a percentage
   @discussion - sets the cell width of this TableCell
   */

   function setWidth( $width )
   {
      $this->width = $width;
   }

//========================================================================

   /*!
   @function disableWrapping()
   @discussion - disables word wrapping within this TableCell
   */

   function disableWrapping()
   {
      $this->noWrap = true;
   }

//========================================================================

   /*!
   @function enableWrapping()
   @discussion - enables word wrapping within this TableCell
   */

   function enableWrapping()
   {
      $this->noWrap = false;
   }

//========================================================================

   /*!
   @function setHorizontalAlignment( $alignment )
   @param $alignment - a horizontal alignment specifier
      i.e. one of the constants LEFT, CENTER, or RIGHT
   @discussion - sets the horizontal alignment within this TableCell
   */

   function setHorizontalAlignment( $alignment )
   {
      $this->horizAlignment = $alignment;
   }

//========================================================================

   /*!
   @function issetBackgroundColor( )
   @discussion - returns TRUE if the background color has been specified
   */

   function issetBackgroundColor( )
   {
      //require
      return isset( $this->bgColor );
   }


//========================================================================

   /*!
   @function setVerticalAlignment( $alignment )
   @param $alignment - a vertical alignment specifier
      i.e. one of the constants TOP, CENTER, or BOTTOM
   @discussion - sets the vertical alignment within this TableCell
   */

   function setVerticalAlignment( $alignment )
   {
      $this->vertAlignment = $alignment;
   }

//========================================================================

   /*!
   @function getHTML()
   @discussion - generates an HTML representation of this TableCell
   @result - retuns a string containing an HTML representation of this
      TableCell
   */

   function getHTML()
   {
      if ( $this->isHeader )
      {
         $openTag = '<th ';
         $closeTag = '</th>';
      }
      else
      {
         $openTag = '<td ';
         $closeTag = '</td>';
      }

      $head = $openTag;

      if ( isset( $this->width ) )
      {
         $head .= ' width="' . $this->width . '"';
      }

      if ( isset( $this->colSpan ) )
      {
         $head .= ' colspan="' . $this->colSpan . '"';
      }

      if ( isset( $this->rowSpan ) )
      {
         $head .= ' rowspan="' . $this->rowSpan . '"';
      }

      if ( isset( $this->bgColor ) )
      {
         $head .= ' bgcolor="' . $this->bgColor->getHexString() . '"';
      }

      if ( isset( $this->noWrap ) && $this->noWrap )
      {
         $head .= ' nowrap="nowrap"';
      }

      if ( isset( $this->horizAlignment ) )
      {
         $head .= ' align="' . $this->horizAlignment . '"';
      }

      if ( isset( $this->vertAlignment ) )
      {
         $head .= ' valign="' . $this->vertAlignment . '"';
      }

      return $head . '>' . $this->innerHTML . $closeTag . NL;
   }

//========================================================================

   /*!
   @function _setHTMLComponent( $htmlComponent )
   @param $htmlComponent - an HTMLComponent to use inside this TableCell
   @discussion - This method should only be used by friends of TableCell
      and is provided only for the purpose of optimizing HTML generation
   */

   function _setHTMLComponent( &$htmlComponent )
   {
      assert( 'isInstanceOf( $htmlComponent, "HTMLComponent" )' );

//      // if(){print 'ERROR, non-HTMLComponent passed into TableCell :'; print_r($htmlComponent); exit;}
//      if( !is_object($htmlComponent) || ! hasMethods( $htmlComponent, new_array('getHTML') ) )
//      {
//         print 'ERROR, non-HTMLComponent passed into TableCell: [';
//         print_r($htmlComponent);
//         print '] - exiting';
//         exit;
//      }
      $this->innerHTML = $htmlComponent->getHTML();
   }

//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */

   function _invariant()
   {

      $colorOK = ( isInstanceOf( $this->bgColor, 'Color') || !isset( $this->bgColor ) );
      assert ( '$colorOK' );
      return ( $colorOK && parent::_invariant() );
   }

//========================================================================

};

?>