<?php

/*
assertionLibrary
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/09 15:11:59 $
$Log: assertionLibrary.php,v $
Revision 1.1  2003/09/09 15:11:59  dougqh
Initial revision

Revision 1.1  2003/07/14 15:07:25  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

/*!
@library assertion
@abstract - functions for enabling and disabling assertions
*/

//========================================================================

/*!
@function turnOffAssertions()
@discussion - turns off all assertion checking
*/

function turnOffAssertions()
{
   //print "Assertions are disabled <br/>\n";

   global $GL_assertionsEnabled;
   $GL_assertionsEnabled = false;

   assert_options( ASSERT_ACTIVE, 0 );
   assert_options( ASSERT_WARNING, 0 );

   //my way of checking that assertion checking really is off
   assert( "false" );
}

//========================================================================

/*!
@function turnOnAssertions()
@discussion - turns on all assertion checking
*/

function turnOnAssertions()
{
   //print "Assertions are enabled <br/>\n";

   global $GL_assertionsEnabled;
   $GL_assertionsEnabled = true;

   assert_options( ASSERT_ACTIVE, 1 );
   assert_options( ASSERT_WARNING, 1 );
}

//========================================================================

/*!
@function setAssertionMode()
@discussion - sets the assertion mode based on the global variable
   $assert which is can be set through the query string
*/

/*!
@function setAssertionMode( $isOn )
@param $isOn - true turns assertions off / false turns assertions off
@discussion - turns assertion checking on or off according to the parameter
   is on
*/

function setAssertionMode( $isOn )
{
   if ( $isOn )
   {
      turnOnAssertions();
   }
   else
   {
      turnOffAssertions();
   }
}

//========================================================================

/*!
@function assertionsAreEnabled()
@result - returns true if assertion checking is enabled;
   otherwise returns false
*/

function assertionsAreEnabled()
{
   global $GL_assertionsEnabled;
   return $GL_assertionsEnabled;
}

//========================================================================

/*!
@function unreachablePoint( [ $message ] )
@param $message - an optional message about the failure
@discussion - this function should be called when a section of
   code that should not be run under any circumstances is reached

   This function will terminate the currently executing script.
*/

function unreachablePoint( $message = UNSPECIFIED )
{
   print "<font color='red'>\n";
   print "An unexpected failure has occurred. <br/>\n";
   print "<br/>\n";

   if ( $message != UNSPECIFIED )
   {
      print getStringDepiction( $message ) . "<br />\n";

      debug( "unreachablePoint", "Message", $message );
   }

   print "</font>\n";
   print BR_NL;

   print 'Back Trace: ' . BR_NL;
   print getStringDepiction( getBacktrace() );
   print 'History: ' . BR_NL;
   print getStringDepiction( getHistory() );
   print BR_NL;

   niceExit();
}

//========================================================================

/*!
@function invalidParameters( $functionName )
@param $functionName - name of the function passed invalid parameters
@discussion - a wrapper around unreachablePoint that signals
   invalid parameters passed to a function
*/

function invalidParameters( $functionName )
{
   unreachablePoint( $functionName . ' - Invalid parameters passed' );
}

//========================================================================

/*!
@function invariant( &$object )
@param $object - an Object
@discussion - returns true if ENABLE_INVARIANT is false or
   the value of $object->_invariant() if ENABLE_INVARIANT is true

   A wrapper around invariant checks to provide finer debug checking
   control.
@result - returns a boolean
*/

function invariant( &$object )
{
   return ( ! ENABLE_INVARIANT ) ||
          $object->_invariant();
}

//========================================================================
?>