<?php

/*
callLibrary
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/09 15:11:59 $
$Log: callLibrary.php,v $
Revision 1.1  2003/09/09 15:11:59  dougqh
Initial revision

Revision 1.4  2002/09/24 22:08:07  dougqh
Added some code to make sure indices 0 through 4 of the parameter arrays are always set.

Revision 1.3  2002/09/24 20:52:42  dougqh
Changing quotes to ticks.

Revision 1.2  2002/09/03 20:53:21  dougqh
debugging

Revision 1.1  2002/07/01 20:21:39  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

/*!
@library call
@abstract - a library of functions that solves problems encountered when
   using references with the standard PHP function call_user_func.
*/

//========================================================================

/*!
@function callStaticMethod( $class, $method, &$parameters )
@param $class - a String containing the name of the class on which to
   invoke the static method
@param $method - a String containing the name of static method to be
   invoked
@param $parameters - an array consisting of up to five parameters to
   be passed to the static method - an array of more than five
   parameters will raise an error
   
   NOTE: An array must be passed regardless of whether or not any parameters
   are needed.
@discussion - produces whatever value is generated by making the static call
   $class::$method
@result - returns the value produces by a call to $class::$method
*/

function &callStaticMethod( $class, $method, &$parameters )
{
   //require
   {
      assert( '$class != ""' );
      assert( '$method != ""' );
      assert( 'count( $parameters ) <= 5' );
   }
   //body
   {
      $numParams = count( $parameters );
      for ( $i = $numParams; $i < 5; ++$i )
      {
         $parameters[ $i ] = UNSPECIFIED;
      }
      
      eval( '$result =&' . $class . '::' . $method . '( $parameters[ 0 ], $parameters[ 1 ], $parameters[ 2 ], $parameters[ 3 ], $parameters[ 4 ] );' );
   }
   //ensure
   {
   }
   
   return $result;
}

//========================================================================

/*!
@function callMethod( $object, $method, &$parameters )
@param $object - an Object on which the method will be invoked
@param $method - a String containing the name of a method
@param $parameters - an array of parameters not exceeding 5 in count
   to pass to the method - an array of more than 5 parameters will
   raise an error
@discussion - calls the specified method on the specified Object using
   the specified parameters
@result - returns the value produced by the call to the specified method
*/

function &callMethod( &$object, $method, &$parameters )
{
   //require
   {
      assert( 'isInstanceOf( $object, "Object" )' );
   }
   //body
   {
      $numParams = count( $parameters );
      for ( $i = $numParams; $i < 5; ++$i )
      {
         $parameters[ $i ] = UNSPECIFIED;
      }

      $result =& $object->$method( 
         $parameters[ 0 ], $parameters[ 1 ],
         $parameters[ 2 ], $parameters[ 3 ],
         $parameters[ 4 ] );
   }
   //ensure
   {
   }
   
   return $result;
}

//========================================================================

?>