<?php

/*
compare
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/09 15:11:59 $
$Log: compareLibrary.php,v $
Revision 1.1  2003/09/09 15:11:59  dougqh
Initial revision

Revision 1.2  2003/07/09 22:05:54  dougqh
?

Revision 1.1  2002/09/03 23:03:29  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

/*!
@class compare
@abstract - a library of static comparison functions
@discussion - compares two values
*/

class compare
{

//========================================================================
   
   /*!
   @function equals( $lhs, $rhs )
   @param $lhs - Any left hand side
   @param $rhs - Any right hand side
   @discussion - compares $lhs to $rhs to determine if they are equal
   @result - returns a boolean
   */
   
   /* static */ function equals( $lhs, $rhs )
   {
      if ( is_object( $lhs ) )
      {
         return $lhs->_equals( $rhs );
      }
      elseif ( is_object( $rhs ) )
      {
         return $rhs->_equals( $lhs );
      }
      else
      {
         return ( $lhs == $rhs );
      }
   }

//========================================================================
   
   /*!
   @function strongEquals( $lhs, $rhs )
   @param $lhs - Any left hand side
   @param $rhs - Any right hand side
   @discussion - compares $lhs to $rhs to determine if they are equal under
      strong eqivalence
   @result - returns a boolean
   */
   
   /* static */ function strongEquals( $lhs, $rhs )
   {
      if ( is_object( $lhs ) )
      {
         return $lhs->_strongEquals( $rhs );
      }
      elseif ( is_object( $rhs ) )
      {
         return $rhs->_strongEquals( $lhs );
      }
      else
      {
         return ( $lhs === $rhs );
      }
   }
   
//========================================================================

   /*!
   @function lessThan( $lhs, $rhs )
   @param $lhs - Any left hand side
   @param $rhs - Any right hand side
   @discussion - compares $lhs to $rhs to determine if lhs is less than rhs
   @result - returns a boolean
   */
   
   /* static */ function lessThan( $lhs, $rhs )
   {
      if ( is_object( $lhs ) )
      {
         return $lhs->_lessThan( $rhs );
      }
      elseif ( is_object( $rhs ) )
      {
         return compare::greaterThanOrEquals( $rhs, $lhs );
      }
      else
      {
         return ( $lhs < $rhs );
      }
   }

//========================================================================

   /*!
   @function greaterThan( $lhs, $rhs )
   @param $lhs - Any left hand side
   @param $rhs - Any right hand side
   @discussion - compares $lhs to $rhs to determine if lhs is greater than rhs
   @result - returns a boolean
   */
   
   /* static */ function greaterThan( $lhs, $rhs )
   {
      if ( is_object( $lhs ) )
      {
         return $lhs->_greaterThan( $rhs );
      }
      elseif ( is_object( $rhs ) )
      {
         return compare::lessThanOrEquals( $rhs, $lhs );
      }
      else
      {
         return ( $lhs > $rhs );
      }
   }

//========================================================================

   /*!
   @function lessThanOrEquals( $lhs, $rhs )
   @param $lhs - Any left hand side
   @param $rhs - Any right hand side
   @discussion - compares $lhs to $rhs to determine if lhs is less than or equal to rhs
   @result - returns a boolean
   */
   
   /* static */ function lessThanOrEquals( $lhs, $rhs )
   {
      if ( is_object( $lhs ) )
      {
         return $lhs->_lessThan( $rhs ) || $lhs->_equals( $lhs );
      }
      elseif ( is_object( $rhs ) )
      {
         return compare::greaterThan( $rhs, $lhs );
      }
      else
      {
         return ( $lhs <= $rhs );
      }
   }

//========================================================================

   /*!
   @function greaterThanOrEquals( $lhs, $rhs )
   @param $lhs - Any left hand side
   @param $rhs - Any right hand side
   @discussion - compares $lhs to $rhs to determine if lhs is less than or equal to rhs
   @result - returns a boolean
   */
   
   /* static */ function greaterThanOrEquals( $lhs, $rhs )
   {
      if ( is_object( $lhs ) )
      {
         return $lhs->_greaterThan( $rhs ) || $lhs->_equals( $lhs );
      }
      elseif ( is_object( $rhs ) )
      {
         return compare::lessThan( $rhs, $lhs );
      }
      else
      {
         return ( $lhs >= $rhs );
      }
   }

//========================================================================

};

?>