<?php

/*
process
$Author: millz $
$Revision: 1.3 $
$Date: 2003/09/12 18:42:17 $
$Log: htmlLibrary.php,v $
Revision 1.3  2003/09/12 18:42:17  millz
- added sectionIsInTag

Revision 1.2  2003/09/08 14:00:38  millz
- bug fix to default bool in getDropDownByQuery - strong equivalence was not the correct thing to use

Revision 1.1  2003/09/08 13:58:44  millz
-

Revision 1.3  2003/07/29 14:38:51  millz
- added new drop down creation func

Revision 1.2  2003/07/14 13:56:44  dougqh
- Changing printError calls to unreachablePoint calls.

Revision 1.1  2003/07/09 22:05:54  dougqh
Initial revision

Revision 1.3  2002/11/11 15:22:19  dougqh
Using new debugging constant in process::start.

Revision 1.2  2002/11/06 20:30:52  dougqh
debugging

Revision 1.1  2002/10/28 22:44:23  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

/*!
@class process
@abstract - used to find information about processes running on the process
   - also used to execute commands
@discussion - this library should ALWAYS be used instead of making calls
   directly to PHP's execute functions to ensure proper operation under
   PHP-Accelerator

   PHP-Accelerator must be set to NOT cache this file.
*/

//========================================================================

   define( 'COLUMN_HASH_NAME' , 'colHash' );
   define( 'COLUMN_HASH_KEY_VAL_NAME' , 'val' );
   define( 'COLUMN_HASH_KEY_COMP_NAME' , 'comp' );

//========================================================================

class html
{

//========================================================================

   /*!
   @function getDevelItemDropDown( $type, $selectName = UNSPECIFIED, $isMultiple = false, $where = UNSPECIFIED, $any = '' )
   @param $type - the data type, such as state or user, needs to match the class name - will also be used as select name (with _id appended to it)
   @discussion - the first char of type will be uppercased to get class name, so that can be all lowercase
   @result - returns a String
      - returns false if the specified process does not exist
   */

   function &getDevelItemDropDown( $type, $selectName = UNSPECIFIED, $isMultiple = false, $where = UNSPECIFIED, $any = '' )
   {
        if( strpos( strtolower($type), "version") !== false )
        {
            $className = "Version";
        }
        else
        {
            $className = ucfirst($type);
        }
        
      $whereClause = '';
      if( $where !== UNSPECIFIED )
      {
         $whereClause = $where;
      }

      if( ! tryImportClass( 'Bugs.' . $className ) )
      {
         if ( ! tryImportClass( 'Shared.' . $className ))
         {
            unreachablePoint(
               'Not able to find class [' . $className . '] in htmlLibrary::getDevelItemDropDown()' );
         }
      }

      if( $selectName === UNSPECIFIED )
      {
         $selectName = $type . '_id';
      }

      $proto =& callStaticMethod( $className, 'getPrototype', new_array() );
      $iterator =& $proto->doSearch( $whereClause, new_array() );

      importClass( 'CollectionUI.IteratorSelectComponent' );
      $iterSelect =& new IteratorSelectComponent( $iterator, COLUMN_HASH_NAME.'['.$selectName.']['.COLUMN_HASH_KEY_VAL_NAME.']', $isMultiple, $any);

      return $iterSelect;
   }

//========================================================================

   /*!
   @function sectionIsInTag($stringWithTags, $start, $end)
   @param $stringWithTags - the string of xml/html that may have tags - must be valid *ml
   @param $start - 0-indexed start postion of section to test
   @param $end - 0-indexed end postion of section to test
   @discussion - this will indicate if the section of the string in question in within a single tag <>
                  It will return false if the section is not surrounded by <> 
   @result - bool
   */

   // end is greater than start
   // there is no > or < in the section

   function sectionIsInTag($stringWithTags, $start, $end)
   {
      // how do we look on the right side?
      // is there a > closer to our right side than a <?
      
      //   --------------------------
      //   | # | 1st | 2nd | return |
      //   --------------------------
      //   | 0 |     |     | false  |
      //   | 1 | >   |     | true   |
      //   | 2 | >   |  <  | true   |
      //   | 3 | <   |  >  | false  |
      //   | 4 | <   |     | false  |
      //   --------------------------

      if($end < $start){unreachablepoint( "html::sectionIsInTag called with invalid start [$start] and end [$end]" );}
      // if(strpos(substr($stringWithTags, $start, $end-$start ), '>') !== false ){unreachablepoint ("html::sectionIsInTag called with > in the test section");}
      // if(strpos(substr($stringWithTags, $start, $end-$start ), '<') !== false ){unreachablepoint ("html::sectionIsInTag called with < in the test section");}

      // this cannot be <= b/c of the case when there are no tags at all
      $firstStrposGTRight =  strpos ( $stringWithTags, '>', $end);      
 
      if($firstStrposGTRight === false) // there no gt on the right
      {
         return false;  // case 0,4 from above chart
      }
      else
      {
         $firstStrposLTRight = strpos ( $stringWithTags, '<', $end);
         if( $firstStrposLTRight === false ) // there is no less than
         {
            return true;  // case 1 from above chart
         }
         else
         {
            return ( $firstStrposGTRight <  $firstStrposLTRight );  // case 2, 3 from above chart
         }
      }   
   }

//========================================================================

   /*!
   @function &getMonthDropDown( $name, $defaultDaysOld = 0 )
   @param $name - the name to call this select comp
   @param $defaultDaysOld - the default date for the select component will equal that of TODAY - $defaultDaysOld
   @discussion - nothing much to discuss
   @result - select htmlcomponent
   */

   function &getMonthDropDown( $name, $defaultDaysOld = 0 )
   {
      importClass( 'HTMLComponents.LightForms.SelectComponent' );

      $monthHash = array(  'Jan' => 1,
                           'Feb' => 2,
                           'Mar' => 3,
                           'Apr' => 4,
                           'May' => 5,
                           'Jun' => 6,
                           'Jul' => 7,
                           'Aug' => 8,
                           'Sep' => 9,
                           'Oct' => 10,
                           'Nov' => 11,
                           'Dec' => 12,
          );
      $numSecsInDay = 24 * 60 * 60;
      $secsOld = $defaultDaysOld * $numSecsInDay;
      $thisMonth = date('n', time() - $secsOld );

      $select =& new SelectComponent( $name );

      foreach($monthHash as $key => $value)
      {
         $select->addOption( $value, $key,($value == $thisMonth) );
      }

      return $select;

   }


//========================================================================

   /*!
   @function &getDayDropDown( $name, $defaultDaysOld = 0 )
   @param $name - the name to call this select comp
   @param $defaultDaysOld - the default date for the select component will equal that of TODAY - $defaultDaysOld
   @discussion - nothing much to discuss
   @result - select htmlcomponent
   */

   function &getDayDropDown( $name, $defaultDaysOld = 0 )
   {
      importClass( 'HTMLComponents.LightForms.SelectComponent' );

      $numSecsInDay = 24 * 60 * 60;
      $secsOld = $defaultDaysOld * $numSecsInDay;
      $thisDay = date('j', time() - $secsOld);

      $select =& new SelectComponent( $name );

      for($i = 1; $i <= 31; ++$i)
      {
         $select->addOption( $i, $i, ($i == $thisDay) );
      }

      return $select;

   }


//========================================================================

   /*!
   @function &getYearDropDown( $name, $defaultDaysOld = 0 )
   @param $name - the name to call this select comp
   @param $defaultDaysOld - the default date for the select component will equal that of TODAY - $defaultDaysOld
   @discussion - nothing much to discuss
   @result - select htmlcomponent
   */

   function &getYearDropDown( $name, $defaultDaysOld = 0 )
   {
      importClass( 'HTMLComponents.LightForms.SelectComponent' );

      $numSecsInDay = 24 * 60 * 60;
      $secsOld = $defaultDaysOld * $numSecsInDay;
      $thisYear = date('Y', time() - $secsOld);

      $select =& new SelectComponent( $name );

      for($i = 2003; $i <= 2010; ++$i)
      {
         $select->addOption( $i, $i, ($i == $thisYear) );
      }

      return $select;

   }

//========================================================================

   /*!
   @function &getYearDropDown( $name, $defaultDaysOld = 0 )
   @param $name - the name to call this select comp
   @param $defaultDaysOld - the default date for the select component will equal that of TODAY - $defaultDaysOld
   @discussion - nothing much to discuss
   @result - select htmlcomponent
   */

   function &getDateDropDown( $nameStart, $defaultDaysOld = 0 )
   {
      importClass( 'HTMLComponents.CompositeHTMLComponent' );

      $joiner =& new CompositeHTMLComponent( '' );

      $joiner->add( html::getMonthDropDown( $nameStart.'Month', $defaultDaysOld ) );
      $joiner->add( html::getDayDropDown( $nameStart.'Day', $defaultDaysOld ) );
      $joiner->add( html::getYearDropDown( $nameStart.'Year', $defaultDaysOld ) );


      return $joiner;
   }

//========================================================================

   /*!
   @function &getDropDownByQuery( $variableName, $sql, $table, $defaultValue = UNSPECIFIED  )
   @param $sql - sql to run
   @param $defaultValue - the value which should be selected by default - in event of tie, last wins
   @discussion - builds select from SQL string - first col is value, 2nd is label
   @result - select htmlcomponent
   */

   function &getDropDownByQuery( $variableName, $sql, $labelColumn, $valueColumn, $table, $defaultValue = UNSPECIFIED )
   {
      importClass( 'Database.DBConnectionProvider' );
      $conn =& DBConnectionProvider::getReadOnlyConnection();
      
      // print $conn->fetchMode . BR_NL;
      
      // $oldFetchMode = $conn->SetFetchMode(ADODB_FETCH_NUM);
      // print $conn->fetchMode . BR_NL;
      importClass( 'Database.StandardCacheHandler' );
      $cacheHandler =& StandardCacheHandler::create( $table );
      
      $cacheTime = $cacheHandler->getMultipleCacheTime();
      
      // print "cacheTime is $cacheTime";
      
      // $stmt = $conn->Prepare( $sql );

         // run the query and cache it for a while (or get it from the cache)
      $recordSet =
            $conn->CacheExecute(
               $cacheTime,
               $sql );
      
      if ( $recordSet === false )
      {
         unreachablePoint(
            'Error in running query in htmlLibrary::getDropDownByQuery - tried to run -> ['.$sql.']'.BR_NL.$conn->ErrorMsg() );
      }
      
      // $array =& $recordSet->GetArray();
      
      importClass( 'HTMLComponents.LightForms.SelectComponent' );

      $select =& new SelectComponent($variableName,false );

      // print_r($recordSet->fields);
      // exit;

      while ( !$recordSet->EOF)
      {
         $value = $recordSet->fields[$valueColumn];
         $label = $recordSet->fields[$labelColumn];
         $select->addOption( $value, $label, ($value == $defaultValue) );
         $recordSet->MoveNext();
         // exit;
      }
      
      // $conn->SetFetchMode($oldFetchMode);
      
      return $select;
   }

//========================================================================

};

?>