<?php

/*
imageLibrary
$Author: dougqh $
$Revision: 1.2 $
$Date: 2004/04/09 17:02:31 $
$Log: imageLibrary.php,v $
Revision 1.2  2004/04/09 17:02:31  dougqh
- Removed uses of call time pass by reference which has deprecated.

Revision 1.1  2003/09/09 15:11:59  dougqh
Initial revision

Revision 1.11  2003/04/01 19:02:22  millz
- updates to text centering

Revision 1.10  2002/10/24 20:32:36  millz
no real changes

Revision 1.9  2002/08/25 16:23:15  dougqh
Correcting some header comments.

Revision 1.8  2002/08/20 20:52:40  millz
removed ImageBorderedTextDimensions

Revision 1.7  2002/08/20 18:47:02  millz
made font non-optional in ImageCenteredTextPosition

Revision 1.6  2002/08/20 18:14:21  millz
updates to ImageCenteredTextPosition logic

Revision 1.5  2002/07/19 19:06:30  millz
small update to imagecenteredtextposition logic

Revision 1.4  2002/07/15 18:44:56  dougqh
Slight change to positioning in ImageDrawText, so that ImageCenteredTextPosition which as desired.

Revision 1.3  2002/07/08 17:12:55  dougqh
Added Image*TextDimensions functions which calculate the dimensions
needed to display text on an image.
Added ImageDimensions function which provides the dimensions of an
image handle.
Added ImageCenteredTextPosition which can be used to center text
on an image.
Added ImageDrawBorderedText which draws text with a border around it.
Made minor adjustment to ImageDrawShadowedText, so that text placement is
consistent between the different ImageDraw*Text functions.

Revision 1.2  2002/07/05 18:48:20  millz
fixes to allow dynamic text on form buttons

Revision 1.1  2002/07/01 20:21:39  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

/*
@library image
@abstract - This File is a collection of functions for loading, manipulating,
   and saving PHP image resources.
*/

//========================================================================

define( "GIF", "gif" );
define( "JPEG", "jpeg" );
define( "PNG", "png" );
define( "WBMP", "wbmp" );

//========================================================================

   /*!
   @function &createImage( $width, $height )
   @param $width - the number of pixels in width
   @param $height - the number of pixels in height
   @discussion - Creates a empty, new 24-bit image
   */

   function &createImage( $width, $height )
   {
      return ImageCreateTrueColor( $width, $height );
   }

//========================================================================


/*!
@function loadImage( $fileName )
@param $fileName - the name of the image to be loaded
@discussion - This function is similar to the built-in PHP ImageCreateFrom
   functions, but it determines what the image type is by using the file
   extension.

   Currently supported image types can be found at
   http://www.php.net/manual/en/ref.image.php.

   As of 12/17/2001, these file types are GIF, JPEG, PNG, WBMP, XBM, XPM.
*/

function &loadImage( $fileName )
{
   //require
   {
      assert( "\$fileName != ''" );
      assert( "file_exists( \$fileName )" );
   }
   //body
   {
      $extension = getExtension( $fileName );

      if ( $extension == "jpg" )
      {
         $extension = JPEG;
      }

      $loadingFunction = "ImageCreateFrom" . $extension;

      $image =& $loadingFunction( $fileName );

      // $imageWidth = imagesx( $imgToCopy );
      // $imageHeight = imagesy( $imgToCopy );

      // $image =& ImageCreateTrueColor( $imageWidth, $imageHeight );

      // $color =& imagecolorallocate ( $image, 123, 234, 23);

      // imagefilledrectangle ( $image, 0, 0, $imageWidth-1, $imageHeight-1, $color);


      // imagecopy ( $image, $imgToCopy, 0, 0, 0, 0, $imageWidth, $imageHeight);


      // writeImageToBrowser( $image, $extension );
   }
   //ensure
   {
   }

   return $image;
}

//========================================================================

/*!
@function saveImage( $image, $fileName, [ $destroy ] )
@param $image - a PHP image resouce
@param $fileName - the name of the file in which the image should be saved
@param $destroy - an optional boolean parameter specifying whether or not to
   destory the image resouce - defaults to true, which will destory the
   resource
@discussion -
   NOTE: The types of files that can be written are
   fewer than the types of a files that can read.

   Currently supported image types can be found at
   http://www.php.net/manual/en/ref.image.php.

   As of 12/17/2001, these file types are GIF, JPEG, PNG, WBMP.
*/

function saveImage( &$image, $fileName, $destroy = true )
{
   //require
   {
      assert( "\$fileName != ''" );
   }
   //body
   {
      $extension = getExtension( $fileName );

      if ( $extension == "jpg" )
      {
         $extension = JPEG;
      }

      $saveFunction = "Image" . $extension;

      $saveFunction( $image, $fileName );

      if ( $destroy )
      {
         ImageDestroy( $image );
      }
   }
   //ensure
   {
   }
}

//========================================================================

/*!
@function writeImageToBrowser( $image, $type, [ $destroy ] )
@param $image - an image resource
@param $type - an image type constant or an image file extension
@param $destroy - optional boolean parameter indicating if the image
   object should be destroyed after written - defaults to true
@discussion - outputs an image directly to the browser in the
   specified file format
*/

function writeImageToBrowser( &$image, $type, $destroy = true )
{
   if ( $type == "jpg" )
   {
      $type = JPEG;
   }

   if ( $type == "wbmp" )
   {
      $contentType = "vnd.wap.wbmp";
   }
   else
   {
      $contentType = $type;
   }

   header( "Content-type: image/" . $contentType );

   $writeFunction = "Image" . $type;

   $writeFunction( $image );

   if ( $destroy )
   {
      ImageDestroy( $image );
   }
}

//========================================================================

/*!
@function ImageDimensions( $imageHandle )
@param $imageHandle - a PHP image handle
@discussion - provides an ordered pair containing the width and height of
   the image

   The first element is the width.
   The second element is the height.
@result - returns an ordered pair
*/

function ImageDimensions( &$imageHandle )
{
   return new_array( ImagesX( $imageHandle ), ImagesY( $imageHandle ) );
}

//========================================================================

/*!
@function ImageColorAllocate2( $imageHandle, $color )
@param $imageHandle - a handle to a PHP image resouce
@param $color - a Color object
@discussion - allocates the specified color for use with the
   specified image
@result - returns a color handle
*/

function &ImageColorAllocate2( &$imageHandle, &$color )
{
   assert( "isInstanceOf( \$color, 'Color' )" );

   return ImageColorAllocate( $imageHandle,
      $color->getRed(), $color->getGreen(), $color->getBlue() );
}

//========================================================================

/*!
@function ImageCenteredTextPosition( &$imageHandle, $textDimensions, &$font )
@param $imageHandle - a handle to a PHP image resource
@param $textDimensions - an order pair returned from one of the Image*TextDimensions
   functions
@param $font - a GenePort font object for the text to be centered
@discussion - provides an ordered pair that provides the correct x and y
   for centering the text on the specified image
@result - returns an ordered pair
*/

function ImageCenteredTextPosition( &$imageHandle, $textDimensions, &$font )
{
   list( $imageWidth, $imageHeight ) = ImageDimensions( $imageHandle );
   list( $textWidth, $textHeight ) = $textDimensions;

   // because of problems with calculating the baseline position, which
   // is really what we need to know when creating centered text (vertically centered)
   // we will get height data for two types of text: one with nothing going under
   // the baseline, and one with something GOING under the baseline ("T", "Ty" respectively)
   //
   // From that we will compare the height of our current text to see if we need to move the
   // vertical pixel start position up a bit.

   $verticalAdjustmentAmount = 0;

   list ($noneUnderBaselineWidth,   $noneUnderBaselineHeight)   = ImageTextDimensions( "T", $font );
   list ($letterUnderBaselineWidth, $letterUnderBaselineHeight) = ImageTextDimensions( "Tyg", $font );

   if($textHeight > $noneUnderBaselineHeight){
      // we need to adjust
      $verticalAdjustmentAmount = $noneUnderBaselineHeight - $letterUnderBaselineHeight + 2;
   }


   // the -2 and -1 at the ends is because we are calculating the exact left side
   // of the baseline whereas our PHP funcs are not
   // quite exact, the subtraction corrects for this
   $yVal = round  ( ( ( $imageHeight - $textHeight ) / 2 ) + $textHeight + $verticalAdjustmentAmount - 3 );
   $xVal = round  ( ( $imageWidth -  $textWidth ) / 2 ) - 1;

   $forDebug = "
   textHeight = $textHeight
   noneUnderBaselineHeight = $noneUnderBaselineHeight
   letterUnderBaselineHeight = $letterUnderBaselineHeight
   verticalAdjustmentAmount = $verticalAdjustmentAmount
   yVal = $yVal
   ";

   // mail( 'millz@incogen.com', 'debug!', $forDebug);

   return new_array(  $xVal, $yVal  );
}

//========================================================================

/*!
@function ImageTextDimensions( $text, $font )
@param $text - the String being displayed
@param $font - a Font to use when drawing the text
@discussion - provides an ordered pair representing the width
   and height that the requested text will take up on the image
   when drawn using ImageDrawText

   The first element is the width.
   The second element is the height.
@result - returns an ordered pair
*/

function ImageTextDimensions( $text, $font )
{
   $box = ImageTTFBBox(
      $font->getActualSize(), 0,
      $font->getTrueTypeFile(),
      $text );

   //see http://www.php.net/manual/en/function.imagettfbbox.php
   //for information about ImageGetTTFBBox

   return new_array(
      $box[ 4 ] - $box[ 0 ],
      $box[ 1 ] - $box[ 5 ] );
}

//========================================================================

/*!
@function ImageDrawText( $imageHandle, $text, $font, $xPos, $yPos, $colorHandle )
@param $imageHandle - a handle to a PHP image resouce
@param $text - a String of text to write on the image
@param $font - a Font object specifying the font for this text
@param $xPos - the x position of the left edge of the first character
@param $yPos - the y position of the lower edge of the first character
@param $colorHandle - a handle to a PHP color resource
@discussion - draws text on an image

   NOTE: That this function takes color handles NOT Color objects.  Use
      ImageColorAllocate2 to get a color handle for a Color object.
*/

function ImageDrawText( $imageHandle, $text, $font, $xPos, $yPos, $colorHandle )
{
   assert( "isInstanceOf( \$font, 'Font' )" );

   _ImageDrawText(
      $imageHandle, $text,
      $font->getTrueTypeFile(), $font->getActualSize(),
      $xPos, $yPos + 2, $colorHandle );
}

//========================================================================

/*!
@function ImageShadowedTextDimensions( $text, $font )
@param $text - the String being displayed
@param $font - a Font to use when drawing the text
@discussion - provides an ordered pair representing the width
   and height that the requested text will take up on the image
   when drawn using ImageDrawShadowedText


   The first element is the width.
   The second element is the height.
@result - returns an ordered pair
*/

function ImageShadowedTextDimensions( $text, $font )
{
   list( $width, $height ) = ImageTextDimensions( $text, $font );

   //This function must be maintained in parallel with _ImageDrawShadowedText

   return new_array( $width + 3, $height + 2 );
}

//========================================================================

/*!
@function ImageDrawShadowedText( $imageHandle, $text, $font, $xPos, $yPos, $colorHandle, $shadowColorHandle )
@param $imageHandle - a handle to a PHP image resource
@param $text - a string of text to write on the image
@param $font - a Font object specifying the font for this text
@param $xPos - the x position of the left edge of the first character
@param $yPos - the y position of the lower edge of the first character
@param $colorHandle - a handle to a PHP color resource - this color is for the acutal text
@param $shadowColorHandle - a handle to a PHP color resource - this color is for the shadow
@discussion - similar to ImageDrawText above, but also draws a shadowed version
   of the text behind the actual text

   NOTE: That this function takes color handles NOT Color objects.  Use
      ImageColorAllocate2 to get a color handle for a Color object.
*/

function ImageDrawShadowedText(
   &$imageHandle, $text, &$font, $xPos, $yPos,
   &$colorHandle, &$shadowColorHandle )
{
   assert( "isInstanceOf( \$font, 'Font' )" );

   _ImageDrawShadowedText(
      $imageHandle, $text,
      $font->getTrueTypeFile(), $font->getActualSize(),
      $xPos, $yPos,
      $colorHandle, $shadowColorHandle );
}

//========================================================================

/*!
@function ImageBorderedTextDimensions( $text, $font, $border )
@param $text - the String being displayed
@param $font - a Font to use when drawing the text
@param $borderWidth - the width in pixels of the border
@discussion - provides an ordered pair representing the width
   and height that the requested text will take up on the image
   when drawn using ImageDrawBorderedText

   The first element is the width.
   The second element is the height.
@result - returns an ordered pair
*/

//function ImageBorderedTextDimensions( $text, &$font, $borderWidth )
//{
//   list( $width, $height ) = ImageTextDimensions( $text, $font );
//
//   //This function must be maintained in parallel with _ImageDrawBorderedText
//
//   return new_array( $width + 2 * $borderWidth, $height + 2 * $borderWidth );
//}

//========================================================================

/*!
@function ImageDrawBorderedText( $imageHandle, $text, $font, $xPos, $yPos, $colorHandle, $shadowColorHandle )
@param $imageHandle - a handle to a PHP image resource
@param $text - a string of text to write on the image
@param $font - a Font object specifying the font for this text
@param $xPos - the x position of the left edge of the first character
@param $yPos - the y position of the lower edge of the first character
@param $colorHandle - a handle to a PHP color resource - this color is for the acutal text
@param $borderColorHandle - a handle to a PHP color resource - this color is for the text border
@param $borderWidth - the width in pixels of the border
@discussion - similar to ImageDrawText above, but also draws a thin outline around the text

   NOTE: That this function takes color handles NOT Color objects.  Use
      ImageColorAllocate2 to get a color handle for a Color object.
*/

function ImageDrawBorderedText( &$imageHandle, $text, &$font, $xPos, $yPos,
   &$colorHandle, &$borderColorHandle, $borderWidth )
{
   _ImageDrawBorderedText(
       $imageHandle, $text,
       $font->getTrueTypeFile(), $font->getActualSize(),
       $xPos, $yPos,
       $colorHandle, $borderColorHandle,
       $borderWidth );
}

//========================================================================

/*!
@function _ImageDrawText( $image, $text, $fontFile, $size, $xPos, $yPos, $colorHandle )
@param $imageHandle - a handle to a PHP image resource
@param $text - a string of text to write on the image
@param $fontFile - a specifying a font file name - no path
@param $size - the point size of the font
@param $xPos - the x position of the left edge of the first character
@param $yPos - the y position of the lower edge of the first character
@param $colorHandle - a handle to a PHP color resource - this color is for the acutal text
@discussion - draws text on an image
*/

function _ImageDrawText( &$imageHandle, $text, $fontFile, $size, $xPos, $yPos,
   &$colorHandle )
{
   debug( "_ImageDrawText", "Text", $text );
   debug( "_ImageDrawText", "FontFile", $fontFile );
   debug( "_ImageDrawText", "Size", $size );
   debug( "_ImageDrawText", "XPos", $xPos );
   debug( "_ImageDrawText", "YPos", $yPos );

   //require
   {
      assert( "file_exists( '$fontFile' ) && is_file( \$fontFile )" );
      assert( "\$size > 0" );
      assert( "\$xPos >= 0" );
      assert( "\$yPos >= 0" );
   }
   //body
   {
      debug( "_ImageDrawText", "fontFile", $fontFile );

      // $imageWidth = imagesx($imageHandle);
      // $imageHeight = imagesy($imageHandle);

      // $tempImageToHoldText =& imageCreate( $imageWidth, $imageHeight );

      // imagefilledrectangle ( $tempImageToHoldText, 0, 0, $imageWidth-1, $imageHeight-1, imagecolorat ( $imageHandle, $xPos, $yPos) );
      // imagecolortransparent ( $tempImageToHoldText , imagecolorat ( $imageHandle, $xPos, $yPos) );

      ImageTTFText( $imageHandle, $size, 0, $xPos, $yPos, $colorHandle, $fontFile, $text );

      // imagecopy ( $imageHandle, $tempImageToHoldText, 0, 0, 0, 0, $imageWidth, $imageHeight);

   }
   //ensure
   {
   }
}

//========================================================================

/*!
@function _ImageDrawShadowedText( $imageHandle, $text, $fontFile, $size, $xPos, $yPos, $colorHandle, $shadowColorHandle )
@param $imageHandle - a handle to a PHP image resource
@param $text - a string of text to write on the image
@param $fontFile - a string a font file name - no path
@param $size - the point size of the font
@param $xPos - the x position of the left edge of the first character
@param $yPos - the y position of the lower edge of the first character
@param $colorHandle - a handle to a PHP color resource - this color is for the acutal text
@param $shadowColorHandle - a handle to a PHP color resource - this color is for the shadow
@discussion - similar to ImageDrawText above, but also draws a shadowed version
   of the text behind the actual text
*/

function _ImageDrawShadowedText( &$imageHandle, $text, $fontFile, $size, $xPos, $yPos,
    &$colorHandle, &$shadowColorHandle )
{
   //This function must be maintained in parallel with ImageShadowedTextDimensions

   _ImageDrawText( $imageHandle, $text, $fontFile, $size, $xPos + 1, $yPos - 1, $shadowColorHandle );
   _ImageDrawText( $imageHandle, $text, $fontFile, $size, $xPos + 2, $yPos, $shadowColorHandle );
   _ImageDrawText( $imageHandle, $text, $fontFile, $size, $xPos + 3, $yPos, $shadowColorHandle );

   _ImageDrawText( $imageHandle, $text, $fontFile, $size, $xPos, $yPos - 2, $colorHandle );
}

//========================================================================

/*!
@function _ImageDrawBorderedText( $imageHandle, $text, $fontFile, $size, $xPos, $yPos, $colorHandle, $borderColorHandle )
@param $imageHandle - a handle to a PHP image resource
@param $text - a string of text to write on the image
@param $fontFile - a string a font file name - no path
@param $size - the point size of the font
@param $xPos - the x position of the left edge of the first character
@param $yPos - the y position of the lower edge of the first character
@param $colorHandle - a handle to a PHP color resource - this color is for the acutal text
@param $borderColorHandle - a handle to a PHP color resource - this color is for the text border
@param $borderWidth - the width in pixels of the border
@discussion - similar to ImageDrawText above, but also draws a thin outline around the text

   NOTE: That this function takes color handles NOT Color objects.  Use
      ImageColorAllocate2 to get a color handle for a Color object.
*/

function _ImageDrawBorderedText( $imageHandle, $text, $fontFile, $size, $xPos, $yPos, $colorHandle, $borderColorHandle, $borderWidth )
{
   //This function must be maintained in parallel with ImageBorderedTextDimensions

   $borderWidthTimesTwo = $borderWidth * 2;

   $xPos -= $borderWidth;
   $yPos += $borderWidth;

   for ( $curX = $xPos; $curX <= $xPos + $borderWidthTimesTwo; $curX++ )
   {
      for ( $curY = $yPos; $curY <= $yPos + $borderWidthTimesTwo; $curY++ )
      {
         _ImageDrawText( $imageHandle, $text, $fontFile, $size, $curX, $curY, $borderColorHandle );
      }
   }

   _ImageDrawText( $imageHandle, $text, $fontFile, $size, $xPos + $borderWidth, $yPos + $borderWidth, $colorHandle );
}

//========================================================================

?>