<?php

/*
stringLibrary
$Author: millz $
$Revision: 1.3 $
$Date: 2004/05/19 15:12:48 $
$Log: stringLibrary.php,v $
Revision 1.3  2004/05/19 15:12:48  millz
- improved logic in getFormattedDBTimeStamp and removed redundant code

Revision 1.2  2003/09/08 14:03:15  millz
- created getShortFormattedDBTimeStamp

Revision 1.1  2003/09/08 13:54:26  millz
-

Revision 1.22  2003/07/09 22:05:54  dougqh
Investigating improvements to niceWordWrap.

Revision 1.21  2003/03/06 19:24:00  dougqh
- Added isValidJavaScriptIdentifier.

Revision 1.20  2003/01/06 14:43:33  dougqh
- Added the functions beforeSubstring and includingSubstring.

Revision 1.19  2002/12/05 22:36:19  millz
- further fixes to containsOnly

Revision 1.18  2002/12/05 21:36:54  millz
- update to containsOnly and getSingularArticle

Revision 1.17  2002/11/18 14:58:26  dougqh
Minor improvement to getSingularArticle.

Revision 1.16  2002/11/14 19:54:49  dougqh
Added new function startsWith.  Changed parameter order of endsWith.

Revision 1.15  2002/11/11 22:18:34  dougqh
Added a new function afterSubstring.

Revision 1.14  2002/10/24 18:19:13  dougqh
Slight changes to getStringDepiction. Added function whiteSpaceToSingleSpace.

Revision 1.13  2002/10/06 20:16:47  dougqh
Added functions getIsOrAre and endsWith.

Revision 1.12  2002/10/02 14:20:23  millz
small update to the soon-to-be-infamous getSingularArticle

Revision 1.11  2002/09/24 18:14:11  dougqh
Changed quotes to ticks - add function getSingularArticle.

Revision 1.10  2002/09/10 20:45:14  dougqh
Adding functions to get the possessive forms of words.

Revision 1.9  2002/09/07 19:37:05  dougqh
Added a new function cleanUpVariableName.

Revision 1.8  2002/09/04 13:36:09  dougqh
Renamed isReal isFloat. Slight changes to isFloat.

Revision 1.7  2002/08/05 13:48:37  dougqh
Added function niceWordWrap.

Revision 1.6  2002/08/01 19:43:59  clay
added isIPAddress

Revision 1.5  2002/08/01 19:17:08  clay
changed the return values from numeric to false or true

Revision 1.4  2002/08/01 18:56:42  clay
Added isInteger and isReal to check on strings that should be numbers

Revision 1.3  2002/07/23 22:13:11  dougqh
Added new functions isAlphabetic, isAlphaNumeric, and containsOnly.

Revision 1.2  2002/07/09 13:28:53  dougqh
Added a new function removeWhiteSpace.

Revision 1.1  2002/07/01 20:21:39  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

/*
@library StringFunctions
@abstract - this file contains functions for doing string manipulation
   operations not related to URLs
   - for URL manipulation functions see the URLFunctions library
*/

//========================================================================

define( 'ALPHABETIC_CHARACTERS', 'abcdefghijklmnopqrstuvwxyz' );
define( 'ALPHANUMERIC_CHARACTERS', 'abcdefghijklmnopqrstuvwxyz0123456789' );

//========================================================================

/*!
@function ucaseWords( $string )
@param $string - a string
@discussion - a function that does a better job of capitalizing
   all the words in a string than the built in ucwords

   NOTE:
   This function was taken from PHP.net.
   http://www.php.net/manual/en/function.ucwords.php
@result - a string with all the words in the string capitalized
*/

function ucaseWords( $string )
{
   /*
   The code is horribly difficult to follow, but it been
   spaced out so that it is "pretty".
   */

   $string = strtolower( $string );
   $break = true;

   for ( $i = 0; $i < strlen( $string ); $i++ )
   {
      $subed = $string[ $i ];
      if ( ( ( ord( $subed ) > 64 ) && ( ord( $subed ) < 123 ) ) ||
           ( ( ord( $subed ) > 48 ) && ( ord( $subed ) < 58 ) ) )
      {
         if ( $break )
         {
            $string[ $i ] = strtoupper( $subed );
         }
         $break = false;
      }
      else
      {
         $break = true;
      }
   }

   return $string;
}

//========================================================================

/*!
@function getFormattedDBTimeStamp()
@discussion - uses the current db conn to properly decipher and format a timestamp column into a user-presentable form
*/

function getFormattedDBTimeStamp( $timeStampFromDBCol, $dateFormat = 'M j, Y, g:i a' )
{
   // if( $timeStampFromDBCol == '0000-00-00 00:00:00' ){ return '(None)';}

   // THIS CONNECTION is only needed for date formatting purposes!
   importClass( 'Database.DBConnectionProvider' );
   $dbcon =& DBConnectionProvider::getReadOnlyConnection();

   $currUnixDate = time();
   $DBUnixDate = $dbcon->UnixTimeStamp( $timeStampFromDBCol );

   if( $DBUnixDate <= 0 )  // assume something before Jan 1970 is too old, therefore something must be wrong with $timeStampFromDBCol
   { return '(None)'; }

   $numSecsSinceDate = $currUnixDate - $DBUnixDate;
   $numDaysSinceDate = $numSecsSinceDate / 60 / 60 / 24;
   
   if( $numDaysSinceDate < 0 ){ $daysLabel = ' days from now'; $numDaysSinceDate = - $numDaysSinceDate;}
   else{ $daysLabel = ' days ago'; }

   return date( $dateFormat, $DBUnixDate ) . " (".number_format($numDaysSinceDate,1).$daysLabel.")";
}

//========================================================================

/*!
@function getShortFormattedDBTimeStamp()
@discussion - uses the current db conn to properly decipher and format a timestamp column into a user-presentable form
*/

function getShortFormattedDBTimeStamp( $timeStampFromDBCol )
{
   
    return getFormattedDBTimeStamp( $timeStampFromDBCol, 'M j, Y' );

}

//========================================================================

/*!
@function getStringDepiction( $object )
@param $object - a variable of any data type
@discussion - translates the object into its print_r string representation
   booleans will be translated into the strings "true" or "false"
@result - returns the print_r string representation of the $object with
   appropriate HTML formatting
*/

function getStringDepiction( $object )
{
   $result = getSimpleStringDepiction( $object );

   $result = str_replace( "\t", '    ', $result );
   $result = str_replace( ' ', '&nbsp;', $result );
   $result = str_replace( "<br/>\n", '<br/>', $result );
   $result = nl2br( $result );

   return $result;
}

//========================================================================

/*!
@function getSimpleStringDepiction( $object )
@param $object - a variable of any data type
@discussion - translates the object into its print_r string representation
   booleans will be translated into the strings "true" or "false"

   NOTE: Unlike getStringDepiction, this function does not perform
      any additional operations to make the string print nicely as HTML.
      This function is designed, so that things are displayed nicely as text.
@result - returns the print_r string representation of $object WITHOUT any
   HTML formatting
*/

function getSimpleStringDepiction( $object )
{
   if ( is_bool( $object ) )
   {
      return boolToString( $object );
   }
   elseif ( $object === NULL )
   {
      return 'NULL';
   }
   else
   {
      ob_start();
      print_r( $object );
      $result = ob_get_contents();
      ob_end_clean();

      return $result;
   }
}

//========================================================================

/*!
@function boolToString( $bool )
@param $bool - a value that can be interpreted as true or false
@result - if $bool is true returns the string "true";
   otherwise returns the string "false"
*/

function boolToString( $bool )
{
   return ( $bool ? 'true' : 'false' );
}

//========================================================================

/*!
@function niceWordWrap( $string, $maxLineLength, [ $changeSoftBreak ] )
@param $string - a String to display
@param $lineLength - the maximum number of characters in a line
@param $changeSoftBreak - a boolean indicating if the last word
   break before the end of the line should be translated to a line break
   - defaults to true
@discussion - breaks the line at the last space before the maximum line
   length is reached

   If no space is found a break is forced at the maximum line length.

   Guarantees that all lines are less than or equal to the maxLineLength.
@result - returns a String
*/

function niceWordWrap( $string, $lineLength, $changeSoftBreak = true )
{
//   return
//      preg_replace(
//         '/\S{' . $lineLength . '}/',
//         '\0 ',
//         $string );

   $string = str_replace( "\t", ' ', $string );

   //$changeSoftBreak = ( $changeSoftBreak === UNSPECIFIED ) ? true : $changeSoftBreak;
   $softBreakReplace = ( $changeSoftBreak ) ? "\n" : ' ';

   //$strings = explode( "\n", $string );

   $resultString = '';
   $isNotFirst = false;

   foreach( explode( "\n", $string ) as $curString )
   {
      if ( ( $curLength = strlen( $curString ) ) <= $lineLength )
      {
         $resultString .= $curString . "\n";
      }
      else
      {
         for ( $pos = 0; $pos < $curLength; )
         {
            $curFragment = substr( $curString, $pos, $lineLength );
            $spacePos = strrpos( $curFragment, ' ' );

            if ( $spacePos === false )
            {
               $resultString .= $curFragment . "\n";

               $pos += $lineLength;
            }
            else
            {
               $resultString .= substr( $curFragment, 0, $spacePos ) . $softBreakReplace;

               $pos += ( $spacePos + 1 );
            }
         }
      }
   }

   //clean up the possible doublings the above code creates
   $resultString = str_replace( array( "\n\n", "\n " ), "\n", $resultString );

   return $resultString;
}

//========================================================================

/*!
@function addToList( $list, $joiner, $value )
@param $list - the current list String
@param $delimiter - the String used to join the values together
@param $value - the String value to add to the end of the list
@discussion - adds value the specified value to the end of the list
   adding the $delimiter between the $list and the new value if the
   list is non-empty
@result - returns the new list
*/

function addToList( $list, $delimiter, $value )
{
   //require
   {
   }
   //body
   {
      $newList = $list;

      $newList .= ( $newList == '' ) ? '' : $delimiter;

      $newList .= $value;
   }
   //ensure
   {
      assert( '( $list == "" ) || ( strpos( $newList, $list ) === 0 )' );
   }

   return $newList;
}

//========================================================================

/*!
@function htmlEntitiesReverse( $string )
@param $string - a String that may contain HTML Entities
@discussion - a function that is the inverse of the function htmlEntities
   i.e. it reverses the translation of odd characters into &x;, etc.

   NOTE: This function does not support all entities.
      See this page for a listing of all entities.
      http://www.imasy.or.jp/~mistral/netscape/entities.html

   NOTE: This code adapted from code found at
      http://www.php.net/manual/en/function.preg-replace.php

@result - returns a String with its HTML Entities turn back into
   their single character representations
*/

function htmlEntitiesReverse( $string )
{
   $string = str_replace( "", "", $string );

   $search = array ( "'&(quot|#34);'i",                 // Replace html entities
                     "'&(amp|#38);'i",
                     "'&(lt|#60);'i",
                     "'&(gt|#62);'i",
                     "'&(nbsp|#160);'i",
                     "'&(iexcl|#161);'i",
                     "'&(cent|#162);'i",
                     "'&(pound|#163);'i",
                     "'&(copy|#169);'i",
                     "'&#(\d+);'e");                    // evaluate as php

   $replace = array ( "\"",
                      "&",
                      "<",
                      ">",
                      " ",
                      chr( 161 ),
                      chr( 162 ),
                      chr( 163 ),
                      chr( 169 ),
                      "chr(\\1)");

   $string = preg_replace ( $search, $replace, $string );

   return $string;
}

//========================================================================

/*!
@function removeWhiteSpace( $string )
@param $string - a String
@discussion - removes all the whitespace from the specified String
@result - returns the original string with all the whitespace removed
*/

function removeWhiteSpace( $string )
{
   return str_replace( array( ' ', "\t", "\n", "\r" ), '', $string );
}

//========================================================================

/*!
@function whiteSpaceToSingleSpace( $string )
@param $string - a String
@discussion - converts all regions of white space in the string
   to a single space

   NOTE: multiple spaces are converted to a single space.
@result - returns a String
*/

function whiteSpaceToSingleSpace( $string )
{
   return preg_replace( '/\s+/', ' ', $string );
}

//========================================================================

/*!
@function cleanUpVariableName( $string )
@param $string - a String
@discussion - takes a string that is the basis for a variable name
   and transforms it into a proper variable name
@result - returns a String
*/

function cleanUpVariableName( $string )
{
   //replace anything non-alphanumeric with an underscore
   //prepend "v_" in case the first character was a digit
   return 'v_' . preg_replace( "/[\W]/", "_", $string );
}

//========================================================================

/*!
@function isAlphabetic( $string, [ $additions ] )
@param $string - a String
@param $additions - a String containing additional acceptable characters
   - defaults to empty
@discussion - indicates if the String is composed entirely of alphabetic
   characters
*/

function isAlphabetic( $string, $additions = '' )
{
   // this is case insensitive b/c we know that ALPHABETIC_CHARACTERS is all lowercase
   return containsOnly( strtolower( $string ), ALPHABETIC_CHARACTERS . $additions );
}

//========================================================================

/*!
@function isAlphaNumeric( $string, [ $additions ] )
@param $string - a String
@param $additions - a String containing additional acceptable characters
   - defaults to empty
@discussion - indicates if the character is an alphanumeric character
   - by default alphanumeric means only letters and numbers
@result - returns true if the character is alphanumeric character;
   otherwise returns false
*/

function isAlphaNumeric( $string, $additions = '' )
{
   // this is case insensitive b/c we know that ALPHANUMERIC_CHARACTERS is all lowercase
   return containsOnly( strtolower( $string ), ALPHANUMERIC_CHARACTERS . $additions );
}

//========================================================================

/*!
@function containsOnly( $string, $acceptableCharacters )
@param $string - a String
@param $acceptableCharacters - a String containing acceptable characters
   for the String to contain
@discussion - returns true if $string is composed entirely of
   characters from $acceptableCharacters; otherwise returns false
@result - returns true if $string is composed entirely of
   characters from $acceptableCharacters; otherwise returns false
*/

function containsOnly( $string, $acceptableCharacters )
{
   return ( strspn( $string , $acceptableCharacters ) == strlen( $string ) );
}

//========================================================================

/*!
@function stripNonAlphanumeric( $string, [ $additional ] )
@param $string - a String
@param $additional - a String of additional characters to accept
   - defaults to empty String
@discussion - strips any non-alphanumeric characters out the String
@result - returns a String
*/

function stripNonAlphanumeric( $string, $additional = '' )
{
   if ( isAlphaNumeric( $string, $additional ) )
   {
      return $string;
   }
   else
   {
      $length = strlen( $string );
      for ( $i = 0, $result = ''; $i < $length; ++$i )
      {
         if ( isAlphaNumeric( $string[ $i ], $additional ) )
         {
            $result .= $string[ $i ];
         }
      }

      return $result;
   }
}

//========================================================================

/*!
@function isInteger($string)
@param $string - a String
@discussion - returns true if $string is an integer
@result - returns true if $string is composed entirely of
   digits otherwise returns false
*/

function isInteger( $string )
{
   if( preg_match( "/^-?\d+$/",$string ) )
   {
      return true;
   }
   elseif( preg_match ( '/^-?\d+,\d{3}/', $string ) )
   {
      return true;
   }
   elseif( preg_match( '/\d?\.\d+/', $string ) )
   {
      return false;
   }
   elseif ( is_numeric( $string ) )
   {
      if( preg_match( '/^-?\d+$/', floatval( $string ) ) )
      {
         return true;
      }
   }
   //else

   return false;
}

//========================================================================

/*!
@function isFloat( $string )
@param $string - a String
@discussion - returns true if it is a number
@result - returns true if $string is not composed entirely of
   digits otherwise returns false
*/
function isFloat( $string )
{
   return ( is_numeric( $string ) || isInteger( $string ) );
}

//========================================================================

/*!
@function isIPAddress($string)
@param $string - a String
@discussion - returns true if $string is a valid IP
@result - returns true if $string is an IP

*/
function isIPAddress($string){

   return preg_match("/\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\:?\d?/",$string);

}

//========================================================================

/*!
@function getPossessive( $string )
@param $string - takes a word and attempts to provide its possessive form
@result - returns a String
*/

function getPossessive( $string )
{
   $lastCharIndex = strlen( $string ) - 1;

   if ( ( strrpos( $string, 's' ) === $lastCharIndex ) ||
        ( strrpos( $string, 'x' ) === $lastCharIndex ) ||
        ( strrpos( $string, 'z' ) === $lastCharIndex ) )
   {
      $string .= '\'';
   }
   else
   {
      $string .= '\'s';
   }

   return $string;
}

//========================================================================

/*!
@function getSingularPossessive( $string )
@param $string - a String
@discussion - takes a singular word and provides its possessive form
@result - returns a String
*/

function getSingularPossessive( $string )
{
   return $string . '\'s';
}

//========================================================================

/*!
@function getPluralPossessive( $string )
@param $string - a String
@discussion - takes a plural word and provides its possessive form
@result - returns a String
*/

function getPluralPossessive( $string )
{
   //s is last character
   if ( strrpos( $string, 's' ) === strlen( $string ) - 1 )
   {
      $string .= '\'';
   }
   else
   {
      $string .= '\'s';
   }

   return $string;
}

//========================================================================

/*!
@function getSingularArticle( $word )
@param $word - a word
@discussion - provides the appropriate article a or an to proceed the
   specified word
@result - returns 'a' or 'an'
*/

function getSingularArticle( $word )
{
   $lowerFirst = strtolower( $word[ 0 ] );

   if ( preg_match("/\Auser/i", $word ) ) // catch the nice weirdos
   {
      return 'a';
   }
   elseif ( isAllUppercase( $word[0] ) && isAllUppercase( $word[1] ) )
   {
      if(
          $word[0] == 'H' ||
          $word[0] == 'E' ||
          $word[0] == 'I' ||
          $word[0] == 'O' ||
          $word[0] == 'A' ||
          $word[0] == 'F' ||
          $word[0] == 'L' ||
          $word[0] == 'X' ||
          $word[0] == 'N' ||
          $word[0] == 'M' ||
          $word[0] == 'S'
        )
        { return 'an'; }
   }
   elseif ( containsOnly( $lowerFirst, 'aeiou' ) )
   {
      return 'an';
   }
   else
   {
      return 'a';
   }
}

//========================================================================

/*!
@function isAllUppercase( $word )
@param $word - a String
@discussion - indicates if a String is completely uppercase
@result - returns a boolean
*/

function isAllUppercase( $word )
{
   return containsOnly( $word, strtoupper( ALPHABETIC_CHARACTERS ) );
}

//========================================================================

/*!
@function getIsOrAre( $word )
@param $noun - a noun
@discussion - provides 'is' or 'are' as appropriate for the given word
@result - returns 'is' or 'are'
*/

function getIsOrAre( $word )
{
   //s is last character
   if ( strrpos( $word, 's' ) === strlen( $word ) - 1 )
   {
      return 'are';
   }
   else
   {
      return 'is';
   }
}

//========================================================================

/*!
@function endsWith( $needle, $haystack )
@param $needle - a String to search for
@param $haystack - a String to search
@discussion - indicates if $haystack ends with $needle
@result - returns a boolean
*/

function endsWith( $needle, $haystack )
{
   $needleLength = strlen( $needle );

   if ( $needleLength == 1 )
   {
      //strrpos only works with single characters
      return ( strrpos( $haystack, $needle ) == strlen( $haystack ) - strlen( $needle ) );
   }
   else
   {
      //not a single character string, so used something more exotic
      $parts = explode( $needle, $haystack );
      $numParts = count( $parts );

      //number parts is 1 or 0 then $needle was not in $haystack
      if ( $numParts <= 1 ) return false;

      //if the last part is an empty string then $needle was at the end of $haystack
      return ( $parts[ $numParts - 1 ] == '' );
   }
}

//========================================================================

/*!
@function beginsWith( $needle, $haystack )
@param $needle - a String to search for
@param $haystack - a String to search
@discussion - indicates if haystack starts with needle
@result - returns a boolean
*/

function beginsWith( $needle, $haystack )
{
   return ( strpos( $haystack, $needle ) === 0 );
}

//========================================================================

/*!
@function afterSubstring( $needle, $haystack )
@param $needle - the substring to find
@param $haystack - the string to search in
@discussion - provides everything after the last occurrence of the needle
   from the haystack
@result - returns a String
*/

function afterSubstring( $needle, $haystack )
{
   return array_pop( explode( $needle, $haystack ) );
}

//========================================================================

/*!
@function beforeSubstring( $needle, $haystack )
@param $needle - the substring to find
@param $haystack - the string to search in
@discussion - provides everything before the first occurrence of the needle
   from the haystack
@result - returns a String
*/

function beforeSubstring( $needle, $haystack )
{
   $pos = strpos( $haystack, $needle );
   return ( ( $pos === false ) ? $haystack : substr( $haystack, 0, $pos ) );
}

//========================================================================

/*!
@function includingSubstring( $needle, $haystack )
@param $needle - the substring to find
@param $haystack - the string to search in
@discussion - provides everything up to and including the first occurrence of the
   needle from the haystack
@result - returns a String
*/

function includingSubstring( $needle, $haystack )
{
   $pos = strpos( $haystack, $needle );
   return ( ( $pos === false ) ? $haystack : substr( $haystack, 0, $pos + strlen( $needle ) ) );
}

//========================================================================

/*!
@function isValidJavaScriptIdentifier( $string )
@param $string - a string
@discussion - indicates if the provided string is a valid JavaScript identifier
@result - returns a boolean
*/

function isValidJavaScriptIdentifier( $string )
{
   return isAlphabetic( $string[ 0 ], '_' ) &&
          isAlphaNumeric( substr( $string, 0 ), '_' );
}

//========================================================================

?>