<?php

/*
systemMethods
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/09 15:11:59 $
$Log: systemMethodsLibrary.php,v $
Revision 1.1  2003/09/09 15:11:59  dougqh
Initial revision

Revision 1.4  2003/07/11 13:11:11  dougqh
- Removed pointless caching in _tryRegisterObject2.

Revision 1.3  2003/03/17 15:11:24  dougqh
- Commented out some debugging

Revision 1.2  2003/03/17 14:28:15  dougqh
Debugging

Revision 1.2  2003/03/17 13:40:09  dougqh
Calling _store on the three new StorageSystems.

Revision 1.1  2002/11/06 20:30:52  dougqh
Initial revision

Revision 1.2  2002/07/18 14:18:13  dougqh
Turned off some debugging.

Revision 1.1  2002/07/01 20:21:39  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, //printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

//define( 'SYSTEM_FLAG_PREFIX', 'smx_' );

define( 'FINALIZE_METHOD', '_finalize' );
define( 'DISPOSE_METHOD', '__dispose' );

//========================================================================

/*!
@library systemMethods
@discussion - a collection of functions used to identifying objects
   implementing special methods and call all objects implementing
   that method at script termination
*/

//========================================================================

class systemMethods
{

//========================================================================

   /*!
   @function tryRegisterObject( $object )
   @param $object - an Object
   @discussion - checks to see if this Object implements any of the
      special system methods - if the Object does implement them
      it is registered for later invocation.
   */

   function tryRegisterObject( &$object )
   {
      systemMethods::_tryRegisterObject2( $object, FINALIZE_METHOD );
      //systemMethods::_tryRegisterObject2( $object, DISPOSE_METHOD );
   }

//========================================================================

   /*!
   @function finalizeAll()
   @discussion - called to call the _finalize method on all implementing
      Objects
   */

   function finalizeAll()
   {
      systemMethods::_execute( FINALIZE_METHOD );
   }

//========================================================================

   /*!
   @function disposeAll()
   @discussion - called to call the __dispose method on all implementing
      Objects
   */

   function disposeAll()
   {
      //systemMethods::_execute( DISPOSE_METHOD );
   }

//========================================================================

   /*!
   @function _tryRegisterObject2( $object, $method )
   @param $object - an Object
   @param $method - a String containing a method name
   @discussion - checks to see if this Object implements the specified method
      If it does it will be registered as implementing the specified method,
      for later invoction.
   */

   function _tryRegisterObject2( &$object, $method )
   {
      if ( method_exists( &$object, $method ) )
      {
         global $GL_methodGroupsHash;
         global $GL_methodCountHash;

         //print 'Object : ' . $object->object_id . ' has method : ' . $method . '<br />' . NL;

         if ( isset( $GL_methodGroupsHash{ $method } ) )
         {
            $GL_methodGroupsHash{ $method }[ $GL_methodCountHash{ $method }++ ] =& $object;
         }
         else
         {
            $GL_methodCountHash{ $method } = 1;
            $GL_methodGroupsHash{ $method }[ 0 ] =& $object;
         }
      }
   }

//========================================================================

   /*!
   @function _execute( $method )
   @param $method - a String containing a method name
   @discussion - executes the specified method on all Objects known
      to implement it
   */

   function _execute( $method )
   {
      global $GL_methodGroupsHash;
      //$objects =& $GL_methodGroupsHash{ $method };

      if ( isset( $GL_methodGroupsHash{ $method } ) )
      {
         //print 'SystemMethods::_execute : method : ' . $method . '<br />' . NL;

         global $GL_methodCountHash;
         $count = $GL_methodCountHash{ $method };

         //print 'SystemMethods::_execute : count : ' . $count . '<br />' . NL;

         for ( $i = 0; $i < $count; ++$i )
         {
            //print 'Class : ' . get_class( $GL_methodGroupsHash{ $method }[ $i ] ) . '<br />' . NL;
//            print 'systemMethods::_execute address of: ' .
//               get_address_of( $GL_methodGroupsHash{ $method }[ $i ] ) . BR_NL;

            $GL_methodGroupsHash{ $method }[ $i ]->$method();
         }
      }
   }

//========================================================================

};

?>