<?php

/*
timeLibrary
$Author: dougqh $
$Revision: 1.1 $
$Date: 2003/09/09 15:11:59 $
$Log: timeLibrary.php,v $
Revision 1.1  2003/09/09 15:11:59  dougqh
Initial revision

Revision 1.11  2003/03/17 14:27:59  dougqh
Minor clean-up / debugging

Revision 1.12  2003/03/17 13:40:09  dougqh
Calling _store on the three new StorageSystems.

Revision 1.11  2003/03/07 20:57:08  dougqh
No changes

Revision 1.10  2002/11/22 14:24:59  dougqh
Minor fix to the stand-alone addTime.

Revision 1.9  2002/11/20 16:36:13  geneport
Move must functions into a class gpTime in compliance with new library standards.

Revision 1.8  2002/11/14 19:13:54  dougqh
Bumped up the maximum number of time addition requests to 1024.

Revision 1.7  2002/11/14 15:26:46  dougqh
Better support for command line.

Revision 1.6  2002/10/02 14:51:02  dougqh
Combatting duplicate definition conflicts with GP3 code.

Revision 1.5  2002/09/26 21:50:12  dougqh
Upped allowed number of time addition requests.

Revision 1.4  2002/09/26 19:37:51  dougqh
Increased number of allow increment requests.

Revision 1.3  2002/09/24 22:47:59  dougqh
Quotes to ticks

Revision 1.2  2002/09/18 22:45:09  dougqh
Added new functions to provide better control over PHP time out limits.

Revision 1.1  2002/07/01 20:21:39  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a 
legal AGREEMENT between you (either as a 
registered individual or as the 
registered representative and on 
behalf of a single entity) and INCOGEN, Inc., 
for the software product identified above, which 
product includes computer software and may 
include associated media, printed materials, 
and "online" or electronic documentation 
("SOFTWARE PRODUCT").  By installing, copying, 
or otherwise using the SOFTWARE PRODUCT, you 
agree to be bound by the terms of this EULA. 
If you do not agree to the terms of this EULA, 
then DO NOT install or use the SOFTWARE 
PRODUCT; in such event the original purchaser 
may, however, return it to the place of 
purchase within thirty days of the date of 
original purchase for a full refund.

Please read the remaining text of this agreement 
in the accompanying license.txt file
*/

//========================================================================

define( 'MAX_NUM_ADD_TIME_REQUESTS', 4096 );

//========================================================================

if ( ! function_exists( 'getmicrotime' ) )
{
   
/*!
@function getmicrotime()
@discussion - provides the current time
@result - number of secs since epoch (down to the millisec)
*/

function getmicrotime()
{ 
   list( $sec, $usec ) = explode( ' ', microtime() ); 
   return ( $sec + $usec ); 
}

}

//========================================================================

/*!
@function setTimeOut( $seconds )
@param $seconds - a number greater than 0
@discussion - sets the remaining amount of time for which this script
   is allowed to execute
*/

function setTimeOut( $seconds )
{
   deprecated( 'setTimeOut', 'gpTime::setTimeOut' );
   
   gpTime::setTimeOut( $seconds );
}

//========================================================================

/*!
@function addTime( $seconds )
@discussion - adds additional seconds to the amount of time before
   this script times out
*/

function addTime( $seconds )
{
   deprecated( 'addTime', 'gpTime::addTime' );
   
   gpTime::addTime( $seconds );
}

//========================================================================

class gpTime
{

//========================================================================

   /*!
   @function setTimeOut( $seconds )
   @param $seconds - a number greater than 0
   @discussion - sets the remaining amount of time for which this script
      is allowed to execute
   */
   
   function setTimeOut( $seconds )
   {
      //happy with infinite time no reason to change
      if ( IS_COMMAND_LINE ) return;
      
      debug( 'setTimeOut', 'seconds', $seconds );
      set_time_limit( $seconds );
      //ini_set( 'max_execution_time', $seconds );
      
      global $GL_endTime;
      $GL_endTime = getmicrotime() + $seconds;
   }

//========================================================================   
   
   /*!
   @function addTime( $seconds )
   @discussion - adds additional seconds to the amount of time before
      this script times out
   */
   
   function addTime( $seconds )
   {
      if ( IS_COMMAND_LINE ) return;
      
      static $numRequests;
      $numRequests = isset( $numRequests ) ? $numRequests + 1 : 0;
      if ( $numRequests == MAX_NUM_ADD_TIME_REQUESTS )
      {
         print 'time::addTime - excessive number of addTime calls made';
         print 'NumRequests: ' . $numRequests;
         exit;
      }
      
      global $GL_endTime;
      
      gpTime::setTimeout( intval( $GL_endTime - getmicrotime() + $seconds ) );
   }

//========================================================================

};

?>