<?php

/*
webServer
$Author: dougqh $
$Revision: 1.2 $
$Date: 2003/09/09 15:13:51 $
$Log: webServerLibrary.php,v $
Revision 1.2  2003/09/09 15:13:51  dougqh
- Fixed problem with defined check in tryKillProcess

Revision 1.1  2003/09/09 15:11:59  dougqh
Initial revision

Revision 1.3  2003/08/29 21:08:09  dougqh
- Modified to not do memory check if MAX_APACHE_CHILD_MEMORY is not defined.

Revision 1.2  2003/07/09 22:05:54  dougqh
?

Revision 1.1  2002/10/28 22:45:15  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

/*!
@class webServer
@abstract - a collection of functions that can be used to
   get information about the web server - usually Apache
*/

class webServer
{

//========================================================================

   /*!
   @function getProcessID()
   @discussion - provides the id of the current Apache process
   @result - returns a number
   */

   function getProcessID()
   {
      return getmypid();
   }

//========================================================================

   /*!
   @function tryKillProcess()
   @discussion - kills the current server process if its memory
      usage is too high - limit is controlled by MAX_APACHE_CHILD_MEMORY
   */

   function tryKillProcess()
   {
      if (
         defined( 'MAX_APACHE_CHILD_MEMORY' ) &&
         webServer::getMemoryUsage() > MAX_APACHE_CHILD_MEMORY )
      {
         webServer::killProcess();
      }
   }

//========================================================================

   /*!
   @function killProcess()
   @discussion - kills the current server process after script
      execution is complete
   */

   function killProcess()
   {
      apache_child_terminate();
   }

//========================================================================

   /*!
   @function getMemoryUsage()
   @discussion - gets the memory usage of the current server process
   @result - returns an integer (in KBs)
   */

   function getMemoryUsage()
   {
      return process::getMemoryUsage( getmypid() );
   }

//========================================================================

   /*!
   @function getUser()
   @discussion - provides the name of the user running the web server
   @result - returns a String
   */

   function getUser()
   {
      return process::getUser( getmypid() );
   }

//========================================================================

};

?>