<?php

/*
Config
$Author: dougqh $
$Revision: 1.3 $
$Date: 2004/01/13 14:40:23 $
$Log: Config.php,v $
Revision 1.3  2004/01/13 14:40:23  dougqh
- Better error reporting for problem with recent item handling

Revision 1.2  2004/01/06 15:45:05  millz
- bug fixes

Revision 1.1  2004/01/05 19:48:56  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'Database.ADatabaseItem' );

//========================================================================

/*!
@class Config
@abstract -
*/

class Config extends ADatabaseItem
{

//========================================================================

   // <class vars>

//========================================================================

   /*!
   @function Config()
   @discussion - constructs a new Config object
   @result - constructs a new Config object
   */

   function Config( $id = UNSPECIFIED )
   {
        $this->ADatabaseItem( $id );
   }

//========================================================================

   /*!
   @function getPrototype()
   @discussion - provides the config prototype
   */

   /* static */
   function &getPrototype()
   {
      return Config::_getPrototype( __FILE__ );
   }


//========================================================================

   /*!
   @function getTable()
   @discussion - provides the table name (with schema if necessary)
   @result - returns a String
   */

   function getTable()
   {
      return 'config';
   }

//========================================================================

   /*!
   @function getAllColumns()
   @discussion - returns the columns for this item's row
   */

   function getAllColumns()
   {
      return array(
         $this->getPrimaryColumn(),
         'typeName',
         'varName',
         'description',
         'value',
         'user_id' );
   }

//========================================================================

   /*!
   @function setValue( $value )
   @discussion -
   */

    function setValue( $value )
    {
        $this->value = serialize( $value );
    }

//========================================================================

   /*!
   @function getValue( )
   @discussion -
   */
   function getValue()
   {
      global $php_errormsg;
      $php_errormsg = '';
      $value = @unserialize( $this->value );
      if ( ! empty( $php_errormsg ) )
      {
         print 'Problem unserializing config info' . BR_NL;
         print 'Error: ' . $php_errormsg . BR_NL;
         print_r( $this->value );
         unreachablePoint();
      }
      return $value;
   }

//========================================================================

    /*!
    @function doSearchByType( $type, $order = UNSPECIFIED )
    @discussion -
    */
    function &doSearchByType( $type, $order = UNSPECIFIED )
    {
        return $this->doSearch( 'typeName = ?',
                            new_array($type) ,
                            $order );
    }

//========================================================================

    /*!
    @function doSearchByTypeAndUser( $type, &$user, $order = UNSPECIFIED )
    @discussion -
    */
    function &doSearchByTypeAndUser( $type, &$user, $order = UNSPECIFIED )
    {
        return $this->doSearch( 'typeName = ? and user_id = ?',
                            new_array($type, $user->getPrimaryID() ) ,
                            $order );
    }
//========================================================================

    /*!
    @function doIDSearchWithType( $type, $ids )
    @discussion -
    */
    function &doIDSearchWithType( $type, $ids )
    {
        return $this->doSearch( 'typeName = ? and config_id in (' . implode( ',', $ids ) . ')',
                            new_array( $type )
                            );
    }

//========================================================================

    /*!
    @function &getConfigByTypeAndId( $name, $id )
    @discussion -
    */
    function &getConfigByTypeAndId( $name, $id )
    {
        $prototype =& Config::getPrototype();
        $iter =& $prototype->doIDSearchWithType( $name, array( $id ) );
        $iter->reset();

        if ( $iter->isEnd() )
        {
            return NULL;
        }
        else
        {
            return $iter->getCurrent();
        }
    }

//========================================================================

    /*!
    @function &staticCreateNew( $type, $value = '' )
    @discussion -
    */
    /* static */
    function &staticCreateNew( $type, $value = '' )
    {
        return Config::staticCreateNamedNew( $type, '', $value );
    }

//========================================================================

    /*!
    @function &staticCreateNamedNew( $type, $varName, $value = '' )
    @discussion -
    */
    /* static */
    function &staticCreateNamedNew( $type, $varName, $value = '' )
    {
      $config =& new Config();
      $config->typeName = $type;
      $config->varName = $varName;
      $config->setValue( $value );

      return $config;
    }

//========================================================================

    /*!
    @function setUser( &$user )
    @discussion -
    */
    function setUser( &$user )
    {
        $this->user_id = $user->getPrimaryID();
    }

//========================================================================

   /*!
   @function isUser( &$user )
   @discussion -
   */
   function isUser( &$user )
   {
      if ( ! is_object( $user ) )
      {
         print_r( $user );
         unreachablePoint( 'Bad User in Config->isUser' );
      }

      return ( $this->user_id == $user->getPrimaryID() );
   }

//========================================================================

    /*!
    @function getDescription()
    @discussion -
    */
    function getDescription()
    {
        return $this->description;
    }

//========================================================================

    /*!
    @function setDescription( $desc )
    @discussion -
    */
    function setDescription( $desc )
    {
        $this->description = $desc;
    }

//========================================================================

    /*!
    @function _getRegularIdentifyingString()
    @discussion -
    */
    function _getRegularIdentifyingString()
    {
        return $this->typeName . ':' . $this->varName;
    }

//========================================================================
};

?>