<?php

/*
Project
$Author: dougqh $
$Revision: 1.8 $
$Date: 2004/04/19 13:14:42 $
$Log: Project.php,v $
Revision 1.8  2004/04/19 13:14:42  dougqh
- Fixed 4266

Revision 1.7  2004/04/01 22:12:56  millz
- little fix to addElement

Revision 1.6  2004/03/24 19:44:11  millz
- added _setDefaultTester and _store

Revision 1.5  2004/02/17 16:03:39  millz
- working on methods needed for project web tools

Revision 1.4  2003/12/18 20:42:27  dougqh
Updated to work under PHP 4.2

Revision 1.3  2003/12/17 14:42:49  dougqh
- 3910 - Added method searchDevelopmentItems

Revision 1.2  2003/11/03 20:02:30  dougqh
- Delete debugging in getAvailableTesters.

Revision 1.1  2003/09/09 21:01:07  stage
Initial revision

Revision 1.5  2003/07/17 20:52:34  millz
- corrected getVerifReqdDevItems

Revision 1.4  2003/07/17 14:57:32  millz
- made bug fixes and new iterator generators for stats portlets

Revision 1.3  2003/07/14 18:24:35  dawn
- Changed getAvailableTesters to include QA-leads. Minor change to empty / distinct handling in _getUserIDsForUserType.

Revision 1.2  2003/07/14 18:01:32  dawn
- add getAvailableTesters

Revision 1.1  2003/07/09 20:33:12  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'Database.ADatabaseItem' );

//========================================================================

// define( 'FILES_BASE_DIR_NAME', 'files' ); - this is now def'd in configuration.php

define( 'USER_PROJECT_MAPPING_TABLE', 'user_project_usertype' );

define( 'DEFAULT_TESTER_ID_COLUMN', 'defaultTester_id' );

//========================================================================

/*!
@class Project
@abstract -
*/

class Project extends ADatabaseItem
{

//========================================================================

   var $name;
   var $description;

//========================================================================

   /*!
   @function Project()
   @discussion - constructs a new Project object
   @result - constructs a new Project object
   */

   function Project( $primary_id = UNSPECIFIED )
   {
      $this->ADatabaseItem( $primary_id );
   }

//========================================================================

   /*!
   @function getTable()
   @discussion - provides the table name (with schema if necessary)
   @result - returns a String
   */

   function getTable()
   {
      return SHARED_SCHEMA . '.project';
   }

//========================================================================

   /*!
   @function getPrototype()
   @discussion - constructs a Project prototype
   */

   /* static */
   function &getPrototype()
   {
      return Project::_getPrototype( __FILE__ );
   }

//========================================================================

   /*!
   @function getFromPrimaryID( $primary_id )
   */

   /* static */
   function &getFromPrimaryID( $primary_id )
   {
      return Project::_getFromPrimaryID(
         Project::getPrototype(),
         $primary_id );
   }

//========================================================================

   /*!
   @function _setDefaultTester( &$user )
   */

    function _setDefaultTester( &$user )
    {
        $this->defaultTester_id = $user->getPrimaryID();
    }

//========================================================================


   /*!
   @function _store()
   */
    function _store()
    {
        $prim_id = parent::_store();
        // Using SQL check to see if $this->defaultTester_id is
        // listed as a tester for the project with ID $prim_id.
        // If it is NOT, then INSERT it as one.

        importClass( 'Shared.UserType' ); // for the constants
        $sqlFind = 'select 1 from user_project_usertype where user_id = '.
                        $this->defaultTester_id. ' and project_id = '. $prim_id .
                        ' and usertype_id = '.QUALITY_ASSURANCE_USER_TYPE_ID;

        importClass( 'Database.DBConnectionProvider' );
        $dbcon =& DBConnectionProvider::getConnection(); // we may have to write as well

        $rs =& $dbcon->execute( $sqlFind );
        $foundEntry = false;
        while (!$rs->EOF) { $foundEntry = true; break; }

        if( !$foundEntry )
        {
            // add it in
            $sql = 'insert into user_project_usertype (user_id, project_id, usertype_id)  values ('.
                        $this->defaultTester_id. ' , '. $prim_id . ' , '.QUALITY_ASSURANCE_USER_TYPE_ID . ')';
            $rs =& $dbcon->execute( $sql );
            $cacheHandler =& Project::getUserProjectUserTypeCacheHandler();
            $cacheHandler->markAllDirty();

            // check what we did - not really needed
            $rs =& $dbcon->execute( $sqlFind );
            $foundEntry = false;
            while (!$rs->EOF) { $foundEntry = true; break; }
            if( !$foundEntry ){ print 'Unable to set default tester of project (id = '.$prim_id.') to be a QA usertype (with user ID of '.$this->defaultTester_id . ')'; }
        }

    }

//========================================================================

   /*!
   @function getName()
   @discussion - a normal get function
   @result - returns name item for this object
   */

   function getName()
   {
      return $this->name;
   }

//========================================================================

   /*!
   @function setName( $name )
   @param $name - the value to set the name member to
   @discussion - a normal set function
   @result - returns nothing
   */

   function _setName( $name )
   {
      $this->name = $name;
   }

//========================================================================

   /*!
   @function getDirectory()
   @discussion - gives the base files directory for this project
   @result - returns string (file path dir)
   */

   function getDirectory()
   {
      return FILES_BASE_DIR_NAME . DIRECTORY_SEPARATOR . stripNonFileNameCharacters($this->getName());
   }

//========================================================================

   /*!
   @function getDescription()
   @discussion - a normal get function
   @result - returns description item for this object
   */

   function getDescription()
   {
      return $this->description;
   }

//========================================================================

   /*!
   @function setDescription( $description )
   @param $description - the value to set the description member to
   @discussion - a normal set function
   @result - returns nothing
   */

   function _setDescription( $description )
   {
      $this->description = $description;
      $this->_setChanged( true );
   }

//========================================================================

   /*!
   @function getAllColumns()
   @discussion - returns the columns for this item's row
   */

   function getAllColumns()
   {
      return array( $this->getPrimaryColumn(), 'name', DEFAULT_TESTER_ID_COLUMN );
   }

//========================================================================

   /*!
   @function _getRegularIdentifyingString()
   */

   function _getRegularIdentifyingString()
   {
      return $this->getName();
   }

//========================================================================

   /*!
   @function addDevelopmentItem( &$devItem )
   @param $devItem - an ADevelopmentItem
   @discussion - adds this ADevelopmentItem to this Project
   */

   function addDevelopmentItem( &$devItem )
   {
      $devItem->_setProject( $this );
      $devItem->_store();
   }

//========================================================================

   /*!
   @function _addClientVersion( $version )
   @param $version - a Version - (usually where isNew is true)
   @discussion - adds a server version to this Project
   */

   function _addClientVersion( &$version )
   {
      $this->_addVersion( $version, CLIENT_VERSION_TYPE );
   }

//========================================================================

   /*!
   @function _addServerVersion( $version )
   @param $version - a Version - (usually where isNew is true)
   @discussion - adds a server version to this Project
   */

   function _addServerVersion( &$version )
   {
      $this->_addVersion( $version, SERVER_VERSION_TYPE );
   }

//========================================================================

   /*!
   @function _addVersion( $version, $versionType )
   @param $version - a Version - (usually where isNew is true)
   @param $versionType - one of CLIENT_VERSION_TYPE or SERVER_VERSION_TYPE
   @discussion - adds a Version to this Project
   */

   function _addVersion( &$version, $versionType )
   {
      //need Version for its constants
      importClass( 'Bugs.Version' );
      $version->_setProjectInfo( $this, $versionType );
      $version->_store();
   }

//========================================================================

   /*!
   @function addSubproject( &$subproject )
   @param $subproject - the subproject to add to this project
   @discussion - adds a subproject to this Project
   */

   function addSubproject( &$subproject )
   {
      $subproject->_setProject( $this );
      $subproject->_store();
   }

//========================================================================

   /*!
   @function removeSubproject( &$obj )
   @param $cat - the Subproject to remove from this project
   @discussion - removes the Subproject from this Project
   */

   function removeSubproject( $obj )
   {
      if ( compare::equals( $this, $obj->getProject() ) )
      {
         $obj->delete();
      }
   }

//========================================================================

   /*!
   @function addServerinstance( &$instance )
   @param $subproject - the instance to add to this project
   @discussion - adds a instance to this Project
   */

   function addServerinstance( &$instance )
   {
      $instance->_setProject( $this );
      $instance->_store();
   }

//========================================================================

   /*!
   @function removeServerinstance( &$obj )
   @param $cat - the Serverinstance to remove from this project
   @discussion - removes the Serverinstance from this Project
   */

   function removeServerinstance( $obj )
   {
      if ( compare::equals( $this, $obj->getProject() ) )
      {
         $obj->delete();
      }
   }

//========================================================================

   /*!
   @function addCategory( &$cat )
   @param $cat - the Category to add to this project
   @discussion - adds a Category to this Project
   */

   function addCategory( &$cat )
   {
      $cat->_setProject( $this );
      $cat->_store();
   }

//========================================================================

   /*!
   @function removeElement( $obj )
   @param $obj - the object that should be removed from the project - one of these types: Subproject, ServerInstance, Category, ClientType
   @discussion - removes the object from this Project if it is of a valid type
   */

   function removeElement( $obj )
   {
      // look at the obj type and then toss it over to the proper add method
      if( isInstanceOf( $obj, 'Subproject' ) )
      {
         $this->removeSubproject( $obj );
      }
      elseif( isInstanceOf( $obj, 'ServerInstance' ) )
      {
         $this->removeServerInstance( $obj );
      }
      elseif( isInstanceOf( $obj, 'Category' ) )
      {
         $this->removeCategory( $obj );
      }
      elseif( isInstanceOf( $obj, 'ClientType' ) )
      {
         $this->removeClientType( $obj );
      }
      elseif( isInstanceOf( $obj, 'Subproject' ) )
      {
         unreachablepoint( 'Project::addElement does not understand the type of the input var!' );
      }
   }

//========================================================================

   /*!
   @function addElement( $obj )
   @param $obj - the object that should be added to the project - one of these types: Subproject, ServerInstance, Category, ClientType
   @discussion - adds the object to this Project if it is of a valid type
   */

   function addElement( &$obj )
   {
      // look at the obj type and then toss it over to the proper add method
      if( isInstanceOf( $obj, 'Subproject' ) )
      {
         $this->addSubproject( $obj );
      }
      elseif( isInstanceOf( $obj, 'ServerInstance' ) )
      {
         $this->addServerInstance( $obj );
      }
      elseif( isInstanceOf( $obj, 'Category' ) )
      {
         $this->addCategory( $obj );
      }
      elseif( isInstanceOf( $obj, 'ClientType' ) )
      {
         $this->addClientType( $obj );
      }
      else
      {
         unreachablepoint( 'Project::addElement does not understand the type of the input var!' );
      }
   }

//========================================================================

   /*!
   @function removeCategory( &$obj )
   @param $cat - the Category to remove from this project
   @discussion - removes the Category from this Project
   */

   function removeCategory( $obj )
   {
      if ( compare::equals( $this, $obj->getProject() ) )
      {
         $obj->delete();
      }
   }

//========================================================================

   /*!
   @function addClientType( &$clientType )
   @param $cat - the clientType to add to this project
   @discussion - adds a clientType to this Project
   */

   function addClientType( &$clientType )
   {
      $clientType->_setProject( $this );
      $clientType->_store();
   }

//========================================================================

   /*!
   @function removeClientType( &$obj )
   @param $cat - the clientType to remove from this project
   @discussion - removes the clientType from this Project
   */

   function removeClientType( $obj )
   {
      if ( compare::equals( $this, $obj->getProject() ) )
      {
         $obj->delete();
      }
   }

//========================================================================

   /*!
   @function getUnassignedDevelopmentItems()
   @discussion - provides the set of unassigned DevelopmentItems for
      this Project
   @result - returns IIterator< ADevelopmentItem >
   */

   function &getUnassignedDevelopmentItems()
   {
      importClass( 'Bugs.ADevelopmentItem' );
      $devItemPrototype =& ADevelopmentItem::getPrototype();

      importClass( 'Bugs.State' );
      $final = ADatabaseItem::_getAndWherePairs(
         array(
            State::_getActiveStateWherePair(),
            ADevelopmentItem::_getUnassignedWherePair(),
            ADevelopmentItem::_getProjectWherePair( $this ) ) );

      importClass( 'Bugs.State' );
      return $devItemPrototype->doSearch(
         $final[ 0 ],
         $final[ 1 ] );
   }

//========================================================================

   /*!
   @function getNewDevelopmentItems()
   @discussion - provides an IIterator of DevelopmentItems
   @result - returns IIterator< ADevelopmentItem >
   */

   function &getNewDevelopmentItems()
   {
      $final = ADatabaseItem::_getAndWherePairs(
         array(
            ADevelopmentItem::_getNewWherePair(),
            ADevelopmentItem::_getProjectWherePair( $this ) ) );

      //print_r( $final );

      importClass( 'Bugs.ADevelopmentItem' );
      $devItemPrototype =& ADevelopmentItem::getPrototype();
      return $devItemPrototype->doSearch(
         $final[ 0 ],
         $final[ 1 ] );
   }

//========================================================================

   /*!
   @function getVerificationRequestedDevelopmentItems()
   @discussion - provides an IIterator of DevelopmentItems
   @result - returns IIterator< ADevelopmentItem >
   */

   function &getVerificationRequestedDevelopmentItems()
   {
      importClass( 'Bugs.ADevelopmentItem' );
      $devItemPrototype =& ADevelopmentItem::getPrototype();

      $final = ADatabaseItem::_getAndWherePairs(
         array(
            ADevelopmentItem::_getVerificationRequestedWherePair(),
            ADevelopmentItem::_getProjectWherePair( $this ) ) );

      importClass( 'Bugs.State' );
      return $devItemPrototype->doSearch(
         $final[ 0 ],
         $final[ 1 ] );
   }

//========================================================================

   /*!
   @function getVerificationRequestedDevelopmentItemsFor()
   @discussion - provides an IIterator of DevelopmentItems
   @result - returns IIterator< ADevelopmentItem >
   */

   function &getVerificationRequestedDevelopmentItemsFor( &$user )
   {
      importClass( 'Bugs.ADevelopmentItem' );
      $devItemPrototype =& ADevelopmentItem::getPrototype();

      $final = ADatabaseItem::_getAndWherePairs(
         array(
            ADevelopmentItem::_getVerificationRequestedWherePair(),
            ADevelopmentItem::_getProjectWherePair( $this ),
            array( 'tester_id=?', array( User::getCurrentUserID() ) ) ) );

      importClass( 'Bugs.State' );
      return $devItemPrototype->doSearch(
         $final[ 0 ],
         $final[ 1 ] );
   }

//========================================================================

   /*!
   @function getAllActiveDevelopmentItems()
   @discussion - provides all the active ADevelopmentItems in this Project
   @result - returns IIterator< ADevelopmentItem >
   */

   function &getAllActiveDevelopmentItems()
   {
      importClass( 'Bugs.ADevelopmentItem' );
      importClass( 'Bugs.State' );
      $devItemPrototype =& ADevelopmentItem::getPrototype();

      $final = ADatabaseItem::_getAndWherePairs(
         array(
            ADevelopmentItem::_getProjectWherePair( $this ),
            State::_getActiveNonVRStateWherePair() ) );

      importClass( 'Bugs.State' );
      return $devItemPrototype->doSearch(
         $final[ 0 ],
         $final[ 1 ],
         'priority_id desc' );
   }

//========================================================================

   /*!
   @function getAllDevelopmentItems()
   @discussion - provides all the ADevelopmentItems in this Project
   @result - returns IIterator< ADevelopmentItem >
   */

   function &getAllDevelopmentItems()
   {
      importClass( 'Bugs.ADevelopmentItem' );
      $devItemPrototype =& ADevelopmentItem::getPrototype();

      $final = ADevelopmentItem::_getProjectWherePair( $this );

      importClass( 'Bugs.State' );
      return $devItemPrototype->doSearch(
         $final[ 0 ],
         $final[ 1 ] );
   }

//========================================================================

   /*!
   @function _getUserWherePair()
   @discussion - provides a where pair that list the users for
      this Project
   @result - returns a WherePair
   */

//   function _getUserWherePair()
//   {
//
//      return array(
//         'user_id IN (' . implode( ',', $this->_getUserIDs() ) . ')',
//         array() );
//   }

//========================================================================

   /*!
   @function getTesters()
   @discussion - provides an IIterator of testers for this Project
      If a person is NOT a tester on a bug they will NOT be returned
      in the IIterator.
   @result - returns an IIterator< User >
   */

   function &getTesters()
   {
      if ( ! isset( $this->testerIDs ) )
      {
         importClass( 'Database.DBConnectionProvider' );
         $conn =& DBConnectionProvider::getReadOnlyConnection();

         importClass( 'Bugs.ADevelopmentItem' );
         $prototype =& ADevelopmentItem::getPrototype();

         $this->testerIDs = $conn->CacheGetCol(
            $prototype->_getMultipleRowCacheTime(),
            'SELECT DISTINCT(tester_id) FROM report WHERE project_id=?',
            array( $this->getPrimaryID() ) );
      }

      importClass( 'Shared.User' );
      $userProto =& User::getPrototype();

      return $userProto->doIDSearch( $this->testerIDs );
   }

//========================================================================

   /*!
   @function getSubmitters()
   @discussion - provides an IIterator of submitters for this Project
      If a person is NOT a tester on a bug they will NOT be returned
      in the IIterator.
   @result - returns an IIterator< User >
   */

   function &getSubmitters()
   {
      if ( ! isset( $this->submitterIDs ) )
      {
         importClass( 'Database.DBConnectionProvider' );
         $conn =& DBConnectionProvider::getReadOnlyConnection();

         importClass( 'Bugs.ADevelopmentItem' );
         $prototype =& ADevelopmentItem::getPrototype();

         $this->submitterIDs = $conn->CacheGetCol(
            $prototype->_getMultipleRowCacheTime(),
            'SELECT DISTINCT(submitter_id) FROM report WHERE project_id=?',
            array( $this->getPrimaryID() ) );
      }

      importClass( 'Shared.User' );
      $userProto =& User::getPrototype();

      return $userProto->doIDSearch( $this->submitterIDs );
   }

//========================================================================

   /*!
   @function getUserProjectUserTypeCacheHandler()
   @discussion - provides the cache handler for the user_project_usertype
      table
   @result - returns an ADBCacheHandler
   */

   function &getUserProjectUserTypeCacheHandler()
   {
      importClass( 'Database.StandardCacheHandler' );
      return StandardCacheHandler::create( USER_PROJECT_MAPPING_TABLE );
   }

//========================================================================

   /*!
   @function _getUserIDsForUserType( $userTypeID )
   @param $userTypeID - a RowID
   @discussion - provides an array of user_ids for this Project
   @result - returns an integer[]
   */

   function _getUserIDsForUserType( $userTypeID )
   {
      if ( ! isset( $this->userIDsHash{ $userTypeID } ) )
      {
         importClass( 'Database.DBConnectionProvider' );
         $conn =& DBConnectionProvider::getReadOnlyConnection();

         $cacheHandler =& Project::getUserProjectUserTypeCacheHandler();

         $userIDs = $conn->CacheGetCol(
            $cacheHandler->getMultipleCacheTime(),
            'SELECT DISTINCT(user_id) ' .
               'FROM '.USER_PROJECT_MAPPING_TABLE.' ' .
               'WHERE project_id=? AND usertype_id=?',
            array(
               $this->getPrimaryID(),
               $userTypeID ) );

         if ( is_array( $userIDs ) )
         {
            $userIDs = $userIDs;
         }
         else
         {
            $userIDs = array();
         }

         $this->userIDsHash{ $userTypeID } = $userIDs;
      }

      return $this->userIDsHash{ $userTypeID };
   }

//========================================================================

   /*!
   @function getDevelopers()
   @discussion - provides developers for this Project
   @result - returns an IIterator< User >
   */

   function &getDevelopers()
   {
      importClass( 'Shared.User' );
      $userPrototype =& User::getPrototype();

      //constant loaded from UserType by User
      return $userPrototype->doIDSearch(
         $this->_getUserIDsForUserType( DEVELOPER_TYPE_ID ) );
   }

//========================================================================

   /*!
   @function getQALeads()
   @discussion - provides QA Leads for this Project
   @result - returns an IIterator< User >
   */

   function &getQALeads()
   {
      importClass( 'Shared.User' );
      $userPrototype =& User::getPrototype();

      //constant loaded from UserType by User
      return $userPrototype->doIDSearch(
         $this->_getUserIDsForUserType( QALEAD_TYPE_ID ) );
   }

//========================================================================
   /*!
   @function getAvailableTesters(  )
   @discussion - provides available testers for the project
   @result - returns IIterator< User >
   */

   function &getAvailableTesters()
   {
      importClass( 'Shared.User' );
      $userPrototype =& User::getPrototype();

      //A little wasteful to do two queries, but typically they'll be cached
      $ids = arrayMerge(
         $this->_getUserIDsForUserType( QUALITY_ASSURANCE_USER_TYPE_ID ),
         $this->_getUserIDsForUserType( QA_LEAD_USER_TYPE_ID ) );

      //constant loaded from UserType by User
      return $userPrototype->doIDSearch( $ids );
   }


//========================================================================

   /*!
   @function getDesigners()
   @discussion - provides an of designers for this Project
   @result - returns an IIterator< User >
   */

   function &getDesigners()
   {
      importClass( 'Shared.User' );
      $userPrototype =& User::getPrototype();

      //constant loaded from UserType by User
      return $userPrototype->doIDSearch(
         $this->_getUserIDsForUserType( DESIGNER_TYPE_ID ) );
   }

//========================================================================

   /*!
   @function _isUserTypeX( $userID, $userTypeID )
   @param $userID - a user_id number/key
   @param $userTypeID - the usertype id to check against
   @discussion - return bool if user is this type for this project
   @result - returns a boolean
   */

   function _isUserTypeX( $userID, $userTypeID )
   {
      importClass( 'Database.DBConnectionProvider' );
      $conn =& DBConnectionProvider::getReadOnlyConnection();

      $cacheHandler =& Project::getUserProjectUserTypeCacheHandler();

      $answer = $conn->CacheGetOne(
         $cacheHandler->getMultipleCacheTime(),
         'SELECT 1 FROM '.USER_PROJECT_MAPPING_TABLE.' WHERE project_id=? and user_id=? and usertype_id=?',
         array( $this->getPrimaryID(), $userID, $userTypeID ) );

      return ( $answer == 1 );
   }

//========================================================================

   /*!
   @function isDeveloper( $user )
   @param $user - a User
   @discussion - indicates if the provider User is a Developer for
      this Project
   @result - returns a boolean
   */

   function isDeveloper( &$user )
   {
      importClass( 'Shared.UserType' ); // to get the constants

      return (
         FORCE_DEVELOPER ||
         $this->_isUserTypeX( $user->getPrimaryID(), DEVELOPER_USER_TYPE_ID ) );
   }

//========================================================================

   /*!
   @function isQALead( $user )
   @param $user - a User
   @discussion - indicates if the provider User is a QALead for
      this Project
   @result - returns a boolean
   */

   function isQALead( &$user )
   {
      importClass( 'Shared.UserType' ); // to get the constants

      return (
         FORCE_QA_LEAD ||
         $this->_isUserTypeX( $user->getPrimaryID(), QA_LEAD_USER_TYPE_ID ) );
   }

//========================================================================

   /*!
   @function isQA( $user )
   @param $user - a User
   @discussion - indicates if the provider User is a QALead for
      this Project
   @result - returns a boolean
   */

   function isQA( &$user )
   {
      importClass( 'Shared.UserType' ); // to get the constants

      return (
         FORCE_QA ||
         $this->_isUserTypeX(
            $user->getPrimaryID(),
            QUALITY_ASSURANCE_USER_TYPE_ID ) ||
         $this->isQALead( $user ) );
   }

//========================================================================

   /*!
   @function isDesigner( $user )
   @param $user - a User
   @discussion - indicates if the provider User is a designer for
      this Project
   @result - returns a boolean
   */

   function isDesigner( &$user )
   {
      importClass( 'Shared.UserType' ); // to get the constants

      return (
         FORCE_DESIGNER ||
         $this->_isUserTypeX( $user->getPrimaryID(), DESIGNER_USER_TYPE_ID ) );
   }

//========================================================================

   /*!
   @function getCategories()
   @discussion - provides an IIterator accross the Categories of
      this Project
   @result - returns an IIterator
   */

   function &getCategories()
   {
      importClass( 'Bugs.Category' );
      $categoryPrototype =& Category::getPrototype();

      return $categoryPrototype->doSearch(
         'project_id = ?',
         array( $this->getPrimaryID() ) );
   }

//========================================================================

   /*!
   @function getSubprojects()
   @discussion - provides an IIterator accross the Subprojects of
      this Project
   @result - returns an IIterator
   */

   function &getSubprojects()
   {
      importClass( 'Bugs.Subproject' );
      $subprojectPrototype =& Subproject::getPrototype();

      return $subprojectPrototype->doSearch(
         'project_id=?',
         array( $this->getPrimaryID() ) );
   }

//========================================================================

   /*!
   @function _getVersionWherePair()
   @discussion - provides a WherePair that retrieves all the versions
      for this Project
   @result - returns a WherePair
   */

   function _getVersionWherePair()
   {
      return array( 'project_id=?', array( $this->getPrimaryID() ) );
   }

//========================================================================

   /*!
   @function getServerVersions()
   @discussion - provides the collection of versions for this Project
   @result - returns an IIterator< Version >
   */

   function &getServerVersions()
   {
      importClass( 'Bugs.Version' );
      $versionPrototype =& Version::getPrototype();

      $pair = ADatabaseItem::_getAndWherePairs(
         array(
            $this->_getVersionWherePair(),
            Version::_getServerWherePair() ) );

      return $versionPrototype->doSearch(
         $pair[ 0 ],
         $pair[ 1 ] );
   }

//========================================================================

   /*!
   @function getClientVersions()
   @discussion - provides the collection of versions for this Project
   @result - returns an IIterator< Version >
   */

   function &getClientVersions()
   {
      importClass( 'Bugs.Version' );
      $versionPrototype =& Version::getPrototype();

      $pair = ADatabaseItem::_getAndWherePairs(
         array(
            $this->_getVersionWherePair(),
            Version::_getClientWherePair() ) );

      return $versionPrototype->doSearch(
         $pair[ 0 ],
         $pair[ 1 ] );
   }

////========================================================================
//
//   /*!
//   @function _getPlatformWherePair()
//   @discussion - provides a WherePair that selects all platforms
//      for this Project
//   @result - returns a WherePair
//   */
//
//   function _getPlatformWherePair()
//   {
//      return array( 'project_id=?', array( $this->getPrimaryID() ) );
//   }

//========================================================================

   /*!
   @function getServerPlatforms()
   @discussion - provides the collection of available server platforms
      for this Project
   @result - returns an IIterator< Platform >
   */

   function &getServerPlatforms()
   {
      importClass( 'Bugs.Platform' );
      $platformPrototype =& Platform::getPrototype();

      $pair = Platform::_getServerWherePair();

      return $platformPrototype->doSearch(
         $pair[ 0 ],
         $pair[ 1 ] );
   }

//========================================================================

   /*!
   @function getClientPlatforms()
   @discussion - provides the collection of available server platforms
      for this Project
   @result - returns an IIterator< Platform >
   */

   function &getClientPlatforms()
   {
      importClass( 'Bugs.Platform' );
      $platformPrototype =& Platform::getPrototype();

      $pair = Platform::_getClientWherePair();

      return $platformPrototype->doSearch(
         $pair[ 0 ],
         $pair[ 1 ] );
   }

//========================================================================

   /*!
   @function getClientTypes()
   @discussion - provides the collection of available ClientTypes
      for this Project
   @result - returns an IIterator< ClientType >
   */

   function &getClientTypes()
   {
      importClass( 'Bugs.ClientType' );
      $clientTypePrototype =& ClientType::getPrototype();

      return $clientTypePrototype->doSearch(
         'project_id=?', array( $this->getPrimaryID() ) );
   }

//========================================================================

   /*!
   @function getServerInstances()
   @discussion - provides the collection of available ServerInstances
      for this Project
   @result - returns an IIterator< ServerInstance >
   */

   function &getServerInstances()
   {
      importClass( 'Bugs.ServerInstance' );
      $serverInstancePrototype =& ServerInstance::getPrototype();

      return $serverInstancePrototype->doSearch(
         'project_id=?', array( $this->getPrimaryID() ) );
   }

//========================================================================

   /*!
   @function getDefaultTester()
   @discussion - provides the default tester for this Project
   @result - returns a User
   */

   function &getDefaultTester()
   {
      importClass( 'Shared.User' );
      return User::getFromPrimaryID( $this->defaultTester_id );
   }

//========================================================================

   /*!
   @function _getDevelopmentItemCacheTime()
   @discussion - provides the cache time for ADevelopmentItems
   @result - returns an unsigned integer
   */

   /* static */
   function _getDevelopmentItemCacheTime()
   {
      //Since this will be called often, cache the result

      static $instanceArray;

      if ( ! isset( $instanceArray ) )
      {
         importClass( 'Bugs.ADevelopmentItem' );
         $devItemProto =& ADevelopmentItem::getPrototype();

         $instanceArray[ 0 ] =& $devItemProto->getCacheHandler();
      }

      return $instanceArray[ 0 ]->getMultipleCacheTime();
   }

//========================================================================

   /*!
   @function getAllActiveVeryUrgentDevelopmentItems()
   @discussion - provides all the closed ADevelopmentItems in this Project
   @result - returns IIterator< ADevelopmentItem >
   */

   function &getAllActiveVeryUrgentDevelopmentItems()
   {
      importClass( 'Bugs.ADevelopmentItem' );
      $devItemPrototype =& ADevelopmentItem::getPrototype();

      $final = ADevelopmentItem::_getProjectWherePair( $this );
      importClass( 'Bugs.State' );
      importClass( 'Bugs.Priority' );
      // $devItemPrototype =& ADevelopmentItem::getPrototype();

      $final = ADatabaseItem::_getAndWherePairs(
         array(
            new_array('priority_id = ?', VERY_URGENT_PRIORITY_ID),
            new_array('project_id = ?', $this->getPrimaryID() ),
            State::_getActiveNonVRStateWherePair() ) );

      importClass( 'Bugs.State' );
      return $devItemPrototype->doSearch(
         $final[0],
         $final[1] );
   }

//========================================================================

   /*!
   @function getAllActiveUrgentDevelopmentItems()
   @discussion - provides all the closed ADevelopmentItems in this Project
   @result - returns IIterator< ADevelopmentItem >
   */

   function &getAllActiveUrgentDevelopmentItems()
   {
      importClass( 'Bugs.ADevelopmentItem' );
      $devItemPrototype =& ADevelopmentItem::getPrototype();

      $final = ADevelopmentItem::_getProjectWherePair( $this );



      importClass( 'Bugs.State' );
      importClass( 'Bugs.Priority' );
      // $devItemPrototype =& ADevelopmentItem::getPrototype();

      $final = ADatabaseItem::_getAndWherePairs(
         array(
            new_array('priority_id = ?', URGENT_PRIORITY_ID),
            new_array('project_id = ?', $this->getPrimaryID() ),
            State::_getActiveNonVRStateWherePair() ) );

      importClass( 'Bugs.State' );
      return $devItemPrototype->doSearch(
         $final[0],
         $final[1] );
   }

//========================================================================

   /*!
   @function getAllClosedDevelopmentItems()
   @discussion - provides all the closed ADevelopmentItems in this Project
   @result - returns IIterator< ADevelopmentItem >
   */

   function &getAllClosedDevelopmentItems()
   {
      importClass( 'Bugs.ADevelopmentItem' );
      $devItemPrototype =& ADevelopmentItem::getPrototype();

      $final = ADevelopmentItem::_getProjectWherePair( $this );

      $binds = array(
         CLOSED_FIXED_STATE_ID,
         $this->getPrimaryID() );

      importClass( 'Bugs.State' );
      return $devItemPrototype->doSearch(
         'state_id >= ? AND project_id = ?',
         $binds );
   }

//========================================================================

   /*!
   @function getDevelopmentItemsAssignedTo( $user )
   @param $user - a User - a developer
   @discussion - provides the "active" ADevelopmentItems assigned
      to the provider User
   @result - returns an IIterator< ADevelopmentItem >
   */

   function &getDevelopmentItemsAssignedTo( &$user )
   {
      importClass( 'Bugs.ADevelopmentItem' );
      $devItemPrototype =& ADevelopmentItem::getPrototype();

      importClass( 'Bugs.State' );
      return $devItemPrototype->doSearch(
         '((state_id >= ? AND state_id <= ?) OR state_id=?) AND developer_id=? AND project_id=?',
         array(
            UNDER_DEVELOPMENT_ASSIGNED_STATE_ID,
            UNDER_DEVELOPMENT_FIX_FAILED_STATE_ID,
            SUBMITTED_ASSIGNED_STATE_ID,
            $user->getPrimaryID(),
            $this->getPrimaryID() ) );
   }

//========================================================================

   /*!
   @function searchDevelopmentItems( $wherePair, [ $joinStruct ] )
   @discussion - searches the ADevelopmentItems of this Project to
      see if they comply with the provided wherePair
   @result -
   */

   function &searchDevelopmentItems(
      &$baseWherePair,
      $order = UNSPECIFIED,
      $joinStruct = UNSPECIFIED )
   {
      importClass( 'Bugs.ADevelopmentItem' );
      $proto =& ADevelopmentItem::getPrototype();
      $wherePair =
         ADatabaseItem::_getAndWherePairs(
         array(
            $baseWherePair,
            array(
               'project_id=?',
               array( $this->getPrimaryID() ) ) ) );

      return $proto->doSearch( $wherePair[ 0 ], $wherePair[ 1 ], $order, $joinStruct );
   }

//========================================================================

    /*!
    @function changeUsers( $designerUserIter, $devUserIter, $qaUserIter, $qaLeadUserIter )
    @discussion - sets the user permissions for this project, pass in iterator<User> for each of the usertypes
    @result - void
    */
    function changeUsers( $designerUserIter, $devUserIter, $qaUserIter, $qaLeadUserIter )
    {
        importClass( 'Shared.UserType' ); // for constants for later use
        $this->_setDesigners( $designerUserIter );
        $this->_setQAs( $qaUserIter );
        $this->_setQALeads( $qaLeadUserIter );
        $this->_setDevelopers( $devUserIter );
    }


//========================================================================

    /*!
    @function _setDesigners( $designerUserIter )
    @discussion - will set up the project to have the users in the iter as designers - and no other users
    @result - void
    */
    function _setDesigners( $designerUserIter )
    {
        // constants imported in changeUsers()
        $this->_setUsers( $designerUserIter, DESIGNER_USER_TYPE_ID );
    }

//========================================================================

    /*!
    @function _setQAs( $qaUserIter )
    @discussion - will set up the project to have the users in the iter as QA techs - and no other users
    @result - void
    */
    function _setQAs( $qaUserIter )
    {
        // constants imported in changeUsers()
        $this->_setUsers( $qaUserIter, QUALITY_ASSURANCE_USER_TYPE_ID );
    }

//========================================================================

    /*!
    @function _setQALeads( $qaLeadUserIter )
    @discussion - will set up the project to have the users in the iter as QA leads - and no other users
    @result - void
    */
    function _setQALeads( $qaLeadUserIter )
    {
        // constants imported in changeUsers()
        $this->_setUsers( $qaLeadUserIter, QA_LEAD_USER_TYPE_ID );
    }

//========================================================================

    /*!
    @function _setDevelopers( $devUserIter )
    @discussion - will set up the project to have the users in the iter as developers - and no other users
    @result - void
    */
    function _setDevelopers( $devUserIter )
    {
        // constants imported in changeUsers()
        $this->_setUsers( $devUserIter, DEVELOPER_USER_TYPE_ID );
    }

//========================================================================

    /*!
    @function _setUsers( $userIter, $usertype_id )
    @discussion - generic user setter for any usertype - for this project
    will set the users for the usertype for this project, the iter passed in
    is to represent the entire user set for that usertype
    @result - void
    */
    function _setUsers( $userIter, $usertype_id )
    {
        importClass( 'Database.DBConnectionProvider' );
        $conn =& DBConnectionProvider::getConnection();

        $sql = 'delete from '.USER_PROJECT_MAPPING_TABLE.' where project_id = '.
                                                    $this->getPrimaryID().
                                                    ' and usertype_id = '.$usertype_id;
        if ( $conn->Execute( $sql ) === false )
        {
            unreachablePoint(
                getLocation() . NL .
                'DB Error when deleting old usertype mappings for a project ['.$sql.']: ' . $conn->ErrorMsg() );
        }

        for ( $this->userIter->reset(); ! $this->userIter->isEnd(); $this->userIter->moveNext() )
        {
            $user =& $this->userIter->getCurrent();

            $sql = 'insert into '.USER_PROJECT_MAPPING_TABLE.' (project_id, user_id, usertype_id) values '.
                    '('.$this->getPrimaryID().','.$user->getPrimaryID().','.$usertype_id.')';

            if ( $conn->Execute( $sql ) === false )
            {
                unreachablePoint(
                    getLocation() . NL .
                    'DB Error when inserting new usertype mapping for a project ['.$sql.
                        '] - user perms could be missing for project where project_id = '.
                        $this->getPrimaryID().': ' . $conn->ErrorMsg() );
            }
        }

        $cacheHandler =& Project::getUserProjectUserTypeCacheHandler();
        $cacheHandler->makeAllDirty();
    }

//========================================================================

};

?>