<?php

/*
User
$Author: millz $
$Revision: 1.11 $
$Date: 2004/06/01 15:22:37 $
$Log: User.php,v $
Revision 1.11  2004/06/01 15:22:37  millz
- added REMOTE_USER check

Revision 1.10  2004/04/01 22:12:28  millz
- removed is_devlopment check in getAllCols

Revision 1.9  2004/01/29 18:27:36  millz
- undoing some work toward having an admin col

Revision 1.8  2004/01/19 19:48:11  millz
- pass by ref

Revision 1.7  2004/01/13 14:42:34  dougqh
- ?

Revision 1.6  2004/01/06 15:41:02  millz
- adding getters for recent and favs

Revision 1.5  2003/12/18 20:42:27  dougqh
Updated to work under PHP 4.2

Revision 1.4  2003/10/02 16:48:44  dougqh
- Better debugging information in getCurrentUser - added support for IIS authentication.

Revision 1.3  2003/10/01 21:27:28  millz
- updated error messages for bad login info

Revision 1.2  2003/10/01 18:43:38  dougqh
- Improved error checking in getCurrentUser

Revision 1.1  2003/09/09 21:01:07  stage
Initial revision

Revision 1.2  2003/07/14 13:56:50  dougqh
- Changing printError calls to unreachablePoint calls.

Revision 1.1  2003/07/09 20:33:12  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'Database.ADatabaseItem' );

//========================================================================

importClass( 'Shared.UserType' );

//========================================================================

define( 'DEVELOPER_TYPE_ID', 2 );
define( 'TESTER_TYPE_ID', 7 );
define( 'DESIGNER_TYPE_ID', 4 );
define( 'QALEAD_TYPE_ID', 112 );

define( 'ENABLE_IIS_LOGIN', true );

//========================================================================

/*!
@class User
@abstract -
*/

class User extends ADatabaseItem
{

//========================================================================

   /*!
   @function User( [ $primary_id ] )
   @discussion - constructs a new User object
   @result - constructs a new User object
   */

   function User( $primary_id = UNSPECIFIED )
   {
      $this->ADatabaseItem( $primary_id );

      $this->isNull = false;
   }

//========================================================================

   /*!
   @function getPrototype()
   @discussion - provides the User prototype
   */

   /* static */
   function &getPrototype()
   {
      return User::_getPrototype( __FILE__ );
   }

//========================================================================

   /*!
   @function getFromPrimaryID( $primary_id )
   */

   /* static */
   function &getFromPrimaryID( $primary_id )
   {
      return User::_getFromPrimaryID(
         User::getPrototype(),
         $primary_id );
   }

//========================================================================

   /*!
   @function isNull()
   @discussion - indicates if this User object is "null"
   @result - returns a boolean
   */

   function isNull()
   {
      return $this->isNull;
   }

//========================================================================

   /*!
   @function getUsersDevelopmentItems()
   @discussion - provides an IIterator of DevelopmentItems
   @result - returns IIterator< ADevelopmentItem >
   */

   function &getUsersDevelopmentItems()
   {
      importClass( 'Bugs.ADevelopmentItem' );
      $devItemPrototype =& ADevelopmentItem::getPrototype();

      importClass( 'Bugs.State' );
      return $devItemPrototype->doSearch(
         '(state_id >= ? and  state_id <= ?) developer_id=?',
         array(
            UNDER_DEVELOPMENT_ASSIGNED_STATE_ID,
            UNDER_DEVELOPMENT_FIX_FAILED_STATE_ID,
            $this->getPrimaryID() ) );
   }

//========================================================================

   /*!
   @function getUsersIncompleteDevelopmentItems()
   @discussion - provides an IIterator of DevelopmentItems
   @result - returns IIterator< ADevelopmentItem >
   */

   function &getUsersIncompleteDevelopmentItems()
   {
      importClass( 'Bugs.ADevelopmentItem' );
      $devItemPrototype =& ADevelopmentItem::getPrototype();

      //TODO: Limit by Project
      importClass( 'Bugs.State' );
      return $devItemPrototype->doSearch(
         '( (state_id = ? or state_id = ?) AND tester_id = ?) or (state_id = ? and (designer_id=? or submitter_id = ?))',
         array(
            DESIGNER_NEEDS_MORE_INFO_STATE_ID,
            NOT_REPRODUCIBLE_STATE_ID,
            $this->getPrimaryID(),
            DEVELOPER_NEEDS_MORE_INFO_STATE_ID,
            $this->getPrimaryID(),
            $this->getPrimaryID() ) );
   }

//========================================================================

   /*
   @function getCurrentUser()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */

   /* static */
   function &getCurrentUser()
   {
      //Use a static array because a single variable with global extent assigned by
      //reference will be garbage collected.  The hack solution is to use an array
      //assigned by value then assign its sole member by reference.  This way
      //only one object is constructed AND identity is preserved.

      static $curUserArray;

      if ( ! isset( $curUserArray ) )
      {
         if    ( ! empty( $_SERVER{ 'PHP_AUTH_USER' } )  )
         {
            $userName = trim( $_SERVER{ 'PHP_AUTH_USER' } );
         }
         elseif( ! empty( $_SERVER{ 'REMOTE_USER' }   )  ) // sometimes works if PHP_AUTH_USER won't - there is no REMOTE_PW
         {                                                 // http://us2.php.net/manual/en/reserved.variables.php#reserved.variables.server
         
            $userName = trim( $_SERVER{ 'REMOTE_USER' } );
         }

         if (
            empty( $userName ) &&
            ENABLE_IIS_LOGIN &&
            ! empty( $_SERVER{  'HTTP_AUTHORIZATION' } ) )
         {
            //Based off of information from
            //http://www.php-center.de/en-html-manual/features.http-auth.html
            list( $userName, $pw ) =
               explode(
                  ':',
                  base64_decode(
                     substr( $_SERVER{ 'HTTP_AUTHORIZATION' }, 6 ) ) );

            $userName = trim( $userName );
         }

         if ( empty( $userName ) )
         {
            print 'No Authenticated User Found - please see BugPort <a href="http://incogen.com/public_documents/bugport/forrest/Administration/FAQ.html">FAQ</a>' . BR_NL;
            User::_printAuthenticationInfo();
            exit;
         }

         $userName = trim( $userName );

         $curUserArray = array();

         $userProto =& User::getPrototype();
         $iter =& $userProto->doSearch(
            'user_name = ?',
            array( $userName ) );

         $iter->reset();
         if ( ! $iter->isEnd() )
         {
            $curUserArray[ 0 ] =& $iter->getCurrent();
         }
         else
         {
            print 'User authentication information found,' . BR_NL;
            print 'but no user found in iuser table where "user_name = \'' . $userName . '\'"' . BR_NL;
            User::_printAuthenticationInfo();
            exit;
         }
      }

      return $curUserArray[ 0 ];
   }

//========================================================================

   /*!
   @function _printAuthenticationInfo()
   @discussion - prints out PHP authentication information for debugging
      purposes
   */

   /* static */
   function _printAuthenticationInfo()
   {
      if ( isset( $_SERVER{ 'PHP_AUTH_USER' } ) )
      {
         print '_SERVER{ PHP_AUTH_USER } = "' . $_SERVER{ 'PHP_AUTH_USER' } . '"' . BR_NL;
      }
      else
      {
         print '_SERVER{ PHP_AUTH_USER } is NOT set.' . BR_NL;
      }

      if ( isset( $_SERVER{ 'REMOTE_USER' } ) )
      {
         print '_SERVER{ REMOTE_USER } = "' . $_SERVER{ 'REMOTE_USER' } . '"' . BR_NL;
      }
      else
      {
         print '_SERVER{ REMOTE_USER } is NOT set.' . BR_NL;
      }

      if ( isset( $_SERVER{ 'HTTP_AUTHORIZATION' } ) )
      {
         print '_SERVER{ HTTP_AUTHORIZATION } = "' . $_SERVER{ 'HTTP_AUTHORIZATION' } . '"' . BR_NL;
      }
      else
      {
         print '_SERVER{ HTTP_AUTHORIZATION } is NOT set.' . BR_NL;
      }

      print BR_NL;
      print 'Other _SERVER info' . BR_NL;
      foreach ( $_SERVER as $key => $value )
      {
         $shouldPrint =
            ( beginsWith( 'PHP', $key ) && $key != 'PHP_AUTH_PW' ) ||
            ( beginsWith( 'HTTP', $key ) && $key != 'HTTP_COOKIE' ) ||
            ( $key == 'SERVER_SOFTWARE' );

         if ( $shouldPrint )
         {
            print '_SERVER{ ' . $key . ' } = "' . $value . '"' . BR_NL;
         }
      }
   }

//========================================================================

   /*
   @function getCurrentUserID()
   @discussion - return user_id
   @result - int
   */

   /* static */
   function &getCurrentUserID()
   {
      // !!! this needs to return the proper user
      $user =& User::getCurrentUser();

      if ( ! isInstanceOf( $user, 'User' ) )
      {
         unreachablePoint( 'Unable to get current user is User::getCurrentUserID()' );
      }

      $user_id = $user->getPrimaryID();

      if ( $user_id < 1 )
      {
         unreachablePoint(
            'Found invalid user_id of [' . $user_id . '] in User::getCurrentUserID()' );
      }

      return $user_id;
   }

//========================================================================

   /*!
   @function makeNull()
   @discussion - tags this object as a "null" instance
   */

   function makeNull()
   {
      $this->isNull = true;
   }

//========================================================================

   /*!
   @function setCurrentProject( $project )
   @discussion - sets the current Project for this User
   @result - returns a Project
   */

   function setCurrentProject( &$project )
   {
      $this->currentProject_id = $project->getPrimaryID();
      $this->_store();
   }

//========================================================================

   /*!
   @function getCurrentProject()
   @discussion - provides the current Project for this User
   @result - returns a Project
   */

   function &getCurrentProject()
   {
      importClass( 'Shared.Project' );
      
      if( !isset($this->currentProject_id) || $this->currentProject_id == null)
      {
        // we need to pick a random one if there is one
        importClass( 'Shared.Project' );
        $projProto =& Project::getPrototype();
        $allProjectsIter =& $projProto->doSearch();
        if( $allProjectsIter->isEnd() ){ print "No projects found, please add at least one project."; }
        $thisProject =& $allProjectsIter->getCurrent();
        $this->currentProject_id = $thisProject->getPrimaryID();
        $this->store();
        return $thisProject;
      }
      
      return Project::getFromPrimaryID( $this->currentProject_id );
   }

//========================================================================

   /*!
   @function getPrimaryColumn()
   @discussion - provides the name of the primary column of this
      ADatabaseItem
   @result - returns a String
   */

   function getPrimaryColumn()
   {
      return 'user_id';
   }

//========================================================================

   /*!
   @function getTable()
   @discussion - provides the table name (with schema if necessary)
   @result - returns a String
   */

   function getTable()
   {
      return SHARED_SCHEMA . '.iuser';
   }

//========================================================================

   /*!
   @function getAllColumns()
   @discussion - returns the columns for this item's row
   */

   function getAllColumns()
   {
      $array =  array(
         $this->getPrimaryColumn(),
         'first_name',
         'last_name',
         'user_name',
         'email',
         'currentProject_id', 
         'isAdmin' );
      

      
      return $array;
   }

//========================================================================

   /*!
   @function isAdmin()
   @discussion - returns bool
   */
   
   function isAdmin()
   {
      return ( $this->isAdmin == 1 );
   }

//========================================================================
   
   /*!
   @function setAdmin($_admin)
   @discussion - param should be 1 or 0
   */
   
   function setAdmin($_admin)
   {
        // print "seting isAdmin to $_admin";
      $this->isAdmin = intval($_admin);
   }

//========================================================================

   /*!
   @function _getRegularIdentifyingString()
   */

   function _getRegularIdentifyingString()
   {
      return $this->getName();
   }

//========================================================================

   /*!
   @function getUserName()
   @discussion - a normal get function
   @result - returns userName item for this object
   */

   function getUserName()
   {
      return $this->user_name;
   }

//========================================================================

   /*!
   @function setUserName( $userName )
   @param $userName - the value to set the userName member to
   @discussion - a normal set function
   @result - returns nothing
   */

   function setUserName( $userName )
   {
      $this->user_name = $userName;
   }

//========================================================================

   /*!
   @function getEmailAddress()
   @discussion - provides the email address of this User
   @result - returns a String
   */

   function getEmailAddress()
   {
      return $this->email;
   }

//========================================================================

   /*!
   @function setEmail( $email )
   @param $email - the value to set the email member to
   @discussion - a normal set function
   @result - returns nothing
   */

   function setEmail( $email )
   {
      $this->email = $email;
   }

//========================================================================

   /*!
   @function getFirstName()
   @discussion - a normal get function
   @result - returns firstName item for this object
   */

   function getFirstName()
   {
      return $this->first_name;
   }

//========================================================================

   /*!
   @function setFirstName( $firstName )
   @param $firstName - the value to set the firstName member to
   @discussion - a normal set function
   @result - returns nothing
   */

   function setFirstName( $firstName )
   {
      $this->first_name = $firstName;
   }

//========================================================================

   /*!
   @function getLastName()
   @discussion - a normal get function
   @result - returns lastName item for this object
   */

   function getLastName()
   {
      return $this->last_name;
   }

//========================================================================

   /*!
   @function setLastName( $lastName )
   @param $lastName - the value to set the lastName member to
   @discussion - a normal set function
   @result - returns nothing
   */

   function setLastName( $lastName )
   {
      $this->last_name = $lastName;
   }

//========================================================================

   /*!
   @function getName()
   @discussion - get the real name of the user
   @result - returns name for this object
   */

   function getName()
   {
      return $this->getFirstName() . ' ' . $this->getLastName();
   }

//========================================================================

//   /*!
//   @function _getDeveloperIDs()
//   @discussion - provides the user_ids of all developers
//   @result - returns an Integer[]
//   */
//
//   /* static */
//   function _getDeveloperIDs()
//   {
//      static $developerIDs;
//
//      if ( ! isset( $developerIDs ) )
//      {
//         importClass( 'Database.DBConnectionProvider' );
//         $conn =& DBConnectionProvider::getReadOnlyConnection();
//
//         importClass( 'Shared.Project' );
//         $cacheHandler =& Project::getUserProjectCacheHandler();
//
//         $developerIDs = $conn->CacheGetCol(
//            $cacheHandler->getMultipleCacheTime(),
//            'SELECT user_id FROM user_project_usertype WHERE usertype_id = ?',
//            array( DEVELOPER_TYPE_ID ) );
//      }
//
//      return array_unique( $developerIDs );
//   }

//========================================================================

   /*!
   @function getDefaultOrderBy()
   @discussion - returns a string for the column(s) to order by and in what direction - do not return the 'ORDER BY'
   @result - string
   */

   function getDefaultOrderBy()
   {
      return 'last_name';
   }

////========================================================================
//
//   /*!
//   @function _getDeveloperWherePair()
//   @discussion -
//   */
//
//   function _getDeveloperWherePair()
//   {
//      //TODO: Find out if there's a way to bind an array
//      return array(
//         'user_id IN (' . implode( ',', User::_getDeveloperIDs() ) . ')',
//         array() );
//   }
//
////========================================================================
//
//   /*!
//   @function _getDesignerIDs()
//   @discussion - provides the user_ids of all designers
//   @result - returns an Integer[]
//   */
//
//   /* static */
//   function _getDesignerIDs()
//   {
//      static $designerIDs;
//
//      if ( ! isset( $designerIDs ) )
//      {
//         importClass( 'Database.DBConnectionProvider' );
//         $conn =& DBConnectionProvider::getReadOnlyConnection();
//
//         $cacheHandler =& Project::_getUserProjectCacheHandler();
//
//         $designerIDs = $conn->CacheGetCol(
//            $cacheHandler->getSingleCacheTime(),
//            'SELECT user_id FROM user_project_usertype WHERE usertype_id = ?',
//            array( DESIGNER_TYPE_ID ) );
//
//      }
//
//      return array_unique( $designerIDs );
//   }

//========================================================================

//   /*!
//   @function _getDesignerWherePair()
//   */
//
//   function _getDesignerWherePair()
//   {
//      //TODO: Find out if there's a way to bind an array
//      return array(
//         'user_id IN (' . implode( ',', User::_getDesignerIDs() ) . ')',
//         array() );
//   }


//========================================================================

   /*!
   @function _getSubmitterIDs()
   @discussion - provides the user_ids of all designers
   @result - returns an Integer[]
   */

   /* static */
   function _getSubmitterIDs()
   {
      static $submitterIDs;

      if ( ! isset( $submitterIDs ) )
      {
         importClass( 'Database.DBConnectionProvider' );
         $conn =& DBConnectionProvider::getReadOnlyConnection();

         $prototype =& User::getPrototype();

         $submitterIDs = $conn->CacheGetCol(
            $prototype->_getMultipleRowCacheTime(),
            'SELECT DISTINCT(submitter_id) FROM report',
            array( ) );
      }

      return $submitterIDs;
   }

//========================================================================

   /*!
   @function _getSubmitterWherePair()
   @discussion -
   */

   function _getSubmitterWherePair()
   {
      //TODO: Find out if there's a way to bind an array
      return array(
         'user_id IN (' . implode( ',', User::_getSubmitterIDs() ) . ')',
         array() );
   }

//========================================================================

   /*!
   @function storeFavoriteItemSet( &$favSet )
   @result -
   */
    function storeFavoriteItemSet( &$favSet )
    {
        if ( $favSet->isNew() )
        {
           $favSet->_setUser( $this );
        }
        else
        {
           if ( ! $favSet->isUser( $this ) )
           {
              unreachablePoint(
                 'User->storeFavoriteItemSet call with an invalid FavoriteItemSet' );
           }
        }
        $favSet->_store();
    }

//========================================================================

   /*!
   @function getFavoriteItemSets()
   @result - returns an Iter of FavoriteItemSet
   */
    function &getFavoriteItemSets()
    {
        importClass( 'Bugs.FavoriteItemSet' );
        $proto =& FavoriteItemSet::getPrototype();
        return $proto->doSearchByUser( $this );
    }

//========================================================================

   /*!
   @function getRecentItemSet()
   @result - returns an Iter of DevelItems
   */
    function &getRecentItems()
    {
        importClass( 'Bugs.RecentItemSet' );
        $proto =& RecentItemSet::getPrototype();
        $iter =& $proto->doSearchByUser( $this );
        $iter->reset();
        if( $iter->isEnd() )
        {
            $recents =& new RecentItemSet( toRef( NULL ) );
            $recents->_setUser( $this );
            return $recents;
        }

        return $iter->getCurrent();
    }

//========================================================================

   /*!
   @function _getTesterIDs()
   @discussion - provides the user_ids of all testers
   @result - returns an Integer[]
   */

   /* static */
   function _getTesterIDs()
   {
      static $testerIDs;

      if ( ! isset( $testerIDs ) )
      {
         importClass( 'Database.DBConnectionProvider' );
         $conn =& DBConnectionProvider::getReadOnlyConnection();

         $prototype =& User::getPrototype();

         $testerIDs = $conn->CacheGetCol(
            $prototype->_getMultipleRowCacheTime(),
            'SELECT DISTINCT(tester_id) FROM report',
            array( ) );
      }

      return $testerIDs;
   }

//========================================================================

   /*!
   @function _getTesterWherePair()
   @discussion -
   */

   function _getTesterWherePair()
   {
      //TODO: Find out if there's a way to bind an array
      return array(
         'user_id IN (' . implode( ',', User::_getTesterIDs() ) . ')',
         array() );
   }

//========================================================================

};

?>