<?php

/*
TimeDuration
$Author: millz $
$Revision: 1.3 $
$Date: 2003/11/05 14:20:26 $
$Log: TimeDuration.php,v $
Revision 1.3  2003/11/05 14:20:26  millz
- minor mods

Revision 1.2  2003/11/04 21:59:02  dougqh
- nothing

Revision 1.1  2003/11/04 18:14:08  millz
-

Revision 1.1  2003/11/04 18:12:17  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

// importClass( '<package>.Object' );

//========================================================================

   define('SECS_IN_DAY' , 60 * 60 * 24);
   define('SECS_IN_HOUR', 60 * 60);
   define('SECS_IN_MIN' , 60);

//========================================================================

/*!
@class TimeDuration
@abstract -
*/

class TimeDuration extends Object
{

//========================================================================

   var $seconds; // float
   var $preferredUnit; // TimeUnit

//========================================================================

   /*!
   @function TimeDuration ()
   @discussion - constructs a new TimeDuration  object
   @result - constructs a new TimeDuration  object
   */

   function TimeDuration( $timeAmount = 0, $unit = SEC_UNIT )
   {

      $this->Object();

      if(!isTimeUnit( $unit )){ unreachablepoint('Time.TimeDuration received invalid unitType'); }

      switch ($unit) {
          case SEC_UNIT:
              $this->_setUsingSeconds( $timeAmount );
              break;
          case MIN_UNIT:
              $this->_setUsingMinutes( $timeAmount );
              break;
          case HR_UNIT:
              $this->_setUsingHours( $timeAmount );
              break;
          case DAY_UNIT:
              $this->_setUsingDays( $timeAmount );
              break;
          default:
              unreachablepoint('Time.TimeDuration does not understand the inputted unitType, TimeDuration probably needs to be updated to reflect the new unit type');
      }

   }


//========================================================================

   /*!
   @function setPreferredUnit( $unit )
   @discussion - 
   @result - standard setter
   */

   function setPreferredUnit( $unit )
   {
      $this->preferredUnit = $unit;
   }

//========================================================================

   /*!
   @function getPreferredUnit ()
   @discussion - 
   @result - unit
   */

   function getPreferredUnit()
   {
      return $this->preferredUnit;
   }

//========================================================================

   /*!
   @function _setUsingSeconds( $timeAmount )
   @param - $timeAmount - float - number of time units
   @discussion -
   @result - nothing
   */

   function _setUsingSeconds( $timeAmount )
   {
      $this->seconds = $timeAmount;
      $this->preferredUnit = SEC_UNIT;
   }

//========================================================================

   /*!
   @function _setUsingMinutes( $timeAmount )
   @param - $timeAmount - float - number of time units
   @discussion -
   @result - nothing
   */

   function _setUsingMinutes( $timeAmount )
   {
      $this->seconds = $timeAmount * SECS_IN_MIN;
      $this->preferredUnit = MIN_UNIT;
   }

//========================================================================

   /*!
   @function _setUsingHours( $timeAmount )
   @param - $timeAmount - float - number of time units
   @discussion -
   @result - nothing
   */
   function _setUsingHours( $timeAmount )
   {
      $this->seconds = $timeAmount * SECS_IN_HOUR;
      $this->preferredUnit = HR_UNIT;
   }

//========================================================================

   /*!
   @function _setUsingDays( $timeAmount )
   @param - $timeAmount - float - number of time units
   @discussion -
   @result - nothing
   */
   function _setUsingDays( $timeAmount )
   {
      $this->seconds = $timeAmount * SECS_IN_DAY;
      $this->preferredUnit = DAY_UNIT;
   }

//========================================================================

   /*!
   @function getSeconds( )
   @discussion -
   @result - float - num seconds
   */
   function getSeconds()
   {
      return $this->seconds;
   }

//========================================================================

   /*!
   @function getMinutes( )
   @discussion -
   @result - float - num Minutes
   */
   function getMinutes()
   {
      return $this->seconds / SECS_IN_MIN;
   }

//========================================================================

   /*!
   @function getHours( )
   @discussion -
   @result - float - num Hours
   */
   function getHours()
   {
      return $this->seconds / SECS_IN_HOUR;
   }

//========================================================================

   /*!
   @function getDays( )
   @discussion -
   @result - float - num Days
   */
   function getDays()
   {
      return $this->seconds / SECS_IN_DAY;
   }

//========================================================================

   /*!
   @function getValue( $unitType )
   @param - $unitType - the units to receive the return val in
   @discussion -
   @result - float - num units for this time duration
   */
   function getValue( $unitType )
   {
      if(!isTimeUnit( $unitType )){ unreachablepoint('Time.TimeDuration.getValue() received invalid unitType'); }

      switch ($unitType) {
          case SEC_UNIT:
              return $this->getSeconds( );
              break;
          case MIN_UNIT:
              return $this->getMinutes( );
              break;
          case HR_UNIT:
              return $this->getHours( );
              break;
          case DAY_UNIT:
              return $this->getDays( );
              break;
          default:
              unreachablepoint('Time.TimeDuration.getValue() does not understand the inputted unitType, TimeDuration probably needs to be updated to reflect the new unit type');
      }
   }

//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */

   function _invariant()
   {
      return parent::_invariant();
   }

//========================================================================

};

?>