<?php

/*
TimeDurationField
$Author: dougqh $
$Revision: 1.5 $
$Date: 2003/11/05 14:21:05 $
$Log: TimeDurationField.php,v $
Revision 1.5  2003/11/05 14:21:05  dougqh
- Reduce the size of the text field to 4.

Revision 1.4  2003/11/05 14:16:33  dougqh
- Adding support for multiple fields - implemented _getDisabledHTML

Revision 1.3  2003/11/04 22:28:35  millz
- using iterator for selcomp

Revision 1.2  2003/11/04 19:44:09  millz
- slight mod to getFormValue

Revision 1.1  2003/11/04 19:40:59  millz
-


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.LightForms.ALightFormField' );
importConstants( 'Time' );

//========================================================================

define( 'DURATION_VALUE_FIELD_SUFFIX', '_value' );
define( 'DURATION_UNIT_FIELD_SUFFIX', '_unit' );

//========================================================================
/*!
@class TimeDurationField
@abstract -
*/

class TimeDurationField extends ALightFormField
{

//========================================================================

   var $curUnit;

//========================================================================

   /*!
   @function TimeDurationField()
   @discussion - constructs a new TimeDurationField object
   @result - constructs a new TimeDurationField object
   */
   function TimeDurationField( $name, $displayName, $defaultUnit )
   {
      if ( ! isTimeUnit( $defaultUnit ) )
      {
         unreachablepoint( 'TimeUI.TimeDurationField.getValue() received invalid unitType' );
      }

      $this->ALightFormField( $name, $displayName );
      $this->curUnit = $defaultUnit;
   }

//========================================================================

   /*!
   @function setValue( $duration )
   @discussion - overriding setValue to change curUnit
   */
   function setValue( &$duration )
   {
      if ( ! empty( $duration ) )
      {
         $this->curUnit = $duration->getPreferredUnit();
      }
      parent::setValue( $duration );
   }

//========================================================================

   /*!
   @function _getDefaultValue()
   @discussion - defaults to NULL
   */
   function _getDefaultValue()
   {
      return NULL;
   }

//========================================================================

   /*!
   @function _getTextValue()
   @discussion - helper used by _getEnabledHTML and _getDisabledHTML
   @result - returns a String
   */

   function _getTextValue()
   {
      $duration =& $this->getValue();
      if ( ! empty( $duration ) )
         return $duration->getValue( $this->curUnit );
      else
         return '';
   }

//========================================================================

   /*!
   @function _getEnabledHTML()
   @discussion -
   @result - html string
   */
   function _getEnabledHTML()
   {
      //Create a TextComponent
      importClass( 'HTMLComponents.LightForms.TextComponent' );
      $textComp =& new TextComponent(
         $this->getName() . DURATION_VALUE_FIELD_SUFFIX,
         $this->_getTextValue(),
         4 );

      //Create a SelectComponent containing all the time unit
      // constants - selecting the one where the unit == $this->curUnit
      importClass( 'HTMLComponents.LightForms.SelectComponent' );
      $selComp =& new SelectComponent(
         $this->getName() . DURATION_UNIT_FIELD_SUFFIX );

      $hashIter =& getUnitHashIterator();
      for ( $hashIter->reset(); ! $hashIter->isEnd(); $hashIter->moveNext() )
      {
         $selComp->addOption( $hashIter->getCurrent(),
                              $hashIter->getCurrent(),
                              ($hashIter->getCurrent() == $this->curUnit)
                            );
      }

      //return the HTML containing the TextComponent and SelectComponent
      return $textComp->getHTML().$selComp->getHTML();
   }

//========================================================================

   /*!
   @function _getDisabledHTML()
   @discussion - provides HTML when this field is disabled
   @result - returns HTML
   */
   function _getDisabledHTML()
   {
      if ( $this->isEmpty() )
      {
         return '';
      }
      else
      {
         importClass( 'HTMLComponents.Text' );
         $text =& new Text( $this->_getTextValue() . ' ' . $this->curUnit );
         return $text->getHTML();
      }
   }

//========================================================================

   /*!
   @function &_getFormValue()
   @discussion -
   @result - TimeDuration object
   */
   function &_getFormValue()
   {
      $valueFieldName = $this->getName() . DURATION_VALUE_FIELD_SUFFIX;
      $unitFieldName = $this->getName() . DURATION_UNIT_FIELD_SUFFIX;

      if ( ! isset( $_REQUEST{ $valueFieldName } ) ||
           isEmpty( $_REQUEST{ $valueFieldName } ) ||
           ! isset( $_REQUEST{ $unitFieldName } ) ||
           isEmpty( $_REQUEST{ $unitFieldName } ) )
      {
         return NULL;
      }

      importClass( 'Time.TimeDuration' );
      return new TimeDuration(
         $_REQUEST{ $valueFieldName },
         $_REQUEST{ $unitFieldName } );
   }

//========================================================================

   /*!
   @function isValid()
   @discussion -
   @result - bool
   */
   function isValid()
   {
       //TODO: Finish this
       return parent::isValid();
   }

//========================================================================

};

?>