<?php

//Set the current working directory to the directory of this script
$myDir = substr( __FILE__, 0, strrpos( __FILE__, DIRECTORY_SEPARATOR ) );
$directories = explode( DIRECTORY_SEPARATOR, $myDir );
array_pop( $directories ); // pop off bin
array_pop( $directories ); // pop off system
$rootDir = implode( DIRECTORY_SEPARATOR, $directories );

define( 'IS_COMMAND_LINE', true );

//========================================================================

define( 'CLASS_DIR', $rootDir . DIRECTORY_SEPARATOR . 'php_classes' );
define( 'IS_GENEPORT4_SCRIPT', true );
require_once( CLASS_DIR . DIRECTORY_SEPARATOR . 'Libraries' . DIRECTORY_SEPARATOR . 'importLibrary.php' );

//========================================================================

primeImport();
runStartUpProcesses();

//========================================================================

importConstants( 'Executable' );

//========================================================================

//argv[ 0 ] is the script name - do not care about that

//argv[ 1 ] is the Executable class
if ( isset( $argv[ 1 ] ) )
{
   $class = $argv[ 1 ];
}
else
{
   print 'Executable class not specified.' . NL;
   exit( INVALID_CLASS_SPECIFIED );
}

$argumentsHash = new_hash();
for ( $i = 2; $i < $argc; $i+=2 )
{
   $name = str_replace( PHP_FLAG_PREFIX, '', $argv[ $i ] );

   if ( ! isset( $argv[ $i + 1 ] ) )
   {
      print 'No matching value for argument ' . $name . NL;
      exit( MISSING_ARGUMENT_VALUE );
   }

   $argumentsHash{ $name } = $argv[ $i + 1 ];
}

//print_r( $argumentsHash );

if ( ! tryImportClass( $class ) )
{
   todo( 'system/bin/executor.php', 'Reenable error once bug in import library\'s tryImportClass is fixed.' );
//   print 'Invalid class specified.' . NL;
//   exit( INVALID_CLASS_SPECIFIED );
}

$className = absoluteClassToClass( $class );
$executable =& new $className( $argumentsHash );

if ( ! isInstanceOf( $executable, 'Executable' ) )
{
   print 'Specified class is not an Executable.' . NL;
   exit( INVALID_CLASS_SPECIFIED );
}

//all is well, so run it
$result = $executable->execute();

//========================================================================

runEndProcesses();

//========================================================================

exit( $result );

?>