<?php

/*
Table
$Author: apache $
$Revision: 1.1 $
$Date: 2003/12/18 20:39:26 $
$Log: Table.php,v $
Revision 1.1  2003/12/18 20:39:26  apache
Initial revision

Revision 1.18  2003/07/09 21:46:24  dougqh
Minor tweaks

Revision 1.17  2003/04/04 19:17:07  millz
- got rid of a hardcoded width spec

Revision 1.16  2003/03/28 15:30:36  millz
- updated to use new width methods

Revision 1.15  2003/03/27 19:56:26  millz
- bug fix

Revision 1.14  2003/03/27 19:18:51  millz
- updated to extend AHTMLComponent

Revision 1.13  2002/10/23 18:17:13  millz
updates to addSpacerRow

Revision 1.12  2002/09/24 19:35:37  dougqh
Switching quotes to ticks.

Revision 1.11  2002/08/23 18:27:25  dougqh
Changed the name attribute to the new standard compliant id.

Revision 1.10  2002/08/22 14:44:16  dougqh
?

Revision 1.9  2002/08/19 21:22:23  millz
added methods and logic for cell and column colors

Revision 1.8  2002/08/19 20:47:45  dougqh
?

Revision 1.7  2002/08/05 14:08:51  dougqh
Added new method setDefaultCell.  setDefaultCell controls the style given
to cells added using Table::addCell( HTMLComponent ).

Revision 1.6  2002/07/30 20:08:17  dougqh
Added new method addSpacerCell which adds a cell containing a specified
number of non-breaking spaces.
Slight optimization of addEmptyCell.
Calling parent::_invariant now.
Changed default cell padding and cell spacing settings.
Removed isset checks on cellPadding and cellSpacing since they
are explicitly set in the constructor.

Revision 1.5  2002/07/29 22:57:53  dougqh
Debugging.

Revision 1.4  2002/07/29 22:39:37  dougqh
Added support allowing TableCells to span the remaining columns in
a row.
Minor optimizations to addEmptyCell.

Revision 1.3  2002/07/15 17:03:00  dougqh
Added new method addSpacerRow to Table.  It adds a row with a single
cell containing a BR to the Table.

Revision 1.2  2002/07/08 21:21:08  dougqh
Optimized HTML building for Table by ...
Moving all the logic from TableRow into Table thereby eliminating
creation of TableRow objects.
Exploiting the new _setHTMLComponent method of TableCell, so that
one default cell can be used for all simple addCell calls.
Reusing a standard empty cell when calling addEmptyCell.

Revision 1.1  2002/07/01 20:14:25  dougqh
Initial revision


IMPORTANT-READ CAREFULLY. This INCOGEN
End-User License Agreement ("EULA") is a
legal AGREEMENT between you (either as a
registered individual or as the
registered representative and on
behalf of a single entity) and INCOGEN, Inc.,
for the software product identified above, which
product includes computer software and may
include associated media, printed materials,
and "online" or electronic documentation
("SOFTWARE PRODUCT").  By installing, copying,
or otherwise using the SOFTWARE PRODUCT, you
agree to be bound by the terms of this EULA.
If you do not agree to the terms of this EULA,
then DO NOT install or use the SOFTWARE
PRODUCT; in such event the original purchaser
may, however, return it to the place of
purchase within thirty days of the date of
original purchase for a full refund.

Please read the remaining text of this agreement
in the accompanying license.txt file
*/

//========================================================================

importClass( 'HTMLComponents.AHTMLComponent' );

//========================================================================

importClass( 'HTMLComponents.Table.TableCell' );

//========================================================================

/*!
@class Table
@abstract - this class provides a means to describe
   HTML tables
*/

class Table extends AHTMLComponent /* implements HTMLComponent */
{
//========================================================================

   var $rowsHTML;
   var $currentRowHTML;
   var $currentRowTerminator;

   var $cellPadding;
   var $cellSpacing;
   var $border = 0;

   var $altColColor;
   var $currentRowColor;

   var $emptyCell;
   var $defaultCell;
   var $headerCell;

   var $numColumns;
   var $numRowColumns;

//========================================================================

   /*!
   @function Table( [ $table_id ] )
   @param $table_id - an optional ID for the table tag in the generated HTML
   @discussion - constructs a new Table object
   @result - constructs a new Table object
   */

   function Table( $table_id = UNSPECIFIED )
   {
      //require
      {
      }
      //body
      {

         $this->cellPadding = 0;
         $this->cellSpacing = 0;
         if ( $table_id !== UNSPECIFIED ) $this->table_id = $table_id;

         $this->rowsHTML = '';
         $this->currentRowHTML = '';
         $this->currentRowTerminator = '';

         //TableCell imported uncoditionally above
         $null = NULL;
         $this->emptyCell =& new TableCell( $null, false );

         //TableCell imported uncoditionally above
         $this->defaultCell =& new TableCell( $null, false );

         //A header cell
         $this->headerCell =& new TableCell( $null, true );

         $this->numColumns = 0;
         $this->numRowColumns = 0;

         $this->AHTMLComponent();

         // this is needed so that statusbar (and its inner table), etc. take up the whole page
         // $this->setRequestedWidth( '100%' );
      }
      //ensure
      {
         assert( '$this->_invariant()' );
      }
   }

//========================================================================

   /*!
   @function setDefaultCell( $cell )
   @param $cell - an example TableCell
   @discussion - sets the default settings used for TableCells added to
      this Table using Table::addCell( HTMLComponent ).
   */

   function setDefaultCell( &$cell )
   {
      assert( 'isInstanceOf( $cell, "TableCell" )' );

      $this->defaultCell =& $cell;

      assert( '$this->_invariant()' );
   }

//========================================================================

   /*!
   @function setWidth( $width )
   @discussion - sets the width of this Table object
   */

   function setWidth( $width )
   {
      $this->setRequestedWidth( $width );

      assert( '$this->_invariant()' );
   }

//========================================================================

   /*!
   @function setCellPadding( $cellPadding )
   @discussion - sets the cell padding of this Table object
   */

   function setCellPadding( $cellPadding )
   {
      assert( '$cellPadding >= 0' );

      $this->cellPadding = $cellPadding;

      assert( "\$this->_invariant()" );
   }

//========================================================================

   /*!
   @function setCellSpacing( $cellSpacing )
   @discussion - sets the cell spacing of this Table object
   */

   function setCellSpacing( $cellSpacing )
   {
      assert( '$cellSpacing >= 0' );
      assert( '$this->_invariant()' );

      $this->cellSpacing = $cellSpacing;

      assert( '$this->_invariant()' );
   }

//========================================================================

   /*!
   @function setAlternatingColumnColor( $color )
   @param $color - an object containing the color to alternate b/t, will color odd columns, zero-indexed
   @discussion - sets the column background color to alternate between
   */

   function setAlternatingColumnColor( &$color )
   {
      assert( 'isInstanceOf( $color, "Color" )' );

      $this->altColColor =& $color;

      assert( "\$this->_invariant()" );
   }


//========================================================================

   /*!
   @function setBorder( $border )
   @param $border - an integer containing the number of pixels to be
      used for this Table's border
   @discussion - sets the border size for this Table object
   */

   function setBorder( $border )
   {
      assert( '$border >= 0' );
      assert( '$this->_invariant()' );

      // print "set border called [$border]<br>";

      $this->border = $border;

      assert( '$this->_invariant()' );
   }

//========================================================================

   /*!
   @function addSpacerRow( [ $color ] )
   @param $color - optional background Color for the spacer row
      - defaults to no Color specification
   @discussion - adds a row with a single cell containing a BR in
      it to the table
   */

   function addSpacerRow( $color = UNSPECIFIED )
   {
      $this->rowsHTML .= $this->currentRowHTML . $this->currentRowTerminator;

      if ( isset( $this->numRowColumns ) )
      {
          $colspan = ' colspan="' . $this->numRowColumns . '"';
      }
      else
      {
         $colspan = '';
      }

      if ( $color === UNSPECIFIED )
      {
         $this->rowsHTML .= '<tr><td' . $colspan . '><!--spacer--><br /></td></tr>' . NL;
      }
      else
      {
         $this->rowsHTML .= '<tr bgcolor="' . $color->getHexString() . '"><td' . $colspan . '><!--spacer--><br /></td></tr>' . NL;
      }

      $this->currentRowHTML = '';
      $this->currentRowTerminator = '';
   }

//========================================================================

   /*!
   @function addDividerRow()
   @discussion - adds a divider row to the table, which is a row
      containing an HR
   */

   function addDividerRow()
   {
      $this->rowsHTML .= $this->currentRowHTML . $this->currentRowTerminator;

      if ( isset( $this->numRowColumns ) )
      {
          $colspan = ' colspan="' . $this->numRowColumns . '"';
      }
      else
      {
         $colspan = '';
      }

      $this->rowsHTML .= '<tr><td' . $colspan . '><hr /></td></tr>' . NL;

      $this->currentRowHTML = '';
      $this->currentRowTerminator = '';
   }

//========================================================================

   /*!
   @function startRow( [ $color ] )
   @param $color - an optional Color object used to specify the background
      color for the new row
   @discussion - begins a new row in the Table

      - this implicitly ends the previous row
   */

   function startRow( $color = UNSPECIFIED )
   {
      //require
      {
         assert( '$this->_invariant()' );
      }
      //body
      {
         $this->numColumns = max( $this->numColumns, $this->numRowColumns );

         $this->rowsHTML .= $this->currentRowHTML . $this->currentRowTerminator;

         $this->currentRowColor =& $color;

         if ( $color === UNSPECIFIED )
         {
            $this->currentRowHTML = '<tr>';
         }
         else
         {
            $this->currentRowHTML = '<tr bgcolor="' . $color->getHexString() . '">';
         }

         $this->numRowColumns = 0;
         $this->currentRowTerminator = '</tr>' . NL;
      }
      //ensure
      {
         assert( '$this->_invariant()' );
      }
   }

//========================================================================

   /*!
   @function addSpacerCell( [ $count ] )
   @param $count - optional number of non-breaking spaces to use
      - defaults to 1
   @discussion - adds a spacer cell to the Table containing the
      specified number of non-breaking spaces
   */

   function addSpacerCell( $count = UNSPECIFIED )
   {
      importClass( 'HTMLComponents.RawHTML' );
      $this->addCell( RawHTML::getNonBreakingSpace( $count ) );
   }

//========================================================================

   /*!
   @function addEmptyCell( [ $columnSpan, [ $rowSpan ] ] )
   @param $columnSpan - number of columns to span - defaults to 1
   @param $rowSpan - number of rows to span - defaults to 1
   @discussion - adds an empty cell to this Table
   */

   function addEmptyCell( $columnSpan = UNSPECIFIED, $rowSpan = UNSPECIFIED )
   {
      //require
      {
         assert( '$this->_invariant()' );
      }
      //body
      {
         //loaded TableCell unconditionally at top of document

         if ( ( $columnSpan !== UNSPECIFIED ) || ( $rowSpan !== UNSPECIFIED ) )
         {
            $null = NULL;
            $cell =& new TableCell( $null );

            if ( $columnSpan !== UNSPECIFIED ) $cell->setColumnSpan( $columnSpan );
            if ( $rowSpan !== UNSPECIFIED ) $cell->setRowSpan( $rowSpan );

            $this->_addCell( $cell );
         }
         else
         {
            $this->_addCell( $this->emptyCell );
         }
      }
      //ensure
      {
         assert( '$this->_invariant()' );
      }
   }

//========================================================================

   /*!
   @function addCell( $htmlComponent, [ $horizontalAlignment, [ $columnSpan ] ] )
   @param $htmlComponent - an HTMLComponent to place in a new TableCell in this Table
   @param $horizontalAlignment - a horizontal alignment constant - defaults to left
   @param $columnSpan - a column span - defaults to 1
   @discussion - adds the specified the HTMLComponent to this Table in a new
      TableCell.  The TableCell will have the default TableCell settings.
   */

   /*!
   @function addCell( $cell )
   @param $cell - a TableCell object
   @discussion - adds a cell to the current row in the table
   */

   function addCell( &$htmlComponent,
      $horizontalAlignment = UNSPECIFIED,
      $columnSpan = UNSPECIFIED )
   {
      //require
      {
         assert( '$this->_invariant()' );

         assert( 'isInstanceOf( \$htmlComponent, "HTMLComponent" )' );
      }
      //body
      {
         if ( isInstanceOf( $htmlComponent, 'TableCell' ) )
         {
            //it is cell, so just add it
            $this->_addCell( $htmlComponent );
         }
         else
         {
            if ( ( ( $horizontalAlignment !== UNSPECIFIED ) &&
                   ( $horizontalAlignment !== LEFT ) ) ||
                 ( ( $columnSpan !== UNSPECIFIED ) &&
                   ( $columnSpan !== LEFT ) ) )

            {
               $cell =& new TableCell( $htmlComponent );

               if ( $horizontalAlignment !== UNSPECIFIED )
               {
                  $cell->setHorizontalAlignment( $horizontalAlignment );
               }

               if ( $columnSpan !== UNSPECIFIED )
               {
                  $cell->setColumnSpan( $columnSpan );
               }

               $this->_addCell( $cell );
            }
            else
            {
               $this->defaultCell->_setHTMLComponent( $htmlComponent );
               //loaded TableCell unconditionally at top of document
               $this->_addCell( $this->defaultCell );
            }
         }
      }
      //ensure
      {
         assert( '$this->_invariant()' );
      }
   }

//========================================================================

   /*!
   @function addHeader( &$htmlComponent )
   @param $htmlComponent - an HTMLComponent
   @discussion - adds the HTMLComponent to the table inside of a
      header

      NOTE: Unlike addCell, TableCells should NOT be passed to
         this function.
   */

   function addHeader( &$htmlComponent )
   {
      assert( 'isInstanceOf( $htmlComponent, "HTMLComponent" )' );

      $this->headerCell->_setHTMLComponent( $htmlComponent );

      $this->_addCell( $this->headerCell );

      assert( '$this->_invariant()' );
   }

//========================================================================

   /*!
   @function _addCell( &$tableCell )
   @param $tableCell - a TableCell to add to this Table
   @discussion - provided mainly for optimizing HTML generation
      -helper method of addCell
   */

   function _addCell( &$tableCell )
   {
      assert( 'isInstanceOf( $tableCell, "TableCell" )' );

      if ( isset( $tableCell->colSpan ) )
      {
         if ( $tableCell->colSpan === COLUMN_SPAN_REMAINDER )
         {
            $tableCell->colSpan = $this->numColumns - $this->numRowColumns;
            $this->numRowColumns = $this->numColumns;
         }
         else
         {
            $this->numRowColumns += $tableCell->colSpan;
         }
      }
      else
      {
         // $this->currentRowColor !== UNSPECIFIED &&
         $this->numRowColumns++;
      }

      $doColorChange = isset( $this->altColColor )  && ( $this->numRowColumns % 2 );

      if ( $doColorChange )
      {
         // we have a column color that we need to use,
         // do we need to average it with the curr row col before using it?
         if( $this->currentRowColor !== UNSPECIFIED )
         {
            $thisCellColor =& Color::getAverageColor( $this->altColColor, $this->currentRowColor );
         }
         else
         {
            $thisCellColor  =& $this->altColColor;
         }

         $tableCell->setBackgroundColor( $thisCellColor );
      }

      $this->currentRowHTML .= $tableCell->getHTML();

      if ( $doColorChange )
      {
         // clean up the cell changes to keep the template valid
         $tableCell->unSetBackgroundColor();
      }
   }

//========================================================================

   /*!
   @function getHTML()
   @discusssion - returns an HTML representation of this Table
   @result - a returns a string containing an HTML representation
      of this Table
   */

   function getHTML()
   {
      //require
      {
         assert( '$this->_invariant()' );
      }
      //body
      {
         $html = '<table';

         $width = $this->getWidth();
         if( $width !== UNSPECIFIED )
         {
            $html .= ' width="' . $width . '"';
         }

         $html .= ' style="border-collapse: collapse; border-color: black" ';
         $html .= ' cellspacing="' . $this->cellSpacing . '"';
         $html .= ' cellpadding="' . $this->cellPadding . '"';

         if ( isset( $this->table_id ) )
         {
            $html .= ' id="' . $this->table_id . '"';
         }

         if ( isset( $this->border ) )
         {
            $html .= ' border="' . $this->border . '"';
         }

         $html .= '>' . NL;

         if ( isset( $this->table_id ) )
         {
            $html .= '<!--table:' . $this->table_id . '-->';
         }

         $html .= $this->rowsHTML . NL;

         $html .= $this->currentRowHTML . $this->currentRowTerminator;

         $html .= '</table>' . NL;
      }
      //ensure
      {
         assert( '$html != ""' );
         assert( '$this->_invariant()' );
      }

      return $html;
   }

//========================================================================

   /*
   @function _invariant()
   @discussion - defines a boolean expression that should always be true
      for this object
   @result - returns a boolean expression indicating if the object is in
      a valid state
   */

   function _invariant()
   {
      return parent::_invariant() &&
             ( ! isset( $this->cellPadding ) || ( $this->cellPadding >= 0 ) ) &&
             ( ! isset( $this->cellSpacing ) || ( $this->cellSpacing >= 0 ) ) &&
             ( ! isset( $this->border ) || ( $this->border >= 0 ) ) &&
             isInstanceOf( $this->emptyCell, 'TableCell' ) &&
             isInstanceOf( $this->defaultCell, 'TableCell' );
   }

//========================================================================

};

?>